/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 241 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    ABORT_P = 269,
    ABSOLUTE_P = 270,
    ACCESS = 271,
    ACTION = 272,
    ADD_P = 273,
    ADMIN = 274,
    AFTER = 275,
    AGGREGATE = 276,
    ALL = 277,
    ALSO = 278,
    ALTER = 279,
    ALWAYS = 280,
    ANALYSE = 281,
    ANALYZE = 282,
    AND = 283,
    ANY = 284,
    ARRAY = 285,
    AS = 286,
    ASC = 287,
    ASSERTION = 288,
    ASSIGNMENT = 289,
    ASYMMETRIC = 290,
    AT = 291,
    ATTRIBUTE = 292,
    AUTHORIZATION = 293,
    BACKWARD = 294,
    BEFORE = 295,
    BEGIN_P = 296,
    BETWEEN = 297,
    BIGINT = 298,
    BINARY = 299,
    BIT = 300,
    BOOLEAN_P = 301,
    BOTH = 302,
    BY = 303,
    CACHE = 304,
    CALLED = 305,
    CASCADE = 306,
    CASCADED = 307,
    CASE = 308,
    CAST = 309,
    CATALOG_P = 310,
    CHAIN = 311,
    CHAR_P = 312,
    CHARACTER = 313,
    CHARACTERISTICS = 314,
    CHECK = 315,
    CHECKPOINT = 316,
    CLASS = 317,
    CLOSE = 318,
    CLUSTER = 319,
    COALESCE = 320,
    COLLATE = 321,
    COLLATION = 322,
    COLUMN = 323,
    COMMENT = 324,
    COMMENTS = 325,
    COMMIT = 326,
    COMMITTED = 327,
    CONCURRENTLY = 328,
    CONFIGURATION = 329,
    CONNECTION = 330,
    CONSTRAINT = 331,
    CONSTRAINTS = 332,
    CONTENT_P = 333,
    CONTINUE_P = 334,
    CONVERSION_P = 335,
    COPY = 336,
    COST = 337,
    CREATE = 338,
    CROSS = 339,
    CSV = 340,
    CURRENT_P = 341,
    CURRENT_CATALOG = 342,
    CURRENT_DATE = 343,
    CURRENT_ROLE = 344,
    CURRENT_SCHEMA = 345,
    CURRENT_TIME = 346,
    CURRENT_TIMESTAMP = 347,
    CURRENT_USER = 348,
    CURSOR = 349,
    CYCLE = 350,
    DATA_P = 351,
    DATABASE = 352,
    DAY_P = 353,
    DEALLOCATE = 354,
    DEC = 355,
    DECIMAL_P = 356,
    DECLARE = 357,
    DEFAULT = 358,
    DEFAULTS = 359,
    DEFERRABLE = 360,
    DEFERRED = 361,
    DEFINER = 362,
    DELETE_P = 363,
    DELIMITER = 364,
    DELIMITERS = 365,
    DESC = 366,
    DICTIONARY = 367,
    DISABLE_P = 368,
    DISCARD = 369,
    DISTINCT = 370,
    DO = 371,
    DOCUMENT_P = 372,
    DOMAIN_P = 373,
    DOUBLE_P = 374,
    DROP = 375,
    EACH = 376,
    ELSE = 377,
    ENABLE_P = 378,
    ENCODING = 379,
    ENCRYPTED = 380,
    END_P = 381,
    ENUM_P = 382,
    ESCAPE = 383,
    EVENT = 384,
    EXCEPT = 385,
    EXCLUDE = 386,
    EXCLUDING = 387,
    EXCLUSIVE = 388,
    EXECUTE = 389,
    EXISTS = 390,
    EXPLAIN = 391,
    EXTENSION = 392,
    EXTERNAL = 393,
    EXTRACT = 394,
    FALSE_P = 395,
    FAMILY = 396,
    FETCH = 397,
    FILTER = 398,
    FIRST_P = 399,
    FLOAT_P = 400,
    FOLLOWING = 401,
    FOR = 402,
    FORCE = 403,
    FOREIGN = 404,
    FORWARD = 405,
    FREEZE = 406,
    FROM = 407,
    FULL = 408,
    FUNCTION = 409,
    FUNCTIONS = 410,
    GLOBAL = 411,
    GRANT = 412,
    GRANTED = 413,
    GREATEST = 414,
    GROUP_P = 415,
    HANDLER = 416,
    HAVING = 417,
    HEADER_P = 418,
    HOLD = 419,
    HOUR_P = 420,
    IDENTITY_P = 421,
    IF_P = 422,
    ILIKE = 423,
    IMMEDIATE = 424,
    IMMUTABLE = 425,
    IMPLICIT_P = 426,
    IN_P = 427,
    INCLUDING = 428,
    INCREMENT = 429,
    INDEX = 430,
    INDEXES = 431,
    INHERIT = 432,
    INHERITS = 433,
    INITIALLY = 434,
    INLINE_P = 435,
    INNER_P = 436,
    INOUT = 437,
    INPUT_P = 438,
    INSENSITIVE = 439,
    INSERT = 440,
    INSTEAD = 441,
    INT_P = 442,
    INTEGER = 443,
    INTERSECT = 444,
    INTERVAL = 445,
    INTO = 446,
    INVOKER = 447,
    IS = 448,
    ISNULL = 449,
    ISOLATION = 450,
    JOIN = 451,
    KEY = 452,
    LABEL = 453,
    LANGUAGE = 454,
    LARGE_P = 455,
    LAST_P = 456,
    LATERAL_P = 457,
    LC_COLLATE_P = 458,
    LC_CTYPE_P = 459,
    LEADING = 460,
    LEAKPROOF = 461,
    LEAST = 462,
    LEFT = 463,
    LEVEL = 464,
    LIKE = 465,
    LIMIT = 466,
    LISTEN = 467,
    LOAD = 468,
    LOCAL = 469,
    LOCALTIME = 470,
    LOCALTIMESTAMP = 471,
    LOCATION = 472,
    LOCK_P = 473,
    MAPPING = 474,
    MATCH = 475,
    MATERIALIZED = 476,
    MAXVALUE = 477,
    MINUTE_P = 478,
    MINVALUE = 479,
    MODE = 480,
    MONTH_P = 481,
    MOVE = 482,
    NAME_P = 483,
    NAMES = 484,
    NATIONAL = 485,
    NATURAL = 486,
    NCHAR = 487,
    NEXT = 488,
    NO = 489,
    NONE = 490,
    NOT = 491,
    NOTHING = 492,
    NOTIFY = 493,
    NOTNULL = 494,
    NOWAIT = 495,
    NULL_P = 496,
    NULLIF = 497,
    NULLS_P = 498,
    NUMERIC = 499,
    OBJECT_P = 500,
    OF = 501,
    OFF = 502,
    OFFSET = 503,
    OIDS = 504,
    ON = 505,
    ONLY = 506,
    OPERATOR = 507,
    OPTION = 508,
    OPTIONS = 509,
    OR = 510,
    ORDER = 511,
    ORDINALITY = 512,
    OUT_P = 513,
    OUTER_P = 514,
    OVER = 515,
    OVERLAPS = 516,
    OVERLAY = 517,
    OWNED = 518,
    OWNER = 519,
    PARSER = 520,
    PARTIAL = 521,
    PARTITION = 522,
    PASSING = 523,
    PASSWORD = 524,
    PLACING = 525,
    PLANS = 526,
    POSITION = 527,
    PRECEDING = 528,
    PRECISION = 529,
    PRESERVE = 530,
    PREPARE = 531,
    PREPARED = 532,
    PRIMARY = 533,
    PRIOR = 534,
    PRIVILEGES = 535,
    PROCEDURAL = 536,
    PROCEDURE = 537,
    PROGRAM = 538,
    QUOTE = 539,
    RANGE = 540,
    READ = 541,
    REAL = 542,
    REASSIGN = 543,
    RECHECK = 544,
    RECURSIVE = 545,
    REF = 546,
    REFERENCES = 547,
    REFRESH = 548,
    REINDEX = 549,
    RELATIVE_P = 550,
    RELEASE = 551,
    RENAME = 552,
    REPEATABLE = 553,
    REPLACE = 554,
    REPLICA = 555,
    RESET = 556,
    RESTART = 557,
    RESTRICT = 558,
    RETURNING = 559,
    RETURNS = 560,
    REVOKE = 561,
    RIGHT = 562,
    ROLE = 563,
    ROLLBACK = 564,
    ROW = 565,
    ROWS = 566,
    RULE = 567,
    SAVEPOINT = 568,
    SCHEMA = 569,
    SCROLL = 570,
    SEARCH = 571,
    SECOND_P = 572,
    SECURITY = 573,
    SELECT = 574,
    SEQUENCE = 575,
    SEQUENCES = 576,
    SERIALIZABLE = 577,
    SERVER = 578,
    SESSION = 579,
    SESSION_USER = 580,
    SET = 581,
    SETOF = 582,
    SHARE = 583,
    SHOW = 584,
    SIMILAR = 585,
    SIMPLE = 586,
    SMALLINT = 587,
    SNAPSHOT = 588,
    SOME = 589,
    STABLE = 590,
    STANDALONE_P = 591,
    START = 592,
    STATEMENT = 593,
    STATISTICS = 594,
    STDIN = 595,
    STDOUT = 596,
    STORAGE = 597,
    STRICT_P = 598,
    STRIP_P = 599,
    SUBSTRING = 600,
    SYMMETRIC = 601,
    SYSID = 602,
    SYSTEM_P = 603,
    TABLE = 604,
    TABLES = 605,
    TABLESPACE = 606,
    TEMP = 607,
    TEMPLATE = 608,
    TEMPORARY = 609,
    TEXT_P = 610,
    THEN = 611,
    TIME = 612,
    TIMESTAMP = 613,
    TO = 614,
    TRAILING = 615,
    TRANSACTION = 616,
    TREAT = 617,
    TRIGGER = 618,
    TRIM = 619,
    TRUE_P = 620,
    TRUNCATE = 621,
    TRUSTED = 622,
    TYPE_P = 623,
    TYPES_P = 624,
    UNBOUNDED = 625,
    UNCOMMITTED = 626,
    UNENCRYPTED = 627,
    UNION = 628,
    UNIQUE = 629,
    UNKNOWN = 630,
    UNLISTEN = 631,
    UNLOGGED = 632,
    UNTIL = 633,
    UPDATE = 634,
    USER = 635,
    USING = 636,
    VACUUM = 637,
    VALID = 638,
    VALIDATE = 639,
    VALIDATOR = 640,
    VALUE_P = 641,
    VALUES = 642,
    VARCHAR = 643,
    VARIADIC = 644,
    VARYING = 645,
    VERBOSE = 646,
    VERSION_P = 647,
    VIEW = 648,
    VIEWS = 649,
    VOLATILE = 650,
    WHEN = 651,
    WHERE = 652,
    WHITESPACE_P = 653,
    WINDOW = 654,
    WITH = 655,
    WITHIN = 656,
    WITHOUT = 657,
    WORK = 658,
    WRAPPER = 659,
    WRITE = 660,
    XML_P = 661,
    XMLATTRIBUTES = 662,
    XMLCONCAT = 663,
    XMLELEMENT = 664,
    XMLEXISTS = 665,
    XMLFOREST = 666,
    XMLPARSE = 667,
    XMLPI = 668,
    XMLROOT = 669,
    XMLSERIALIZE = 670,
    YEAR_P = 671,
    YES_P = 672,
    ZONE = 673,
    NULLS_FIRST = 674,
    NULLS_LAST = 675,
    WITH_ORDINALITY = 676,
    WITH_TIME = 677,
    POSTFIXOP = 678,
    UMINUS = 679
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 179 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 743 "gram.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 771 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  727
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   79665

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  442
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  576
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2367
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4580

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   679

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   431,     2,     2,
     436,   437,   429,   427,   440,   428,   438,   430,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   441,   439,
     424,   423,   425,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   434,     2,   435,   432,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   426,   433
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   690,   690,   697,   704,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   831,   841,   852,   853,   862,   863,   867,   868,   872,
     877,   881,   886,   891,   895,   899,   904,   908,   962,   964,
     968,   972,   976,   980,   994,  1012,  1023,  1024,  1028,  1036,
    1054,  1066,  1074,  1095,  1102,  1121,  1128,  1145,  1163,  1174,
    1175,  1187,  1194,  1211,  1224,  1234,  1252,  1270,  1271,  1275,
    1282,  1290,  1291,  1292,  1293,  1294,  1295,  1309,  1315,  1321,
    1330,  1338,  1346,  1350,  1358,  1366,  1373,  1382,  1383,  1391,
    1402,  1410,  1418,  1429,  1437,  1445,  1452,  1461,  1471,  1472,
    1476,  1477,  1480,  1482,  1486,  1487,  1488,  1489,  1493,  1494,
    1495,  1501,  1513,  1517,  1521,  1536,  1559,  1560,  1561,  1565,
    1566,  1567,  1571,  1572,  1576,  1580,  1581,  1588,  1595,  1605,
    1612,  1622,  1623,  1628,  1629,  1634,  1640,  1646,  1652,  1658,
    1668,  1678,  1679,  1683,  1684,  1692,  1707,  1713,  1719,  1725,
    1731,  1750,  1759,  1768,  1779,  1790,  1799,  1808,  1819,  1830,
    1839,  1848,  1857,  1866,  1875,  1884,  1895,  1909,  1910,  1915,
    1923,  1931,  1940,  1948,  1956,  1965,  1974,  1983,  1992,  2002,
    2015,  2030,  2039,  2047,  2062,  2070,  2080,  2090,  2097,  2104,
    2112,  2120,  2128,  2136,  2144,  2151,  2158,  2166,  2173,  2180,
    2188,  2196,  2204,  2212,  2220,  2228,  2238,  2245,  2253,  2261,
    2269,  2277,  2284,  2294,  2295,  2299,  2300,  2301,  2305,  2313,
    2317,  2318,  2322,  2329,  2336,  2343,  2353,  2356,  2357,  2361,
    2362,  2367,  2371,  2375,  2380,  2395,  2408,  2409,  2414,  2423,
    2433,  2443,  2469,  2475,  2505,  2534,  2556,  2557,  2561,  2562,
    2571,  2572,  2573,  2576,  2577,  2582,  2583,  2587,  2591,  2595,
    2599,  2603,  2607,  2611,  2615,  2619,  2623,  2627,  2631,  2635,
    2639,  2648,  2652,  2656,  2660,  2664,  2668,  2672,  2673,  2678,
    2682,  2689,  2696,  2697,  2698,  2699,  2700,  2704,  2708,  2716,
    2727,  2742,  2758,  2774,  2803,  2804,  2805,  2806,  2807,  2814,
    2821,  2822,  2826,  2827,  2831,  2832,  2836,  2840,  2847,  2851,
    2858,  2859,  2860,  2864,  2865,  2868,  2889,  2910,  2911,  2915,
    2923,  2924,  2925,  2956,  2963,  2970,  2981,  2992,  3002,  3011,
    3044,  3051,  3058,  3065,  3076,  3086,  3087,  3088,  3092,  3093,
    3094,  3095,  3096,  3097,  3106,  3114,  3118,  3131,  3146,  3160,
    3175,  3189,  3207,  3228,  3229,  3233,  3234,  3238,  3239,  3242,
    3248,  3252,  3260,  3265,  3271,  3272,  3276,  3281,  3288,  3289,
    3299,  3301,  3303,  3305,  3308,  3311,  3314,  3318,  3319,  3320,
    3321,  3322,  3325,  3326,  3331,  3332,  3333,  3334,  3337,  3338,
    3339,  3340,  3343,  3344,  3347,  3348,  3351,  3366,  3381,  3395,
    3396,  3397,  3409,  3424,  3437,  3438,  3450,  3470,  3482,  3490,
    3501,  3502,  3505,  3506,  3509,  3513,  3517,  3521,  3525,  3529,
    3533,  3537,  3541,  3545,  3549,  3553,  3559,  3560,  3564,  3565,
    3566,  3571,  3574,  3575,  3587,  3599,  3614,  3615,  3623,  3624,
    3628,  3629,  3633,  3634,  3638,  3639,  3643,  3654,  3667,  3668,
    3678,  3689,  3690,  3703,  3710,  3727,  3735,  3746,  3749,  3753,
    3757,  3761,  3773,  3783,  3786,  3790,  3803,  3813,  3823,  3832,
    3841,  3850,  3860,  3869,  3879,  3889,  3899,  3908,  3917,  3926,
    3935,  3944,  3953,  3962,  3971,  3980,  3989,  3998,  4007,  4016,
    4034,  4045,  4046,  4047,  4048,  4052,  4053,  4057,  4058,  4068,
    4079,  4099,  4107,  4119,  4120,  4124,  4128,  4136,  4140,  4144,
    4151,  4155,  4160,  4165,  4172,  4179,  4184,  4194,  4208,  4209,
    4214,  4215,  4219,  4220,  4230,  4241,  4261,  4270,  4278,  4295,
    4310,  4335,  4344,  4362,  4374,  4375,  4376,  4386,  4394,  4411,
    4430,  4450,  4475,  4476,  4477,  4481,  4483,  4505,  4507,  4509,
    4511,  4513,  4518,  4523,  4533,  4534,  4538,  4539,  4543,  4544,
    4548,  4549,  4550,  4554,  4560,  4561,  4562,  4566,  4567,  4572,
    4573,  4600,  4601,  4602,  4603,  4604,  4605,  4610,  4621,  4644,
    4654,  4668,  4670,  4675,  4680,  4682,  4687,  4697,  4698,  4699,
    4700,  4712,  4732,  4755,  4765,  4776,  4786,  4796,  4807,  4816,
    4823,  4830,  4839,  4848,  4857,  4866,  4875,  4886,  4889,  4890,
    4893,  4897,  4904,  4905,  4906,  4907,  4908,  4911,  4914,  4915,
    4923,  4930,  4931,  4934,  4936,  4947,  4957,  4967,  4979,  4980,
    4996,  5011,  5012,  5016,  5026,  5037,  5046,  5056,  5065,  5066,
    5069,  5070,  5073,  5074,  5075,  5078,  5092,  5097,  5107,  5116,
    5128,  5129,  5133,  5141,  5153,  5164,  5178,  5189,  5212,  5222,
    5240,  5251,  5262,  5273,  5287,  5288,  5289,  5290,  5291,  5292,
    5293,  5294,  5295,  5296,  5297,  5298,  5299,  5300,  5301,  5302,
    5303,  5307,  5308,  5311,  5312,  5315,  5317,  5330,  5341,  5342,
    5343,  5375,  5384,  5393,  5402,  5411,  5420,  5429,  5439,  5448,
    5457,  5466,  5475,  5484,  5496,  5497,  5498,  5499,  5500,  5501,
    5502,  5503,  5504,  5505,  5506,  5507,  5508,  5509,  5510,  5511,
    5512,  5513,  5514,  5515,  5516,  5517,  5518,  5522,  5523,  5537,
    5548,  5559,  5570,  5581,  5594,  5595,  5599,  5600,  5601,  5602,
    5603,  5604,  5605,  5606,  5607,  5608,  5609,  5610,  5611,  5614,
    5615,  5625,  5631,  5639,  5647,  5655,  5663,  5671,  5679,  5687,
    5695,  5703,  5711,  5719,  5727,  5735,  5743,  5751,  5759,  5769,
    5770,  5773,  5774,  5784,  5800,  5814,  5840,  5842,  5844,  5846,
    5853,  5862,  5863,  5866,  5873,  5880,  5887,  5901,  5909,  5917,
    5925,  5933,  5941,  5949,  5957,  5965,  5973,  5981,  5989,  5997,
    6005,  6013,  6021,  6033,  6034,  6037,  6047,  6061,  6062,  6066,
    6067,  6072,  6088,  6101,  6111,  6123,  6124,  6127,  6128,  6138,
    6148,  6149,  6153,  6157,  6161,  6172,  6185,  6199,  6216,  6217,
    6218,  6219,  6231,  6258,  6259,  6263,  6264,  6268,  6269,  6273,
    6274,  6277,  6278,  6286,  6297,  6308,  6321,  6322,  6325,  6326,
    6327,  6330,  6331,  6332,  6335,  6336,  6337,  6353,  6365,  6378,
    6393,  6394,  6397,  6398,  6402,  6403,  6411,  6412,  6416,  6417,
    6432,  6441,  6450,  6459,  6468,  6480,  6481,  6482,  6483,  6484,
    6490,  6494,  6509,  6510,  6516,  6526,  6530,  6535,  6543,  6584,
    6588,  6592,  6596,  6604,  6605,  6610,  6611,  6618,  6622,  6626,
    6630,  6634,  6638,  6642,  6646,  6650,  6654,  6658,  6662,  6666,
    6670,  6674,  6682,  6686,  6690,  6694,  6700,  6701,  6708,  6709,
    6712,  6724,  6728,  6743,  6754,  6755,  6760,  6761,  6776,  6787,
    6801,  6812,  6826,  6837,  6851,  6859,  6861,  6863,  6868,  6870,
    6883,  6892,  6893,  6897,  6901,  6913,  6924,  6935,  6948,  6949,
    6950,  6954,  6967,  6968,  6982,  6990,  7000,  7013,  7014,  7017,
    7018,  7029,  7038,  7055,  7065,  7074,  7083,  7092,  7101,  7111,
    7120,  7130,  7139,  7148,  7158,  7168,  7177,  7186,  7196,  7206,
    7216,  7226,  7236,  7246,  7256,  7266,  7276,  7286,  7296,  7306,
    7317,  7328,  7339,  7350,  7360,  7371,  7382,  7392,  7402,  7410,
    7419,  7428,  7437,  7446,  7455,  7464,  7473,  7482,  7496,  7497,
    7500,  7501,  7511,  7521,  7530,  7539,  7548,  7557,  7567,  7577,
    7587,  7597,  7606,  7615,  7624,  7633,  7642,  7651,  7660,  7669,
    7678,  7687,  7696,  7705,  7714,  7723,  7740,  7749,  7757,  7765,
    7773,  7781,  7790,  7798,  7806,  7815,  7824,  7833,  7841,  7849,
    7857,  7865,  7873,  7881,  7889,  7906,  7923,  7924,  7925,  7930,
    7936,  7945,  7946,  7947,  7948,  7949,  7953,  7954,  7957,  7958,
    7959,  7960,  7964,  7965,  7966,  7971,  7982,  8004,  8014,  8015,
    8018,  8027,  8033,  8052,  8059,  8066,  8073,  8080,  8087,  8094,
    8102,  8110,  8118,  8126,  8134,  8141,  8148,  8157,  8158,  8159,
    8163,  8166,  8169,  8172,  8175,  8182,  8184,  8186,  8191,  8193,
    8205,  8218,  8231,  8249,  8270,  8271,  8272,  8273,  8283,  8299,
    8309,  8310,  8314,  8318,  8322,  8326,  8330,  8334,  8338,  8342,
    8346,  8350,  8354,  8358,  8362,  8366,  8370,  8374,  8384,  8385,
    8396,  8403,  8414,  8425,  8426,  8430,  8444,  8451,  8469,  8475,
    8491,  8504,  8513,  8521,  8529,  8538,  8549,  8560,  8570,  8571,
    8582,  8592,  8602,  8612,  8622,  8632,  8640,  8661,  8684,  8692,
    8701,  8712,  8713,  8725,  8741,  8757,  8771,  8791,  8816,  8817,
    8821,  8822,  8823,  8824,  8828,  8842,  8859,  8860,  8864,  8865,
    8868,  8869,  8872,  8873,  8877,  8878,  8891,  8898,  8908,  8915,
    8925,  8926,  8927,  8928,  8929,  8930,  8931,  8932,  8933,  8937,
    8941,  8948,  8955,  8956,  8960,  8961,  8962,  8972,  8982,  8983,
    8987,  8988,  8989,  8990,  9000,  9007,  9025,  9026,  9036,  9042,
    9048,  9054,  9070,  9080,  9086,  9092,  9101,  9103,  9108,  9119,
    9120,  9131,  9145,  9146,  9157,  9168,  9169,  9172,  9173,  9174,
    9175,  9176,  9177,  9178,  9179,  9182,  9183,  9194,  9212,  9213,
    9217,  9218,  9222,  9230,  9258,  9269,  9270,  9280,  9291,  9294,
    9295,  9296,  9297,  9298,  9301,  9302,  9303,  9351,  9352,  9356,
    9357,  9372,  9373,  9380,  9388,  9396,  9404,  9412,  9420,  9431,
    9432,  9459,  9474,  9475,  9494,  9498,  9502,  9517,  9524,  9534,
    9535,  9538,  9550,  9551,  9555,  9567,  9575,  9580,  9585,  9590,
    9595,  9603,  9611,  9616,  9621,  9628,  9629,  9632,  9633,  9634,
    9641,  9642,  9643,  9644,  9648,  9649,  9653,  9657,  9658,  9661,
    9670,  9683,  9684,  9685,  9686,  9690,  9691,  9695,  9697,  9707,
    9712,  9715,  9720,  9721,  9729,  9739,  9740,  9741,  9749,  9753,
    9754,  9757,  9758,  9763,  9764,  9768,  9769,  9773,  9774,  9778,
    9779,  9783,  9784,  9788,  9799,  9800,  9801,  9802,  9806,  9807,
    9812,  9818,  9836,  9837,  9841,  9842,  9848,  9853,  9860,  9868,
    9903,  9928,  9932,  9958,  9962,  9974,  9987, 10001, 10012, 10027,
   10033, 10038, 10044, 10051, 10052, 10060, 10064, 10068, 10074, 10081,
   10086, 10087, 10088, 10089, 10093, 10094, 10106, 10107, 10112, 10119,
   10126, 10133, 10144, 10145, 10158, 10162, 10169, 10190, 10200, 10212,
   10217, 10218, 10221, 10222, 10225, 10226, 10231, 10232, 10237, 10238,
   10246, 10251, 10252, 10256, 10260, 10266, 10296, 10301, 10308, 10313,
   10319, 10324, 10333, 10335, 10338, 10342, 10343, 10344, 10345, 10346,
   10347, 10352, 10382, 10383, 10384, 10385, 10396, 10402, 10410, 10411,
   10417, 10422, 10427, 10432, 10437, 10442, 10447, 10452, 10458, 10464,
   10470, 10477, 10499, 10508, 10512, 10520, 10524, 10532, 10544, 10565,
   10569, 10575, 10579, 10592, 10603, 10618, 10620, 10622, 10624, 10626,
   10628, 10633, 10634, 10638, 10639, 10646, 10655, 10663, 10672, 10683,
   10691, 10692, 10693, 10697, 10699, 10701, 10703, 10705, 10707, 10709,
   10714, 10719, 10725, 10733, 10738, 10745, 10752, 10756, 10760, 10790,
   10791, 10793, 10801, 10816, 10818, 10820, 10822, 10824, 10826, 10828,
   10830, 10832, 10834, 10836, 10839, 10841, 10843, 10846, 10848, 10850,
   10853, 10855, 10862, 10864, 10871, 10873, 10880, 10882, 10890, 10897,
   10904, 10911, 10928, 10935, 10942, 10949, 10956, 10972, 10979, 10986,
   10993, 11000, 11007, 11014, 11018, 11026, 11030, 11040, 11047, 11054,
   11067, 11080, 11099, 11120, 11130, 11137, 11153, 11158, 11176, 11178,
   11180, 11182, 11184, 11186, 11188, 11190, 11192, 11194, 11196, 11198,
   11200, 11202, 11204, 11206, 11208, 11212, 11217, 11221, 11225, 11230,
   11247, 11248, 11249, 11264, 11276, 11278, 11280, 11290, 11313, 11323,
   11333, 11341, 11352, 11356, 11362, 11369, 11376, 11386, 11393, 11421,
   11456, 11467, 11468, 11475, 11481, 11507, 11517, 11530, 11538, 11551,
   11561, 11574, 11584, 11597, 11601, 11605, 11609, 11613, 11617, 11621,
   11623, 11627, 11636, 11641, 11648, 11663, 11670, 11674, 11678, 11682,
   11686, 11693, 11701, 11709, 11713, 11717, 11721, 11725, 11729, 11735,
   11739, 11748, 11752, 11756, 11761, 11775, 11777, 11781, 11783, 11785,
   11788, 11791, 11794, 11795, 11798, 11806, 11816, 11817, 11820, 11821,
   11822, 11827, 11831, 11835, 11839, 11850, 11851, 11855, 11856, 11864,
   11865, 11869, 11870, 11875, 11883, 11885, 11899, 11902, 11929, 11930,
   11933, 11934, 11945, 11963, 11970, 11979, 11996, 12041, 12049, 12057,
   12065, 12073, 12094, 12095, 12096, 12099, 12100, 12101, 12104, 12105,
   12108, 12109, 12110, 12111, 12112, 12113, 12114, 12115, 12116, 12119,
   12121, 12126, 12128, 12133, 12135, 12137, 12139, 12141, 12143, 12155,
   12159, 12166, 12170, 12176, 12180, 12191, 12192, 12195, 12199, 12203,
   12209, 12210, 12215, 12219, 12226, 12227, 12228, 12229, 12230, 12231,
   12232, 12233, 12243, 12247, 12254, 12261, 12262, 12278, 12282, 12287,
   12291, 12306, 12311, 12315, 12318, 12321, 12322, 12323, 12326, 12333,
   12343, 12357, 12358, 12362, 12373, 12374, 12377, 12378, 12381, 12385,
   12392, 12396, 12400, 12407, 12417, 12418, 12422, 12423, 12426, 12427,
   12438, 12439, 12448, 12449, 12457, 12467, 12468, 12472, 12473, 12476,
   12492, 12500, 12508, 12530, 12531, 12542, 12546, 12573, 12575, 12580,
   12583, 12586, 12588, 12590, 12592, 12602, 12604, 12615, 12619, 12623,
   12627, 12631, 12640, 12647, 12679, 12683, 12689, 12706, 12710, 12714,
   12720, 12721, 12722, 12724, 12726, 12730, 12731, 12732, 12748, 12749,
   12750, 12755, 12756, 12757, 12762, 12763, 12764, 12765, 12771, 12772,
   12773, 12774, 12775, 12795, 12796, 12797, 12798, 12799, 12800, 12801,
   12802, 12803, 12804, 12805, 12806, 12807, 12808, 12809, 12810, 12811,
   12812, 12813, 12814, 12815, 12816, 12817, 12818, 12819, 12820, 12821,
   12822, 12823, 12824, 12825, 12826, 12827, 12828, 12829, 12830, 12831,
   12832, 12833, 12834, 12835, 12836, 12837, 12838, 12839, 12840, 12841,
   12842, 12843, 12844, 12845, 12846, 12847, 12848, 12849, 12850, 12851,
   12852, 12853, 12854, 12855, 12856, 12857, 12858, 12859, 12860, 12861,
   12862, 12863, 12864, 12865, 12866, 12867, 12868, 12869, 12870, 12871,
   12872, 12873, 12874, 12875, 12876, 12877, 12878, 12879, 12880, 12881,
   12882, 12883, 12884, 12885, 12886, 12887, 12888, 12889, 12890, 12891,
   12892, 12893, 12894, 12895, 12896, 12897, 12898, 12899, 12900, 12901,
   12902, 12903, 12904, 12905, 12906, 12907, 12908, 12909, 12910, 12911,
   12912, 12913, 12914, 12915, 12916, 12917, 12918, 12919, 12920, 12921,
   12922, 12923, 12924, 12925, 12926, 12927, 12928, 12929, 12930, 12931,
   12932, 12933, 12934, 12935, 12936, 12937, 12938, 12939, 12940, 12941,
   12942, 12943, 12944, 12945, 12946, 12947, 12948, 12949, 12950, 12951,
   12952, 12953, 12954, 12955, 12956, 12957, 12958, 12959, 12960, 12961,
   12962, 12963, 12964, 12965, 12966, 12967, 12968, 12969, 12970, 12971,
   12972, 12973, 12974, 12975, 12976, 12977, 12978, 12979, 12980, 12981,
   12982, 12983, 12984, 12985, 12986, 12987, 12988, 12989, 12990, 12991,
   12992, 12993, 12994, 12995, 12996, 12997, 12998, 12999, 13000, 13001,
   13002, 13003, 13004, 13005, 13006, 13007, 13008, 13009, 13010, 13011,
   13012, 13013, 13014, 13015, 13016, 13017, 13018, 13019, 13020, 13021,
   13022, 13023, 13024, 13025, 13026, 13027, 13028, 13029, 13030, 13031,
   13032, 13033, 13034, 13035, 13036, 13037, 13038, 13039, 13040, 13041,
   13042, 13043, 13044, 13045, 13046, 13047, 13048, 13049, 13050, 13051,
   13052, 13053, 13067, 13068, 13069, 13070, 13071, 13072, 13073, 13074,
   13075, 13076, 13077, 13078, 13079, 13080, 13081, 13082, 13083, 13084,
   13085, 13086, 13087, 13088, 13089, 13090, 13091, 13092, 13093, 13094,
   13095, 13096, 13097, 13098, 13099, 13100, 13101, 13102, 13103, 13104,
   13105, 13106, 13107, 13108, 13109, 13110, 13111, 13112, 13113, 13127,
   13128, 13129, 13130, 13131, 13132, 13133, 13134, 13135, 13136, 13137,
   13138, 13139, 13140, 13141, 13142, 13143, 13144, 13145, 13146, 13147,
   13148, 13158, 13159, 13160, 13161, 13162, 13163, 13164, 13165, 13166,
   13167, 13168, 13169, 13170, 13171, 13172, 13173, 13174, 13175, 13176,
   13177, 13178, 13179, 13180, 13181, 13182, 13183, 13184, 13185, 13186,
   13187, 13188, 13189, 13190, 13191, 13192, 13193, 13194, 13195, 13196,
   13197, 13198, 13199, 13200, 13201, 13202, 13203, 13204, 13205, 13206,
   13207, 13208, 13209, 13210, 13211, 13212, 13213, 13214, 13215, 13216,
   13217, 13218, 13219, 13220, 13221, 13222, 13223, 13224, 13225, 13226,
   13227, 13228, 13229, 13230, 13231, 13232, 13233, 13234
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P",
  "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING",
  "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT",
  "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LC_COLLATE_P",
  "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE",
  "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP",
  "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF",
  "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER",
  "SESSION", "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE",
  "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING",
  "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_ORDINALITY", "WITH_TIME",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "ReindexStmt", "reindex_type", "opt_force", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "AlterSystemStmt",
  "CreateDomainStmt", "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "rowsfrom_item",
  "rowsfrom_list", "opt_col_def_list", "opt_ordinality", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_application", "func_expr", "func_expr_windowless",
  "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "opt_target_list", "target_list", "target_el",
  "qualified_name_list", "qualified_name", "name_list", "name",
  "database_name", "access_method", "attr_name", "index_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "RoleId", "role_list",
  "SignedIconst", "ColId", "type_function_name", "NonReservedWord",
  "ColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,    61,    60,    62,   678,    43,    45,    42,
      47,    37,    94,   679,    91,    93,    40,    41,    46,    59,
      44,    58
};
# endif

#define YYPACT_NINF -4011

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4011)))

#define YYTABLE_NINF -2275

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2275)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    5026,   542, 11237, -4011, -4011,   542, -4011, 55185,   -30,   133,
      28,   191, 11073, 55601, 63505,   712,   292, 11714,   542, 63505,
    1591, 41041, 52273, 63505,   394,   489, 41041, 63505, 63921,   157,
     770,   777, 64337, 56017, 51025,   709, 63505,   910,   309, 64753,
   56433,    49, 56849,   489, 38147,    99,   782, 65169,  1311,  1205,
     882, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,   -30, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,   200,
   -4011,   883,   205,   936,   688,   895, -4011, -4011, -4011, 46865,
   63505, 63505, 63505,  1082, 63505,  1022, 63505,   689, 46865, 47281,
   57265,  1274,  1052, 34732, -4011, 44785, 63505, 63505, 65585, 63505,
      71, 53521, 63505,  1135, 63505, 63505, 45201, 66001,  1424,  1166,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, 63505, 11255,   394, -4011, -4011, 63505,
    1192, 46865, 63505,  1223, 63505,  1350, 63505, -4011, 63505,  1365,
   66417,   697,  1494, 47281,  1534, 35162,  1441, 47281, 66833, 63505,
   63505, -4011, -4011,  1448, 63505, 63505, -4011,  1549, 47697,  1222,
    1612,  1800,  1723,   131, -4011, 57681, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, 45617,   292, -4011, -4011, 48113, 63505,
    1788, -4011, -4011, 67249, -4011,  1544, -4011,   726, 48529, 48945,
    1886,  1592, 35592,  1953, 49361, 67665, -4011, -4011, 68081, -4011,
   68497,  1717, 68913, -4011, 49777, -4011,  1866, 69329, -4011,  1635,
    1645,   927, 31341, -4011, -4011, -4011,   -30, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011,   289,  1688,   201,   186,   249,
   -4011, -4011,   195,   202,   230,   289,  2066,  2066, -4011, 63505,
   -4011, -4011,  1688,   499,  1644,  1644,  1644,  1845,   601, -4011,
    1644, -4011, -4011, -4011, -4011, 56849, -4011,  1656,   394,  1675,
    2064,  1726, 63505, -4011, 63505, -4011, 63505, 63505, -4011, -4011,
    2091,  1715,  1948,  1706, -4011, -4011, -4011,  1897,  1902,  1899,
      93,   394,  1806, -4011,  2019, -4011,  1932, 21887,   394, 58097,
   69745,   184, 45617,   394, 58513,  1754,  1272,  1942, -4011, -4011,
   -4011,   611, -4011,  2153,  1778,  2008,  1706,  1166, 32610, -4011,
    1779,  1479, 56849, -4011, -4011, -4011,   368,  2063, 22321, -4011,
   63505,  1785, -4011,  1795,  1801,  1816,   936, -4011,  5026, 63505,
     370,   370,  2167,   370,  1486,  1603, -4011,  1761, -4011,  2110,
    2089, 56849,   782,   213, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011,  1796,  1479, -4011,   255,
   -4011,  1251,  1843,  1352,  1295, -4011, -4011,   784, 63505,  1959,
     203,   614,  1908, 58929,  4029,  1867, -4011,   235, -4011, -4011,
   -4011, -4011,  2155,  2197,  4430,   218, 59345, -4011, 63505, 63505,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,  1903,
   -4011, -4011,  1919,  2186,  1224,  2113,   111,  2229,  5683,  1309,
   59761, 63505,  2200,  2248,  4847,  1275,   683,  2160,   821,  2186,
    2273,  1229,  2299,  5717, 63505, -4011,  2230,  2343,   620, -4011,
     164, -4011,  2074,  2224,    80, 46865,  2044, -4011, -4011, 63505,
   -4011, -4011, -4011,  2118, -4011,   745, 46865, -4011,  2241,  2115,
   36022, -4011, 63505, -4011, -4011, -4011, -4011, -4011,  2181, 63505,
   -4011, -4011,  2311, 63505, -4011,  1644,  2233,  2093,  2467, 78437,
      91, 63505,  2147,  2523, 63505,  2319,  2147,  2154, 70161, -4011,
   -4011,  2147, -4011, -4011, 63505, 63505,  2123,  1255,  2147,  2324,
    2524,  2527,  2198,  2303,   749,   294,   163,  2422,  2147,  2177,
   63505, 70577, 63505,  2179, 63505,  2502, 46865, 63505, -4011,  2295,
   -4011, -4011,  1209, -4011, -4011, -4011, -4011,  2443,  1796,   212,
    2444,  2144,  2446, -4011, -4011,  2183, -4011,  2455,  1867,  2456,
   -4011,  2143, 70993, -4011, 71409, 71825,  2457,  1903, 47281,  2458,
    2143,  2459,  2345,  2461,   212,  2462, -4011,   850,  2463,  2349,
    2468,  1596,  2143, 46033,  2469,   166, -4011, 24057, -4011,  2253,
   -4011,   782, -4011,  1002, -4011, 40625, -4011,   927,  1688, -4011,
   63505,  1688, 63505,  1688, 63505,  1688, 63505,  1688, 63505, 63505,
   63505,  1688, -4011, -4011, -4011, 63505,  2169, 63505, 63505, -4011,
   -4011, -4011, 52689, 47281, 53105, -4011, -4011,   334,   394, -4011,
   -4011, 78437,  2575, 47281,  2502,  2464,  2464,  2464, -4011, -4011,
   -4011,  2400, 63505,  2470,  2479, 52689, 47281, -4011, 72241, 45617,
    2364,  2180, -4011, -4011, -4011, -4011, -4011,   643,  2625,   303,
    2626, 24057,  2196,   199,   199,  2199,  2487, -4011, -4011, -4011,
     259,  2201,  2203, -4011,   261,   261,  2362,  2204,  2207, -4011,
     269,  2208,  2640,  2644,   270,  2214,  2217,  2223,  1471,   199,
   24057, -4011,  2231,   261,  2236,  2237,  2238,  2661,  2239, -4011,
    2664,  2240,   285,   340,  2242,  2243, -4011,  2204, -4011,   236,
    2246,  2250,  2254,  2255,  2257,  2258,  2259,  2261, 24057, 24057,
   -4011, 21019,  1479,   394, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011,   145, -4011,   273,  3959, -4011,  2288, -4011, -4011,  2437,
   24057, -4011, -4011,  2509,  2262, -4011,   276, -4011, -4011, -4011,
    1479, -4011, -4011,   237,  2264, -4011,  1646, -4011, -4011, -4011,
   -4011, -4011, -4011, 43537,  2670, -4011,   361,   394,   164,  1559,
    2619, 39793, 40209, -4011, -4011,  2499, -4011, 63505, -4011, -4011,
   24057, 37731, -4011,  1479,   397, -4011, -4011, -4011,  1499, -4011,
   -4011, -4011,   -30, -4011,  9740, -4011,  1604,  1785, 63505, 63505,
    2678, -4011, -4011, -4011,  1795, -4011, -4011,   936,   936, 24057,
     936,   189,  1038, 22755, 24057,  2563,  2465,   221,   193,  2567,
   -4011,  2473,  1486,  1603, 56849, 63505, 72657,  2389, -4011, 38563,
    1451,  1479,  2357,  2358,  2406, 41873,  2286,  2366,  2367,  2413,
    2371,  2372, 73073, -4011, -4011, -4011, -4011,   896,  1024,   234,
    2373,   179,   644,  2657, -4011,   204,  2420, -4011, -4011, -4011,
    3939, 63505,  2600,  6485,  2494,   218,  2428, -4011, -4011,  2542,
    2392,  2395,  2514,   218,  1151, 73489, -4011, -4011, -4011, -4011,
   -4011, -4011,  2500, 19775, -4011,  2407,  2387,  2417, 63505, 50193,
    1590,  2525,  1197,  1736,   225, 63505,  2603,  2531, 63505,  2347,
    2433,  2436,  2615,  2361,  1485,  2722,  2359, -4011, -4011, -4011,
    1938,  1949,  2536, -4011,  2632,  2671,  7039,  2434,  2435, 77627,
    1380, 36452,  2720,  1411,  2460, -4011,  1411, 63505,  2466,  2474,
   63505,   218, -4011,  2786,   218,   218,  1157,  2789,  2481,   372,
    1405,  2147,  2359,  1671, -4011,  2482,  2485,   281, -4011,  2584,
   -4011, -4011,  1048,  2495, 56849,   180,  1502,  2359,  2486,  2489,
    2361,  2361, 63505, 63505, 63505, 63505, 63505,   194,  2812,  2813,
    2492,   183,  2538,  2414, -4011,  1411, 43953,  2496, -4011,  1411,
   63505,  2497,  1569,  2359,  1382,  1133, -4011, -4011, -4011,  1166,
   -4011, 63505, -4011, 63505,  1796, 78437,  2607, -4011,  2449, -4011,
    1867,   218, -4011, 63505, 63505,  1903,   178,   862,  2608, 63505,
    2673,  2472, -4011,   440, 38970, -4011,  2123,  2427, -4011, -4011,
    2477, -4011,  2477,  2477,  2432,  2432,  2438, -4011, -4011, -4011,
    1471,  2477,  2432, -4011, 79247, -4011,  1358,  1359, -4011,  2838,
    2841, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
     828,  1461, -4011, 63505, 41873, -4011,  2861, -4011, -4011, 78437,
    2633,  2747, -4011, 63505,  2648,  2453, -4011,  2787,  2510, -4011,
   -4011,   831, -4011,  2757, 47281,  1100,   394,  2501, 63505,  2677,
   63505, 63505, 63505, 63505, -4011, -4011,  2651,   764,   127, -4011,
   43953, -4011, 63505,  1671,  2662,  2868,    46,  1644, 63505,  2753,
   -4011, 63505,  2475,  2870,  2703, -4011,  1523, -4011,  2588, -4011,
   46865,   212, -4011, -4011, -4011, -4011, 78437, 63505, 73905, 46865,
     212, 47281, 47281,  2769,   166,  2770,  2534,  2777,  2537, 36452,
     212,   196, 47281, 63505, 63505, 63505, -4011, 63505, -4011, -4011,
   -4011, -4011, 63505, 63505, 47281, 43953,  2782,  2785,   212, 63505,
   63505, -4011,  9740,  1610, 63505,   927, 44369, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, 63505, -4011, 63505, -4011, 63505,
   -4011, 63505, -4011, 63505, -4011, -4011, -4011, 63505, -4011, 63505,
    1614, -4011, -4011,  1616,   160, 63505, 63505,   177, 46865, 63505,
    2676, 63505, 63505, 63505, 63505, 63505,  2564,  2264,   854, -4011,
     251, 56849,  2682, -4011, -4011,  1624,  1311,   717, 63505, -4011,
   -4011, -4011, -4011, -4011, -4011, 53105, 52273,  2773,   119, 63505,
   -4011, -4011,  2471, 24057,  1479, 21453, -4011, -4011, -4011,  2490,
    9740,  2533, 24057, -4011, -4011, 24057,  2498,  2066,  2066, 24057,
   -4011, -4011, -4011, -4011,   863,  2066, -4011, 24057, 24057,  2066,
    2066,  2477,  2477, -4011,  4783, 24057, -4011, 36452, 24057, 26661,
   18925, 24057,  2573,  2515,  2066, -4011,  2066, -4011, 24057, 20585,
   -4011, 24057,  2704, 27523, 24057,  1559,  2709, 24057,  1559,  2927,
    2927,  2766,  3969,  2504,  1479, -4011,  2613,  2066, -4011,  2066,
     865, -4011,   207, 78437, 24057, 41873,  2583,   190, 63505, 24057,
    2506,  1148, -4011, 24057,  1057, -4011,  2512, 24057,  2586, 24057,
   24057, 24057, 24057, 24057, 24057, 24057, 24057, 24057, -4011, 28369,
     210,  2790,  2808,   619,  2448, 60177,  2801, 21887, 18490, -4011,
     256, -4011, -4011, -4011, 63505,  2670, -4011, -4011,  2593, -4011,
   -4011, -4011, -4011, -4011,   277, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011,  2528, -4011, -4011, -4011, -4011,  2528, -4011,  2532,
    2535, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011,  2805,  2806,   212,
   63505,   368, 53937, -4011, 22321, -4011,  1629, -4011,  2543, -4011,
    2784, -4011,  2544, -4011,  7513,  2784, -4011, -4011,   181,  2654,
    2788,  2732, -4011, -4011, -4011,  2546,  9740, -4011,  1492,  9740,
    1547, -4011, -4011, -4011, -4011, -4011, -4011,  1206, -4011, 63505,
    2682,  2563,   193,  2606,   465, 63505, -4011, 33033,  2730, -4011,
    2942, -4011, 79247, -4011,  2554, -4011, 78842, 76401, -4011, -4011,
     527, -4011,   914,  2634,  2636,  2684, 47281, 63505, 63505, -4011,
   41873, 47281, 63505, 63505, 47281, 63505, 63505, -4011,  2917,   787,
   52273,  2685, 51441, -4011, -4011,  2560, 63505,  2620,  2809,  2810,
     833, -4011, -4011, 74321, -4011,  2761, 47281, 63505, 63505, 24057,
    2762, 63505, 63505, -4011,   301,  2649,  2650, -4011, 63505,  2652,
   46865,  2574, 63505, 63505, 63505,  2653,   773, 46865,  2622, 36882,
   63505, 63505, 63505, 63505,  2696, 63505, 63505,  2814,  1025, 56849,
     138,  1672,  2359,  2776, -4011,  1190, -4011, 47281, 63505,  2768,
   -4011, -4011, -4011, 60593,  2982,  2688, -4011, -4011, 74737, -4011,
   -4011, -4011,  1653, -4011, 47281, 47281, 63505,  7951, 63505,  1055,
   -4011, -4011, 78437, -4011, 63505, 63505, 63505, 63505, 54353, 75153,
   75569,  1307,  1327, 63505, 54769, -4011, 63505, -4011, -4011, 42289,
   47281, 63505,   869, 41873, -4011, 63505,  2774,   240, -4011, 63505,
    4536, -4011, -4011,  2665,  2674, 63505,   197,  1756,  2359, 63505,
   63505,  2587,  1676,  2667,  2714, -4011, 63505, 69745, -4011, 47281,
     789, -4011,  2733, 47281, 63505,  9159, -4011, -4011,   218, -4011,
   -4011, -4011, -4011, -4011, 63505, 63505,   218, 63505,   218,   214,
   -4011, 47281, 63505, -4011, -4011, -4011, 63505,  8090, 63505, 63505,
   63505, 63505, 47281, 63505, -4011, -4011,   826,   969,    72,    81,
    2734, 63505,  2862, 63505, 75985, 47281, 63505, 63505, 63505,   332,
   -4011, -4011, -4011,  2710, -4011, 47281,   789, -4011,  8651, 63505,
   63505,  2679,  2680,   136,  2749, -4011, -4011, -4011, -4011, -4011,
   -4011,  2843,  3006, 63505, -4011,  2847,  2850,  2666,  2668,  2853,
     801, 63505, -4011, -4011, -4011, -4011, 63505,  2859,   801,  2804,
     143, -4011, -4011,  2147, -4011,  2631,  1680, -4011, -4011, 24057,
    3025, 78437,  2624,  2627,  2700,  2701,  2705, -4011,  2629,  2707,
    2066, -4011, -4011,  1556, -4011, -4011,  1698, -4011,  2639,   764,
    1285, -4011, 41873, 63505,   725,   810,  2932, 50609,  2305,  2922,
   63505,  2686, 63505,  2305, 63505, -4011,  1686, 52273, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011,  2921, -4011,   394,
    2123,  2123,  2123,  2123, -4011, -4011, -4011, -4011,  2825,  1725,
   -4011,  2641,  2123, 63505,  2755,  2305,  2655, -4011,  1671,  2945,
     813, 63505, 50609,  1643,  2687,  3054,  1644,   394,  2836, -4011,
   20180,  3372,  2839, 45617,  2924,  2926,  2946, -4011,  1796, -4011,
    3061, -4011,  2959,   212,  1867, -4011,  2143, -4011, 63505, -4011,
   63505, 63505, 63505, 63505,  1903, -4011, -4011,  2143,  2845,   212,
     212, -4011,  2846,   212,  2143,  2775,  2950, 45617, -4011,   166,
   -4011, -4011, 24057,  1644, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011,  1700, -4011, 63505, -4011,  2928,  2930,  2936,  2659,
    2669,  2708, 63505,  2675, -4011,  2659,   218,  2659,  2264,  2264,
    2659,  2669, 46449,  3085,  2953,   185, -4011,   668,    32,  2888,
   -4011, -4011, -4011, -4011, 78437, -4011, -4011, -4011, -4011, -4011,
   63505,  2716,    94,  2864,  2681, 46449,  3070,   212, -4011, 46865,
   -4011, -4011, -4011,  2756,  2771, 46865,  2877,  2731, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011,  2929, 63505,  1714, -4011, -4011,
    1558, -4011,  1599, 24057, 24057,   345, -4011,  8068,  1720, 24057,
    2689,  2690,  1730, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
    2692,  2971, -4011,  2693,  1740,  1749,  2697,  2698, -4011, -4011,
    2742,  2699,  8322,  2706, 26661, 26661,   380, -4011, -4011, 26661,
    2711, -4011,  1789,  7638,  2702,  2712,  2715, -4011,  2718,  2719,
    8437, 23189, 24057, 23189, 23189,  8807,  2702,  2721,  1793, 41873,
    2857,  9214,  1802, -4011, 24057, 41873,  3478, 24057, -4011, 24057,
   63505,  2723,  2724, -4011, -4011,  4783, -4011,  2726, -4011, 26661,
   26661, -4011,  8533, 21019, -4011, -4011,  2985, -4011, -4011,  1421,
   -4011,  2727, -4011, -4011,  9844,   216, 24057,  2506, 24057,  2779,
   36452,  9830, 24057,  5049,  5793,  5793,   424,   424,   171,   171,
     171,  1529,  2448, -4011, -4011, -4011,  2739,  2743,  2744,  2880,
    2239, 24057, -4011,  1705,  1892, 63505,  1144,  1979,  2284, -4011,
   -4011, 29649,  2750, -4011, 24057, 24057, 24057,  2725, -4011,  3128,
    9740,    55, -4011,  3133, -4011,  1166,  2066,   865, 40625, -4011,
   -4011, 24057, -4011, -4011, -4011,  1795, -4011, -4011, -4011, -4011,
   -4011, 63505,  1311, 24057, -4011, -4011,   488,  1665, 24057,  1492,
   -4011, -4011,  2772, -4011, 24057, -4011, -4011, -4011,  2264, -4011,
   -4011, -4011, 29649,  2760,  2765, 32187,  2855, -4011, -4011, 63505,
     137, -4011, -4011, -4011,  2745, -4011, -4011, 76401,  1461, -4011,
   78842, -4011, 78842, -4011,  1461,  3130, -4011, 76401,  1545, 47281,
   63505, 63505, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011,  2970, -4011, 47281, 47281,  2934, 63505,  2933,  2935,
   24057,   757, 63505,  2751,  2752,  1271,  3014, 63505, -4011,  3056,
     212, -4011, -4011,  2834, -4011,  9740, -4011, -4011, -4011, -4011,
   -4011, 47281, 63505, -4011, 45617, -4011,  1796, 78437, -4011, -4011,
   -4011, 63505,  2791, 63505, -4011, 63505, 63505, 63505,  1903, -4011,
   -4011, -4011, -4011,   864, -4011, -4011, 63505, 63505,   132,  2835,
    2837, 63505, -4011,   793,  2584,  9707, 63505, 63505, 63505,  3015,
   -4011, -4011, -4011, -4011,  2956, -4011, -4011, 76401, -4011,  2143,
     834,  2842,  2359, -4011,  2948, -4011,  1064, -4011, -4011, -4011,
   -4011, -4011,  3071,   212,  3072,   212, 63505, 63505, 63505, 63505,
   -4011, -4011, -4011, -4011, -4011, 41873, 41873, 41873,  1803, -4011,
   -4011,   394, -4011, -4011, -4011, -4011, -4011, -4011,  3030, -4011,
    1808, -4011,  1018, -4011, -4011, -4011, -4011, -4011, -4011, 47281,
   63505, 10384, 63505, 63505, 63505,  1503, -4011,   849, 78437, -4011,
   78032, 47281, 63505, -4011, -4011, -4011,  3000,  2944, -4011,   830,
    2947, 47281,  2840, -4011,  2856, -4011, -4011,  2858,  1834,  2359,
    1671, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,  1044,
     211,  2009,  2359,  2860, -4011,  2865, -4011, -4011, -4011,  2995,
    3001,  3007,  2869,  2872,  2913,  2874,  2878,  2915, -4011,  2879,
    2931,  2881,  2939,  2882,   212, 78437,  3010,   394,  2910,  3107,
     212, -4011,  2884, -4011, -4011,  3211, -4011, 63505, -4011,  2891,
    2033,  2359, -4011, -4011, 47281, 63505, -4011, -4011, -4011,   801,
   78437,  3064,   801,   801, 63505, 63505,   801, -4011, -4011, -4011,
    3065,  3066,   801, -4011, -4011, -4011, -4011,  2233,  2826, 34302,
   -4011,  3260,  4557,  2830,  2627,  2828,  2066,   175,   993,   881,
    2949,  2066,  3043,  2833, -4011, -4011, 41873, 34302,  1775,  3060,
    2851,  2851,  2851,  2851,  2851,  2851,  2851, -4011,  2683,   322,
    2147, 45617, 63505, 45617, -4011,   810,  2948, 63505, 63505,  2849,
    2848, -4011, -4011, -4011, -4011, 47281,   153, 47281,  2066, -4011,
   -4011,  2905, -4011, 63505,  1644,  3237,  2527,  1100,  2977,  1264,
    3194,  2687, -4011, -4011, -4011, -4011, 63505, 63505,   764,   394,
   -4011,  2854,  2852, -4011, 63505, 63505, 63505, 63505,  2716,  2867,
    2873, 78437,    58,  3044,  3046,  2361,  3263,  1311,  2687,  2952,
   63505, -4011,  1837,   130, -4011,   394, 45617, 76806, -4011,  3249,
   -4011, -4011,   860,  3137, -4011, -4011,  1311,   212, 78437, 63505,
   -4011,   212,   166,  2925,   212,  2940,   212,   212, 63505, -4011,
   -4011, 63505, -4011, 63505, 43953,   212, -4011,  9740, -4011, -4011,
    2991,  2993,  2998, 63505,  2659, 46865, -4011,  2875, 47281,  1050,
   -4011, -4011,  3067, -4011, -4011, -4011, -4011, -4011,  3176,  3180,
   -4011, -4011, -4011,   220, -4011, 47281, 52689,   271, 47281, -4011,
    1796, -4011, -4011,  1867,   218, -4011, 63505,  3121, -4011, -4011,
   -4011,  2883,  1842,  8914, 24057, -4011,  3193, 78437, -4011,  5361,
   -4011, -4011, -4011, -4011, 24057, -4011, -4011, -4011, -4011, -4011,
   24057, -4011, 24057,  3170, -4011,  3312,  3312, 78437, 26661,  1618,
    2236, 26661, 26661, 26661, 26661, 26661, 26661, 26661, 26661, 26661,
   28803,   398, -4011, -4011, 24057, 24057,  3177,  3170, -4011, -4011,
    1450,  1450, 78437,  2889,  2702,  2890,  2892, 24057, -4011, -4011,
    1849, 27946,  2893, 41873, -4011, 24057,  7943,  1873,  2943,  9699,
    1479,  5503, -4011,  3267,   394, 24057,  1360,  1674, 24057,  1877,
   24057,  3182, -4011, -4011, -4011,  2896, -4011, -4011, 78437, 24057,
   26661, 26661, 10182, -4011, 10453, 24057,  2899, 10460, 21019, -4011,
    3082,  2951, 33456, -4011,   489,   489,   489,   489, -4011, 63505,
   63505, 63505, 30072,  3191, 29226, 61009,  2906,  2041, -4011, 61009,
   61425, -4011,  2907, -4011,  2911,  1479, 24057,  3189,    63,    63,
    3082, -4011, 24057, 23623,  2914, -4011,   164,  2916, -4011, -4011,
    7392, -4011, -4011,  2919, -4011,  2918, -4011,  1665, -4011, -4011,
   -4011,  5648,  3099, -4011, -4011,  2906, 24491,  2855, -4011,  1879,
   -4011, -4011, 21887, -4011, -4011,  1881, 33033,  2760, 22321,  1479,
    1885,  1588, -4011, -4011, 76401, -4011,  2984, -4011, -4011, -4011,
    2851,  2143,  2143,  1145,  2659,  3210,  1145,  5931, -4011, -4011,
   30495, 63505, 63505, -4011, 63505,  1889,  1452, 63505, -4011, 63505,
   -4011, -4011, -4011, -4011,  3327, -4011, 63505, -4011, -4011,  2979,
    2980, -4011, 63505, 63505, 63505, 63505, -4011, -4011,  1843, -4011,
   -4011, 47281, 63505, -4011, -4011, -4011,   228,  2051,  2359, -4011,
    3003, -4011, -4011,  3188, -4011,  3315,  3021, 63505,  2937, -4011,
    1452,   796,  2361,   884, -4011, -4011,  3008, 63505, -4011, 63505,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, 42289,
   -4011, -4011, 63505, -4011, 41873, 34302, 41873, -4011,  1104,   238,
    2128,  2359, -4011,  3016, -4011,  3018,  3019,  3068,   769,   942,
    3020,  3022,  3069,  2954,  2957,  2958, -4011, -4011,   289,   394,
   -4011, -4011,   394,  2143,   394, 63505, 63505, 63505,  3332,  3033,
   63505, 63505, 63505, 63505, 63505,  3238,   651,  1722, 47281, 63505,
   63505, 47281, 63505, 63505, 63505, 63505, 63505, 63505, 63505, -4011,
    3320,  3253,  1850,  3293,  3028, 63505, -4011, 63505,  2584, 63505,
   63505, -4011, -4011, -4011,  2960,   801, -4011, -4011,  3197,  3200,
   -4011,   801,   801, -4011,   440, 41873, -4011,  1904,  2918,  1938,
    1949, -4011, -4011, -4011, -4011, -4011, -4011,  2631, -4011, -4011,
    2066,  1869,  2963, -4011,  2964, -4011, -4011, -4011, -4011, -4011,
   -4011,  2965, -4011,   865, -4011, -4011, 63505,  2851, -4011,  1428,
     970,  1011,  1119, 61841, 62257, 62673,  2973, 63505, 63505, 26661,
   -4011,  1289,   744, -4011,  3204, 63505,  3011, -4011, -4011, -4011,
    3124, 63505, -4011, -4011, -4011, -4011, -4011,  2976, -4011,  3084,
   50609,  2143, 47281, 47281,  2143, -4011, 78437,  2978,  2687, 47281,
    1100,  1095, 70577,  3017, -4011,  2975,  3273, -4011,  2986,  2990,
   -4011, -4011, 63505,  2948,  1900,    56,  1635, -4011, 51857,  1643,
    3254, -4011, -4011, -4011,  3363,  3086, -4011,  1311,  2716,  3086,
     394,  2620, -4011, 76401, 24057, 24057, -4011,  2999, -4011,  3005,
    3883, -4011,  2123, -4011, -4011, -4011, -4011, -4011, -4011,  3083,
   63505, -4011, -4011,  3023,   212, -4011, -4011, 63505, -4011, 63505,
   -4011, -4011,   212,   212, -4011,  3135, -4011, 63505, 63505, 63505,
    2659, -4011,   218, -4011,  3290, 46449, -4011, -4011, -4011, -4011,
   -4011,  3355,   119,  3304, -4011, -4011,  3266,  3268,  3269,  3271,
     857, -4011, -4011, 24057,  9740, -4011,  3029, -4011,  9740,  6143,
    9740,  3177, -4011,  2333,  3313, -4011,   873,  3031,  2333,  1836,
    1836,   428,   428,   248,   248,   248,  3312,   398,  9740,  9740,
   -4011, -4011, -4011, -4011,  3032, -4011, -4011, -4011,  2702, -4011,
   24925,  3181,  3420, -4011, -4011, -4011,  3075,  3076,  3038, -4011,
   24057, 25359,  3036, 79247, -4011, -4011,   865,  1634, 26661, 26661,
    2938, -4011,  1069, 24057, 78437,  1922,  2938,  1827,  1976, 24057,
   24057, 10705,   262, 24057,  6447,  3040, 24057, 77211, -4011, -4011,
   63505, 63505, 63505, 63505, -4011, -4011, -4011, 61009, 61425,  3042,
   19351,  2041,  3045, 63505, -4011, -4011,  3047, 29649,  3283,  3221,
   -4011, 29649,  3221,  1079,  3221,  3285, -4011, 33879, -4011, -4011,
    3048, -4011, -4011, 18490,  1578,  9740,  3440,  3329, 24057,  3055,
    3057,  3059,  9740, 24057, -4011,   394,   394, -4011, -4011, 36452,
   -4011, -4011, -4011,  3247,  9740, -4011,  1311, 63505,  1479,  2262,
    3077, 63505, -4011,  2855, -4011, -4011,  3131,  1931, -4011,   289,
   -4011, -4011, -4011, -4011,  3139, 52273,  3349, -4011, 24057,  1933,
   -4011,  3102,  3437,   286,  1937,  1945,  1452, -4011,  3011, -4011,
    1293,  3328,   318, -4011,   212, -4011, 78437, -4011, 63505, 63505,
   -4011, -4011, -4011, -4011,  2286, -4011, -4011, 63505, 63505, 63505,
   63505, -4011, 47281, 63505, -4011, 41873,  2683,  3270, -4011, -4011,
    3272,   289, 63505, -4011, 78437,   212,   212, -4011, -4011, -4011,
   -4011,  3081,  3459,  3157, 63505, 63505, 63505, 63505, 47281, 63505,
   63505,  2066,  2066, 78437,  3078, -4011,  2066,  2066,  3087, -4011,
   47281, 63505, 63505, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, 47281, 63505, -4011,  3150, -4011, -4011, -4011,
   63505, 63505, 63505, 63505,  3377, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, 63505, -4011, -4011,   394,
     394, 78437,   212,   212, -4011, -4011, -4011,  3322, -4011,   801,
     801, -4011, -4011,   250,  1957, -4011, 30918, -4011, -4011,  2523,
     394,  2523,  1420, -4011, -4011,  2523, -4011,  2523, -4011,  1452,
    3088,   751,  3362, -4011, -4011, -4011, -4011,  3365,   289, -4011,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -4011, 24057, -4011,  1137,  2333, -4011, -4011,
   -4011, -4011,  3011,  1644,  3141, 46865,   928, -4011,  3352,   725,
   50609,   245, 63505, -4011,  2143,  2143,  3144, 63505,  3495, -4011,
      57, 63505,  3407,  3134, -4011,   394, -4011, -4011,  2687, 63505,
   50609,  2716,  1958, -4011, -4011, -4011,  3129,  3046,  3095,  1643,
    1160, 63505, -4011,  3132, -4011, -4011,  3381,  3098, -4011,  9740,
    9740,   394, 17996,  3249, -4011, 63505,  3356,   212, -4011,   212,
     212, -4011, -4011, 63505,  2659,  2659,  2659, -4011,  3282, -4011,
   -4011,   212, 46449,   857,   857,   857,   857, -4011, -4011, -4011,
    9740, -4011, -4011, -4011, 26661,  3385, -4011,  3103, 78437, -4011,
    3104,  1975,  1982, 27523,  3250, -4011, -4011, -4011,  6470,  3152,
    9740,  3207,  3108,  3109, -4011,   338,   338,  1069,  1987, -4011,
   26661, 26661,  2938,  2938, 24057,  2938, -4011, -4011,  6519,  3280,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011, 42705, 61009,  3112,
   63505,  2041, 29649, -4011, -4011,  1543, -4011, 29649,  3353, -4011,
   29649, 63505,  3115, 63505,    55, 24057, 24057,  3153, -4011, -4011,
   -4011,  3082, -4011,   865,  3116, 63505, -4011, -4011,   782, -4011,
   -4011, -4011, -4011, -4011, 46449,  3305, 46449,  1452,  6816,  3011,
   30495, 37312, 63505, 63089, 63089,  3264,  3011,  3141, -4011, -4011,
   -4011, -4011, -4011, -4011,  3120, -4011, -4011, -4011,  3199, -4011,
   -4011,    13,  2682,  1988, -4011, -4011, -4011, -4011, -4011,  3320,
   -4011, -4011, 34302, 47281, 63505, -4011,  3202, -4011, -4011, -4011,
   -4011, -4011, 31764, 36452, -4011,   769,  3123,  3126,   942, -4011,
   -4011, -4011,    15,  2682, 63505,  1200,  1127,  3163,  2659,  3417,
   -4011, -4011, -4011,  3320, -4011, -4011,   801, -4011, -4011, -4011,
    2147,  3455, -4011, 41873, -4011, 43121, -4011, -4011, -4011,   394,
   -4011,   394,  3325, 63505, 39377,   394,   394, -4011, 46865,  3537,
    3537, 63505, -4011, -4011,  7025,  3331, -4011,  3141,  3354,  3394,
   -4011,  3140, 63505,  3291,  3143,  3146,   407,   407,  2948, 63505,
    1992,  1311,  1100, 50609,  2948, -4011,  1237,  3149,  3446, -4011,
    3555,  2867,  3151, -4011, -4011, 51857,  3335,  3086, 63505,  3046,
    3279, -4011,  3286, -4011,   260, -4011, 63505, 30495, -4011, 78842,
   -4011,  2003, -4011, -4011,  2750, 63505,    90, -4011, -4011, -4011,
   -4011, -4011, -4011,   271, -4011, -4011, -4011, -4011,   780, 26661,
   78437,  2010, 24057, -4011, 24057, -4011,  3543, -4011, -4011, -4011,
      95, -4011, -4011, -4011,   338,   338,  2938, -4011,  3545,  3082,
   -4011,  2012,  3563, -4011, 63505,  2017, -4011, 24057,  3162, -4011,
   -4011, 29649,  1543,  2024, 63505,  2035, 78437,  3165,  2702,  9740,
   63505, -4011,  3166, -4011, -4011, -4011, -4011,  1050,  1145,   271,
    3437,  3141, -4011,  3164, -4011, -4011, 63505, -4011,   316,   316,
   63505,  3141, -4011, -4011, 63505,  3248, -4011, -4011, 41873,  3223,
   -4011,    18,  2682, 63505, 78437,  1867,    87, -4011, 78437, 78437,
   -4011,  3255, -4011, -4011, 63505, 63505, 63505, 63505, 63505,   212,
   -4011,  2826,   394, -4011, -4011,  2048, -4011, -4011, -4011, 63505,
    2975, -4011,  2975, -4011, -4011,  3537,   291, -4011, -4011, -4011,
    1447,  3371, -4011,   147,  3357,  3258,  3173, -4011, 46865,  3606,
    3289, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
    3472,  2687,  3132, -4011, -4011, -4011, -4011, 24057,  3338,  1311,
    1643,  3254, -4011, -4011, -4011,  2053,  3086, -4011, -4011,  3554,
    3368,  3562, -4011,  2054, -4011, -4011,  3883, 17996,  3507, -4011,
    3239, 63505, -4011, -4011, -4011,   780,  2059, -4011,  2061,  2072,
    3334,  3240, -4011, 24057,  1362,  2907, 42705,  3192, -4011,  2078,
   -4011,  9740, 63505, -4011, -4011, -4011,  2080, -4011, -4011,  3187,
   -4011,  3598, -4011, -4011,  3479, -4011, 63089,  3233, 36452, -4011,
    1665,  1665,  1644, -4011,  1452, -4011, 63505, -4011, 24057, -4011,
    3281, -4011, -4011,  2084, -4011,   945,  3344,  3487,  2094,  2096,
   63505,  2669,  3235,  2669, -4011,  2659, -4011, -4011, -4011, -4011,
   43121,  2975, -4011, -4011, -4011,  3515,  3461, -4011, -4011, -4011,
   -4011,   365, -4011,  3389,  3390, 63505, -4011,  3205, -4011,  2098,
   63505, 63505,  3611,  3612, -4011,  7062, 46865,  3132,  3046,  1643,
    2683, -4011, -4011,  3392, -4011,  3398,  2687, 30495,  3249, -4011,
     808, -4011, -4011, -4011, -4011, -4011, -4011, -4011,  2702, 25793,
   25793,  3215, -4011, -4011, 63505, -4011,  2104, -4011, 63505,  3217,
   46449,   316,  3219, -4011,  3220, -4011, -4011,  3354,  1452,  2682,
    9740, 63505, 46865,  3599, -4011, -4011, -4011,  3344, -4011, -4011,
    2682, 63505, -4011,  3346, -4011,   705,   705,  3550, -4011,  3284,
   -4011, -4011,  3222, -4011,  3655,  2948, -4011,   769,  1311, -4011,
    3225, -4011,  3086,  3046, -4011, -4011,  3086, -4011, -4011, -4011,
   -4011,  1727, 27095,  3358,   805,  7954, -4011, -4011, -4011, -4011,
    2105, -4011, -4011, -4011,   271,  1665, 24057,  1452, -4011,  3357,
   -4011,  2682,  1867, 63505, -4011, -4011, -4011,  3134, -4011,  3645,
   -4011,   799, -4011, -4011, -4011, -4011, -4011,  3078,  3132, 41457,
   -4011,  3086,  2750, -4011,  1372, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011,  3636, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011,  7307, -4011, -4011, -4011, -4011,  3531, -4011, -4011, -4011,
   -4011, -4011,  2111, -4011, -4011, -4011, -4011, -4011, -4011,  1906,
   -4011, -4011,  1914,  1816, 26227, -4011,  1452,  3384, -4011, 41457,
   -4011,  1372, -4011, 46865, -4011, -4011,  3231, 41457,  2112, -4011
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1403,  1199,   549,  1287,  1286,  1199,   245,     0,  1289,     0,
    1199,   372,   961,     0,     0,     0,     0,   549,  1199,     0,
    1403,     0,     0,     0,     0,  1416,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1199,     0,     0,  1423,     0,
       0,     0,     0,  1416,     0,  1291,     0,     0,     0,     0,
       2,     4,    61,    62,    26,    25,    31,    30,    84,    85,
      49,    17,    75,    55,   118,   117,   119,    37,    33,    69,
      22,    24,    34,    38,    57,    39,    50,    96,    56,    20,
      54,    79,    58,    82,    44,    11,    12,    45,    73,    13,
      46,    74,    14,    47,    15,    63,    86,    29,    59,    83,
      60,     5,    40,    71,    67,    10,    51,    52,    53,    76,
      77,    78,   101,    81,   113,    36,   110,    90,    91,   107,
      92,   108,     8,    93,    48,    16,   104,   103,   105,    70,
      41,    72,   102,    23,   106,    18,    19,   109,    80,    99,
      95,   114,   112,   120,    97,    64,     6,     7,    87,    21,
      43,     9,    28,    27,    42,    35,   116,    32,  1289,    89,
     100,    88,    65,    94,    68,    98,   115,    66,   111,  1390,
    1377,  1425,  1389,  1402,     0,  1392,  1198,  1197,  1183,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   548,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1209,
    1948,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,   343,
    1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,
    2222,  2223,  2224,  2225,  1981,  1982,  1983,  1984,  1985,  1986,
    1987,  2226,  2227,  1988,  1989,  1990,  1991,  1992,  2228,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2229,
    2230,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2231,  2038,  2039,  2040,
    2232,  2041,  2042,  2043,  2233,  2044,  2045,  2046,  2047,  2048,
    2049,  2050,  2234,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2235,
    2067,  2068,  2069,  2070,  2236,  2237,  2238,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2239,  2081,  2082,
    2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,
    2093,  2094,  2095,  2096,  2097,  2240,  2241,  2098,  2099,  2242,
    2100,  2101,  2102,  2243,  2103,  2244,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2245,  2112,  2246,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2247,  2121,  2248,  2124,  2122,
    2123,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2249,
    2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2250,
    2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2251,  2166,  2167,  2168,  2252,  2169,
    2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2253,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2254,
    2255,  2188,  2256,  2189,  2257,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  2258,  2259,  2207,  2208,  2209,  2210,  2211,  2212,
    2213,  2214,  2215,  2216,  2217,  2218,  2260,  2261,  2262,  2263,
    2264,  2265,  2266,  2267,  2268,  2219,  2220,  2221,   342,  1368,
    1919,  1949,  1950,  1288,  1269,   549,     0,  1186,   371,     0,
       0,     0,     0,     0,     0,     0,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   168,     0,
       0,   395,   394,     0,     0,     0,   933,   400,     0,     0,
       0,     0,     0,   537,  1330,  2122,  1328,  1369,   246,   249,
     250,   247,   248,  1941,     0,  1040,  1041,  1043,     0,     0,
    1053,   773,   774,     0,   772,     0,   776,     0,     0,     0,
     768,     0,     0,     0,     0,     0,   775,   765,     0,   764,
       0,     0,     0,   771,     0,   766,     0,     0,  1187,  1327,
     401,  1403,     0,  1305,  1306,  1307,  1289,  1296,  1308,  1301,
    1303,  1302,  1304,  1300,  1940,  1964,   872,   872,   872,   872,
     869,   870,   872,   872,   872,  2139,     0,     0,   851,     0,
     853,  1945,   872,   877,   456,   456,   456,     0,   876,   881,
     456,  1180,  1218,  1924,  1415,     0,   852,  1179,  2188,  1319,
       0,     0,     0,  1057,     0,  1058,     0,  2154,  1191,   230,
    2164,  2254,  2188,   229,   224,   225,   198,  1968,     0,     0,
     876,     0,  1188,  1189,   835,  1422,  1420,  1906,  1986,  1999,
    2084,   221,  2150,  2155,  2164,  2254,  2188,  2218,   177,   187,
     182,     0,   239,  2164,  2254,  2188,   235,  1209,     0,  1393,
    1508,  1915,     0,  1182,  1181,  1290,     0,  1293,     0,  1470,
    2135,  1397,  1399,  1295,  1390,     0,     0,     1,  1403,  1284,
    1419,  1419,     0,  1419,     0,  1382,  1390,  1385,  1389,     0,
       0,     0,     0,  1948,  2269,  2270,  2271,  2272,  2273,  2274,
    2275,  2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2290,     0,     0,  1925,  1949,
    1953,     0,   783,     0,   124,  1920,   921,     0,     0,     0,
       0,  1919,     0,     0,     0,     0,  1954,     0,  1942,  1955,
    1956,  1957,     0,  2056,     0,     0,     0,  1818,  1990,  2041,
    1828,  1826,  1827,  1820,  1821,  1822,  1823,  1824,  1825,     0,
    1038,  1819,     0,   146,   124,     0,     0,  2056,     0,     0,
       0,     0,     0,  2056,     0,     0,     0,     0,     0,   146,
    2087,   124,  2056,     0,     0,  1203,     0,     0,     0,  1205,
    1208,  1184,  1272,     0,  1915,     0,     0,   814,   804,     0,
     815,   805,   810,     0,   817,     0,     0,   807,     0,     0,
       0,   818,     0,   806,   808,   820,   809,   816,     0,     0,
     811,   812,     0,     0,  1195,   456,   349,     0,     0,     0,
       0,     0,   124,  1259,     0,  2056,   124,     0,     0,   399,
     398,   124,   397,   396,  1990,  2041,     0,   960,   124,  2056,
       0,   170,   619,   552,     0,     0,   697,  2087,   124,     0,
       0,     0,     0,     0,     0,   936,     0,     0,   536,   549,
    1331,  1329,     0,  1044,   223,   222,  1042,  2056,     0,   317,
       0,     0,  2056,  1246,   770,     0,   769,  2056,     0,  2056,
    1943,   161,     0,   767,  1990,  2041,  2056,     0,     0,  2056,
     153,  2056,     0,  2056,   317,  2056,   553,     0,  2056,     0,
    2056,  2087,   155,     0,  2056,   317,   781,     0,  1324,     0,
    1298,  2258,  1313,     0,  1309,  1316,  1312,  1403,   872,   871,
       0,   872,     0,   872,     0,   872,     0,   872,     0,     0,
       0,   872,  1946,  1947,   854,     0,   878,     0,     0,   885,
     884,   883,     0,     0,     0,   886,  1512,  1346,     0,  1177,
    1194,     0,     0,     0,   936,  1060,  1060,  1060,  1190,   228,
     226,     0,     0,     0,     0,     0,     0,  1196,     0,     0,
       0,     0,  1928,  1930,  1931,  1829,  1896,     0,  2223,  2224,
    2225,  1887,     0,  2226,  2227,  2228,  2271,  1737,  1724,  1733,
    1738,  1725,  1727,  1734,  2229,  2230,  2025,  2231,  2232,  1938,
    2233,  2234,  2236,  2237,  2238,  2239,  1729,  1731,  2240,  2241,
       0,  1939,  2243,  2244,  2108,  2246,  2247,  2249,  2250,  1735,
    2252,  2253,  2254,  2255,  2256,  2257,  1937,     0,  1736,  2259,
    2261,  2262,  2263,  2264,  2265,  2266,  2267,  2268,     0,     0,
    1912,     0,  1706,     0,  1552,  1553,  1575,  1576,  1554,  1581,
    1582,  1594,  1555,     0,  1911,  1619,  1786,  1705,  1720,  1711,
       0,  1704,  1700,  1405,  1905,  1907,     0,  1701,  1927,  1929,
    1888,   190,   241,     0,   242,  1913,  2164,   178,   220,   192,
     219,   193,   191,     0,  1988,   179,     0,     0,   180,     0,
       0,     0,     0,   238,   236,     0,  1185,     0,  1510,  1509,
       0,     0,  1894,  1916,   790,  1282,  1283,  1281,     0,  1278,
    1280,  1292,  1289,  1901,  1900,  1902,     0,  1398,     0,     0,
       0,  1380,  1379,     3,  1295,  1417,  1418,     0,     0,     0,
       0,     0,     0,     0,     0,  1460,  1433,  1434,  1436,  1457,
    1461,  1469,     0,  1386,     0,     0,  1514,     0,  1471,     0,
       0,  1926,     0,     0,     0,     0,   784,     0,     0,     0,
       0,     0,     0,   123,  1244,   232,  1242,     0,     0,     0,
       0,     0,     0,     0,  1251,     0,     0,   159,   160,   564,
     549,     0,  2056,     0,     0,     0,     0,  1000,  1007,     0,
       0,     0,     0,     0,     0,     0,  1001,   999,  1002,   234,
    1011,  1024,  1027,     0,   911,     0,     0,     0,     0,     0,
    1109,     0,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   255,   267,   312,   528,
       0,     0,     0,   531,     0,  2056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   128,     0,     0,     0,     0,
       0,     0,   515,   527,     0,     0,     0,     0,     0,   524,
       0,   124,   259,   508,   512,     0,     0,     0,   628,   627,
    1249,  1248,     0,     0,     0,  1109,     0,   251,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   335,   336,     0,     0,     0,   128,     0,
       0,     0,     0,   261,     0,     0,  1204,  1201,  1202,     0,
    1207,     0,  1268,     0,     0,     0,     0,   822,     0,   819,
       0,     0,   813,  1990,  2041,     0,     0,     0,     0,     0,
       0,   374,   348,     0,     0,   694,     0,     0,  1951,  1563,
    1592,  1570,  1592,  1592,  1559,  1559,  1572,  1560,  1561,  1599,
       0,  1592,  1559,  1564,     0,  1562,  1602,  1602,  1587,     0,
    1544,  1545,  1546,  1547,  1573,  1574,  1548,  1579,  1580,  1549,
    1616,  1559,  1952,     0,     0,   705,     0,  1221,  1258,     0,
       0,     0,   558,     0,  2056,     0,   126,   739,     0,   695,
     400,     0,   126,     0,     0,   164,     0,   623,     0,     0,
       0,     0,     0,     0,   643,   642,     0,     0,     0,   696,
       0,   126,     0,   511,  2056,     0,   456,   456,     0,     0,
     935,   938,     0,     0,     0,  1372,  1374,  1373,     0,  1371,
       0,   317,   315,   316,   692,  1052,     0,     0,     0,     0,
     317,     0,     0,  2056,   317,  2056,     0,  2056,     0,     0,
     317,   317,     0,     0,     0,     0,   624,     0,   780,   778,
     777,   779,     0,     0,     0,     0,     0,  2056,   317,     0,
       0,   761,  1839,     0,     0,  1403,     0,   209,   210,   208,
    1314,   211,  1315,  1311,  1297,     0,   862,     0,   866,     0,
     857,     0,   863,     0,   858,   855,   856,     0,   861,     0,
       0,   457,   459,     0,     0,  2010,  2024,     0,  2047,  2075,
    2076,  2155,  2160,     0,  2183,  2192,     0,   887,   916,   882,
       0,     0,  1356,  1178,  1845,     0,  1403,     0,     0,  1059,
    1056,  1055,  1054,   227,   199,     0,     0,     0,   918,  2154,
    1193,   834,   549,     0,  1702,     0,  1709,  1710,  1591,  1578,
    1886,     0,     0,  1586,  1585,     0,     0,     0,     0,     0,
    1568,  1567,  1566,  1708,  1853,     0,  1565,     0,     0,     0,
       0,  1592,  1592,  1590,  1639,     0,  1569,     0,     0,  1866,
       0,  1872,     0,     0,     0,  1598,     0,  1596,     0,     0,
    1675,     0,     0,     0,     0,     0,     0,     0,     0,  1623,
    1624,  1706,  1839,     0,  1707,  1934,     0,     0,  1584,     0,
    1616,  1910,  1829,     0,     0,     0,     0,  1899,     0,  1837,
       0,     0,  1653,  1835,     0,  1655,     0,     0,     0,  1828,
    1826,  1827,  1820,  1821,  1822,  1823,  1824,  1825,  1833,  1636,
       0,     0,  1788,     0,  1635,     0,  1473,     0,     0,  1932,
    1889,   243,   244,   240,     0,     0,   195,   194,     0,   213,
     217,   218,   189,   216,     0,   212,   197,  1777,  1776,   196,
     188,   185,   183,   200,   202,   203,   186,   184,   237,     0,
       0,  1958,  2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,
    2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,
    2309,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,
    2319,  2320,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,
    2329,  2330,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,
    2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,
    2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,  2367,  1891,
    1890,  1922,  1959,  1960,  1961,  1962,  1895,     0,     0,   317,
    1276,     0,  1273,  1904,     0,  1400,     0,  1917,     0,  1285,
    1396,  1395,  1426,  1427,   953,  1394,  1451,  1452,  1447,     0,
       0,     0,  1466,  1464,  1443,  1437,  1442,  1440,     0,  1444,
    1619,  1459,  1384,  1431,  1432,  1435,  1383,     0,  1462,     0,
    1356,  1460,  1436,  1343,     0,     0,  1515,     0,   975,   977,
       0,   976,     0,   979,     0,   988,     0,     0,   974,   993,
       0,   982,   980,     0,     0,     0,     0,     0,     0,   785,
       0,     0,     0,     0,     0,     0,  2183,   231,  1240,     0,
       0,     0,     0,   920,   919,     0,     0,   940,     0,     0,
       0,  1254,   445,     0,   314,     0,     0,     0,     0,     0,
       0,     0,     0,   690,   687,     0,     0,   686,     0,   562,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   598,     0,
    1109,     0,   631,     0,  1009,     0,  1008,     0,     0,     0,
    1010,  1005,  1006,  2155,  2164,  2188,   233,  1026,     0,  1025,
    1023,   963,     0,   964,     0,     0,     0,     0,     0,  2034,
     269,   282,     0,  1108,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   303,     0,   306,   305,     0,
       0,     0,     0,     0,   310,     0,     0,     0,   309,     0,
       0,   529,   530,     0,     0,     0,  1109,     0,   263,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,   149,     0,
     145,   148,     0,     0,     0,     0,   514,   526,     0,   518,
     519,   516,   520,   521,     0,     0,     0,     0,     0,     0,
     513,     0,     0,   621,   620,   626,     0,     0,     0,     0,
       0,     0,     0,     0,  1062,  1061,     0,     0,     0,     0,
       0,     0,   729,     0,     0,     0,     0,     0,     0,     0,
     152,   634,   635,     0,   636,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,   207,  1200,  1206,  1271,  1923,
    1270,     0,     0,     0,   821,     0,     0,     0,     0,     0,
       0,     0,   823,   824,   825,   826,     0,     0,     0,     0,
       0,   351,   352,   124,   350,  1951,     0,   718,   693,     0,
    1544,     0,  1540,  1536,  1605,  1606,  1607,  1604,  1617,  1603,
       0,  1550,  1608,  1559,  1556,   706,     0,   708,   711,     0,
    1219,   418,     0,     0,   555,   598,     0,   403,   157,     0,
       0,     0,     0,   122,   168,   170,   401,     0,   169,   171,
     173,   174,   175,   172,   176,   618,   622,     0,   551,     0,
       0,     0,     0,     0,   644,   648,   647,   651,   649,     0,
     645,     0,     0,  1532,     0,   144,     0,   507,   510,     0,
       0,     0,   403,   487,   328,     0,   456,     0,     0,   937,
       0,     0,     0,     0,     0,     0,     0,  1370,     0,  1030,
       0,  1247,  2056,   317,     0,  1028,   162,  1944,     0,   762,
       0,     0,     0,     0,     0,  1032,   758,   154,     0,   317,
     317,   554,     0,   317,   156,     0,     0,     0,   546,   317,
     782,  1326,     0,   456,  1299,  1310,   859,   868,   867,   865,
     864,   860,     0,   879,     0,   455,     0,     0,     0,   893,
     894,     0,     0,   892,   909,   895,     0,   897,   889,   888,
     898,   899,     0,     0,   918,     0,  1353,     0,  1351,     0,
    1513,  1355,  1344,  1318,     0,  1317,  1321,  1323,  1322,  1320,
       0,   501,     0,     0,   876,     0,     0,   317,  1192,     0,
     836,   837,   843,     0,     0,     0,     0,     0,   844,   840,
     841,   842,   845,   846,   847,     0,     0,     0,  1897,  1849,
       0,  1850,     0,     0,     0,  1885,  1881,     0,     0,     0,
       0,     0,     0,  1854,  1857,  1858,  1859,  1856,  1860,  1855,
       0,     0,  1861,     0,     0,     0,     0,     0,  1589,  1588,
       0,     0,     0,     0,     0,     0,     0,  1678,  1711,     0,
       0,  1813,     0,  1839,  1871,     0,     0,  1600,     0,     0,
       0,     0,     0,     0,     0,  1839,  1877,     0,     0,     0,
       0,  1775,     0,  1772,     0,     0,     0,     0,  1896,     0,
       0,     0,     0,  1935,  1620,  1637,  1909,     0,  1898,     0,
       0,  1621,  1644,     0,  1878,  1671,     0,  1676,  1659,     0,
    1652,     0,  1657,  1661,  1640,  1899,  1838,     0,  1836,     0,
       0,  1638,     0,  1633,  1631,  1632,  1625,  1626,  1627,  1628,
    1629,  1630,  1634,  1817,  1815,  1816,     0,     0,     0,  1796,
       0,     0,  1656,  2049,  2084,     0,  1416,  1416,  1416,  1404,
    1414,     0,  1527,  1908,     0,     0,     0,     0,  1712,     0,
    1843,  1425,  1841,  1925,  1914,     0,     0,  1616,     0,  1511,
    1892,     0,   788,   789,   787,  1295,  1279,  1275,  1274,  1903,
    1294,     0,  1403,     0,   951,   952,     0,   956,     0,     0,
    1445,  1467,     0,  1458,     0,  1449,  1450,  1441,  1468,  1463,
    1388,  1387,     0,  1530,     0,     0,  1340,  1333,  1516,     0,
    1473,  1358,  1360,  1361,     0,  1896,   978,     0,  1559,   989,
       0,   973,     0,   972,  1559,     0,   990,     0,  1559,     0,
       0,     0,  1137,  1064,  1113,   786,  1138,  1065,  1114,  1139,
    1066,  1241,     0,  1243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   669,  2056,
     317,  1252,  1140,     0,  1067,   313,  1253,  1115,  1257,   689,
     688,     0,     0,  1116,     0,   563,     0,     0,   568,   569,
     570,     0,     0,     0,   571,     0,  1990,  2041,     0,   576,
     583,   588,   578,     0,   589,   584,     0,     0,     0,     0,
       0,     0,   595,   602,     0,     0,     0,     0,     0,     0,
    1003,  1004,  1141,  1070,     0,  1117,   962,     0,  1071,   158,
       0,     0,   256,   270,   604,   669,  1111,   289,   302,   297,
     298,   296,  2056,   317,  2056,   317,     0,     0,     0,     0,
     299,   294,   295,   291,   304,  1967,  2026,  2165,     0,   608,
     610,     0,   615,   307,  1085,   324,   323,   322,     0,   311,
       0,   329,   332,   308,   287,   290,   288,   284,   268,     0,
       0,     0,     0,     0,     0,     0,  1921,     0,     0,  1034,
       0,     0,     0,   147,  1099,   137,     0,     0,   133,     0,
       0,     0,     0,   127,     0,  1147,  1075,     0,     0,   260,
     509,   517,   522,  1079,   525,  1127,   523,  1153,  1076,     0,
    1109,     0,   252,     0,  1077,     0,  1121,  1149,  1101,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1260,     0,
       0,     0,     0,     0,   317,     0,     0,     0,  1111,  2056,
     317,  1148,     0,  1106,  1135,     0,   337,     0,  1100,     0,
       0,   262,  1081,  1129,     0,     0,   205,   204,   206,     0,
       0,     0,     0,     0,     0,     0,     0,   828,   797,   827,
       0,     0,     0,   791,   373,   346,   347,   349,   356,     0,
     717,     0,     0,  1541,  1537,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1557,   707,     0,     0,     0,     0,
    1239,  1239,  1239,  1239,  1239,  1239,  1239,  1220,  1250,     0,
     124,     0,     0,     0,   557,   597,   604,     0,     0,     0,
     402,   406,   410,   411,   412,     0,     0,     0,     0,   138,
     125,     0,   747,     0,   456,     0,   170,   163,     0,     0,
       0,   328,   704,   702,   701,   703,     0,     0,     0,   722,
     700,     0,  1531,  1533,     0,     0,     0,     0,   501,   405,
       0,   459,     0,     0,   491,     0,     0,     0,   328,     0,
       0,   967,     0,   985,   968,     0,     0,     0,  1014,  1019,
    1015,   995,     0,   534,  1375,  1376,     0,   317,     0,     0,
     599,   317,   317,     0,   317,     0,   317,   317,     0,  1175,
     625,     0,   677,     0,     0,   317,   760,  1840,   880,   458,
       0,     0,     0,     0,   891,     0,   532,   896,     0,   908,
     903,   905,     0,   912,  1354,  1347,  1349,  1348,     0,     0,
    1345,  1846,   759,     0,   506,     0,     0,   317,     0,   913,
       0,   838,   839,     0,     0,   848,     0,     0,  1421,  1847,
    1848,     0,     0,     0,     0,  1882,     0,     0,  1750,     0,
    1726,  1728,  1558,  1740,     0,  1571,  1751,  1752,  1730,  1732,
       0,  1830,     0,     0,  1741,  1680,  1681,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1693,  1692,  1742,  1812,     0,     0,  1869,  1870,  1743,  1601,
    1602,  1602,     0,     0,  1876,     0,     0,     0,  1748,  1753,
       0,     0,     0,     0,  1759,     0,  1780,     0,     0,     0,
    1703,  1840,  1593,  1594,     0,     0,     0,     0,     0,     0,
       0,     0,  1677,  1660,  1654,     0,  1658,  1662,     0,     0,
       0,     0,  1646,  1672,  1642,     0,     0,  1648,     0,  1673,
       0,     0,     0,  1719,  1416,  1416,  1416,  1416,  1413,     0,
       0,     0,     0,  2152,     0,  1494,  1472,  1474,  1481,  1494,
    1499,  1721,  1525,  1722,     0,  1915,     0,  1454,  1425,  1425,
    1425,  1718,     0,     0,     0,  1424,   181,     0,   214,   201,
       0,  1277,  1918,     0,  1428,     0,  1831,   956,   954,   955,
    1430,     0,     0,  1465,  1438,  1342,     0,  1340,  1335,     0,
    1336,  1896,     0,  1332,  1365,     0,     0,  1530,     0,  1364,
       0,  1559,   970,   971,     0,   994,     0,  1136,  1063,  1112,
    1239,   923,   924,     0,   922,     0,     0,     0,   444,   939,
       0,     0,     0,   669,     0,     0,   448,     0,  1255,     0,
    1154,  1098,   565,   566,     0,   577,     0,   586,   585,     0,
       0,   573,     0,     0,     0,     0,   572,   591,   538,   592,
     594,     0,     0,   593,   596,   601,  1109,     0,   632,  1087,
       0,  1133,   997,     0,   965,     0,     0,     0,     0,   418,
     283,     0,     0,     0,   271,   281,     0,     0,   286,     0,
     279,   300,   292,   301,   293,   612,   613,   611,   607,     0,
     614,   616,     0,   326,     0,     0,     0,  1143,     0,  1109,
       0,   264,  1083,     0,  1131,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1144,  1118,     0,     0,
     130,   129,     0,   136,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   338,
     319,     0,   725,     0,     0,     0,   340,     0,     0,     0,
       0,  1142,  1072,   792,     0,     0,   793,   801,     0,     0,
     794,     0,     0,   803,     0,     0,   345,   353,  2108,  1820,
    1821,   715,   720,   712,   714,   716,   713,     0,   719,   669,
       0,     0,     0,  1542,     0,  1610,  1611,  1612,  1613,  1614,
    1615,     0,  1609,  1616,   709,   710,     0,  1239,  1238,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     430,     0,     0,   424,     0,     0,  1019,   417,   420,   421,
       0,     0,   558,   561,   559,   560,   590,     0,   437,     0,
       0,   140,     0,     0,   141,   139,     0,     0,   328,     0,
     166,   401,     0,     0,   550,   650,   653,   646,     0,   721,
     723,   698,     0,   604,     0,     0,  1327,   497,     0,   487,
     483,   485,   484,   486,     0,   493,   327,     0,   501,   493,
       0,   940,   966,     0,     0,     0,  1012,  1016,  1013,     0,
       0,   981,     0,   996,   959,  1170,  1171,  1168,  1169,     0,
       0,  1367,  1031,     0,   317,  1029,   763,     0,   754,     0,
     756,  1033,   317,   317,   637,     0,   547,     0,     0,     0,
     890,   910,     0,   906,     0,     0,   873,   915,  1352,  1350,
     499,     0,   918,     0,   874,   917,     0,     0,     0,     0,
       0,  1851,  1577,     0,  1884,  1880,     0,  1723,  1852,     0,
    1864,  1863,  1679,  1865,     0,  1698,     0,     0,  1690,  1688,
    1689,  1682,  1683,  1684,  1685,  1686,  1687,  1691,  1874,  1873,
    1867,  1868,  1597,  1595,     0,  1745,  1746,  1747,  1875,  1754,
       0,  1981,  1781,  1758,  1774,  1773,     0,     0,     0,  1761,
       0,     0,  1770,     0,  1814,  1583,  1616,  1622,     0,     0,
    1645,  1879,  1663,     0,     0,     0,  1641,     0,     0,     0,
       0,  1650,  1830,     0,     0,     0,     0,  1799,  1794,  1795,
       0,     0,     0,     0,  1407,  1406,  1412,  1494,  1499,     0,
    1390,     0,  1481,     0,  1493,  1479,  1492,     0,     0,  1505,
    1503,     0,  1505,     0,  1505,     0,  1476,     0,  1495,  1477,
    1492,  1524,  1517,     0,  1916,  1526,     0,  1456,     0,     0,
       0,     0,  1844,     0,  1842,  1713,     0,  1893,  1401,     0,
    1429,  1446,  1439,  2006,  1528,  1341,     0,     0,  1338,  1339,
       0,     0,  1359,  1340,  1362,   991,     0,     0,   983,     0,
     929,   930,   928,   931,     0,     0,     0,   669,     0,     0,
     464,     0,   947,   947,     0,     0,   450,   496,  1019,   672,
       0,     0,     0,   670,   317,  1068,     0,   587,     0,     0,
     582,   580,   579,   581,   539,  1152,  1069,     0,     0,     0,
       0,   998,     0,     0,  1086,     0,   415,     0,   276,  1110,
       0,     0,     0,   275,     0,   317,   317,   609,   325,   330,
     331,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   748,   731,     0,     0,   749,   750,
       0,     0,     0,  1036,  1037,  1035,   134,   131,   132,   135,
    1096,  1080,  1128,     0,     0,  1078,     0,  1122,  1093,  1089,
       0,     0,     0,     0,     0,  1151,  1105,  1126,  1150,  1103,
    1124,  1102,  1123,  1104,  1125,  1097,     0,  1535,   728,     0,
       0,     0,   317,   317,   639,  1082,  1130,     0,   795,     0,
       0,   796,   798,   376,     0,   379,   386,   357,   362,  1259,
       0,  1259,     0,   359,   363,  1259,   358,  1259,   355,   691,
       0,     0,     0,  1538,  1543,  1618,  1551,   668,     0,  1230,
    1229,  1228,  1232,  1231,  1234,  1233,  1225,  1224,  1237,  1236,
    1223,  1222,  1227,  1226,     0,   422,     0,   428,   432,   433,
     431,   423,  1019,   456,   495,     0,     0,   681,     0,   556,
     403,   434,     0,   407,   143,   142,     0,     0,     0,   170,
       0,     0,   655,   659,   699,     0,  1534,   633,   328,     0,
     403,   501,     0,   408,   413,   414,     0,   491,     0,   487,
       0,     0,   498,  1217,   502,   503,     0,     0,   969,   986,
     987,     0,     0,  1019,  1018,     0,   541,   317,   600,   317,
     317,  1176,   678,     0,   902,   901,   900,   533,     0,   904,
     500,   317,     0,     0,     0,     0,     0,   850,   829,   849,
    1883,  1739,  1749,  1862,     0,     0,  1699,     0,     0,  1744,
    2260,     0,     0,     0,     0,  1778,  1779,  1760,     0,  2099,
    1765,     0,     0,     0,  1936,  1669,  1667,  1664,     0,  1665,
       0,     0,  1647,  1643,     0,  1649,  1674,  1785,     0,  1801,
    1798,  1411,  1410,  1409,  1408,  1480,  1478,     0,  1483,  1490,
       0,  1475,     0,  1504,  1500,     0,  1501,     0,     0,  1502,
       0,     0,  1490,     0,  1425,     0,     0,  1790,  1716,  1717,
    1714,  1425,  1933,  1616,     0,     0,  1334,  1337,     0,  1366,
    1357,   984,   992,  1245,     0,     0,     0,   446,     0,  1019,
       0,     0,     0,   950,   950,     0,  1019,   495,   674,   673,
     676,   671,   675,  1256,     0,   574,   575,  1088,     0,  1134,
    1094,     0,  1356,     0,   605,   272,   273,   274,   277,   319,
     285,   278,     0,     0,     0,  1084,     0,  1132,  1091,  1145,
    1073,  1119,     0,     0,   737,     0,     0,     0,     0,  1146,
    1074,  1120,     0,  1356,     0,     0,     0,     0,  1265,     0,
     318,   727,   726,   319,   339,  1107,     0,   799,   800,   377,
     124,     0,   354,     0,   384,     0,   382,   381,   383,     0,
     370,     0,     0,     0,     0,     0,     0,  1539,     0,  1050,
    1050,     0,   669,  1235,     0,     0,   419,   495,   463,     0,
     425,     0,     0,     0,     0,     0,     0,     0,   604,     0,
       0,     0,   165,   403,   604,   654,     0,     0,     0,   724,
       0,   405,     0,  1325,   404,     0,     0,   493,     0,   491,
       0,   488,     0,   492,     0,  1210,     0,     0,  1017,     0,
    1021,     0,   980,   957,  1527,     0,   545,  1051,   755,   757,
     638,   907,   914,   317,   830,   831,   832,   833,  1694,     0,
       0,     0,     0,  1755,     0,  1756,  1783,  1782,  1762,  1766,
       0,  1763,  1764,  1666,  1670,  1668,  1651,  1787,     0,  1425,
    1520,     0,  1523,  1482,     0,     0,  1484,     0,     0,  1486,
    1488,     0,     0,     0,     0,     0,  1919,     0,  1453,  1455,
       0,  1391,     0,   215,  1832,  1529,  1363,   908,     0,   317,
     947,   495,   465,  2108,   466,   946,     0,   948,   953,   953,
       0,   495,   669,   567,     0,     0,   257,   603,     0,   321,
     333,     0,  1356,     0,     0,     0,   744,   732,     0,     0,
     751,     0,   253,  1090,     0,     0,     0,     0,     0,   317,
     802,   356,     0,   380,   389,     0,   387,   360,   365,     0,
     369,   367,   366,   361,   364,  1050,     0,  1047,  1046,   667,
       0,   454,   426,     0,   474,     0,     0,   682,     0,     0,
       0,   443,   442,   439,   438,   440,   441,   436,   435,   629,
     741,   328,  1217,   617,   656,   657,   652,     0,     0,     0,
     487,   483,   409,   418,   392,     0,   493,   489,   490,     0,
       0,     0,  1267,     0,   941,  1020,     0,     0,     0,   540,
       0,     0,   544,   535,   875,  1695,     0,  1696,     0,     0,
       0,  1768,  1767,     0,  1804,  1525,     0,     0,  1519,     0,
    1491,  1507,     0,  1487,  1485,  1496,     0,  1498,  1713,  1789,
    1791,     0,  1715,   925,     0,   926,   950,   469,     0,   949,
     956,   956,   456,   669,   447,  1095,     0,   606,     0,   280,
       0,   265,  1092,     0,   735,     0,   746,   744,     0,     0,
       0,  1261,     0,  1262,  1263,  1266,   341,   344,   375,   385,
       0,   368,  1045,  1049,  1048,     0,     0,   427,   460,   461,
     462,     0,   429,   470,   471,     0,   679,     0,   684,     0,
       0,     0,     0,     0,  1211,     0,     0,  1217,   491,   487,
     416,   482,   390,     0,  1214,     0,   328,     0,  1019,  1022,
    1174,   543,   542,  1697,  1771,  1757,  1784,  1769,  1800,     0,
       0,     0,  1518,  1521,     0,  1489,     0,  1497,     0,     0,
       0,   953,     0,   669,     0,   944,   943,   463,   449,  1356,
     320,     0,     0,     0,   742,   745,   733,   746,   753,   752,
    1356,     0,   388,     0,   453,     0,     0,     0,   472,     0,
     473,   494,     0,   683,     0,   604,   740,     0,     0,   658,
       0,  1212,   493,   491,  1215,  1216,   493,   942,   958,  1173,
    1172,  1403,  2222,  2006,  2194,     0,  1802,  1805,  1803,  1797,
       0,  1506,  1792,  1793,   317,   956,     0,   451,   467,   474,
     258,  1356,     0,     0,   734,   254,  1264,   659,   479,     0,
     478,     0,   476,   475,   680,   685,   630,   730,  1217,   662,
     393,   493,  1527,  1156,  1403,  1155,  1157,  1165,  1162,  1164,
    1163,  1161,     0,  1809,  1808,  1807,  1811,  1810,  1522,   927,
     945,     0,   669,   266,   736,   743,     0,   477,   481,   480,
    1213,   664,     0,   660,   663,   665,   666,   391,   932,     0,
    1166,  1160,  1390,  1377,     0,   468,   452,     0,   640,     0,
    1158,  1403,  1806,     0,   661,  1159,     0,   662,     0,   641
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4011, -4011, -4011,  2961, -4011,  -795,   410,  2318,  -875, -4011,
   -4011, -4011,  1123, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
    2894, -4011, -4011,  1504, -2085, -4011, -4011,   125,  2863, -1100,
     110,  2530,  1198, -4011,  -954, -4011, -4011,  -500,   151, -4011,
    2871,   573, -4011, -4011, -4011, -4011, -4011, -4011, -4011, -4011,
    -676,  1667,  1039,  -825, -2356, -4011, -4011, -1210, -2755, -4011,
     458, -4011, -4011,  1605, -4011, -4011, -4011,   899,   379,  -536,
   -4011, -4011, -4011, -4011, -4011, -4011, -4011,  -356, -4011, -4011,
    -671,   135,    45, -2082,  -401, -4011, -4011,   321,  -403, -1103,
   -4011, -3094, -4011,  -103, -4011, -4011, -4011,  -383, -1189,  1138,
   -4011,  -637,  -957,  1434,  -727, -4011,  -269, -4011,  -787,  -668,
    -670,  -738,  -562, -3271, -3660, -3291, -3053,  1146,   154, -4011,
   -2734,   156, -4011, -4011,   158,   159, -4011, -4011, -1295, -1226,
   -4011,  -766, -4011, -4011, -4011, -2532, -4011, -4011, -4011, -4011,
     101, -4011, -4011, -4011, -4011,   348, -4011, -4011, -4011, -4011,
   -4011, -4011, -2347,  1557,  1560, -4011, -4011, -2735, -4011,  -775,
   -4011,   494, -2583,  1058, -4011, -4011, -4011,  2271, -4011, -4011,
   -4011, -4011, -4011, -4011, -1378, -4011, -4011,   161, -4011,  1570,
     866, -4011, -4011, -4011,  -772,  -841,  -832, -4011, -2568, -4011,
   -4011, -4011, -4011,  -344, -4011, -4011, -4011, -4011, -4011, -4011,
    -846, -4011,   925, -2707, -4011, -4011,   941, -4011, -4011, -4011,
   -4011, -4011,  -724,  -281,  2298, -4011,  -611,  -700, -4011, -4011,
   -4011,  -280, -4011, -4011, -4011, -4011, -4011, -4011,  -908,  1279,
   -1345, -4011, -4011, -4011, -4011, -2028, -4011, -4011, -4011, -1684,
   -4011,  3725,  2016,  1673,   162, -4011,   -16,    82,  2748,  -966,
   -2247,   288,  -432, -4011, -1531, -4011, -4011, -4011, -2174, -4011,
   -4011, -4011, -4011, -3032,   165, -4011,  2754, -4011,   336, -4011,
   -3877, -3471, -3765, -3277, -3012, -4011, -4011,  -915, -4011, -4011,
   -4011, -1205,  1871, -1642, -4011, -1815,   339,  1212,  -814, -2366,
   -3285,  -603, -2804, -4011, -3189,  -534, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011,  -919,  -528, -4011, -4011,  3186, -4011, -3195,
   -4011, -4011, -4011, -4011,  1107, -4011, -4011, -1208,  1006, -4011,
   -4011, -4011, -4011, -4011,  -716,  -805, -4011, -4011, -4011,   167,
   -4011, -4011, -4011, -4011,  1896,  -797,  -617,  3063,   168, -4010,
   -4011, -4011, -4011, -4011, -2610, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -4011, -1809, -4011, -4011, -4011, -4011, -4011, -4011,
   -4011,  1941,  1943,    61,   -32, -4011, -4011, -1077, -4011,  -472,
   -4011,  2244, -4011, -4011, -4011, -4011,  1276,   169,   367, -4011,
       3, -4011, -4011,   172, -2953,     4, -4011, -4011, -4011, -4011,
   -1821,     5, -4011,   646, -4011, -4011, -2417, -4011,   170,    17,
   -4011, -4011,     1,     0,   -36,   -37,   -24,     2,  3074,  2609,
   -4011, -4011, -4011,    -1,  1729, -4011,  -710,  -139, -4011,  1281,
    -555,  1913,  2589,  2592, -4011,  1278, -4011, -4011,  1286, -4011,
   -4011, -4011,  -537,  1926, -4011,  2599, -4011, -4011, -4011,  1269,
    1280, -2924,   719, -2949, -2904,   239,   222, -1114,  -368,    41,
    3105,  2610,   729,  -501, -4011, -4011,  -499, -3936,   681, -4011,
   -3760, -1979,  -539,  1679, -1362, -4011, -4011,  -979, 11973, -4011,
   -4011, -4011, 12743, 13050, -4011, -4011, 13335, 13759, -4011,  -845,
     778, 14303, 12008, -1014, -1617, -1056, 11129, -1183,  -711, -2339,
   -4011, -3043, -2201, -4011, -4011, -4011,  -322,   791,   898, -4011,
   -4011, -4011, -4011, -4011, -4011,  -606, -4011,  -605, -4011, -4011,
   -4011,  -593, -3151, -1528, -4011,  -152, -4011, 11919,  1324, -4011,
    -905, -2352, -2355, -2906, -1507, -4011, -4011, -4011, -4011, -4011,
   -4011, -4011, -1275, -2840,  -448,  1394, -4011, -4011,  1487, -4011,
   -4011, -4011, -1118,  -734, -2255,  1399, -1726, -4011,  -712, -4011,
     703,  2129,  -663,  7344, -1123,  5861,  -437, -1942, -1052, -1301,
   -4011,  -141, -4011,    25,   -10,  -128,  -569,   -11,  3245,  6900,
    -558, -1106,  7978,  9694, 11152, -2680
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1224,  2168,  2040,  2849,  2850,
      53,    54,  1303,    55,    56,    57,    58,    59,    60,    61,
    1240,    62,    63,   900,  1455,  2178,    64,  1907,   699,   700,
     701,  1732,  1733,  2106,  1734,  1722,  1139,  1541,  1259,   674,
     675,  1226,  1260,    66,    67,  1133,  1713,    68,    69,    70,
    1286,  1287,  1234,  1494,  3747,  4349,  2679,  2018,  2886,  2680,
    2681,    71,  1353,  1354,    72,    73,  2797,  1393,  2133,  3316,
    3317,  3778,   529,  2130,  4050,  4051,  3764,  3765,  4057,  4235,
    4236,  2179,  1451,  2880,  3409,  2840,  3842,  2841,  3843,  2842,
    3844,  2828,  3367,  3368,  3369,  2843,  3821,  4267,  2844,  1922,
    4377,  2213,  1563,  1561,  4254,  3639,  3640,  4433,  4382,  4383,
    4384,  4512,  3849,  2884,  3415,  3852,  4080,  2578,   613,  1475,
    2954,   614,  2215,   560,   615,  2180,    79,  2207,  1323,  1324,
    2048,  3321,  2937,    80,   919,  3187,  4126,  4302,  4303,    81,
     208,    82,  1459,    83,    84,  2164,  2834,    85,  1939,  2595,
      86,    87,  2622,  2623,  2624,    88,    89,  3209,  4003,  1288,
    2668,  2669,  2670,  2671,  3230,    90,  1457,  1329,  2187,    91,
      92,    93,    94,    95,  2093,    96,    97,  2181,  1467,  2199,
    2200,  3833,  4096,  4276,  4098,  4552,  4553,  4072,  3166,  3653,
      99,   100,  3816,  3817,  4389,   101,  1937,   102,   103,   104,
    1435,  2156,  2157,  3322,  1395,  2136,  2137,  3398,  3399,   105,
    2757,   106,  3704,  3705,   561,  4392,  4356,  4446,   107,   108,
    3708,  3709,   109,   110,   111,   112,   113,   607,   965,   966,
    1216,   114,  1829,   115,   873,  2788,   116,  1030,  2336,  3888,
     117,   638,   979,   980,  2182,   119,   647,  2314,   649,  1576,
    2939,  2940,  3466,  2283,   784,   120,   121,  2294,  2317,   122,
    1227,  1913,  1914,  3634,  2183,   562,  1481,  2218,  2573,  4293,
    3641,  3983,  4198,  2507,  3120,   124,   563,  1264,  1982,  2221,
    2892,  1885,  1886,  1887,  3430,  1888,  2894,  1889,  1210,  1890,
    2899,  2900,  2901,  3426,  3434,  4120,  4121,   125,  1262,  1980,
     126,   127,   128,  1300,   809,   129,   575,   576,   130,  4247,
     131,   931,   132,   666,  1590,   133,   134,  1995,  3216,   135,
     136,   137,  4525,  4559,  4560,  4561,  3439,  4481,   138,  4527,
    1009,   140,   141,   142,   178,   839,   840,   841,  2184,  4115,
     144,   145,  2160,  2827,  3349,   146,   147,  1908,  2563,   148,
     149,   150,   151,  1439,   152,   153,   154,   155,  1372,   156,
    1168,  1169,   157,   158,   524,   717,  1172,  1180,   159,   617,
     973,   974,   975,  1543,   160,  1012,  2305,   618,   968,   162,
     619,  2526,  3129,  3130,  3133,   620,  2523,   165,  1582,  2299,
    2302,   621,  2530,  2531,  2532,  2533,  2534,  3135,   622,   640,
     922,  2226,   623,  1102,   170,   171,   172,   726,   721,   722,
     174,  1706,  2469,   655,  1187,   687,   734,  3105,  1842,  1843,
    1865,  1866,  1196,  1197,  1855,  1857,  2509,  1858,  2517,  1848,
    3597,  3957,  1861,  1862,  1199,  1200,  1201,  1870,   175,  2472,
    3086,  3087,  3088,  3574,  3575,  3589,  3585,  3944,  4169,  3089,
    1007,  1207,  3090,  4160,  4161,  4318,  3592,  3097,  3127,  2871,
    2872,  2873,  1891,  2143,  1420,  1103,  1421,  2154,  1104,  1626,
    1423,  1105,  1106,  1107,  1426,  1108,  1109,  1110,  1111,  1609,
    1668,  1112,  1113,  1645,  2151,  2152,  1532,  2376,  1115,  1116,
    1117,  3092,  1118,  3532,  3912,  3901,  2402,  2403,  1729,  3528,
    3032,  1702,  2459,  4181,  4329,  4330,  3073,  3558,  3929,  4159,
    4421,  4486,  4487,  1119,  2456,  1698,   811,  1120,  3324,  1700,
    2396,  2481,  2482,  1585,  1607,  2342,  2360,  2361,  2373,  2993,
    2380,  2385,  3016,  3017,  2397,  2425,  1121,  2345,  2346,  2976,
    1611,  1122,  1162,  1163,  1604,  2420,  1175,  1176,   719,  1123,
    1124,  1125,  1577,   710,  4165,   519,   774,  2695,  1820,   843,
     652,  1126,  1127,  1128,  1129,   940,   941,  1293,   520,   768,
     788,  2672,   521,   522,   770,  1825
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     169,   168,   173,   163,   164,   166,   577,   999,  1000,  1001,
     642,   530,   725,  1005,   653,   642,   925,   896,   679,  1305,
     169,  1540,   173,  1500,   518,   950,  1134,  1202,  1510,  1292,
    1208,   567,   735,  1211,  1504,   962,  1358,  2284,   766,  1921,
    1560,   810,   712,  1370,  1328,  1826,   641,   785,   724,  2519,
    1449,   641,  2140,  2413,   976,  1821,  1836,   559,  1983,  1597,
    1469,   787,  1533,  1396,   947,  2000,  2479,   814,  2957,  1647,
    2108,  2541,  2543,  2014,   923,  1620,  1621,  3210,   831,  1148,
    1991,   616,  3225,   709,  3227,  2839,  2153,  1437,  2697,  3193,
    2857,  1442,  2204,  1826,  1636,  3433,  1446,  2060,  2341,   882,
    2793,  3376,  2754,  1452,   648,  3610,  3394,  1839,  2499,  1821,
    3345,  2378,  3134,  1471,  1491,  3676,   680,  3642,   606,  3326,
    2943,  3100,  3098,  3099,  3636,  2378,   729,  2070,  3855,  1516,
    2074,  2075,  3091,  3419,   925,    74,   737,  3326,  3847,   970,
    1531,  3588,  1322,   673,  3407,  3863,   933,  2255,  1337,   738,
     706,    65,  3545,  3040,    75,  1976,    76,  1363,    77,    78,
    3571,    98,   118,  1899,   698,   123,  1990,   139,   143,   161,
     167,  3140,  3984,   736,  3615,  2462,  3510,  3814,  2208,  1195,
    2219,  1261,  1673,  3091,   624,  3586, -2043,  4107,  4298,   573,
     624,  4173,  1141,  4175,  1468, -2077,  1663,  1198,  1613,  1614,
   -1378, -1978, -2098,  1666, -1592, -1381,  1993,  1676,  2776,  1542,
     624,  3350,  3351,  3352,  3353,  3354,  3355,  1492, -1951,  4199,
    2086,  1237,  1289,   981,  1633,  2418, -1951,   624,  2852, -1818,
   -2125,  2081,  2453,  3424,  4355,   528, -1818,  1678,  1391,  2454,
    4294, -1587,   824,  1433,  2540,  1026,  2955,  1492,  1993, -2046,
    2001,  2418,   715,  1237,  2201,  1927,  2068, -1592,   624,  2997,
   -1952, -1926,  4394,  1492, -2274,  1993, -1559,  2295, -1952,   835,
    3093,   985, -2274,  2281, -1572, -1599,  3194,  2316,   573,  1993,
    3139,   573,   573, -1378, -1834,   916,   573,  1138, -1381,  2471,
   -1602, -1834,  2211,  3189, -1587,  2795,  1993,   573,   624,  2914,
    4378,  2916,  3839,  2211,  2685,   526,  1993,  3411, -1592,  2051,
    1923,   732,  4289,  3382,  1464,  2276,  3470,  1933,  2944,   732,
    4290,  3093,  1492,  1238,  4300,  4373,  2589,  1934,  2158,  4311,
   -1923,   685,  1385,  1846,  1465,  1191, -2097,  1924,   630,  4205,
    1419,  4221,  2948,  1711,  4350, -1602,  1035,   630,  2504,  2997,
    2765,  1370,  3982,   630,   630,  1238,  1348, -1378,   631,   836,
    -378,   523, -1381,  1191,  1719,  1289,   573,   631,  1664,  2749,
     624,  2120,   820,   631,   631,  1308,  -124,  4086,  2751,  1511,
    1723,  -124,   630,   525,  2296,  1735,  1735,  4471,  1035,   176,
     877,  2997,  1185,   810,     3,     4,  1710,   821,  2750,   573,
     837,   630,   631,  1647,  1193,   925,  1712,  2752,  1309,  2997,
     707,  2949,  2202,  4379,  4326,   891,  2604,   925,  4087,   898,
     660,   631,  1847,  3991,   686,  1620,  1621,  2505,  2121,  4261,
     908,   177,  1193,  1636,  1578,  1673,  2052,   928,  2053,  2997,
     810,  1194,  2279,   917,  1587,   573,  2285,   938,  2287,  4286,
     838,  2290,  1349,  1502,  3471,  1502,  3370,  1598,  1502,  3987,
    1676,  3383,  4374,  1528,  1720,  2115,  2119,  2974,  1935,  1493,
    1925,   925,  1584,  4455,  4291,  4301,  1827,  4262,  4380,  1964,
    1466,  2277,  2212,  1860,  4263,  1186,  2338,  1970,  3194,  2686,
    1678,   574,  3840,  4093,  2013,  3103,   797,  2626,   918,  1493,
    2282,  1936,  2796,  3598, -1378,  1544,  1580,  2777,  4550, -1381,
    2278,  4264,  4312,  2945,  1160,  1493,   874,  3190,  1161,  1165,
    2140,  1166,  2063,  1299,  2056,  2002,  2058,  1434,  3690,  1601,
    4477,  2999,  1265,  1004,  1004,   716,  2419,  2003,  1928,  2069,
    3629, -1818,  2087, -2097,  2455,  2046,  1826,  2548,  2049,  2050,
    2138,  1409,  2998,  3425,  2065,  3326,  2692,  1613,  1614,  1502,
    2111,  2297,  3060,  2203,   924,   577,  1633,  1962,  2524,  2416,
    3270,  4431,  2107,  2999,  1493,  1721,   725,  3136,  4109,  2298,
    2082,  1667,  1239,  4265,   977,   925,  4558,  3667,  2004,  1608,
    3000,  2999,  1826,   925,   925,  3646, -1834,  3694,  1203,  1434,
   -1378,  2590,  2272,  1697,  1369, -1381,  1530, -2097,   636,   637,
    3333,   169,   724,   173,   978,  2116,   983,  2508,   987,  3588,
    2028,  2259, -2097,  4077,   991, -2043,   872,    48,   636,   637,
    3159,  4049,  3000,  3828, -2077, -1592,  1502, -1378,  3918, -1378,
   -1978, -2098, -1381,  1717, -1381,  1290,  1291,  1871,  1010, -1951,
     641,  3893,   641,  3941,   641,   969,   994,  3945,  2280,  1979,
     641,   992,   993,  3935,  4490,  1872,  2229,  2291,  3837, -2125,
    3970,  1027, -1587,   972,  4123,  2235,   636,   637,  1131,  2239,
    3009,  1140,   924,  1142,  3854,  2245,  2246,  1642, -2046,   737,
    1160, -1952, -1926,  1608,  1161, -2274,  1006,  1619,  2337,  1828,
    2340,  3992,   738,  2258,  1374,  1625, -1599,  1643,   810,  1669,
    2348,  3465,  1708,  2486,  2352,  1380,   636,   637,  3371,  4336,
    1160,  1644,  2364,  2365,  1161,  3142,   736,  3143,   169,   168,
     173,   163,   164,   166,   568,  2382,  2384,  3788,  4472, -1592,
    3115,  2344,  1642,  3091,  4456,  3091,  2398,  1929,  3604,  4266,
    2720,  3303,  2627,  1006,  3306,  3307,  4508,  1342,  3310,  1167,
    2032,  3779,  1643,  1150,  3313,  3004,  3005,  3006,  3007,  3008,
    3009,  3390,  1223,  2035,  1581,  1482,  1646,  1170,  3627,   996,
    2131,  2132,  1206,  2545,    38,   782,  2368,  2369,  1290,  1291,
    4191,  2997,  2705,   887,  1821,  1343,   739,  4201,  3731,  -124,
    -124,  2946,  1228,  3001,  3002,  3003,   573,  3004,  3005,  3006,
    3007,  3008,  3009,  4521,    42,  1137,  4284,  1915,  2693,  1145,
     641,  3091,   935,  1460,  1243,  3004,  3005,  3006,  3007,  3008,
    3009,  4479,  2479,  2479,  2479,   573,  2112,  1581,   654,  1347,
    2214,  1378,  3308,  3309,  2739,  1348,  2378,  2378,  2555,  3810,
    2740,  2378,    46,  1694,  1695,  1696,  1697,  3006,  3007,  3008,
    3009,  1461,   573,    74,  2706,    47,  2353,  3248,   573,  2602,
    3108,  1367,  2195,   740,   662,  4248,  3618,  2831,  1976,    65,
    1930,  3093,    75,  3093,    76,  2643,    77,    78,  1917,    98,
     118,  2378,  2378,   123,  4162,   139,   143,   161,   167,  1924,
    2161,  2525,  4548,   176,  1229,  4068,  1918,  2682,  3866,  2288,
    2289,   800,   801,   802,  2707,   803,   804,   805,   806,   807,
     808,  4340,  4341,  3701,  1518,  1225,  2144,  1664,  2377,  2460,
     673,  1332,  2236,  4069,  4202,   997,  2122,  3642,  3182,  4509,
    -783,  1349,  2400,  2247, -1559,   177,  2741,  2877,  1344,  2196,
    3732,  4534,   663,   924,  2617,  2254,  4082,  2230,  1931,  3093,
    1003,  2354,  1519,  2144,  2546,   924,  2708,  2547,  3435,  3249,
    1151,  2617,  2675, -2275,  2123,   573,  3183,   169,   976,   173,
    3679,  2244,  2060,   569,  3323,  3811,   681,  1929,  3895,  4163,
    3896,   661,  4141,  2145,  4480,  4402,  2947,  1546,  1583,  1548,
     641,  1550,  3323,  1552,  2494,  1554,  1555,  1556,  4510,  4398,
     610,  4408,  1558,   730,  1462,  2893,   573, -1559,  4166,   924,
    1484,  3702,  2676,  4170,  4252,  1368,  4172,  2618,  2355,    14,
    2145,  4511,  3677,   570,  1152,  1919,  1345,  1606,   783,  2832,
    4549,  1004,  2787,  1909,  2618,  3436,   888,  -597,  1230,  1022,
    4372,  2146,  1215,  1910,  2147,  2461,  2829,  1623,  2709,  3433,
    2231,    19,  4083,  2264,   571,   725,   572,   741,  1911,  3977,
     176,  3260,   731,  3792,  3642,   936,  2310,  1605,  4535,    48,
    1673,  1231,  3431,  4100,  1915,  1350,  2356,  1650,  2146,  2357,
    2742,  2147,  4004,  1665,  1379,  2564,  3706,  3205,  3887,  2435,
    1916,  1661,  1463,  1670,  3338,  1676,  2677,  4103,   684,  2371,
    1232,  3703,   177,  3250,  3794,  1520,  1709,  2833,  1351,  3897,
    3680,  2171,  2603,  2743,   573,   664,   665,  2124,  4473,  3184,
    2197,  1920,    38,   924,  2414,  1678,  1725,  1726,  4337,   732,
    1832,   924,   924,  2198, -2184,  2148,  3251,  1352,  4343,   810,
    1840,  1841,  2744,  1845,  4495,  1917,  4334,  1502,  3335,  2934,
    3206,  2710,    42,   738,   738,  2713,   738,  2565,  1233,  2711,
   -1559,   641,  2712,  1918,  2814,  3252,   641,   641,  2621,  3437,
    2358,  4520,  2148,  2176,  3211,  4522,  2617,   736,   736,  4400,
     736,  2995,  2996,  3141,  3707,  2621,  3011,  3356,  2148,  2548,
      46,  4443,  1912,  1521,  3969,   727,  2518,  3004,  3005,  3006,
    3007,  3008,  3009,    47,  2576,  2125,  3336,  3185,   718,  4478,
      30,  2713,  3796,  3681,  2172,  2436,  3682, -2184,  2094,  2437,
    4557,  2748,  3579,  2745,  4306,  1849,  3046,  3047,  3091,  3438,
    3359,  3954,  3091,  3604,  2149,  1206,    38,  4323,  3961,    48,
    2678,   542,  2051,  1485,  2293,    38,   733,  2177,  1971,  2618,
    3580,  4444, -2275,  2426,  2150,  2427,  2746,  2438,  4110,  2577,
     641,   835,  1850,  4162, -2184,  3947,    42,  3758,   641,  2359,
    4111,  2149,  2721,  3761,  3762,    42, -2184,  3582,  2428,  2619,
    2724, -2184,  2726,  3030,  1502,  2747, -2184,  2630,  3881,  3037,
    3630, -2184,  1919,  1486, -2184,  4210, -2184,  3268,  4353,   544,
    2148,  2642,  4358,  4359,    46,   992,   993,  2064,  1279,  2911,
    2013,   728,  2620,    46,  1851,  2917,  2175,    47,  4435,  4436,
    2912,  4532,  3326, -2184,  2006,   742,   641, -1559,  2798,   641,
     641,  1957,  2094,  1972,  2862,  2863,  2864,  2865, -1559,  2228,
    1619, -1559,  1215,  4269, -1559, -2184,  2870,   810,  2234,  4273,
    2819,   836,   776,    48,  3642,  3212,  1852,  3692,  1035,  2719,
    3269,  2997,    48,  4075,  2237,  2067,  3093,   835,  3363,  2052,
    3093,  2053,  2631,  2134,  2429,   778,  3584,  2439,  3538,  2430,
    3213,  2732, -2184,  1487,  2431,  3808,  1302,  2094,  1920,  3988,
   -2184,  1302,   837,  1849,  3461,  1434,   641,  1151,  2910,  2820,
    2621,   542,  3624,  4572,  2907,  3364,  2639,  1853,  3111,  2103,
    3323,  2608,  2771,  3836,  2919,  2920,  4225,   785,  2922,  3365,
    3693,  2104,  3204,   573,  2926,  4112,  2572,   624,  2972,  1535,
    1850,  3235,  1536,  1488,  3154,   796,  2185,   551, -2184,   552,
    3464,   826,   838,  2644,  1225,  2105,  3236,  1225,  3809,   771,
     773,  2479,  3989,   777,  3481,   779,  3631,   836,  2560,   544,
    2378,  1152,  1450,  2378,  2378,  2378,  2378,  2378,  2378,  2378,
    2378,  2378,  2378,  4540,   828,   810,  1022,  3024,  2821,  2822,
    3465,  -940,  2959,   654,  2060,  3632,  1692,  1693,  1694,  1695,
    1696,  1697,  2823,  2378,  4250,  3869,  1225,  3870,   837,  1997,
    1225,  3366,   909,  2432,  3633,  1212,  4393, -2184,  3049,   795,
    2936,  1304,  3271,  2433,  1489,  -146,  1357,  4226,  1631,  1632,
    -146,  3789,  2378,  2378,  1852,   169,  3051,   173,  3052,  1338,
    1673, -2184,   910, -2184, -2184,  -401,  3455,  4274,  1213,  2824,
    -146,   876,  3649,  2999,   909,  -146,  1663,  3649,   838,  1220,
    1998,  3053,  2266,  1279,  2267,  1676,  2268,  2501,  2269,  2814,
    2270,   911,  1339,  1325,  2271,  4275,  1340,  1214, -2184,  2888,
    2313, -2184, -2184, -2184,   910,  1853,   169,  2309,   173,  2306,
    2307,  2308,  1221,  4299,  4375,  1678,    33,   972,  3091,  2703,
    4224,  1341,  2805,  3091,  3433,  1147,  1326,   551,  3091,   552,
      27,  3091,  3000,  3392,  2362,   912,  1217,     3,     4,  2656,
    3165,  1222,  2300,   834,  1223,  4347,  3650,  3578,  1191,  1223,
      38,  3650,  1450,  1192,  4344,  4133,  2825,  1727,  2826,  2658,
    2501,  3091,  2350,  2351,  2033,  1673,  2101,  4419,  -401,  1218,
    2363,  4476,  2576,  4209,  2366,  2367,  4062,   912,  1993,   879,
      42,  4063,  3054,  2377,  2377,   925,  1994,  3055,  2377,  2388,
    2657,  2389,  3412,  4420,   610,  3416,  1728,  2312,  1219,  2102,
    2424,  3651,  1035,  3652,  1143,  2997,  3651,  4229,  3652,  3181,
    2659,    38,  2411,    14,  2412,  1223,  3579,  1193,    46,   925,
    1678,  1327,  3539,  2335,  4064,  1715,  2034,  3162,  2377,  2377,
    2158,    47,    33,   881,  2487,  1893,  3995,  3996,  3491,  2057,
    1311,    42,  1735,  2903,  3580,    19,  3786,  4187,   884,  4189,
    4516,  4047,  4048,  3494,  1194,  3495,  3093,  2037,  4085,  3581,
     897,  3093,  3511,  1525,  4092, -1424,  3093,    48,  1894,  3093,
   -1424,  3582,  3337,  3339,  3340,  3168,  2015,  2925,  4102,    46,
    1642,  1642,   535,  1526,   904,  2951,  1312,  3245,  2552,  4412,
    -504,  3104,    47,  2556,  3583,  4438,  2559,  1895,  3091,  3093,
    1643,  1643,  3173,  3001,  3002,  3003,  3056,  3004,  3005,  3006,
    3007,  3008,  3009,  4167,  1644,  1646,  3057,   810,  2582,  2596,
    3246,   542,  2515,  2516,  1993,  2016,   785,  2017,    48, -1167,
    3460, -1167,  1999,   880, -1424,  3493,  2071,   883,  3498,  3499,
    3500,  3501,  3502,  3503,  3504,  3505,  3506,  3507,  3218,  3247,
    3220,  2378,  3091,   913,   906,  1035,  2015,  2510,  2997,  2632,
     630,  2013,   542,  3664,  1035,  1313,   889,  2997,   890,  3195,
    3584, -1424,  1642,  2015,  3496,  3920,  2638, -1448, -1448,   544,
     631,  -934,  2173,  3647,  3497,  4497,  -505,  2999,  3106,  3733,
    3749,  3215,  1643,   641,   169,  2527,  2038,  3547,  3548,  2041,
     914,  2205,  2673,  2100,    30,  2016,   892,  2017,   893,  3734,
    3750,   730,  1170,  1314,  2566,  1315,  2569,  1619,   915,  1215,
     544,   209,  2016, -1425,  2017,  2059,   527,   934, -1425,  3395,
      38,  2704,  3066,  1160,   608,  2715,  3093,  1161,  3404,  3914,
    2015,  2013,  2338,  2224,  4168,  2225,  3000,  3524,  2090,  3289,
     925,   682,  2097,  2727,  1317,  3296,  1830,  1306,  2013,  1831,
      42,  2858,  2021,  3023,  2737,  3025,  3026,   624,  3767,  3198,
     731,  2479,  1355,  2022,  1359,   930,  2479,  2761,   624,   942,
    4059,  2479,  4061,  1142,  4523,    27,  4065,  2768,  4066,  2016,
    3093,  2017, -1425,  1319,  4566,  2867,  3146,  3091,    46, -2186,
    2868,  1619,   611,  1900,  1035,   943,  2628,  2997,  3668,  3768,
    3473,    47,  1619,  2969,  1900,  3151,  3152,   551,  2262,   552,
    2625,   948,  3678,  3683,  3921,  2013,  3512,  3513,  1321, -1425,
    2378,  2378,  1160,  3769, -1926,  3241,  1161,   732,  4230,  3626,
    2999,  2338,   557,  2015,  1619,  3346,  1900,   612,  3770,  2999,
    2868,  3695,  3771,   957,  2970,  3372,   925,   639,   551,  2971,
     552,  1833,   639,  2882,  1834,  2883,    38,  2261,  3477,   554,
    2262,  2273,  3772,  2275,  2274,  3773,  2274,  3074,  3174,  3075,
     556,  2303, -2186,  1450,  2304,   963,  2500,  3774,  3091,  2501,
    2694,   967,  2016,   641,  2017,   624,    42,  1297,  1298,  3000,
     998,   641,  3442,   641,  3118,  3119,  3445,  3446,  3000,  3448,
    2636,  3450,  3451,  2637,  3172,  1002,  1008,  3001,  3002,  3003,
    3456,  3004,  3005,  3006,  3007,  3008,  3009,  2015,  2013, -2186,
    2789,  1011,  1013,  2699,    46,  3093,  2700,  2800,  2789,  1014,
    2801, -2186,  3518,  1591,  1592,  3578, -2186,    47,  2682,  1019,
    3691, -2186,  3474,  1020,   733,  2815, -2186,  2928,  2816, -2186,
    2274, -2186,  3263,  1021,  1022,  3775,  3476,  4270,  3267,  1025,
    1023,  2968,  1390,  3776,  2262,  1024,  2016,  2978,  2017,  3253,
    2262,  3255,  2814,  4524,  2941,  1028,  1029,  2982, -2186,  2999,
    2262,  3913,  1146,  1447,  1448,  2813,  3807,  2986,  2960,  2861,
    2262,  4206,  1031,  4494,  2963,  2015,  2987,  2941,  3777,  2262,
   -2186,  1153,  2013,  1479,  3579,  1149,  1154,  3323,  3478,  4134,
    4135,  4136,  4137,  1155,  3644,  3645,  3093,  2889,  1159,  3766,
     169,  2878,  4222,   924,  1171,  1189,  3290,  3388,  2893,  3845,
    4119,  2859,  3580,  1506,  1508,  1178,  3013, -2186,  3000,  2262,
    3029,  1179,  1209,  2262,  2016, -2186,  2017,  3581,  1181,  3034,
    3228,  3304,  3035,  3229,  3076,  3233,  3077,   924,  3234,  3582,
    3001,  3002,  3003,  1182,  3004,  3005,  3006,  3007,  3008,  3009,
   -2275, -2275,  1204,  3004,  3005,  3006,  3007,  3008,  3009,  3781,
    2013,  3782,  3583,   925,  3422,   925,  3381,  3423,  3384,  3482,
    1205,  1215,  2262, -2186, -2199,  1236,  3519,  2377,   810,  3520,
    2377,  2377,  2377,  2377,  2377,  2377,  2377,  2377,  2377,  2377,
     982,   984,   986,  1263,  4295,   988,   989,   990,  2705,  1370,
    3529,   641,  1241,  3530,  3541,   995,  3616,  2262,  3620,  3617,
    3522,  3621,  3625,  3272,  2845,  2547,  3648,  1267,   654,  2274,
    3094,  3373,  1268,  3375,  3874,  3875,  3876,  3838,   925,  1299,
    2274,  1035,  2644,  4570,  2997,  4571,  4183,  3300,  3584,  2377,
    2377,  1181, -2186, -1378,  3116,  3915,  3916,  1301,  1302,  3919,
    2015,  3594,  2304,  1307,  1310,  3669,  2378, -2199,  3972,  3443,
    3979,  2547,  1333,  3980,  3985,  2378, -2186,  2274, -2186, -2186,
    2706,  3094,  3986,  1334,  2015,  2274,  3472,   725,  3599,  3600,
    3601,  4351,  2378,  2378,  4052,  4104,  3428,  4053,  4105,  3001,
    3002,  3003,  2015,  3004,  3005,  3006,  3007,  3008,  3009,  2016,
    1346,  2017,  4143, -2186, -2199,  4144, -2186, -2186, -2186,  4145,
    1356,  3147,  2262,  1661,  4153,  4207, -2199,  2304,  4208,  4271,
    2707, -2199,  2274,  2016,  1360,  2017, -2199,  2424,  3486,  1365,
    4296, -2199,  3696,  4297, -2199,  2013, -2199,  4307,  1366,  4315,
    2304,  2016,  4316,  2017,  4320,  1371,  3069,  2501,  3492,  1673,
    1188,  4325,  1190,  3170,  3402,  3079,  3080,  3081,  3946,  2013,
    3949,  3085,  4327, -2199,  1373,  3402,  1826,  2846,   924,  2015,
    1375,  1377,  2708,  3514,  1676,  4369,  1381,  2013,  4370,   725,
    4401,  4406,  2319,  1714,  4407, -2199,  4413,  1387,  4414,  2304,
    2338,  3035,   169,  2309,   173,  2306,  2307,  2308,  1382,  4415,
    1389,  3107,  2262,   641,  1678,  4425,  1392,  4427,  2501,  1584,
    3402,  4442,  3085,  3754,  2304,   724,  2999,  1397,  2016,  1394,
    2017,  4448, -2199,  4449,  2304,  4463,  2304,  4245,  4464,  2320,
   -2199,  4491,  4538,  1672,  2501,  3402,  1673,  1223,  4568,  4579,
    1244,  4569,  4569,  2404,  1438,  1441,  2407,  2008,  1443,  1434,
    1453,  3237,  1454,  1674,  2013,  -167,  1456,  1458,  2321,  1470,
    1472,  1676,  1478,  3256,  2709,  1480,   194,  1677,  1490,  1495,
    1496,  1497,  1245,  1502,   924,  3000,  3864,  1498, -2199,  2322,
    1499,  1501,  1509,  1512,  1513,  1514,  1515,  1517,  1522,  1523,
    2323,  1678,  1534,  1524,  1529,  1559,  1586,  4035,  4036,  1593,
    4038,  2378,  1589,  2847,  1602,  3902,  1603,  1595,  4500,  3868,
    2324,  2076,  2077,  2078,  2079,  2325,  1596,  3871,  3872,  4505,
   -1563, -1570,  1612,   654,  1616,  1615,  1622,  1617,  1246,  1618,
      48,  1681,  1682,  1624,  1627, -1560,  3301,  3116,  2377, -1561,
    1628,  1545,  2848,  1629,  1547,  4119,  1549, -2199,  1551,  1630,
    1553,  3231,  2117,  2118,  1557,  3116, -1564,  1635,  2127, -1562,
    1247,  2326,  1637,  1638,  1639,  1640,  1641,  2710,  1648,  1649,
    4543, -2199,  1651, -2199, -2199,  2711,  1652,  1685,  2712,  1701,
    1653,  1654,  2327,  1655,  1656,  1657,  3877,  1658,  1703,  3261,
    1705,  1718,  1707,  1679,  1714,  1730,  1248,  1680,  1738,  1838,
    1192,  4138,  2155,  1194,  1867,  1877,  1896,  1897, -2199,  1869,
    1898, -2199, -2199, -2199,  1900,  1901,  1902,  1903,  1681,  1682,
    1904,  1905,  1926,  1932,  1938,  1959,  1249,  4154,  4155,  2190,
    2191,  2192,  2193,  3356,  1963,  1683,  1965,  3292,  1966,  3357,
    1672,  1967,   194,  1673,  1968,  1969,  3001,  3002,  3003,  3358,
    3004,  3005,  3006,  3007,  3008,  3009,  1984,  1985,  1986,  2789,
    1674,  1684,  2789,  2789,  1685,  1996,  2789,  2007,  1676,  2328,
    2006,  2012,  2789,  2009,  1677,  2329,  3359,  1686,  3360,  3325,
    1687,  2330,  2010,  2249,   785,  2011,  2094,  2013,  2019,  2020,
    2023,    33,  2253,  1977,  2024,  1252,  2025,  3325,  1678,  2260,
    3463,  1253,  4056,  3824,  3825,  2029,  2030,  2036,  1254,  2039,
    2331,   924,  2332,   924,   641,  2043,  1978,  2377,  2377,  3993,
    3475,  3332,  3334,  2044,  2047,  1256,  3341,  2054,  1279,  2333,
    2055,  2061,   641,  1257,  2062,  2072,  2066,  3826,  2073,  2083,
    2084,  2085,  2088,  2114,  2089,  2095,  2099,  2113,  2126,  3400,
    4010,  4011,  3361,  2139,  2334,  1688,  2128,  1608,  1619,  2141,
    4090,  2142,  2129,  3385,  1625,  1692,  1693,  1694,  1695,  1696,
    1697,  2159,  2163,  2162,  2166,  3427,   924,   169,  3418,  2167,
     537,  2170,  2174,  1327,  2189,  1258, -1390,  2194,  2209,  2210,
    2217,  2222,  2223,  2227,  2238,  2240,   169,  3441, -1390,  1211,
    1679,  2220,  2242, -1390,  1680,  2241,  3845,  2256,  2243,  3362,
    2257,  2286,  2301,  2292,  3363,  2315,  2343,  4044,  4045,  2344,
    2386,  3555,  2399,  2387,  2349,  1681,  1682,  2405,  1673,  2410,
    2417,  3094,  2423,  3094,  2409,  2442,  1672,  3766,  2440,  1673,
    2457,  2458,  1683,  2471,  2485, -1390,  4305,  2421,  1689,  1690,
    1691,  3364,  1692,  1693,  1694,  1695,  1696,  1697,  2488,  2489,
    2490,  2492,  2493,   731,  1676,  3365,  2491, -1390,  1684,  2502,
    1677,  1685,  2511,  2513,  2503,  2512,  2514,  2522,  2536,   641,
    2537,  2539,  2562,  2549,  1686,  2550,  2570,  1687,  2551,  2567,
    4058,  2572,  2581,  2586,  1678,  1584,  2574,  2575,  2591,  2592,
    2597,  2594,  2613,  2616, -1390,  2605,  2601,  2629,  2634,  3094,
    1143,  1147, -1390,  2684,  2689,  2690,  2701,  2698,  2702,  2756,
    2714,  2753,   725,  2767,  3536,  2778,  2779,  2780,  2774,  2775,
    2782,  4319,  4127,  2783,  4128,  4129,  2786,  2784,   725,  2785,
    4178,  4319,  2792,  2794,  2799,  2803,  4132,  3366,  2806,  2808,
    2809,  2807,  2817,  3665,  2810,  2811,  2812,  2837,  1661,  2851,
    2860,  2866,  1688,  3560,  3561,  3562,  3563,  2869,  2874,  2853,
    2876,  3964,  3567,  3116,  3570,  2887,  2890,  2885,  2904,  2902,
    2905,  2875,  2908,  2906,  2909,  2918,  2921,  2924,  2923,  2501,
    2930,  4234,  2931,  4001,  2942,  4365,  4240,  4242,  2932,  1530,
    1680,  2316,  2933,  2950,  2956,  2935,  2953,  3994,  2958,  2961,
    2962,  1004,  2964,  2984,  2965,  3031,  2980,  2981,  2966,  2983,
    2985,  1681,  1682,  3019,  2988,  2989,  2991,  3050,  3065, -1390,
    3072,  3102,  2262,  2994,  3045,  4009,  -980,  3096,  3012,  3018,
    3735,  3123,  3128,  3738,  4032,  3020,  3021,  3126,  3028,  3132,
    3043,  3044,  3101,  3058,  4024,  1689,  1690,  1691,  3138,  1692,
    1693,  1694,  1695,  1696,  1697,  3068,  4078,  1685,  3144,  3070,
    3071,  3150,  2990,  2377,  3153,  3156,  3155,  3160,  3161,  3164,
    1686,  3167,  4146,  3169,  3191,  3176,  3192,  3203,  3202,  4426,
    1160,  3207,  3208,  1181,  1161,  3232,  3217,  3219,   925,  2377,
    2377,  3258,  4043,  3259,  3275,  3265,  3262,  3266,  3264,  3273,
    3276,  2598,  2599,  2600,  3274,  3325,  3277,  3280,  3278,  3283,
    2610,  3279,  2612,  3281,  2614,  2615,  3293,  3282,  3284,  4309,
    3286,  3288,  3295,  3297,  4177,  3285,  3291,  3716,  2081,  3717,
    3299,  4182,  3718,  3287,  3719,  4231,  4186,  3305,  3311,  3312,
     641,  3829,  3315,  3327,  3330,  3331,  2148,   650,   651,  3342,
    3343,  3347,   657,  3386,  3348,  3389,  3391,   668,   676,   650,
    2895,   683,  4371,   641,   676,   676,  3379,   711,  3380,   714,
    3393,  3401,  3402,  3413,  3417,  2789,  3414,  4357,  3440,  1244,
    4354,  2789,  2789,  3408,  2134,  3457,  3447,  3458,  4304,  3468,
    3410,  3420,  3459,  3469,  3480,  3462,  4361,  1605,  4363,  3485,
    3467,  3449,  3015,  2997,  3014,  1666,  3515,  3516,  3591,  3517,
    3523,  1245,  3544,  2722,  3543,  3531,  3552,  2941,   732,  3791,
    3793,  3795,  3797,  3569,   992,   993,  3577,  3593,  3556,  3596,
    3612,  3605,  3628,  3606,  3609,  3780,  3608,  3635,  3656,  1584,
    3658,  3659,  3670,  3672,  4335,  1692,  1693,  1694,  1695,  1696,
    1697,  3671,  3673,  3675,  3790,  3697,  3684,  3698,  3699,  3710,
    3723,  3711,  3700,  3712,  3724,  3730,  3746,  1246,  3748,  3679,
    3759,  3713,  2781,  3760,  3714,  3715,  3751,  3757,  3783,  3784,
    2790,  3812,  3785,  2895,  4366,  2791,  3815,  3822,  4418,  3804,
    3856,  3432,  3820,  4556,  3827,  2274,  4234,   169,  3853,  1247,
    3832,  3831,  1244,  3834,   767,   772,   772,   775,  2377,   772,
    3835,   781,  3848,   767,  3850,   711,  3094,  3851,   812,  3861,
    3094,  3862,  3865,   711,  4211,  4285,   711,  3878,  2896,  4314,
     772,  3880,   711,  4194,  1245,  1248,  3882,   810,  3873,  3883,
    3867,  3884,  3885,  4556,  3886,  3894,  3891,  3898,  3904,  3899,
    3889,  4556,  3903,  3905,  3906,  3907,  3911,  3927,  3937,  3942,
    3943,  3950,  3938,  3940,  3953,  1249,  1672,   641,  3955,  1673,
    2879,  3956,  3958,  3965,  3959,  4216,  3960,   925,  3974,  3971,
    3968,  3976,  3981,  3982,  4012,  3990,  1674,  4013,  4014,  4034,
    1246,  4005,  4039,  4006,  1676,  4046,  4070,  4071,  4025,  2913,
    1677,  2915,  4079,  4067,  4084,  4089,  4091,  4028,  4095,  4106,
    4097,  4108,  4114,  4116,  4117,  4131,  4125,  4139,  4149,  4140,
    4142,  4147,  1247,  4150,  1678,  4151,  4152,  4158,  4164,  4171,
      33,  4174,  4180,  4184,  1252,  4188,  4200,  4203,  4204,  4218,
    1253,  4213,  4219,  4227,  4228,  4232,  4239,  1254,  4246,  4255,
    4019,  2896,  3811,  4258,  4253,  1978,  4256,  3085,  1248,  4259,
    4278,  3085,  4029,  4260,  1256,  4277,  4279,  4544,  4281,  4283,
    4287,  4310,  1257,  4313,  4317,  3962,  3963,  4288,  4322,  4346,
    4338,  1584,  4328,  4332,  4348,  4376,  4360,  4381,  1249,  4385,
    4386,  4388,  4390,  4391,  4403,  2967,   169,  3966,  3973,  3975,
    4396,  4404,  4405,  4410,  4411,  4416,  4417,  4428,  4424,  4429,
    4432,  4430,  4441,  4445,  4355,  4451,  4453,  3290,  4454,  4457,
    4459,  4462,  4467,  4468,  1258,  4474,  1679,  4503,  2898,  3432,
    1680,  4475,  4489,  3557,   641,  4496,  4507,  4498,  4455,  4514,
    4515,  4519,  4547,  4456,  4564,  4567,  4573,  4577,  4533,  4539,
    4007,  1681,  1682,    33,  4081,  1584,  2096,  2897,  2855,  1584,
    1584,  1266,  1737,  1253,  1331,  3214,  3109,  2688,  1683,  1183,
    1254,  1330,  3689,  3763,  2766,  4367,  3314,  4233,  1978,  4452,
    4280,  3823,  4282,  4076,  4268,  4437,   641,  1256,  2929,  3158,
    4499,  4192,  4542,  4458,  1684,  1257,  4460,  1685,  4513,  4399,
    3819,  3163,  2835,  3687,  3226,  2836,  4022,  4023,  2186,  2818,
    1686,  4026,  4027,  1687,  3397,  4546,  4578,  4574,  4257,  4041,
    4042,  3344,  3328,  4517,  4217,  2169,  4447,  4504,  4220,  2789,
    2789,   656,  1579,  3879,  2941,  4333,   924,  3857,  2542,  3145,
    4060,   926,  3858,  4409,  3294,  4526,  4575,  1258,  1588,   844,
    1156,  2898,  2496,  3841,   711,  2497,   767,  4073,  3113,   772,
    2265,   775,  3622,   772,  3114,  2521,  1864,  1835,  1863,  3967,
     812,   641,  3124,   901,  1177,  3122,  3094,  2520,  1868,  3137,
     772,  3094,  3125,  3572,  4324,  3948,  3094,  3936,  1688,  3094,
    4434,  3568,   925,   641,  1873,  4423,  4422,  1164,  3623,  2804,
    4308,  3535,  4492,   767,  4493,  4099,  3525,  4488,   775,   810,
    3117,  3063,  2975,   767,  3061,  3619,  2473,   812,     0,  3094,
       0,     0,     0,     0,     0,     0,  2941,     0,  2941,     0,
       0,  4118,   772,     0,     0,     0,     0,     0,     0,     0,
    3116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,     0,  3889,  3889,  3889,  3889,     0,     0,     0,
       0,  4215,  3177,     0,  3178,  3179,  3180,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     711,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,
    1697,   711,  1018,     0,  2895,     0,     0,     0,  3038,     0,
       0,     0,     0,     0,     0,     0,     0,   785,     0,     0,
       0,     0,  1130,  1244,   711,   676,     0,     0,     0,   676,
       0,     0,  3085,     0,     0,     0,     0,  3085,     0,     0,
    3085,     0,     0,   711,     0,     0,     0,   711,     0,     0,
    1940,     0,  1671,  1130,     0,  1245,     0,  1672,     0,     0,
    1673,     0,     0,     0,   711,     0,  3094,  1672,     0,     0,
    1673,     0,  4185,     0,     0,     0,   711,  1674,     0,     0,
    1675,     0,     0,  1941,     0,  1676,     0,  1674,     0,     0,
       0,  1677,  3325,     0,     0,  1676,  1942,     0,     0,     0,
       0,  1677,     0,     0,     0,     0,     0,     0,     0,  1943,
       0,  1246,     0,     0,     0,  1678,     0,     0,   711,     0,
    3094,     0,     0,     0,     0,  1678,  2789,   641,     0,     0,
       0,   711,     0,   772,   772,   924,     0,     0,     0,  4237,
       0,  4238,     0,  1247,     0,  4243,  4244,  1944,     0,     0,
       0,     0,     0,     0,     0,   676,   676,     0,  1945,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1244,
       0,     0,  2896,     0,     0,     0,     0,     0,  1946,  1248,
     767,   169,  4272,  1947,     0,     0,     0,     0,     0,     0,
       0,   767,     0,     0,     0,   812,     0,     0,     0,     0,
       0,  1245,     0,     0,     0,     0,     0,  4387,   772,  1249,
       0,     0,     0,     0,     0,     0,     0,  1679,     0,     0,
       0,  1680,     0,   711,     0,     0,     0,  1679,     0,   772,
     772,  1680,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1681,  1682,     0,   711,   711,   711,     0,   772,
    1948,   767,  1681,  1682,     0,     0,     0,  1246,     0,  1683,
       0,  3085,     0,     0,     0,  3094,     0,     0,     0,  1683,
       0,     0,     0,     0,    33,     0,   810,   772,  1252,   772,
     772,  1949,     0,     0,  1253,  1684,     0,  3452,  1685,  1247,
    3453,  1254,     0,     0,     0,  1684,     0,     0,  1685,  1978,
       0,  1686,  1130,     0,  1687,     0,     0,     0,  1256,     0,
     194,  1686,  4368,     0,  1687,     0,  1257,     0,     0,     0,
       0,     0,     0,     0,     0,  1248,     0,     0,     0,     0,
       0,     0,  1562,  1562,     0,  3479,     0,   711,     0,   650,
       0,     0,     0,  1950,     0,  4470,     0,     0,     0,  1951,
       0,     0,  1952,     0,     0,  1249,  3094,  1594,     0,     0,
     711,     0,     0,  1600,     0,     0,     0,     0,  1258,   169,
    4397,     0,  2898,     0,     0,     0,  1130,     0,  1953,  1688,
       0,     0,     0,  1250,  1954,     0,     0,     0,     0,  1688,
       0,  4502,  2941,     0,     0,     0,     0,  1955,     0,     0,
       0,     0,     0,     0,     0,  1130,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1251,     0,     0,     0,
      33,     0,  1956,     0,  1252,     0,     0,     0,     0,     0,
    1253,     0,     0,  1130,  1130,     0,  1130,  1254,     0,     0,
       0,     0,     0,     0,     0,  1255,     0,     0,     0,     0,
     924,     0,     0,     0,  1256,  1130,     0,     0,     0,     0,
       0,     0,  1257,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,
    1696,  1697,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,
    1696,  1697,   711,     0,     0,  1130,  2408,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1258,     0,     0,     0,     0,     0,
       0,     0,  4576,     0,  1130,     0,     0,     0,  1130,  1130,
       0,     0,     0,     0,     0,     0,     0,     0,  1269,   711,
     711,  1876,     0,     0,  1270,     0,     0,     0,     0,     0,
       0,  3660,  3661,  3662,  3663,     0,     0,   676,   169,  4518,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   169,  4531,   173,  4528,  4529,  4530,     0,  4563,     0,
       0,     0,     0,     0,  1271,     0,     0,     0,     0,     0,
     676,     0,     0,     0,     0,     0,     0,     0,     0,  4555,
       0,     0,     0,   711,  1992,     0,     0,     0,     0,     0,
     711,     0,     0,   772,  4562,  4531,   173,  4528,  4529,  4530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1272,  4554,     0,   812,     0,     0,     0,
    1273,     0,   711,  1274,  1269,   711,     0,     0,     0,  4555,
    1270,     0,     0,     0,     0,  1672,     0,  4555,  1673,     0,
       0,   169,  4531,   173,  4528,  4529,  4530,     0,     0,   711,
       0,     0,     0,     0,     0,  1674,     0,   772,   772,   772,
     772,   711,     0,  1676,  4554,     0,     0,     0,     0,  1677,
    1271,     0,  4554,     0,     0,   711,     0,  1275,     0,     0,
       0,     0,     0,     0,     0,     0,  2109,     0,   711,     0,
       0,     0,     0,  1678,     0,     0,     0,     0,   772,   772,
       0,     0,     0,     0,   772,     0,  3805,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1272,
       0,     0,     0,     0,     0,     0,  1273,     0,     0,  1274,
       0,     0,     0,     0,  1276,     0,  1277,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,     0,   772,     0,
       0,     0,     0,     0,  1279,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1280,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   772,   772,   772,   772,     0,
       0,     0,     0,  1275,     0,     0,     0,   711,     0,     0,
       0,     0,     0,   711,     0,  1679,  2109,  1281,     0,  1680,
    1282,  1283,     0,     0,     0,   767,     0,     0,     0,     0,
       0,     0,   775,     0,   767,     0,     0,     0,     0,     0,
    1681,  1682,     0,     0,   812,     0,  1284,     0,     0,   772,
       0,     0,     0,     0,     0,     0,     0,  1683,   772,     0,
    1276,     0,  1277,     0,   772,   772,     0,     0,     0,   711,
       0,     0,  1278,     0,     0,     0,     0,     0,     0,     0,
    1279,  1672,     0,  1684,  1673,     0,  1685,     0,     0,     0,
    1280,     0,     0,     0,  1562,     0,     0,     0,     0,  1686,
       0,   772,  1687,   767,  1285,     0,     0,   711,   711,  1676,
     772,     0,     0,     0,     0,  1677,   711,     0,     0,     0,
       0,     0,     0,   711,     0,     0,  1282,  1283,     0,     0,
     650,   650,     0,     0,  2318,     0,     0,     0,  1130,  1678,
    1130,     0,     0,     0,     0,     0,     0,  1130,     0,     0,
    1130,     0,  1284,     0,  1130,  1269,     0,     0,     0,     0,
       0,  1270,  1130,  1130,     0,     0,     0,     0,     0,     0,
    1130,     0,   812,  1130,  1130,  1130,  1130,  1688,     0,     0,
       0,     0,     0,  1130,  1130,     0,  1130,     0,  1130,  1130,
       0,     0,  1130,     0,     0,     0,     0,     0,     0,     0,
       0,  1271,     0,     0,     0,     0,     0,     0,     0,  1130,
    1285,     0,     0,   772,  1130,     0,     0,     0,  1130,     0,
       0,     0,  1130,     0,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,     0,  1130,     0,     0,     0,     0,     0,
     711,  1679,  1130,  1130,     0,  1680,     0,     0,     0,   711,
    1272,     0,     0,     0,     0,     0,     0,  1273,     0,     0,
    1274,     0,     0,     0,     0,     0,  1681,  1682,     0,     0,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
       0,     0,     0,  1683,  3329,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4037,     0,     0,     0,     0,     0,     0,     0,  1684,
       0,     0,  1685,     0,  1275,  4040,  -121,     0,     0,     0,
       0,     0,     0,     0,     0,  1686,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     0,     3,     4,     0,     0,     0,  1672,     0,     0,
    1673,     0,     0,     0,     0,     0,     0,     5,     0,     0,
       0,     0,     0,     0,     0,   711,     0,   711,     0,  1130,
       0,  1276,     0,  1277,     0,  1676,     0,     6,     0,     7,
       8,  1677,     0,  1278,     0,     9,     0,    10,     0,     0,
       0,  1279,     0,     0,     0,     0,     0,    11,     0,    12,
       0,  1280,     0,  1688,   711,  1678,     0,     0,  4101,     0,
    2528,     0,  2535,     0,     0,    13,     0,     0,    14,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      15,     0,    16,     0,  1335,     0,    17,  1282,  1283,     0,
     775,     0,    18,     0,     0,   650,     0,   650,     0,     0,
      19,     0,    20,     0,     0,     0,     0,     0,    21,     0,
       0,     0,     0,  1336,  1130,     0,     0,     0,     0,     0,
       0,     0,     0,    22,     0,   767,     0,   772,   772,   772,
       0,     0,   767,     0,   812,     0,   772,     0,   772,     0,
     772,   772,     0,     0,   711,     0,  1689,  1690,  1691,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,  1679,     0,     0,
       0,  1680,     0,   676,     0,     0,     0,     0,     0,     0,
       0,  1285,     0,  1992,     0,     0,     0,     0,    23,    24,
    2646,     0,  1681,  1682,    25,  2655,     0,     0,     0,     0,
       0,   711,     0,    26,     0,     0,     0,     0,     0,  1683,
       0,  4195,  4197,  4197,    27,     0,     0,     0,     0,     0,
     711,     0,     0,     0,  2696,  2696,     0,     0,     0,     0,
       0,   775,   676,     0,     0,     0,     0,     0,  1685,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   772,
       0,  1686,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    29,     0,     0,     0,     0,    30,
      31,     0,    32,     0,     0,     0,  2755,    33,  2758,  2760,
       0,     0,    34,     0,     0,    35,     0,     0,     0,    36,
       0,     0,     0,     0,    37,    38,     0,     0,     0,     0,
       0,     0,    39,     0,     0,    40,     0,     0,   772,     0,
       0,     0,     0,    41,     0,     0,   772,     0,     0,  1672,
       0,   772,  1673,     0,     0,    42,     0,     0,     0,  1688,
       0,     0,     0,     0,  1130,     0,     0,     0,     0,  1674,
       0,     0,    43,     0,     0,  4292,     0,  1676,     0,     0,
       0,     0,    44,  1677,     0,     0,     0,     0,    45,     0,
       0,     0,  1992,    46,     0,  2696,     0,   711,     0,  2856,
       0,     0,   650,     0,     0,     0,    47,  1678,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2755,     0,
       0,     0,     0,     0,     0,     0,   772,  2881,     0,     0,
       0,     0,    48,     0,     0,  -121,     0,     0,     0,     0,
       0,     0,  1689,  1690,  1691,  4339,  1692,  1693,  1694,  1695,
    1696,  1697,     0,   772,     0,   772,  2696,   772,  2696,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4362,     0,  4364,  1130,     0,     0,
       0,  1672,     0,     0,  1673,     0,     0,     0,     0,  1562,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1679,
       0,  1674,     0,  1680,     0,     0,     0,     0,     0,  1676,
       0,     0,     0,     0,     0,  1677,     0,     0,     0,     0,
       0,     0,     0,     0,  1681,  1682,     0,     0,     0,     0,
       0,     0,     0,     0,   767,     0,     0,     0,     0,  1678,
     767,  1683,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   772,     0,     0,     0,     0,     0,     0,  1130,  1130,
       0,     0,     0,     0,  1130,     0,     0,  1684,     0,     0,
    1685,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1686,     0,  4197,  1687,     0,     0,  1130,
    1130,     0,     0,     0,  1130,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1130,  1130,  1130,  1130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1130,
       0,     0,  1130,     0,  1130,  3042,  1672,     0,     0,  1673,
       0,     0,     0,     0,  1130,  1130,     0,     0,  1130,     0,
    4466,  1679,     0,     0,     0,  1680,  1674,     0,     0,     0,
       0,  1130,     0,  1130,  1676,   812,     0,  1130,     0,     0,
    1677,  1688,     0,     0,     0,     0,  1681,  1682,     0,     0,
       0,  1269,     0,     0,     0,     0,  1130,  1270,     0,     0,
     711,     0,     0,  1683,  1678,     0,  3095,     0,     0,  1130,
    1130,  1130,     0,     0,     0,     0,     0,     0,     0,     0,
    4506,     0,  1311,     0,     0,  1269,  1130,     0,     0,  1684,
       0,  1270,  1685,     0,     0,     0,     0,  1271,  1130,     0,
       0,     0,     0,  1130,     0,  1686,     0,     0,  1687,  1130,
       0,     0,     0,     0,     0,     0,     0,  3095,     0,     0,
    3131,     0,     0,     0,  2535,     0,     0,     0,  1312,     0,
       0,  1271,  4545,     0,  1689,  1690,  1691,     0,  1692,  1693,
    1694,  1695,  1696,  1697,     0,     0,  1272,     0,  3487,     0,
       0,  1672,     0,  1273,  1673,     0,  1274,     0,     0,     0,
       0,     0,     0,     0,     0,  1130,  1679,  2696,     0,     0,
    1680,     0,  1562,     0,     0,     0,     0,     0,     0,  1676,
    1272,     0,     0,  1688,     0,  1677,     0,  1273,     0,     0,
    1274,  1681,  1682,     0,     0,     0,     0,     0,   772,     0,
     772,   772,   772,     0,     0,     0,     0,  1313,  1683,  1678,
    1275,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   566,     0,     0,     0,     0,     0,
     609,     0,     0,     0,  1684,     0,     0,  1685,     0,   659,
       0,     0,     0,     0,  1275,     0,     0,     0,     0,     0,
    1686,     0,     0,  1687,     0,  1314,     0,  1315,   723,     0,
       0,     0,     0,     0,     0,     0,     0,  1316,     0,  1277,
       0,     0,     0,     0,     0,     0,  1689,  1690,  1691,  1278,
    1692,  1693,  1694,  1695,  1696,  1697,     0,  1279,     0,  1672,
    3534,     0,  1673,     0,     0,     0,  1317,  1280,     0,     0,
       0,  1276,     0,  1277,     0,     0,     0,     0,     0,  1674,
       0,  1679,     0,  1278,     0,  1680,     0,  1676,     0,     0,
       0,  1279,     0,  1677,     0,     0,     0,     0,  1688,     0,
    1318,  1280,     0,  1282,  1283,  1319,  1681,  1682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1678,     0,     0,
       0,     0,     0,  1683,     0,     0,     0,     0,     0,  1320,
       0,     0,     0,     0,  1361,     0,     0,  1282,  1283,     0,
    1321,     0,     0,     0,     0,     0,     0,     0,     0,  2696,
    2696,     0,  1685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1362,     0,  1686,     0,   780,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   815,   816,     0,
     819,     0,     0,   825,     0,   827,     0,  1285,     0,     0,
       0,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,
    1697,     0,   711,   711,     0,  3611,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   711,  1679,
       0,  1285,     0,  1680,     0,     0,     0,     0,     0,     0,
       0,  1562,   711,     0,     0,     0,     0,     0,     0,     0,
    1562,   711,     0,  1688,  1681,  1682,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   711,     0,     0,     0,     0,
       0,  1683,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1672,     0,     0,  1673,     0,     0,     0,     0,     0,
       0,     0,     0,   772,     0,     0,   772,  1684,     0,     0,
    1685,  1674,     0,     0,     0,     0,     0,     0,     0,  1676,
     767,     0,     0,  1686,     0,  1677,  1687,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   711,     0,     0,     0,     0,     0,     0,     0,  1678,
       0,   772,     0,     0,     0,     0,     0, -2275, -2275,  1130,
    1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,  1130,
       0,     0,     0,     0,     0,  1130,     0,  1130,     0,     0,
       0,     0,     0,  1130,     0,     0,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,     0,     0,     0,  1130,
    1130,  1688,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1130,     0,     0,     0,  1130,     0,     0,     0,
    1130,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1130,     0,     0,  1130,     0,  1130,     0,     0,     0,     0,
       0,     0,     0,     0,  1130,  1130,  1130,     0,     0,     0,
    1130,  1679,     0,  1130,     0,  1680,     0,  3559,     0,     0,
       0,     0,     0,     0,   711,   711,   711,   767,     0,  3095,
    3576,     0,     0,     0,  3576,  3590,  1681,  1682,     0,     0,
       0,  1130,     0,     0,     0,     0,     0,  1130,  1130,     0,
       0,     0,     0,  1683,  1689,  1690,  1691,     0,  1692,  1693,
    1694,  1695,  1696,  1697,     0,     0,     0,     0,  3637,     0,
       0,  1130,     0,     0,     0,     0,     0,  1130,     0,  1684,
       0,  2535,  1685,  1130,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   878,     0,  1686,     0,     0,  1687,     0,
       0,   886,     0,     0,     0,  3643,  1562,  1562,     0,  2109,
     902,   903,     0,     0,     0,   905,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   921,   772,   772,   772,
     772,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,   952,     0,  1673,   954,
       0,   956,     0,   959,  3686,     0,     0,     0,     0,     0,
       0,     0,     0,  1688,     0,  1674,     0,     0,  1672,     0,
       0,  1673,     0,  1676,     0,     0,     0,     0,     0,  1677,
       0,     0,     0,     0,     0,     0,     0,     0,  1674,     0,
       0,     0,     0,  1269,     0,     0,  1676,     0,     0,  1270,
       0,     0,  1677,  1678,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1015,     0,  1016,     0,  1672,     0,     0,
    1673,     0,     0,     0,     0,     0,  1678,     0,     0,     0,
    3752,     0,     0,     0,     0,     0,     0,  1674,     0,  1271,
       0,     0,     0,     0,     0,  1676,     0,     0,     0,     0,
       0,  1677,     0,     0,     0,     0,  1689,  1690,  1691,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,
    3892,   723,     0,     0,     0,  1678,     0,     0,     0,     0,
       0,   711,     0,     0,     0,     0,     0,     0,  1272,     0,
       0,     0,   772,     0,  1130,  1273,     0,     0,  1274,     0,
     711,     0,     0,     0,     0,  1679,  3818,     0,     0,  1680,
       0,     0,     0,     0,     0,  1992,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   711,  1679,  1235,
    1681,  1682,  1680,     0,     0,     0,     0,  2755,     0,     0,
       0,     0,     0,  3846,     0,     0,     0,  1683,     0,     0,
       0,     0,  1275,  1681,  1682,     0,     0,     0,     0,  1130,
    1130,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1683,     0,     0,  1684,     0,     0,  1685,  1679,     0,     0,
       0,  1680,  2696,     0,  2696,  1364,     0,     0,     0,  1686,
       0,     0,  1687,     0,     0,     0,  1684,     0,     0,  1685,
    1376,     0,  1681,  1682,     0,     0,     0,     0,     0,  1276,
       0,  1277,  1686,  1386,     0,  1687,     0,     0,  1130,  1683,
    1388,  1278,     0,     0,     0,     0,     0,     0,     0,  1279,
       0,     0,  1436,     0,     0,  1440,     0,     0,     0,  1280,
       0,     0,     0,     0,     0,  1684,     0,     0,  1685,     0,
       0,     0,     0,     0,     0,  1130,     0,     0,     0,     0,
       0,  1686,     0,     0,  1687,  1130,  1130,  1688,  1483,     0,
       0,     0,  1960,  1130,  1130,  1282,  1283,     0,  1130,     0,
       0,     0,     0,     0,  1130,  1130,     0,     0,  1130,     0,
    1688,  1130,  3930,     0,     0,   711,   711,   711,   711,     0,
       0,  1961,  3576,  3590,     0,  3576,     0,     0,  3939,     0,
       0,     0,  3095,     0,  1672,     0,  3095,  1673,     0,     0,
       0,     0,  3952,     0,     0,     0,     0,     0,  1130,     0,
       0,     0,     0,  1130,  1674,     0,     0,     0,  1130,  1688,
       0,     0,  1676,     0,   812,     0,     0,     0,  1677,     0,
       0,     0,  3131,     0,     0,     0,  2535,     0,     0,  1285,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
     650,     0,  1678,  1130,  3926,     0,     0,     0,     0,     0,
       0,     0,     0,  1689,  1690,  1691,     0,  1692,  1693,  1694,
    1695,  1696,  1697,  2696,  2696,     0,     0,  4148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,
    1696,  1697,     0,     0,     0,     0,  4157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   772,     0,     0,
       0,     0,     0,     0,  1679,     0,     0,     0,  1680,     0,
       0,   772,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1681,
    1682,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1683,     0,     0,     0,
       0,     0,     0,  1672,     0,     0,  1673,     0,     0,   723,
    1837,     0,     0,     0,     0,     0,     0,     0,     0,  1130,
       0,     0,  1684,  1674,     0,  1685,     0,  1269,     0,     0,
     767,  1676,     0,  1270,     0,  1992,     0,  1677,  1686,     0,
    1672,  1687,  1562,  1673,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   772,  1992,     0,     0,     0,     0,
    1674,  1678,     0,     0,     0,     0,     0,     0,  1676,     0,
       0,     0,  1958,  1271,  1677,     0,     0,     0,     0,     0,
     711,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1678,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1130,
       0,     0,     0,     0,     0,     0,  1688,     0,  1130,     0,
       0,     0,  1272,     0,     0,     0,     0,     0,     0,  1273,
       0,     0,  1274,     0,     0,  1130,  1130,     0,     0,  1130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   767,  3576,     0,     0,     0,  3095,     0,     0,
       0,     0,  3095,  1679,     0,  3095,  2755,  1680,  4176,     0,
    1130,  1130,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1275,     0,  1681,  1682,
       0,     0,     0,     0,     0,  3643,   812,   772,   772,   772,
    1679,     0,     0,     0,  1680,  1683,     0,     0,     0,  1689,
    1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,
       0,     0,     0,  4190,     0,  1681,  1682,     0,     0,     0,
       0,  1684,     0,     0,  1685,     0,     0,   767,   812,     0,
       0,     0,  1683,  1276,     0,  1277,     0,  1686,     0,     0,
    1687,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,  1279,     0,     0,     0,     0,  1684,     0,
       0,  1685,     0,  1280,  2165,     0,     0,     0,  1562,  1562,
       0,     0,     0,   767,  1686,  1672,   711,  1687,  1673,  2188,
       0,     0,     0,     0,     0,     0,     0,  3818,     0,     0,
       0,     0,     0,     0,  2696,  1674,  2026,     0,  1992,  1282,
    1283,     0,     0,  1676,     0,     0,     0,     0,     0,  1677,
    3846,     0,     0,   711,     0,  1688,     0,     0,     0,  2233,
       0,   772,  3643,     0,     0,  2027,     0,     0,     0,     0,
       0,     0,     0,  1678,  2248,     0,  2250,     0,  2251,     0,
       0,     0,     0,  2252,  1130,     0,     0,  1130,     0,  1130,
       0,     0,  1688,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,  1673,     0,     0,     0,     0,     0,     0,
       0,     0,  1130,     0,     0,     0,  3095,     0,     0,  4176,
    1674,     0,     0,  1285,     0,  4331,  1837,     0,  1676,     0,
    1837,     0,  1837,     0,  1677,  1837,     0,     0,     0,     0,
       0,   772,     0,     0,     0,   711,     0,     0,  1689,  1690,
    1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,  1678,     0,
       0,     0,  4251,     0,     0,     0,     0,     0,     0,   772,
     772,   772,   772,     0,     0,  1679,     0,     0,     0,  1680,
       0,     0,     0,     0,  1562,  1689,  1690,  1691,     0,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,  4469,
    1681,  1682,     0,   767,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1683,     0,     0,
       0,  1672,  1130,     0,  1673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,  1674,   818,  1684,     0,  2504,  1685,     0,     0,  1676,
       0,   833,     0,     0,     0,  1677,     0,     0,  1130,  1686,
    1679,   767,  1687,     0,  1680,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1678,
       0,   772,     0,   812,     0,  1681,  1682,     0,     0,     0,
       0,     0,     0,  1130,     0,     0,     0,     0,     0,     0,
       0,     0,  1683,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2505,     0,     0,     0,  1684,     0,
       0,  1685,     0,     0,     0,     0,   772,  1688,     0,     0,
       0,   767,     0,     0,  1686,     0,  1672,  1687,     0,  1673,
       0,     0,  3643,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1130,  1130,  1674,     0,     0,  2755,
       0,     0,     0,  4331,  1676,     0,     0,     0,     0,     0,
    1677,  1679,     0,     0,     0,  1680,     0,   767,     0,     0,
       0,     0,     0,     0,     0,     0,   772,     0,     0,     0,
       0,     0,     0,     0,  1678,     0,  1681,  1682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1688,  1683,     0,     0,     0,  1130,     0,     0,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
       0,  1130,     0,     0,  4565,     0,     0,     0,   772,  1684,
       0,     0,  1685,     0,     0,     0,     0,     0,  2553,  2554,
       0,     0,     0,  2557,  2558,  1686,     0,  2561,  1687,     0,
       0,     0,     0,     0,     0,     0,     0,  2571,     0,  1431,
       0,     0,     0,     0,  2580,  3014,     0,     0,  2583,  2584,
    3015,     0,  2587,  2588,     0,     0,     0,     0,     0,  2593,
       0,     0,     0,     0,     0,     0,  1679,     0,     0,  1130,
    1680,  2609,     0,  2611,     0,  1689,  1690,  1691,   767,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,  3607,     0,  2633,
       0,  1681,  1682,     0,  2635,     0,     0,     0,     0,     0,
       0,     0,     0,  1688,     0,     0,     0,  2640,  1683,     0,
       0,     0,     0,     0,     0,  2645,     0,  2647,  2648,  2651,
    2653,     0,     0,     0,  2660,  2663,     0,     0,   842,     0,
       0,     0,  2674,   875,  1684,     0,  2683,  1685,     0,     0,
    2687,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1686,     0,     0,  1687,  2506,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2716,     0,     0,     0,     0,
       0,  1431,     0,     0,     0,     0,  2723,     0,  2725,     0,
       0,     0,     0,  2728,     0,     0,     0,  2729,     0,  2733,
    2734,  2735,  2736,     0,  2738,     0,  1689,  1690,  1691,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,  2762,  2763,  2764,
       0,  1672,     0,     0,  1673,     0,     0,     0,     0,     0,
    2772,  2773,  1672,     0,     0,  1673,     0,     0,  1688,  1269,
       0,  1674,     0,     0,     0,  1270,     0,     0,     0,  1676,
       0,     0,  1674,     0,     0,  1677,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1678,
    1017,     0,     0,     0,     0,  1271,     0,     0,     0,     0,
    1678,     0,     0,     0,  2830,     0,     0,     0,     0,     0,
       0,     0,     0,  1135,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1158,     0,     0,     0,     0,     0,     0,     0,
       0,  1689,  1690,  1691,  1272,  1692,  1693,  1694,  1695,  1696,
    1697,  1273,     0,  1184,  1274,     0,  1672,     0,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1674,     0,     0,  2977,
    4536,     0,     0,     0,  1676,     0,     0,     0,  1269,  1892,
    1677,  1679,     0,     0,  1270,  1680,     0,     0,     0,     0,
       0,     0,  1679,     0,     0,     0,  1680,     0,  1275,     0,
       0,     0,     0,     0,  1678,     0,  1681,  1682,     0,     0,
    1296,     0,     0,  1837,     0,     0,     0,  1681,  1682,     0,
       0,     0,     0,  1683,  1271,     0,     0,   769,     0,     0,
       0,     0,     0,  1892,  1683,     0,   769,   789,     0,     0,
       0,  2952,     0,   789,     0,     0,     0,     0,     0,  1684,
       0,     0,  1685,     0,   789,  1276,     0,  1277,     0,     0,
    1684,     0,     0,  1685,     0,  1686,     0,  1278,  1687,  1431,
       0,     0,     0,  1272,     0,  1279,  1686,     0,     0,  1687,
    1273,     0,     0,  1274,     0,  1280,     0,     0,  3526,     0,
       0,     0,     0,     0,     0,     0,     0,  4537,     0,     0,
       0,     0,  1445,     0,     0,     0,  1679,     0,     0,     0,
    1680,     0,     0,     0,     0,     0,     0,     0,  2641,     0,
       0,  1282,  1283,     0,  1473,  1476,  1477,     0,     0,     0,
       0,  1681,  1682,     0,     0,     0,     0,  1275,     0,     0,
       0,     0,     0,  1688,     0,  1431,     0,  1284,  1683,     0,
       0,     0,     0,     0,  1688,     0,     0,  3527,     0,     0,
       0,     0,     0,     0,  1892,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1684,     0,     0,  1685,     0,     0,
       0,     0,     0,     0,  1431,     0,     0,     0,     0,     0,
    1686,     0,     0,  1687,  1276,     0,  1277,     0,     0,     0,
    1672,     0,     0,  1673,     0,  1285,  1278,     0,     0,  1431,
       0,     0,     0,     0,  1279,     0,  1135,     0,     0,     0,
    1674,     0,     0,     0,  1280,     0,     0,     0,  1676,     0,
       0,     0,  3112,     0,  1677,     0,  1689,  1690,  1691,  1135,
    1692,  1693,  1694,  1695,  1696,  1697,     0,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,  2730,  1678,     0,
    1282,  1283,     0,     0,     0,     0,  1431,     0,  1688,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3148,  3149,     0,     0,     0,  2731,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1837,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,  1673,     0,
       0,     0,     0,  3171,     0,     0,     0,     0,     0,     0,
       0,     0,  3175,     0,     0,  1674,     0,     0,  3022,     0,
       0,     0,     0,  1676,  1285,     0,     0,  3186,  3188,  1677,
       0,     0,  3188,     0,     0,     0,     0,  3199,  3200,  3201,
    1679,  1689,  1690,  1691,  1680,  1692,  1693,  1694,  1695,  1696,
    1697,  1739,     0,  1678,     0,     0,     0,     0,     0,   769,
       0,     0,     0,     0,     0,  1681,  1682,  3221,  3222,  3223,
    3224,   789,     0,     0,     0,   789,     0,     0,     0,     0,
       0,     0,  1683,     0,     0,     0,   789,     0,     0,     0,
       0,  1672,     0,     0,  1673,     0,     0,     0,     0,  1874,
       0,  3238,   789,  3242,  3243,  3244,   769,     0,  1684,     0,
       0,  1685,     0,  3257,     0,     0,   769,   789,     0,  1676,
       0,     0,   789,  1431,  1686,  1677,     0,  1687,     0,     0,
       0,     0,   789,     0,     0,     0,     0,     0,     0,     0,
     789,     0,  2992,     0,     0,     0,     0,     0,     0,  1678,
       0,     0,     0,     0,     0,  1679,     0,     0,  2483,  1680,
       0,     0,  1987,     0,     0,     0,     0,     0,     0,  2005,
       0,     0,     0,     0,     0,     0,     0,     0,  3298,     0,
    1681,  1682,     0,     0,     0,     0,  3302,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1683,     0,     0,
       0,  2042,  1688,     0,  2045,     0,     0,     0,     0,     0,
       0,  3048,     0,     0,     0,   769,     0,     0,     0,  1269,
     789,     0,     0,  1684,     0,  1270,  1685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1686,
    2080,     0,  1687,  3374,     0,     0,   769,     0,     0,     0,
       0, -2275,     0,     0,  2098,  1680,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1271,     0,  2110,     0,     0,
       0,     0,     0,     0,     0,     0,  1681,  1682,     0,     0,
       0,     0,     0,     0,     0,  3403,     0,     0,  3406,     0,
       0,     0,     0, -2275,     0,  1689,  1690,  1691,     0,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1272,     0,     0,  1688,     0,     0,
    3444,  1273,  1685,     0,  1274,     0,     0,     0,     0,     0,
       0,     0,  2538,     0,  3454,  1686,  1892,  2544,     0,     0,
       0,     0,     0,     0,  1837,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,  2206,     0,  1673,     0,
       0,     0,  2216,   769,     0,     0,     0,     0,  1275,     0,
       0,     0,     0,     0,   769,  1674,     0,     0,     0,     0,
       0,     0,     0,  1676,     0,     0,     0,     0,     0,  1677,
       0,     0,     0,     0,     0,     0,     0,  1432,     0,     0,
    1689,  1690,  1691, -2275,  1692,  1693,  1694,  1695,  1696,  1697,
       0,     0,     0,  1678,     0,     0,     0,     0,  2263,     0,
       0,     0,     0,     0,     0,  1276,     0,  1277,     0,     0,
       0,     0,  1431,     0,   769,     0,     0,  1278,     0,     0,
       0,     0,     0,     0,     0,  1279,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1280,  1135,  1135,     0,     0,
       0,     0,  1672,     0,     0,  1673,   789,     0,     0,     0,
       0,     0,  2311,     0,     0,     0,     0,     0,     0,     0,
       0,   789,  1674,     0,     0,   769,     0,     0,  2769,     0,
    1676,  1282,  1283,   789,     0,     0,  1677,     0,     0,  3027,
    1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1679,     0,  2770,     0,  1680,
    1678,   789,     0,     0,     0,     0,     0,     0,     0,  1432,
       0,   789,     0,     0,     0,     0,     0,     0,     0,     0,
    1681,  1682,     0,     0,   789,     0,     0,   789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1683,     0,   769,
       0,     0,     0,     0,     0,     0,     0,     0,  3654,     0,
    3655,     0,     0,     0,     0,  1285,     0,  3657,     0,     0,
       0,  1431,     0,  1684,     0,     0,  1685,     0,   769,  2470,
       0,     0,     0,  3666,     0,     0,     0,     0,  2484,  1686,
       0,     0,  1687,     0,     0,     0,     0,     0,  3674,     0,
       0,     0,     0,     0,     0,     0,   769,   769,  3685,   769,
       0,     0,  1679,     0,     0,     0,  1680,     0,     0,     0,
       0,     0,     0,  3688,     0,     0,     0,     0,   769,     0,
       0,     0,     0,     0,     0,     0,     0,  1681,  1682,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1892,   789,     0,     0,  1683,     0,  3720,  3721,  3722,   789,
     789,  3725,  3726,  3727,  3728,  3729,     0,  1688,   769,  1822,
    3736,  3737,     0,  3739,  3740,  3741,  3742,  3743,  3744,  3745,
    1684,     0,     0,  1685,     0,     0,     0,     0,  3753,     0,
    3755,  3756,     0,     0,     0,     0,  1686,   769,     0,  1687,
       0,   769,   769,     0,  2495,     0,  2498,  1269,     0,     0,
       0,     0,     0,  1270,     0,     0,     0,  1432,     0,     0,
       0,     0,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1431,     0,     0,     0,  1311,     0,
       0,     0,     0,  1135,  3799,  3801,  3803,     0,     0,  3806,
       0,     0,  1672,  1271,     0,  1673,     0,     0,     0,     0,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
       0,  1432,  1674,     0,  1688,  3033,     0,     0,     0,     0,
    1676,     0,     0,     0,  1312,     0,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3483,     0,  1272,     0,     0,     0,     0,  1432,     0,  1273,
    1678,     0,  1274,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3188,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1837,  1837,
    1837,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1313,   789,     0,  1275,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,
    2664,     0,     0,  1432,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2691,
       0,     0,  1432,     0,  2483,  2483,  2483,     0,     0,     0,
       0,  1314,  1679,  1315,     0,     0,  1680,     0,     0,     0,
       0,     0,  1432,  1316,     0,  1277,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,  1681,  1682,     0,
       0,     0,  1822,  1279,     0,     0,     0,  1432,     0,     0,
       0,     0,  1317,  1280,  1683,     0,     0,     0,     0,     0,
       0,     0,   789,     0,     0,     0,     0,  1892,     0,     0,
    2544,     0,  2544,     0,     0,     0,     0,  1892,   789,     0,
    1684,     0,     0,  1685,     0,     0,  2717,     0,     0,  1282,
    1283,  1319,     0,     0,     0,     0,  1686,     0,   769,  1687,
       0,     0,     0,     0,  1432,     0,     0,   769,     0,   789,
     789,     0,     0,     0,     0,  2718,     0,     0,     0,     0,
     789,     0,     0,     0,     0,     0,  1321,  1431,     0,     0,
       0,     0,   789,   789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   789,     0,  2854,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3997,  3998,
    3999,  4000,     0,     0,  4002,     0,     0,  1892,     0,     0,
       0,     0,     0,  1285,  1688,     0,   769,     0,     0,     0,
       0,     0,     0,     0,     0,  4015,  4016,  4017,  4018,     0,
    4020,  4021,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4030,  4031,     0,     0,     0,     0,     0,     0,
       0,   769,     0,   769,     0,  4033,     0,     0,     0,     0,
     769,  1837,  1837,   769,  1837,     0,     0,   769,  1431,     0,
    1431,     0,     0,     0,     0,   769,   769,     0,     0,     0,
       0,     0,     0,   769,     0,     0,   769,   769,   769,   769,
       0,     0,     0,     0,     0,     0,   769,   769,     0,   769,
       0,   769,   769,     0,     0,   769,     0,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,
       0,  1432,   769,  1822,     0,  1431,     0,   769,     0,     0,
       0,   769,     0,     0,     0,   769,     0,   769,   769,   769,
     769,   769,   769,   769,   769,   769,     0,   769,     0,     0,
    1431,     0,     0,  4088,     0,   769,   769,     0,     0,     0,
       0,     0,  4094,     0,     0,     0,     0,     0,     0,  2544,
       0,     0,     0,     0,     0,     0,     0,  1672,     0,     0,
    1673,     0,  4113,     0,     0,     0,     0,  2544,     0,     0,
       0,     0,     0,     0,     0,  1269,     0,  1674,     0,     0,
    3533,  1270,     0,     0,  4130,  1676,     0,     0,     0,     0,
       0,  1677,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,  1673,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1678,     0,     0,  1674,     0,
       0,  1271,     0,     0,     0,     0,  1676,     0,     0,     0,
       0,  1431,  1677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2544,     0,     0,
       0,  1837,     0,     0,     0,     0,  1678,     0,  1431,  3078,
       0,     0,   769,     0,  1837,     0,     0,     0,     0,     0,
    1272,     0,     0,     0,     0,     0,     0,  1273,     0,     0,
    1274,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,  1673,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1672,     0,     0,  1673,     0,     0,  1674,     0,
    1432,     0,     0,     0,  1432,  1432,  1676,  1679,     0,     0,
       0,  1680,  1677,     0,   789,  4212,     0,  1431,  1822,   789,
    1676,     0,   789,   790,  1275,     0,  1677,     0,     0,   790,
       0,     0,  1681,  1682,     0,  4223,  1678,  1431,     0,     0,
     790,     0,     0,     0,   789,     0,     0,   769,  1679,  1683,
    1678,     0,  1680,     0,     0,     0,     0,     0,   769,     0,
       0,     0,  1431,     0,     0,   769,     0,     0,     0,     0,
       0,     0,     0,  1681,  1682,  1684,     0,     0,  1685,     0,
       0,  1276,     0,  1277,     0,   789,     0,     0,     0,     0,
    1683,  1686,     0,  1278,  1687,     0,     0,     0,  1431,     0,
       0,  1279,   789,   789,     0,     0,     0,     0,     0,     0,
    1432,  1280,  3059,     0,     0,     0,  1684,     0,     0,  1685,
       0,     0,     0,     0,     0,     0,  3188,  1822,   789,     0,
       0,  1822,  1686,     0,     0,  1687,     0,     0,  1679,     0,
       0,     0,  1680,  2483,  3196,     0,     0,  1282,  1283,     0,
       0,     0, -2275,     0,     0,     0,  1680,   789,     0,     0,
       0,   789,     0,  1681,  1682,  1837,     0,     0,     0,  1688,
       0,     0,     0,  3197,     0,  1837,     0,  1681,  1682,   789,
    1683,     0,     0,     0,  1892,     0,     0,     0,     0,     0,
     789,     0,     0,     0, -2275,     0,     0,     0,     0,     0,
       0,     0,     0,   789,     0,  4345,  1684,     0,     0,  1685,
    1688,     0,     0,   789,  4352,     0,     0,     0,     0,     0,
       0,     0,  1686,  1685,     0,     0,     0,     0,     0,  1837,
       0,  1285,     0,     0,     0,     0,  1686,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,  1432,
       0,     0,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,
    1696,  1697,     0,     0,     0,  2544,     0,     0,     0,     0,
    1822,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1688,     0,  3188,  1689,  1690,  1691,     0,  1692,  1693,  1694,
    1695,  1696,  1697,     0, -2275,     0,     0,     0,     0,     0,
       0,  3377,  3378,  1837,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,  1673,     0,     0,     0,  3387,  1432,     0,
       0,   789,     0,     0,     0,     0,     0,  4439,     0,     0,
       0,  3396,     0,     0,     0,     0,     0,     0,  1676,     0,
    3405,  4450,     0,     0,  1677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3421,   789,     0,   790,     0,     0,
     769,   790,     0,     0,     0,     0,  4461,     0,  1678,     0,
       0,  4465,   790,  1689,  1690,  1691,     0,  1692,  1693,  1694,
    1695,  1696,  1697,     0,     0,     0,     0,     0,   790,     0,
     789,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,
       0,     0,  1432,   790,     0,     0,  1431,     0,   790,     0,
       0,     0,     0,   789,     0,     0,     0,   769,   790,     0,
    1135,     0,  4501,   769,     0,     0,   790,     0,     0,     0,
    3549,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   769,   769,  1892,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2275,     0,   769,   769,  1680,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   769,
     769,   769,   769,     0,     0,  1681,  1682,  1822,     0,     0,
       0,     0,   769,  1822,     0,   769,   790,   769,     0,     0,
       0,     0, -2275,     0,     0,     0,     0,   769,   769,     0,
       0,   769,  1269,     0,     0,     0,     0,     0,  1270,     0,
       0,     0,     0,     0,   769,     0,   769,     0,     0,     0,
     769,  1685,     0,  3564,  3565,  3566,     0,     0,     0,     0,
       0,     0,     0,  1431,  1686,     0,     0,     0,     0,   769,
       0,     0,     0,     0,  1431,     0,     0,     0,  1271,   769,
       0,     0,   769,   769,   769,     0,     0,     0,     0,     0,
       0,  1672,     0,     0,  1673,     0,   789,     0,  1672,   769,
       0,  1673,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   769,     0,     0,     0,     0,   769,     0,     0,  1676,
       0,     0,   769,  2483,     0,  1677,  1676,  1272,  2483,     0,
     769,     0,  1677,  2483,  1273,     0,     0,  1274,     0,     0,
       0,     0, -2275,     0,     0,  1432,     0,     0,  1432,  1678,
    1432,     0,     0,     0,     0,  1432,  1678,   789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   789,   789,     0,     0,     0,     0,   769,     0,
       0,     0,     0,     0,     0,     0,  1431,     0,     0,     0,
       0,  1275,     0,     0,     0,     0,     0,     0,     0,   789,
       0,     0,   789,     0,     0,  1432,     0,     0,     0,     0,
       0,  3550,     0,     0,  1431,     0,     0,     0,  3553,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1431,     0,     0,     0,     0,     0,  1692,
    1693,  1694,  1695,  1696,  1697,  1432,     0,     0,  1276,     0,
    1277, -2275,     0,     0,     0,  1680,     0,     0, -2275,     0,
    1278,     0,  1680,     0,     0,     0,     0,     0,  1279,     0,
       0,     0,   790,  1822,  1822,  1822,  1681,  1682,  1280,     0,
       0,  1431,     0,  1681,  1682,     0,     0,   790,     0,     0,
       0,     0,     0, -2275,     0,     0,     0,   789,     0,   790,
   -2275,     0,     0,     0,     0,     0,  1432,     0,  1432,   789,
       0,  3239,     0,     0,  1282,  1283,     0,     0,     0,   789,
    3787,     0,  1685,     0,     0,     0,     0,   790,     0,  1685,
       0,     0,     0,     0,     0,  1686,     0,   790,     0,  3813,
    3240,     0,  1686,  1672,     0,     0,  1673,     0,     0,     0,
     790,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1432,     0,     0,  3830,     0,     0,     0,
       0,  1676,     0,     0,     0,     0,     0,  1677,     0,     0,
       0,     0,   789,     0,     0,     0,     0,     0,  1432,     0,
       0,     0,  4122,     0,     0,     0,     0,     0,  1285,     0,
       0,  1678,     0,     0,     0,     0,     0,  1432,     0,     0,
       0,     0,     0, -2275,     0,     0,     0,     0,     0,     0,
   -2275,     0,     0,     0,  1822,  1432,     0,     0,  1431,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   789,
       0,   789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   789,     0,   789,     0,     0,     0,     0,
       0,     0,     0,  3924,     0,     0,     0,   790,     0,     0,
       0,     0,     0,     0,     0,   790,   790,     0,     0,     0,
       0,     0,     0,     0,     0,  1823,     0,     0,     0,  1432,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2275,   789,  1432,     0,  1680,     0,     0,
    1692,  1693,  1694,  1695,  1696,  1697,  1432,  1692,  1693,  1694,
    1695,  1696,  1697,     0,     0,     0,     0,     0,  1681,  1682,
       0,     0,   789,     0,  3931,  3932,  3933,  3934,     0,  1823,
       0,     0,  2544,   769,     0, -2275,   789,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   789,     0,     0,   789,     0,     0,     0,
       0,     0,     0,     0,  1685,     0,     0,     0,     0,     0,
       0,     0,   769,     0,     0,  1432,     0,  1686,     0,     0,
       0,     0,   769,     0,     0,     0,     0,     0,   769,     0,
     769,     0,     0,     0,     0,  1432,   769,     0,     0,   769,
     769,   769,   769,   769,   769,   769,   769,   769,   769,     0,
       0,     0,   769,   769,     0,     0,     0,     0,     0,     0,
    1432,     0,     0,     0,     0,   769,     0,     0,     0,   769,
       0,  1822,     0,   769,     0,     0,     0,     0,     0,  2544,
       0,     0,     0,   769,     0,     0,   769,     0,   769,     0,
       0,     0,     0,     0,     0, -2275,  1432,   769,   769,   769,
    1431,     0,     0,   769,     0,     0,   769,     0,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,     0,   769,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   769,     0,  1431,     0,     0,     0,
     769,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   769,     0,   532,     0,     0,     0,
     769,     0,     0,     0,  1431,     0,   769,     0,  1431,  1431,
       0,     0,  1432,     0,     0,     0,     0,   533,  1823,     0,
       0,     0,  1692,  1693,  1694,  1695,  1696,  1697,   769,     0,
     534,     0,     0,     0,     0,     0,     0,     0,   790,   535,
       0,     0,     0,  -739,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   790,     0,     0,     0,     0,   789,
     536,     0,     0,     0,     0,     0,   537,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   538,     0,     0,     0,   790,   790,  4122,     0,     0,
       0,     0,   539,     0,     0,     0,   790,  1822,     0,  4124,
     540,     0,  1822,  1432,  1822,     0,     0,     0,   790,   790,
       0,     0,   541,     0,     0,     0,     0,     0,     0,   542,
     790,     0,     0,   543,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -934,     0,
       0,     0,     0,     0,     0,     0,   789,     0,   179,   789,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   845,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   544,     0,     0,
       0,     0,     0,  1822,  -505,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   180,     0,     0,     0,     0,   846,
       0,     0,     0,     0,     0,     0,     0,   181,     0,     0,
       0,     0,   847,   848,     0,   545,     0,     0,   546,     0,
       0,   849,     0,     0,   182,   850,     0,   769,     0,     0,
     183,   791,     0,     0,     0,     0,     0,   791,     0,     0,
       0,     0,   851,     0,     0,   184,     0,     0,   791,     0,
     789,   789,     0,  -401,  1432,     0,   185,   789,     0,  1823,
       0,     0,     0,   852,   186,     0,     0,     0,     0,     0,
       0,   547,     0,     0,   853,     0,   187,   548,     0,     0,
       0,   188,   854,  -401,     0,     0,   549,   189,     0,     0,
       0,  1432,   769,   769,   855,     0,     0,     0,     0,   856,
       0,     0,   190,     0,     0,  4249,     0,     0,     0,     0,
       0,     0,  -401,     0,   550,   551,     0,   552,   553,     0,
     857,     0,     0,     0,     0,     0,   554,   191,     0,     0,
       0,   555,     0,   789,     0,     0,     0,   556,     0,     0,
     557,     0,  1135,   558,     0,   858,     0,     0,   192,     0,
       0,   769,     0,     0,     0,     0,  -401,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   859,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
       0,     0,     0,     0,     0,     0,     0,     0,   769,     0,
       0,     0,     0,     0,     0,     0,     0,   860,   769,   769,
       0,  1432,     0,     0,     0,     0,   769,   769,   194,     0,
       0,   769,  1432,     0,     0,     0,     0,   769,   769,     0,
       0,   769,     0,     0,   769,     0,   194,     0,     0,     0,
       0,     0,     0,     0,  4342,   195,     0,     0,     0,   196,
       0,   197,     0,     0,     0,   769,     0,   198,     0,   769,
     199,     0,     0,   861,     0,     0,     0,   862,     0,   863,
       0,   769,     0,     0,     0,   864,   769,     0,   865,     0,
       0,   769,     0,     0,     0,   200,   201,     0,   202,     0,
     790,     0,   203,     0,  1823,   790,     0,     0,   790,     0,
     204,     0,     0,     0,   866,   205,   867,     0,     0,     0,
     868,     0,     0,     0,     0,     0,   769,   206,   869,     0,
     790,     0,     0,   870,     0,     0,     0,     0,     0,     0,
     207,     0,     0,     0,  1432,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   871,     0,
     789,     0,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,   790,  1432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   789,     0,   790,   790,
       0,  1432,     0,     0,     0,     0,     0,     0,   789,     0,
       0,     0,     0,     0,     0,   791,     0,     0,     0,   791,
       0,   789,     0,  1823,   790,     0,     0,  1823,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,  1432,
       0,     0,     0,   790,     0,   578,     0,   790,     0,     0,
       0,   791,     0,     0,   789,     0,   791,   579,     0,     0,
       0,     0,     0,     0,     0,   790,   791,     0,     0,     0,
       0,     0,     0,     0,   791,     0,   790,     0,   580,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,   581,   769,     0,     0,     0,     0,     0,     0,   790,
       0,     0,     0,   769,   582,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   583,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   584,     0,     0,     0,     0,     0,     0,     0,
    1432,     0,     0,   585,   791,     0,     0,  1174,     0,     0,
       0,   586,     0,     0,     0,     0,  1823,     0,     0,     0,
     789,     0,     0,   587,     0,     0,     0,     0,   588,     0,
       0,     0,   769,     0,   589,     0,  1432,     0,     0,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,   590,
       0,     0,     0,     0,     0,     0,     0,     0,   769,   769,
       0,     0,   769,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   769,     0,   790,     0,     0,
     769,     0,     0,     0,     0,   769,     0,     0,   769,     0,
       0,     0,     0,   769,   769,   591,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   790,   789,     0,   789,     0,     0,     0,   769,     0,
       0,     0,     0,     0,     0,     0,   592,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   593,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
    1432,   789,     0,     0,     0,   194,     0,     0,     0,     0,
     769,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   594,     0,     0,     0,   595,     0,   596,     0,
       0,  1822,     0,   789,   597,     0,     0,   598,     0,     0,
       0,     0,     0,     0,     0,     0,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   599,     0,   600,     0,     0,     0,   601,
       0,     0,     0,     0,     0,     0,     0,   602,     0,     0,
       0,     0,   603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,   604,   769,     0,  1432,     0,  1823,
     791,     0,     0,     0,     0,     0,     0,   605,     0,     0,
       0,     0,     0,     0,     0,   791,     0,   769,  1432,     0,
     769,     0,   769,     0,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   769,     0,     0,     0,   769,
       0,     0,     0,     0,  1432,   791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,     0,     0,     0,     0,
    1610,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,   791,   790,     0,     0,     0,  1822,     0,     0,     0,
       0,     0,  1432,     0,     0,     0,  1432,  1432,     0,  1634,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1659,  1660,     0,
    1662,     0,     0,     0,     0,     0,   769,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,  1704,
       0,     0,     0,     0,     0,   769,     0,     0,   790,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1432,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,   790,  1740,
       0,   769,     0,     0,   769,   791,     0,     0,     0,     0,
       0,     0,     0,   791,   791,     0,     0,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,  1844,     0,
       0,     0,  1856,  1859,     0,     0,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   789,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
    1823,  1823,     0,     0,     0,     0,     0,  1824,     0,     0,
       0,     0,     0,     0,   769,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,   769,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,   769,   769,     0,
       0,     0,     0,     0,     0,   790,     0,     0,   789,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,     0,     0,     0,     0,     0,     0,     0,   790,     0,
       0,     0,     0,     0,   769,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1822,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,   790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,   790,   769,     0,     0,     0,     0,  1822,     0,     0,
       0,   769,     0,     0,     0,  1822,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   790,     0,
       0,     0,   791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,     0,   790,   791,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2347,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2370,     0,     0,  2372,     0,     0,
    2383,     0,     0,     0,     0,     0,     0,  2390,  2395,     0,
       0,     0,     0,  2401,     0,     0,  2406,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2415,     0,     0,     0,     0,  2422,     0,
       0,     0,  2434,     0,     0,     0,  2441,     0,  2443,  2444,
    2445,  2446,  2447,  2448,  2449,  2450,  2451,  1824,  2452,     0,
       0,     0,     0,     0,     0,     0,  1114,  2480,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1422,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,  1430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,     0,     0,     0,     0,  1823,     0,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1174,     0,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,  1422,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,     0,  1824,   791,     0,     0,   791,     0,  2585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,   790,   791,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1724,     0,     0,     0,     0,   790,
       0,  1824,   791,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1422,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,   791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,  1430,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1422,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2802,     0,
       0,  1430,  1422,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1430,     0,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1422,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,  1422,     0,  1823,
       0,     0,     0,     0,     0,   791,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,  1422,     0,     0,
       0,  2927,   790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1430,     0,   790,     0,     0,     0,     0,   791,
       0,     0,  1422,     0,     0,     0,     0,   790,     0,     0,
       0,     0,  1430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,  1430,     0,     0,
       0,  1699,     0,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,     0,     0,     0,     0,   791,     0,  1422,
       0,     0,     0,  2973,     0,     0,     0,     0,  2979,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1430,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2395,     0,  2395,  2395,     0,     0,     0,     0,     0,  1699,
       0,     0,     0,  3036,     0,     0,  3039,     0,  3041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1824,     0,  1699,     0,     0,     0,  1824,  2379,     0,
       0,     0,     0,     0,     0,  3062,     0,  3064,     0,     0,
       0,  3067,     0,     0,     0,     0,   790,     0,  1699,  1699,
       0,  1699,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2480,  2480,  2480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3110,     0,  1424,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,  1844,     0,     0,     0,     0,  3121,     0,     0,
     791,     0,     0,  1859,     0,     0,  1422,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1699,
       0,     0,     0,     0,     0,     0,     0,     0,   790,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3157,
       0,   791,     0,     0,     0,     0,     0,   790,     0,     0,
       0,     0,     0,     0,     0,     0,   791,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,   791,  1823,     0,   790,
       0,     0,     0,     0,  1424,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1699,     0,     0,  1699,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1824,  1824,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,  1422,     0,     0,     0,  1422,
    1422,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,  1430,  1430,     0,     0,     0,     0,
       0,     0,  1823,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1422,     0,     0,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,   791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   791,     0,   791,
    1430,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,   790,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3484,     0,     0,     0,   791,     0,     0,
     791,     0,     0,  3488,  1422,     0,     0,     0,  1424,  3489,
       0,  3490,     0,     0,   790,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,  3508,  3509,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,     0,  2401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3537,     0,     0,  3540,     0,  3542,
       0,     0,  1424,     0,     0,  1824,     0,     0,  3546,     0,
       0,     0,     0,  1422,  3551,     0,     0,  3554,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3595,     0,     0,  1430,     0,
       0,  3602,  2480,     0,     0,     0,     0,     0,     0,  1424,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3614,     0,     0,     0,  1425,
       0,  1114,     0,  1823,     0,     0,  1699,  1174,     0,     0,
       0,  1823,     0,     0,     0,     0,     0,  1422,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1699,
       0,  1699,     0,  2379,  2379,  3010,     0,     0,  2379,     0,
       0,     0,  1699,     0,     0,     0,     0,     0,     0,  1699,
       0,     0,  1430,  1425,  1699,     0,     0,     0,     0,     0,
    1699,     0,     0,     0,     0,  1699,     0,     0,     0,     0,
       0,     0,     0,     0,  1699,     0,     0,     0,  2379,  2379,
       0,  1699,     0,   791,     0,     0,  1427,     0,     0,  1425,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
    1699,     0,  1699,  1699,  1699,  1699,  1699,  1699,  1699,  1699,
    1699,  1699,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1824,     0,     0,     0,     0,  1824,     0,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,  1425,     0,     0,     0,     0,
     791,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,  1824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1699,     0,     0,     0,     0,     0,
    1422,     0,     0,  1422,     0,  1422,     0,     0,     0,     0,
    1422,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,   791,     0,     0,     0,     0,
       0,   791,     0,     0,  1427,  1430,  1425,     0,  1430,     0,
    1430,     0,     0,  3859,  3860,  1430,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1422,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,     0,     0,
    1422,     0,  3890,     0,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,  1424,     0,     0,     0,  1424,
    1424,     0,     0,     0,  1427,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3908,
    3910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1422,  3917,  1422,     0,     0,     0,     0,  3922,  3923,
       0,     0,  3925,     0,     0,  3928,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1430,     0,  1430,     0,
    1427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1699,  2480,  1425,     0,     0,     0,  2480,  1422,  1427,
       0,     0,  2480,     0,     0,  1424,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,  1422,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,  3978,     0,     0,
    1428,     0,  1422,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1430,     0,
    1422,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,  1430,     0,  1824,     0,     0,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1699,     0,     0,     0,
     791,     0,     0,     0,  1422,     0,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,     0,     0,     0,     0,
    1422,     0,     0,     0,     0,   791,     0,     0,     0,     0,
       0,  1422,     0,     0,  1424,     0,     0,     0,     0,  1430,
       0,     0,  1699,     0,     0,     0,     0,     0,  1699,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,     0,     0,
       0,     0,     0,     0,  3010,  3010,  1430,  2379,   791,     0,
    2379,  2379,  2379,  2379,  2379,  2379,  2379,  2379,  2379,  2379,
    3010,     0,  1425,  4074,     0,     0,  1425,  1425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1422,     0,     0,     0,     0,  1699,     0,     0,  1699,     0,
    1699,     0,     0,  1424,     0,  3010,  3010,     0,  1428,     0,
    1422,     0,     0,     0,     0,     0,     0,     0,     0,  2379,
    2379,  1699,     0,  1699,     0,  1430,  1699,     0,     0,     0,
       0,     0,     0,     0,     0,  1422,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,     0,     0,     0,  1699,
    1430,  1422,     0,     0,   791,     0,     0,     0,     0,     0,
    1699,     0,  1425,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,  4156,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,     0,  1430,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1699,     0,     0,     0,
       0,     0,     0,     0,     0,  4179,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1422,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,   791,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1430,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,     0,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,  1824,     0,   791,  1422,     0,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,  1427,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1425,  2401,     0,     0,     0,     0,     0,     0,  2379,     0,
    1424,     0,     0,  1424,     0,  1424,     0,     0,     0,     0,
    1424,     0,     0,     0,     0,     0,  4321,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1424,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,     0,     0,  1422,
    1824,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1424,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1430,     0,  1422,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,  4395,  1699,  1699,  1699,
       0,     0,  3010,     0,     0,     0,     0,  3010,  3010,  3010,
    3010,  3010,  3010,  3010,  3010,  3010,  3010,  1699,  1699,     0,
       0,  1430,  1428,     0,     0,     0,     0,     0,     0,     0,
       0,  1424,     0,  1424,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1699,  2379,  2379,  1699,
       0,  1699,     0,     0,     0,  1699,  3010,  3010,     0,     0,
    1699,     0,     0,  1699,     0,     0,  1427,  4440,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1424,     0,
       0,     0,     0,     0,     0,     0,  1422,     0,     0,     0,
       0,     0,  1429,     0,  1699,     0,     0,  1422,     0,     0,
       0,  1699,   791,  1424,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,  1430,  1424,     0,     0,     0,     0,     0,  4485,  4485,
       0,     0,  1430,     0,     0,  1427,     0,     0,     0,     0,
    1424,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,     0,  1425,     0,     0,
    1425,     0,  1425,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,  4485,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,  4541,     0,     0,     0,  1422,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
    1424,  1428,     0,     0,     0,  1428,  1428,  1425,     0,     0,
       0,  1424,     0,     0,     0,     0,     0,  1422,     0,     0,
       0,     0,     0,     0,  1430,     0,     0,     0,     0,     0,
       0,  1824,     0,     0,     0,     0,  1422,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,  1430,  4485,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1430,     0,     0,     0,     0,     0,  1429,     0,     0,
    1424,  1824,     0,     0,  1422,     0,  3010,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1424,     0,  1429,     0,     0,     0,     0,     0,  1425,     0,
    1425,  1428,     0,     0,     0,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,  1424,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1699,  1699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,  1424,     0,     0,     0,  1425,     0,     0,     0,  1699,
       0,     0,     0,  2379,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1699,     0,  1699,
    1425,     0,     0,     0,  3010,  3010,  1699,     0,     0,  2379,
    2379,  1699,  1699,     0,  1699,     0,     0,  1699,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,  1422,  1427,     0,     0,  1427,     0,  1427,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1699,     0,     0,
    1428,     0,     0,     0,     0,     0,  1430,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,  1429,     0,  1424,  1428,
       0,     0,     0,     0,     0,  1422,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,     0,  1427,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3010,  2379,     0,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,  1425,  3010,  3010,  1699,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,  1422,     0,     0,     0,     0,     0,  1699,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,  1422,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1430,     0,  1424,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1430,  1422,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1430,  1429,     0,  1422,     0,  1429,
    1429,  1422,  1422,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,     0,     0,     0,
       0,     0,  1430,     0,  3010,     0,  1430,  1430,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
    1699,     0,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,  1425,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,  1429,  1428,     0,     0,  1428,
       0,  1428,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,  1427,     0,  1699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,  1427,     0,  1699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1427,     0,     0,  1428,     0,     0,  1424,
       0,     0,     0,     0,  1699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,     0,  1425,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,  1428,
    1699,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1425,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,  1425,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,  1424,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1425,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1425,     0,  1424,  1428,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,  1429,     0,  1429,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,  1424,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1424,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,  1424,  1424,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,  1429,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,  1427,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,  1429,     0,     0,     0,     0,     0,
    1425,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1425,     0,     0,     0,
       0,     0,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,     0,  1425,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,  1427,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,  1428,  1428,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1398,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,     0,     0,
     745,     0,     0,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,     0,  1429,   243,     0,   244,   245,   246,
     247,     0,     0,   746,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,     0,     0,     0,   749,     0,     0,     0,
     263,   264,   265,   266,   267,   268,     0,     0,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,     0,   297,   298,   299,     0,     0,   301,     0,   302,
     303,     0,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,     0,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,     0,   330,
     331,   332,   333,     0,     0,     0,     0,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,     0,   344,
     345,  1429,   346,     0,   757,   348,   758,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,     0,   759,     0,   367,
     368,     0,     0,   370,   371,   760,   372,     0,     0,   374,
       0,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,     0,   761,   385,   762,     0,   387,
     388,   389,   390,   391,   392,   393,     0,   394,     0,   396,
       0,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,     0,   430,   431,   432,
     433,   434,   435,   436,   437,  1429,   438,   439,   440,   441,
     442,     0,   443,     0,   445,   446,   764,   447,     0,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,     0,     0,     0,     0,   471,     0,   473,
       0,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,     0,     0,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   743,  1032,   573,  1033,  1034,  1035,   624,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,  2474,   220,   221,   222,     0,  1429,     0,     0,
    1037,  1429,  1429,   223,   224,     0,   225,   226,   744,   227,
     228,   229,   230,  1038,   745,  1039,  1040,     0,   234,   235,
     236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,
       0,   244,   245,   246,   247,  1045,     0,  1046,     0,   249,
     250,   251,   252,   747,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,   748,   261,   262,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,   268,
    1054,  1055,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,  2475,     0,   281,   282,  1056,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,  1057,   297,   298,   299,  1058,
    1059,   301,     0,   302,   303,  1060,   305,     0,   306,     0,
     307,   750,     0,   751,   308,   309,   310,     0,   311,  1061,
       0,   313,     0,   314,   315,   316,   317,   318,   752,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,     0,
     328,   753,   329,   330,   331,   332,   333,  1062,  1063,     0,
    1064,     0,   337,   754,   755,   338,   756,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,  1065,   757,   348,
     758,     0,   349,   350,   351,  1066,  1067,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
    1068,   759,  1069,   367,   368,   369,  1070,   370,   371,   760,
     372,  1071,  1072,   374,  1073,   376,   377,   378,     0,   379,
       0,     0,  1074,   381,   382,     0,     0,   383,   384,   761,
     385,   762,  1075,   387,   388,   389,   390,   391,   392,   393,
       0,   394,  1076,   396,   397,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,  1077,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   763,   427,   428,
    1078,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,  1079,   443,   444,   445,   446,
     764,   447,  1080,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1081,     0,   461,   462,     0,
     463,   464,   465,   466,   467,   468,     0,  1082,  1083,     0,
       0,   471,  1084,   473,  1085,  1086,   475,   476,   477,   478,
     479,   480,   481,     0,  1087,   482,   483,   484,   485,   486,
    1088,     0,   487,   488,   489,   490,   491,   492,  1089,  2476,
     494,   765,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,   506,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,     0,  1098,  1099,  2477,
       0,     0,     0,     0,     0,     0,  1101,  2478,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,   210,     0,     0,     0,     0,     0,
       0,  1101,  2381,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,  3573,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0, -1494,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0, -1494,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328, -1494,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338, -1494,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347, -1494,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365, -1494,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426, -1494,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1181,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,     0,  1399,   745,
    1400,  1401,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,  1402,  1403,   243,     0,   244,   245,   246,   247,
       0,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,  1404,  1405,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
       0,   297,   298,   299,     0,     0,   301,     0,   302,   303,
    1406,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,     0,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,  1878,   322,   323,
     324,   325,   326,   327,     0,   328,   753,  1879,   330,   331,
     332,   333,  1407,  1408,     0,  1409,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,     0,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1410,   759,  1411,   367,   368,
       0,     0,   370,   371,   760,   372,     0,     0,   374,  1412,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,  1881,   761,   385,   762,     0,   387,   388,
     389,   390,   391,   392,   393,     0,   394,     0,   396,     0,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1413,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,     0,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,  1882,   445,   446,   764,   447,  1415,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1416,  1417,     0,     0,   471,     0,   473,     0,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,     0,  1418,  1883,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,     0,  1398,     0,     0,     0,     0,     0,     0,
       0,   515,   516,   517,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
       0,     0,  1981,   223,   224,     0,   225,   226,   744,   227,
     228,   229,     0,  1399,   745,  1400,  1401,     0,   234,   235,
     236,   237,   238,     0,     0,   239,   240,  1402,  1403,   243,
       0,   244,   245,   246,   247,     0,     0,   746,     0,   249,
     250,   251,   252,   747,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,   748,   261,   262,     0,     0,     0,
     749,     0,     0,     0,   263,   264,   265,   266,   267,   268,
    1404,  1405,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,  1056,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,     0,   297,   298,   299,     0,
       0,   301,     0,   302,   303,  1406,   305,     0,   306,     0,
     307,   750,     0,   751,   308,   309,   310,     0,   311,     0,
       0,   313,     0,   314,   315,   316,   317,   318,   752,   319,
     320,   321,  1878,   322,   323,   324,   325,   326,   327,     0,
     328,   753,  1879,   330,   331,   332,   333,  1407,  1408,     0,
    1409,     0,   337,   754,   755,   338,   756,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,     0,   757,   348,
     758,     0,   349,   350,   351,     0,     0,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
    1410,   759,  1411,   367,   368,     0,     0,   370,   371,   760,
     372,     0,     0,   374,  1412,   376,   377,   378,     0,   379,
       0,     0,   380,   381,   382,     0,     0,   383,  1881,   761,
     385,   762,     0,   387,   388,   389,   390,   391,   392,   393,
       0,   394,     0,   396,     0,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,  1413,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   763,   427,   428,
       0,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,     0,   443,  1882,   445,   446,
     764,   447,  1415,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,     0,   461,   462,     0,
     463,   464,   465,   466,   467,   468,     0,  1416,  1417,     0,
       0,   471,     0,   473,     0,     0,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
       0,     0,   487,   488,   489,   490,   491,     0,  1418,  1883,
     494,   765,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,   515,   516,   517,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,  2891,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,  2391,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,  2392,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
    2393,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,  2394,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,     0,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,  1070,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,    38,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,    42,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,   479,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   971,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,    47,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,  1605,  2339,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,  1070,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,  1087,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  1098,  1099,  1100,     0,     0,     0,
       0,     0,     0,  1101,   743,  1032,   573,  1033,  1034,  1035,
     624,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,  1037,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,  1038,   745,  1039,  1040,     0,   234,
     235,   236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,
     243,     0,   244,   245,   246,   247,  1045,     0,  1046,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,
     268,  1054,  1055,   271,  1173,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,  1057,   297,   298,   299,
    1058,  1059,   301,     0,   302,   303,  1060,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
    1061,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,  1062,  1063,
       0,  1064,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,  1065,   757,
     348,   758,     0,   349,   350,   351,  1066,  1067,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1068,   759,  1069,   367,   368,   369,  1070,   370,   371,
     760,   372,  1071,  1072,   374,  1073,   376,   377,   378,     0,
     379,     0,     0,  1074,   381,   382,     0,     0,   383,   384,
     761,   385,   762,  1075,   387,   388,   389,   390,   391,   392,
     393,     0,   394,  1076,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1077,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,  1078,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,  1079,   443,   444,   445,
     446,   764,   447,  1080,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1081,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1082,  1083,
       0,     0,   471,  1084,   473,  1085,  1086,   475,   476,   477,
     478,   479,   480,   481,     0,  1087,   482,   483,   484,   485,
     486,  1088,     0,   487,   488,   489,   490,   491,   492,  1089,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,  1854,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,     0,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,  2392,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,  1070,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,   479,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,  3603,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,  1070,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,  1087,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  1098,  1099,     0,     0,     0,     0,
       0,     0,     0,  1101,   743,  1032,   573,  1033,  1034,  1035,
     624,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,  1037,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,  1038,   745,  1039,  1040,     0,   234,
     235,   236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,
     243,     0,   244,   245,   246,   247,  1045,     0,  1046,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,  3613,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,
     268,  1054,  1055,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,  1057,   297,   298,   299,
    1058,  1059,   301,     0,   302,   303,  1060,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
    1061,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,  1062,  1063,
       0,  1064,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,  1065,   757,
     348,   758,     0,   349,   350,   351,  1066,  1067,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1068,   759,  1069,   367,   368,   369,  1070,   370,   371,
     760,   372,  1071,  1072,   374,  1073,   376,   377,   378,     0,
     379,     0,     0,  1074,   381,   382,     0,     0,   383,   384,
     761,   385,   762,  1075,   387,   388,   389,   390,   391,   392,
     393,     0,   394,  1076,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1077,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,  1078,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,  1079,   443,   444,   445,
     446,   764,   447,  1080,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1081,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1082,  1083,
       0,     0,   471,  1084,   473,  1085,  1086,   475,   476,   477,
     478,   479,   480,   481,     0,  1087,   482,   483,   484,   485,
     486,  1088,     0,   487,   488,   489,   490,   491,   492,  1089,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,  3900,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,     0,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,  3909,   369,  1070,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,   479,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,  4482,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,  4483,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,  4484,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,  4483,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,  1070,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,  4484,   480,   481,
       0,  1087,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  1098,  1099,     0,     0,     0,     0,
       0,     0,     0,  1101,   743,  1032,   573,  1033,  1034,  1035,
     624,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,  1037,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,  1038,   745,  1039,  1040,     0,   234,
     235,   236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,
     243,     0,   244,   245,   246,   247,  1045,     0,  1046,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,
     268,  1054,  1055,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,  1057,   297,   298,   299,
    1058,  1059,   301,     0,   302,   303,  1060,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
    1061,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,  1062,  1063,
       0,  1064,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,  1065,   757,
     348,   758,     0,   349,   350,   351,  1066,  1067,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1068,   759,  1069,   367,   368,   369,     0,   370,   371,
     760,   372,  1071,  1072,   374,  1073,   376,   377,   378,     0,
     379,     0,     0,  1074,   381,   382,     0,     0,   383,   384,
     761,   385,   762,  1075,   387,   388,   389,   390,   391,   392,
     393,     0,   394,  1076,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1077,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,  1078,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,  1079,   443,   444,   445,
     446,   764,   447,  1080,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1081,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1082,  1083,
       0,     0,   471,  1084,   473,  1085,  1086,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,  1088,     0,   487,   488,   489,   490,   491,   492,  1089,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  2374,  2375,
       0,     0,     0,     0,     0,     0,     0,  1101,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229, -2275,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,  4483,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,     0,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,     0,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,     0,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,  4484,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,     0,     0,   743,  1032,   573,  1033,
    1034,  1101,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,     0,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,   743,
    1032,   573,  1033,  1034,     0,   624,  1036,     0,     0,  1101,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,  1037,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,   230,  1038,
     745,  1039,  1040,     0,  3521,   235,   236,   237,   238,  1041,
    1042,   239,   240,  1043,  1044,   243,     0,   244,   245,   246,
     247,  1045,     0,  1046,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     263,   264,   265,   266,   267,   268,  1054,  1055,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,  1056,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,  1057,   297,   298,   299,  1058,  1059,   301,     0,   302,
     303,  1060,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,  1061,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,   329,   330,
     331,   332,   333,  1062,  1063,     0,  1064,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,  1065,   757,   348,   758,     0,   349,   350,
     351,  1066,  1067,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,  1068,   759,  1069,   367,
     368,   369,     0,   370,   371,   760,   372,  1071,  1072,   374,
    1073,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,   761,   385,   762,  1075,   387,
     388,   389,   390,   391,   392,   393,     0,   394,  1076,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,  1077,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,  1078,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,  1079,   443,   444,   445,   446,   764,   447,  1080,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,  1081,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,  1082,  1083,     0,     0,   471,  1084,   473,
    1085,  1086,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,  1088,     0,   487,   488,
     489,   490,   491,   492,  1089,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,  1101,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,     0,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,     0,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,     0,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,     0,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,     0,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,   479,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,     0,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,     0,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,     0,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,     0,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,     0,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,   743,
    2374,  2375,     0,     0,     0,     0,     0,     0,     0,  1101,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,   230,   231,
     745,   232,   233,     0,   234,   235,   236,   237,   238,     0,
    1042,   239,   240,   241,   242,   243,     0,   244,   245,   246,
     247,  1045,     0,  1046,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,  1058,     0,   301,     0,   302,
     303,   304,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,  1061,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,  3082,   344,
     345,     0,   346,  1065,   757,   348,   758,     0,   349,   350,
     351,  1066,  1067,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   759,   366,   367,
     368,   369,     0,   370,   371,   760,   372,     0,  1072,   374,
     375,   376,   377,   378,     0,   379,     0,   708,   380,   381,
     382,     0,     0,   383,   384,   761,   385,   762,  1075,   387,
     388,   389,   390,   391,   392,   393,     0,   394,  1076,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,   429,  3083,   431,   432,
     433,   434,   435,   436,   437,    38,   438,   439,   440,   441,
     442,  1079,   443,   444,   445,   446,   764,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,  1081,     0,   461,   462,    42,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,  1084,   473,
    1085,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,  1088,     0,   487,   488,
     489,   490,   491,   971,   493,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,    47,   500,   501,   502,
     503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,   743,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3084,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,  1042,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,  1058,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,  3082,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,  1072,   374,   375,   376,   377,   378,     0,   379,     0,
     708,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
    3083,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,  1084,   473,  1085,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,   743,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3084,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
     744,   227,   228,   229,   230,   231,   745,   232,   233,     0,
     234,   235,   236,   237,   238,     0,  1042,   239,   240,   241,
     242,   243,     0,   244,   245,   246,   247,  1045,     0,  1046,
       0,   249,   250,   251,   252,   747,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,   748,   261,   262,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,  1058,     0,   301,     0,   302,   303,   304,   305,     0,
     306,     0,   307,   750,     0,   751,   308,   309,   310,     0,
     311,  1061,     0,   313,     0,   314,   315,   316,   317,   318,
     752,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,   753,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,   754,   755,   338,   756,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,  1065,
     757,   348,   758,     0,   349,   350,   351,  1066,  1067,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   759,   366,   367,   368,   369,     0,   370,
     371,   760,   372,     0,  1072,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,   761,   385,   762,  1075,   387,   388,   389,   390,   391,
     392,   393,     0,   394,  1076,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   763,
     427,   428,   429,  3083,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,  1079,   443,   444,
     445,   446,   764,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,  1081,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,  1084,   473,  1085,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,  1088,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   765,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,
     517,     0,     0,     0,     0,     0,     0,     0,   743,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    48,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,  1042,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,  1058,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,  1072,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,  1084,   473,  1085,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,   786,  1289,   573,     0,     0,     0,   624,     0,     0,
       0,  3638,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,     0,     0,
       0,   223,   224,     0,   225,   226,   744,   227,   228,   229,
     230,   231,   745,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,   239,   240,   241,   242,   243,     0,   244,
     245,   246,   247,   248,     0,   746,     0,   249,   250,   251,
     252,   747,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,   748,   261,   262,     0,     0,     0,   749,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,     0,   272,     0,   273,   274,   275,   276,   277,     0,
     278,   279,   280,     0,     0,   281,   282,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,  1537,   301,
       0,   302,   303,   304,   305,     0,   306,     0,   307,   750,
       0,   751,   308,   309,   310,     0,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   752,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,     0,   328,   753,
     329,   330,   331,   332,   333,   334,   335,     0,   336,     0,
     337,   754,   755,   338,   756,   339,   340,   341,   342,   343,
       0,   344,   345,     0,   346,   347,   757,   348,   758,     0,
     349,   350,   351,     0,     0,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   759,
     366,   367,   368,   369,     0,   370,   371,   760,   372,     0,
     373,   374,   375,   376,   377,   378,     0,   379,  1538,     0,
     380,   381,   382,     0,     0,   383,   384,   761,   385,   762,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   763,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   764,   447,
     448,   449,     0,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,     0,   461,   462,     0,   463,   464,
     465,   466,   467,   468,     0,   469,   470,     0,     0,   471,
     472,   473,   474,  1539,   475,   476,   477,   478,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,     0,     0,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   765,
     495,   496,   497,   498,     0,     0,   499,     0,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,     0,     0,     0,
       0,     0,     0,     0,   786,  1290,  1291,  4054,     0,     0,
       0,     0,     0,     0,  4055,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     3,     4,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      38,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
      42,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   971,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,    47,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,   743,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    48,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,     0,     0,     0,   223,   224,     0,
     225,   226,   744,   227,   228,   229,   230,   231,   745,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,   239,
     240,   241,   242,   243,     0,   244,   245,   246,   247,   248,
       0,   746,     0,   249,   250,   251,   252,   747,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,   748,   261,
     262,     0,     0,     0,   749,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,     0,   272,     0,
     273,   274,   275,   276,   277,     0,   278,   279,   280,     0,
       0,   281,   282,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,     0,   306,     0,   307,   750,     0,   751,   308,   309,
     310,     0,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   752,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,     0,   328,   753,   329,   330,   331,   332,
     333,   334,   335,     0,   336,     0,   337,   754,   755,   338,
     756,   339,   340,   341,   342,   343,     0,   344,   345,     0,
     346,   347,   757,   348,   758,     0,   349,   350,   351,     0,
       0,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   759,   366,   367,   368,   369,
       0,   370,   371,   760,   372,     0,   373,   374,   375,   376,
     377,   378,     0,   379,     0,     0,   380,   381,   382,     0,
       0,   383,   384,   761,   385,   762,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   763,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,     0,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   764,   447,   448,   449,     0,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
       0,   461,   462,     0,   463,   464,   465,   466,   467,   468,
       0,   469,   470,     0,     0,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,     0,     0,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   765,   495,   496,   497,   498,
       0,     0,   499,     0,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4214,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    38,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,    42,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   971,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,    47,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    48,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,   223,   224,     0,   225,   226,     0,   227,
     228,   229,   230,   231,     0,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,   239,   240,   241,   242,   243,
       0,   244,   245,   246,   247,   248,     0,     0,     0,   249,
     250,   251,   252,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,     0,     0,     0,
       0,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,     0,   306,     0,
     307,     0,     0,     0,   308,   309,   310,     0,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,     0,
     328,     0,   329,   330,   331,   332,   333,   334,   335,     0,
     336,     0,   337,     0,     0,   338,     0,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,   347,     0,   348,
       0,     0,   349,   350,   351,     0,     0,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,     0,   366,   367,   368,   369,     0,   370,   371,     0,
     372,     0,   373,   374,   375,   376,   377,   378,     0,   379,
       0,     0,   380,   381,   382,     0,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
       0,   447,   448,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,     0,   461,   462,     0,
     463,   464,   465,   466,   467,   468,     0,   469,   470,     0,
       0,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
       0,     0,   487,   488,   489,   490,   491,   492,   493,     0,
     494,     0,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1157,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2529,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   245,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3557,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,  1398,  1289,   573,     0,     0,
     797,   624,     0,     0,     0,  3951,   211,   212,   213,   214,
     215,   216,   217,   218,  1742,   220,   221,   222,  1743,  1744,
    1745,  1746,  1747,  1748,  1749,   223,   224,  1750,   225,   226,
     744,   227,   228,   229,     0,  1399,   745,  1400,  1401,  1751,
     234,   235,   236,   237,   238,  1752,  1753,   239,   240,  1402,
    1403,   243,  1754,   244,   245,   246,   247,     0,  1755,   746,
    1756,   249,   250,   251,   252,   747,   253,   254,  1757,   255,
     256,   257,   258,   259,   260,  1758,   748,   261,   262,  1759,
    1760,  1761,   749,  1762,  1763,  1764,   263,   264,   265,   266,
     267,   268,  1404,  1405,   271,  1765,   272,  1766,   273,   274,
     275,   276,   277,  1767,   278,   279,   280,  1768,  1769,   281,
     282,  1056,   284,   285,  1770,   286,   287,   288,  1771,   289,
     290,   291,  1772,   292,   293,   294,   295,     0,   297,   298,
     299,     0,  1773,   301,  1774,   302,   303,  1406,   305,  1775,
     306,  1776,   307,   750,  1777,   751,   308,   309,   310,  1778,
     311,     0,  1779,   313,  1780,   314,   315,   316,   317,   318,
     752,   319,   320,   321,  1781,   322,   323,   324,   325,   326,
     327,  1782,   328,   753,     0,   330,   331,   332,   333,  1407,
    1408,  1783,  1409,  1784,   337,   754,   755,   338,   756,   339,
     340,   341,   342,   343,  1785,   344,   345,  1786,   346,     0,
     757,   348,   758,  1787,   349,   350,   351,  1788,  1789,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,  1410,   759,  1411,   367,   368,     0,  1790,   370,
     371,   760,   372,  1791,     0,   374,  1412,   376,   377,   378,
    1792,   379,  1793,  1794,  3318,   381,   382,  1795,  1796,   383,
       0,   761,   385,   762,     0,   387,   388,   389,   390,   391,
     392,   393,  1797,   394,     0,   396,     0,   398,   399,   400,
    1798,   401,   402,   403,   404,   405,   406,   407,   408,  1413,
     410,   411,   412,   413,  1799,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,  1800,   425,   426,   763,
     427,   428,     0,   430,   431,   432,   433,   434,   435,   436,
     437,  1801,   438,   439,   440,   441,   442,  1802,   443,  1882,
     445,   446,   764,   447,  1415,   449,  1803,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,  1804,   461,
     462,  1805,   463,   464,   465,   466,   467,   468,  1806,  1416,
    1417,  1807,  1808,   471,     0,   473,     0,  1809,   475,   476,
     477,   478,   479,   480,   481,  1810,  1811,   482,   483,   484,
     485,   486,  1812,  1813,   487,   488,   489,   490,   491,     0,
    1418,  1814,   494,   765,   495,   496,   497,   498,  1815,  1816,
     499,  1817,  1818,   500,   501,   502,   503,   504,   505,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,  3319,
    3320,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   798,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   799,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   894,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   895,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   944,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   945,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   946,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,  1383,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,  1384,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   245,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,  2606,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,  2607,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   210,     0,     0,     0,     0,
     797,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
       0,   227,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   245,   246,   247,   248,     0,     0,
       0,   249,   250,   251,   252,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,     0,
       0,     0,     0,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,     0,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,     0,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,     0,     0,   338,     0,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
       0,   348,     0,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,     0,   366,   367,   368,   369,     0,   370,
     371,     0,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,     0,     0,  4193,   381,   382,     0,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,     0,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,     0,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,  1741,   800,   801,   802,     0,   803,
     804,   805,   806,   807,   808,   211,   212,   213,   214,   215,
     216,   217,   218,  1742,   220,   221,   222,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,   223,   224,  1750,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,  1751,   234,
     235,   236,   237,   238,  1752,  1753,   239,   240,   241,   242,
     243,  1754,   244,   245,   246,   247,   248,  1755,   746,  1756,
     249,   250,   251,   252,   747,   253,   254,  1757,   255,   256,
     257,   258,   259,   260,  1758,   748,   261,   262,  1759,  1760,
    1761,   749,  1762,  1763,  1764,   263,   264,   265,   266,   267,
     268,   269,   270,   271,  1765,   272,  1766,   273,   274,   275,
     276,   277,  1767,   278,   279,   280,  1768,  1769,   281,   282,
     283,   284,   285,  1770,   286,   287,   288,  1771,   289,   290,
     291,  1772,   292,   293,   294,   295,   296,   297,   298,   299,
     300,  1773,   301,  1774,   302,   303,   304,   305,  1775,   306,
    1776,   307,   750,  1777,   751,   308,   309,   310,  1778,   311,
     312,  1779,   313,  1780,   314,   315,   316,   317,   318,   752,
     319,   320,   321,  1781,   322,   323,   324,   325,   326,   327,
    1782,   328,   753,   329,   330,   331,   332,   333,   334,   335,
    1783,   336,  1784,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,  1785,   344,   345,  1786,   346,   347,   757,
     348,   758,  1787,   349,   350,   351,  1788,  1789,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,  1790,   370,   371,
     760,   372,  1791,   373,   374,   375,   376,   377,   378,  1792,
     379,  1793,  1794,   380,   381,   382,  1795,  1796,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,  1797,   394,   395,   396,   397,   398,   399,   400,  1798,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,  1799,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1800,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1801,   438,   439,   440,   441,   442,  1802,   443,   444,   445,
     446,   764,   447,   448,   449,  1803,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,  1804,   461,   462,
    1805,   463,   464,   465,   466,   467,   468,  1806,   469,   470,
    1807,  1808,   471,   472,   473,   474,  1809,   475,   476,   477,
     478,   479,   480,   481,  1810,  1811,   482,   483,   484,   485,
     486,  1812,  1813,   487,   488,   489,   490,   491,   492,   493,
    1814,   494,   765,   495,   496,   497,   498,  1815,  1816,   499,
    1817,  1818,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1819,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,  1398,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   713,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,     0,  1399,   745,  1400,  1401,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
    1402,  1403,   243,     0,   244,   245,   246,   247,     0,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,  1404,  1405,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,     0,   297,
     298,   299,     0,     0,   301,     0,   302,   303,  1406,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,     0,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,  1878,   322,   323,   324,   325,
     326,   327,     0,   328,   753,  1879,   330,   331,   332,   333,
    1407,  1408,     0,  1409,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
       0,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1410,   759,  1411,   367,   368,     0,     0,
     370,   371,   760,   372,     0,     0,   374,  1412,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,  1880,
     383,  1881,   761,   385,   762,     0,   387,   388,   389,   390,
     391,   392,   393,     0,   394,     0,   396,     0,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1413,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,     0,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
    1882,   445,   446,   764,   447,  1415,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1416,  1417,     0,     0,   471,     0,   473,     0,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
       0,  1418,  1883,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
       0,     0,     0,  2135,     0,     0,     0,     0,     0,   515,
     516,   517,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,  1884,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,   223,   224,     0,   225,   226,   744,   227,
     228,   229,     0,  1399,   745,  1400,  1401,     0,   234,   235,
     236,   237,   238,     0,     0,   239,   240,  1402,  1403,   243,
       0,   244,   245,   246,   247,     0,     0,   746,     0,   249,
     250,   251,   252,   747,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,   748,   261,   262,     0,     0,     0,
     749,     0,     0,     0,   263,   264,   265,   266,   267,   268,
    1404,  1405,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,  1056,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,     0,   297,   298,   299,     0,
       0,   301,     0,   302,   303,  1406,   305,     0,   306,     0,
     307,   750,     0,   751,   308,   309,   310,     0,   311,     0,
       0,   313,     0,   314,   315,   316,   317,   318,   752,   319,
     320,   321,  1878,   322,   323,   324,   325,   326,   327,     0,
     328,   753,  1879,   330,   331,   332,   333,  1407,  1408,     0,
    1409,     0,   337,   754,   755,   338,   756,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,     0,   757,   348,
     758,     0,   349,   350,   351,     0,     0,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
    1410,   759,  1411,   367,   368,     0,     0,   370,   371,   760,
     372,     0,     0,   374,  1412,   376,   377,   378,     0,   379,
       0,     0,   380,   381,   382,     0,  1880,   383,  1881,   761,
     385,   762,     0,   387,   388,   389,   390,   391,   392,   393,
       0,   394,     0,   396,     0,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,  1413,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   763,   427,   428,
       0,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,     0,   443,  1882,   445,   446,
     764,   447,  1415,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,     0,   461,   462,     0,
     463,   464,   465,   466,   467,   468,     0,  1416,  1417,     0,
       0,   471,     0,   473,     0,     0,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
       0,     0,   487,   488,   489,   490,   491,     0,  1418,  1883,
     494,   765,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,     0,     0,     0,
     210,     0,     0,     0,     0,     0,   515,   516,   517,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,  1884,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   786,  1289,   573,     0,
       0,     0,   624,     0,     0,     0,  4241,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,  1731,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,  1537,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,  1538,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,  1539,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   786,  1289,   573,     0,     0,     0,   624,     0,
    1290,  1291,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,  1736,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,  1537,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,  1538,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,  1539,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   786,  1289,
     573,     0,     0,     0,   624,     0,  1290,  1291,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,  1537,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,  1538,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
    1539,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
     624,     0,  1290,  1291,     0,   211,   625,   213,   214,   215,
     216,   217,   218,   626,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     627,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   628,   304,   305,     0,   306,
       0,   629,     0,   630,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   631,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   632,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   633,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     634,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   635,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
    1741,  4551,   573,     0,     0,     0,   624,     0,   636,   637,
       0,   211,   212,   213,   214,   215,   216,   217,   218,  1742,
     220,   221,   222,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
     223,   224,  1750,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,  1751,   234,   235,   236,   237,   238,
    1752,  1753,   239,   240,   241,   242,   243,  1754,   244,   245,
     246,   247,   248,  1755,   746,  1756,   249,   250,   251,   252,
     747,   253,   254,  1757,   255,   256,   257,   258,   259,   260,
    1758,   748,   261,   262,  1759,  1760,  1761,   749,  1762,  1763,
    1764,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    1765,   272,  1766,   273,   274,   275,   276,   277,  1767,   278,
     279,   280,  1768,  1769,   281,   282,   283,   284,   285,  1770,
     286,   287,   288,  1771,   289,   290,   291,  1772,   292,   293,
     294,   295,   296,   297,   298,   299,   300,  1773,   301,  1774,
     302,   303,   304,   305,  1775,   306,  1776,   307,   750,  1777,
     751,   308,   309,   310,  1778,   311,   312,  1779,   313,  1780,
     314,   315,   316,   317,   318,   752,   319,   320,   321,  1781,
     322,   323,   324,   325,   326,   327,  1782,   328,   753,   329,
     330,   331,   332,   333,   334,   335,  1783,   336,  1784,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,  1785,
     344,   345,  1786,   346,   347,   757,   348,   758,  1787,   349,
     350,   351,  1788,  1789,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,  1790,   370,   371,   760,   372,  1791,   373,
     374,   375,   376,   377,   378,  1792,   379,  1793,  1794,   380,
     381,   382,  1795,  1796,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,  1797,   394,   395,
     396,   397,   398,   399,   400,  1798,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,  1799,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1800,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1801,   438,   439,   440,
     441,   442,  1802,   443,   444,   445,   446,   764,   447,   448,
     449,  1803,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,  1804,   461,   462,  1805,   463,   464,   465,
     466,   467,   468,  1806,   469,   470,  1807,  1808,   471,   472,
     473,   474,  1809,   475,   476,   477,   478,   479,   480,   481,
    1810,  1811,   482,   483,   484,   485,   486,  1812,  1813,   487,
     488,   489,   490,   491,   492,   493,  1814,   494,   765,   495,
     496,   497,   498,  1815,  1816,   499,  1817,  1818,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,  1741,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  1742,   220,   221,   222,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,   223,   224,  1750,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
    1751,   234,   235,   236,   237,   238,  1752,  1753,   239,   240,
     241,   242,   243,  1754,   244,   245,   246,   247,   248,  1755,
     746,  1756,   249,   250,   251,   252,   747,   253,   254,  1757,
     255,   256,   257,   258,   259,   260,  1758,   748,   261,   262,
    1759,  1760,  1761,   749,  1762,  1763,  1764,   263,   264,   265,
     266,   267,   268,   269,   270,   271,  1765,   272,  1766,   273,
     274,   275,   276,   277,  1767,   278,   279,   280,  1768,  1769,
     281,   282,   283,   284,   285,  1770,   286,   287,   288,  1771,
     289,   290,   291,  1772,   292,   293,   294,   295,   296,   297,
     298,   299,   300,  1773,   301,  1774,   302,   303,   304,   305,
    1775,   306,  1776,   307,   750,  1777,   751,   308,   309,   310,
    1778,   311,   312,  1779,   313,  1780,   314,   315,   316,   317,
     318,   752,   319,   320,   321,  1781,   322,   323,   324,   325,
     326,   327,  1782,   328,   753,   329,   330,   331,   332,   333,
     334,   335,  1783,   336,  1784,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,  1785,   344,   345,  1786,   346,
     347,   757,   348,   758,  1787,   349,   350,   351,  1788,  1789,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,  1790,
     370,   371,   760,   372,  1791,   373,   374,   375,   376,   377,
     378,  1792,   379,  1793,  1794,   380,   381,   382,  1795,  1796,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,  1797,   394,   395,   396,   397,   398,   399,
     400,  1798,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,  1799,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1800,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1801,   438,   439,   440,   441,   442,  1802,   443,
     444,   445,   446,   764,   447,   448,   449,  1803,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1804,
     461,   462,  1805,   463,   464,   465,   466,   467,   468,  1806,
     469,   470,  1807,  1808,   471,   472,   473,   474,  1809,   475,
     476,   477,   478,   479,   480,   481,  1810,  1811,   482,   483,
     484,   485,   486,  1812,  1813,   487,   488,   489,   490,   491,
     492,   493,  1814,   494,   765,   495,   496,   497,   498,  1815,
    1816,   499,  1817,  1818,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,  1741,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,  2665,   216,   217,
     218,  1742,   220,   221,   222,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,   223,   224,  1750,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,  1751,   234,   235,   236,
     237,   238,  1752,  1753,   239,   240,   241,   242,   243,  1754,
     244,   245,   246,   247,   248,  1755,   746,  1756,   249,   250,
     251,   252,   747,   253,   254,  1757,   255,   256,   257,   258,
     259,   260,  1758,   748,   261,   262,  1759,  1760,  1761,   749,
    1762,  1763,  1764,   263,   264,   265,   266,   267,   268,   269,
     270,   271,  1765,   272,  1766,   273,   274,   275,   276,   277,
    1767,   278,   279,   280,  1768,  1769,   281,   282,   283,  2666,
     285,  1770,   286,   287,   288,  1771,   289,   290,   291,  1772,
     292,   293,   294,   295,   296,   297,   298,   299,   300,  1773,
     301,  1774,   302,   303,   304,   305,  1775,   306,  1776,   307,
     750,  1777,   751,   308,   309,   310,  1778,   311,   312,  1779,
     313,  1780,   314,   315,   316,   317,   318,   752,   319,   320,
     321,  1781,   322,   323,   324,   325,   326,   327,  1782,   328,
     753,   329,   330,   331,   332,   333,   334,   335,  1783,   336,
    1784,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,  1785,   344,   345,  1786,   346,   347,   757,   348,   758,
    1787,   349,   350,   351,  1788,  1789,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,  1790,   370,   371,   760,   372,
    1791,   373,   374,   375,   376,   377,   378,  1792,   379,  1793,
    1794,   380,   381,   382,  1795,  1796,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,  1797,
     394,   395,   396,   397,   398,   399,   400,  1798,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,  1799,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  1800,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1801,   438,
     439,   440,   441,   442,  1802,  2667,   444,   445,   446,   764,
     447,   448,   449,  1803,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,  1804,   461,   462,  1805,   463,
     464,   465,   466,   467,   468,  1806,   469,   470,  1807,  1808,
     471,   472,   473,   474,  1809,   475,   476,   477,   478,   479,
     480,   481,  1810,  1811,   482,   483,   484,   485,   486,  1812,
    1813,   487,   488,   489,   490,   491,   492,   493,  1814,   494,
     765,   495,   496,   497,   498,  1815,  1816,   499,  1817,  1818,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   743,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,  1042,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,  1058,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,  1072,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,  1084,   473,  1085,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,   786,     0,   573,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,  1537,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,  1538,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,  1539,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,     0,   573,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    1716,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,  2091,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,  2092,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     3,     4,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   813,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   829,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     830,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,     0,   573,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   786,     0,   573,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
    1527,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,  2938,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   743,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   907,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   743,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     927,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   743,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   937,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   939,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   949,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   960,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   961,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,  1915,   244,   245,   246,   247,   248,     0,
       0,  1988,   249,   250,   251,   252,     0,   253,   254,  1916,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,  1989,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,  1918,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,  1919,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,  1920,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,  1915,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,  1916,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
    1989,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,  1918,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,  2838,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,  1919,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,  1920,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   677,   217,   218,   643,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,   644,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,   678,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   645,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   646,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   643,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,   644,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,  2568,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   645,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     646,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,  1915,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,  1916,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,  1989,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,  1918,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,  1919,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,  1920,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,   643,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,   644,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   645,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   646,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,  1564,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,  1565,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,  1566,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,  1567,   307,
       0,     0,     0,  1568,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,  1569,  1570,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,  1571,   434,   435,   436,   437,     0,  1572,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,  1573,   463,
    1574,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,  1575,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,   644,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   645,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   646,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   822,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   823,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   708,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     3,     4,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  2649,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,  2650,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,  2661,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,  2662,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   564,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   565,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   669,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   670,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   671,   470,     0,     0,   672,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,   702,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   703,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     704,   470,     0,     0,   705,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     708,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   792,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   793,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   920,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,  1132,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,  1143,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   688,   240,
     241,   242,  1144,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   691,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   692,   428,   429,   430,   431,   432,   693,   434,   435,
     436,   437,     0,   438,   439,   440,   441,  1136,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     695,   470,     0,     0,   696,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   697,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  1242,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     708,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,  1294,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,  1295,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   669,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,  2463,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,  2464,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,  2465,   463,   464,  2466,
     466,  2467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,  2468,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,   573,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
    3573,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,  3587,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,  3798,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    3800,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,  3802,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
    4196,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   658,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     667,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   688,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     689,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   690,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   691,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   692,   428,   429,   430,   431,   432,   693,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   694,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     695,   470,     0,     0,   696,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   697,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   720,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   817,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   832,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   885,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     899,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   932,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   951,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   953,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   955,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     958,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   964,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     688,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   691,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   692,   428,   429,   430,   431,   432,   693,
     434,   435,   436,   437,     0,   438,   439,   440,   441,  1136,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   695,   470,     0,     0,   696,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   697,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,  1444,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,  1474,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
    1503,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  1505,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,  1507,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,  1599,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,  1875,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,     0,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   688,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   691,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   692,   428,   429,   430,   431,   432,   693,   434,   435,
     436,   437,     0,   438,   439,   440,   441,  1136,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,  1906,   465,   466,   467,   468,     0,
     695,   470,     0,     0,   696,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   697,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   688,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   691,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   692,   428,   429,
     430,   431,   432,  1973,   434,   435,   436,   437,     0,   438,
     439,   440,   441,  1974,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   695,   470,     0,     0,
    1975,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   697,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,  2232,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,  2579,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   688,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   691,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   692,   428,   429,   430,   431,
     432,   693,   434,   435,   436,   437,     0,   438,   439,   440,
     441,  1974,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   695,   470,     0,     0,  1975,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   697,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
    2652,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  2654,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,  2759,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,     0,  1399,   745,  1400,  1401,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,  1402,  1403,
     243,     0,   244,   245,   246,   247,     0,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,  1404,  1405,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,     0,   297,   298,   299,
       0,     0,   301,     0,   302,   303,  1406,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
       0,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,  1878,   322,   323,   324,   325,   326,   327,
       0,   328,   753,  1879,   330,   331,   332,   333,  1407,  1408,
       0,  1409,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,     0,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1410,   759,  1411,   367,   368,     0,     0,   370,   371,
     760,   372,     0,     0,   374,  1412,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,  1881,
     761,   385,   762,     0,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   396,     0,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1413,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,     0,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,  1882,   445,
     446,   764,   447,  1415,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1416,  1417,
       0,     0,   471,     0,   473,     0,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,     0,  1418,
    1883,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,   515,   516,   517,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,     0,  1399,
     745,  1400,  1401,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,  1402,  1403,   243,     0,   244,   245,   246,
     247,     0,     0,   746,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,     0,     0,     0,   749,     0,     0,     0,
     263,   264,   265,   266,   267,   268,  1404,  1405,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,  1056,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,     0,   297,   298,   299,     0,     0,   301,     0,   302,
     303,  1406,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,     0,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,     0,   330,
     331,   332,   333,  1407,  1408,     0,  1409,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,     0,   757,   348,   758,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,  1410,   759,  1411,   367,
     368,     0,     0,   370,   371,   760,   372,  1969,     0,   374,
    1412,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,     0,   761,   385,   762,     0,   387,
     388,   389,   390,   391,   392,   393,     0,   394,     0,   396,
       0,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,  1413,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,     0,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,  1882,   445,   446,   764,   447,  1415,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,     0,   461,   462,  3429,   463,   464,   465,   466,
     467,   468,     0,  1416,  1417,     0,     0,   471,     0,   473,
       0,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,     0,  1418,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,     0,   210,     0,     0,     0,     0,     0,
       0,     0,   515,   516,   517,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,     0,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,     0,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,     0,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
    1398,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,     0,
    1399,   745,  1400,  1401,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,  1402,  1403,   243,     0,   244,   245,
     246,   247,     0,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,  1404,  1405,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,     0,   297,   298,   299,     0,     0,   301,     0,
     302,   303,  1406,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,     0,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,     0,
     330,   331,   332,   333,  1407,  1408,     0,  1409,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,     0,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1410,   759,  1411,
     367,   368,  2031,     0,   370,   371,   760,   372,     0,     0,
     374,  1412,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,     0,   761,   385,   762,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     396,     0,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1413,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,     0,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,  1414,   445,   446,   764,   447,  1415,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1416,  1417,     0,     0,   471,     0,
     473,     0,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,     0,  1418,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,     0,  1398,     0,     0,     0,     0,
       0,     0,     0,   515,   516,   517,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
     744,   227,   228,   229,     0,  1399,   745,  1400,  1401,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,  1402,
    1403,   243,     0,   244,   245,   246,   247,     0,     0,   746,
       0,   249,   250,   251,   252,   747,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,   748,   261,   262,     0,
       0,     0,   749,     0,     0,     0,   263,   264,   265,   266,
     267,   268,  1404,  1405,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,  1056,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,     0,   297,   298,
     299,     0,     0,   301,     0,   302,   303,  1406,   305,     0,
     306,     0,   307,   750,     0,   751,   308,   309,   310,     0,
     311,     0,     0,   313,     0,   314,   315,   316,   317,   318,
     752,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,   753,     0,   330,   331,   332,   333,  1407,
    1408,     0,  1409,     0,   337,   754,   755,   338,   756,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,     0,
     757,   348,   758,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,  1410,   759,  1411,   367,   368,  3254,     0,   370,
     371,   760,   372,     0,     0,   374,  1412,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
       0,   761,   385,   762,     0,   387,   388,   389,   390,   391,
     392,   393,     0,   394,     0,   396,     0,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,  1413,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   763,
     427,   428,     0,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,  1414,
     445,   446,   764,   447,  1415,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,  1416,
    1417,     0,     0,   471,     0,   473,     0,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,     0,
    1418,     0,   494,   765,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,     0,
    1398,     0,     0,     0,     0,     0,     0,     0,   515,   516,
     517,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,     0,
    1399,   745,  1400,  1401,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,  1402,  1403,   243,     0,   244,   245,
     246,   247,     0,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,  1404,  1405,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,     0,   297,   298,   299,     0,     0,   301,     0,
     302,   303,  1406,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,     0,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,     0,
     330,   331,   332,   333,  1407,  1408,     0,  1409,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,     0,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1410,   759,  1411,
     367,   368,     0,     0,   370,   371,   760,   372,     0,     0,
     374,  1412,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,     0,   761,   385,   762,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     396,     0,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1413,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,     0,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,  1414,   445,   446,   764,   447,  1415,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1416,  1417,     0,     0,   471,     0,
     473,     0,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,     0,  1418,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,     0,  1398,     0,     0,     0,     0,
       0,     0,     0,   515,   516,   517,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
     744,   227,   228,   229,     0,  1399,   745,  1400,  1401,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,  1402,
    1403,   243,     0,   244,   245,   246,   247,     0,     0,   746,
       0,   249,   250,   251,   252,   747,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,   748,   261,   262,     0,
       0,     0,   749,     0,     0,     0,   263,   264,   265,   266,
     267,   268,  1404,  1405,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,  1056,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,     0,   297,   298,
     299,     0,     0,   301,     0,   302,   303,  1406,   305,     0,
     306,     0,   307,   750,     0,   751,   308,   309,   310,     0,
     311,     0,     0,   313,     0,   314,   315,   316,   317,   318,
     752,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,   753,     0,   330,   331,   332,   333,  1407,
    1408,     0,  1409,     0,   337,   754,   755,   338,   756,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,     0,
     757,   348,   758,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,  1410,   759,  1411,   367,   368,     0,     0,   370,
     371,   760,   372,     0,     0,   374,  1412,   376,   377,   378,
       0,   379,     0,     0,   380,   381,   382,     0,     0,   383,
       0,   761,   385,   762,     0,   387,   388,   389,   390,   391,
     392,   393,     0,   394,     0,   396,     0,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,  1413,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   763,
     427,   428,     0,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,  1882,
     445,   446,   764,   447,  1415,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,  1416,
    1417,     0,     0,   471,     0,   473,     0,     0,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,     0,
    1418,     0,   494,   765,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,     0,
    1398,     0,     0,     0,     0,     0,     0,     0,   515,   516,
     517,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,     0,
    1399,   745,  1400,  1401,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,  1402,  1403,   243,     0,   244,   245,
     246,   247,     0,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,  1404,  1405,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,     0,   297,   298,   299,     0,     0,   301,     0,
     302,   303,  1406,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,     0,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,     0,
     330,   331,   332,   333,  1407,  1408,     0,  1409,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,     0,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1410,   759,  1411,
     367,   368,     0,     0,   370,   371,   760,   372,     0,     0,
     374,  1412,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,     0,   761,   385,   762,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     396,     0,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1413,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,     0,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,     0,   445,   446,   764,   447,  1415,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1416,  1417,     0,     0,   471,     0,
     473,     0,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,     0,  1418,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   515,   516,   517
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    16,   644,   645,   646,
      21,    11,    48,   650,    24,    26,   574,   545,    34,   814,
      20,   975,    20,   938,     7,   594,   689,   737,   947,   795,
     742,    14,   171,   767,   942,   604,   831,  1568,   179,  1228,
     997,   193,    43,   840,   819,  1163,    21,   188,    48,  1870,
     896,    26,  1414,  1670,   612,  1161,  1179,    12,  1263,  1025,
     906,   189,   967,   877,   592,  1273,  1708,   195,  2315,  1083,
    1371,  1886,  1887,  1283,   574,  1054,  1055,  2645,   206,   696,
    1269,    20,  2665,    42,  2667,  2167,  1431,   882,  2030,  2621,
    2175,   886,  1470,  1211,  1073,  2899,   891,  1323,  1605,   536,
    2128,  2836,  2081,   898,    22,  3117,  2861,  1184,  1834,  1215,
    2817,  1639,  2529,   908,   928,  3209,    34,  3160,    17,  2799,
    2294,  2476,  2474,  2475,  3156,  1653,   158,  1335,  3419,   954,
    1340,  1341,  2471,  2888,   692,     0,   173,  2817,  3409,   611,
     965,  3090,   818,    33,  2878,  3430,   583,  1525,   824,   173,
      40,     0,  3058,  2408,     0,  1255,     0,   833,     0,     0,
    3084,     0,     0,  1215,    39,     0,  1269,     0,     0,     0,
       0,  2537,  3643,   173,  3127,  1703,  3016,  3366,  1473,   734,
    1481,   784,    11,  2522,     9,  3089,     0,  3847,  4124,     5,
       9,  3951,   692,  3953,    31,     0,  1101,   734,  1043,  1044,
       0,     0,     0,    58,     5,     0,    68,    36,    72,   975,
       9,  2821,  2822,  2823,  2824,  2825,  2826,    51,     5,  3984,
      37,    18,     4,    22,  1069,    35,    13,     9,  2170,    22,
       0,    37,    22,   103,   147,    44,    29,    66,   875,    29,
    4117,     5,   201,   152,  1886,   152,   152,    51,    68,     0,
      25,    35,   153,    18,   127,    76,    76,    58,     9,    11,
       5,     5,  4272,    51,     5,    68,     5,    16,    13,   105,
    2471,    22,    13,    96,     5,     5,  2623,   158,     5,    68,
    2535,     5,     5,    83,    22,   154,     5,   103,    83,   152,
       5,    29,   246,   161,    58,   152,    68,     5,     9,  2241,
     153,  2243,   246,   246,    64,   277,    68,   249,     5,    95,
      76,   256,    52,   160,    20,   155,    96,   113,   133,   256,
      60,  2522,    51,   120,   234,    34,    25,   123,  1434,   234,
     250,    22,   860,   144,    40,   142,   152,   103,   152,   326,
     879,   326,   310,   106,   326,     5,     8,   152,    32,    11,
      18,  1148,    66,   152,   152,   120,    24,   157,   172,   195,
     110,   391,   157,   142,     3,     4,     5,   172,  1102,   297,
       9,   193,   301,   172,   172,   264,     4,   132,   297,   948,
    1146,     9,   152,   250,   133,  1151,  1152,  4397,     8,   361,
     531,    11,    22,   545,    26,    27,  1130,   326,   326,     5,
     236,   152,   172,  1417,   211,   963,   169,   326,   297,    11,
     361,   379,   285,   266,  4174,   543,  1947,   975,   173,   547,
     263,   172,   233,   105,   115,  1404,  1405,   111,   250,    22,
     558,   403,   211,  1412,  1003,    11,   222,   578,   224,    11,
     592,   248,  1565,   312,  1013,     5,  1569,   588,  1571,  4109,
     286,  1574,   120,   440,   234,   440,   134,  1026,   440,  3648,
      36,   308,   171,   963,   103,  1380,  1385,   122,   264,   303,
     236,  1029,  1011,   108,   214,   385,    79,    70,   331,  1245,
     186,   321,   436,  1194,    77,   115,  1604,  1253,  2835,   249,
      66,   199,   436,   436,   436,   440,     8,   359,   367,   303,
     323,   297,   359,   440,   304,   977,   172,   371,  4518,   304,
     350,   104,   417,   328,   434,   303,   526,   385,   438,   151,
    1882,   153,   241,   436,  1319,   300,  1321,   436,  3235,  1029,
    4407,   193,   297,   440,   440,   436,   346,   312,   359,   359,
    3150,   334,   359,   359,   334,  1311,  1664,  1892,  1314,  1315,
    1396,   190,   172,   423,  1329,  3235,   359,  1402,  1403,   440,
    1374,   310,   346,   436,   574,   575,  1411,  1243,   103,  1675,
     359,  4336,  1369,   193,   303,   214,   612,   440,  3849,   328,
     386,   436,   379,   176,   616,  1143,  4522,   359,   363,   390,
     252,   193,  1710,  1151,  1152,  3163,   334,   359,   737,   436,
     400,   300,  1559,   432,   440,   400,   440,   423,   427,   428,
     435,   611,   612,   611,   625,  1381,   627,   436,   629,  3568,
    1296,  1529,   438,  3812,   635,   439,   525,   436,   427,   428,
    2572,   381,   252,  3388,   439,   436,   440,   437,  3544,   439,
     439,   439,   437,  1143,   439,   427,   428,  1202,   658,   436,
     625,  3491,   627,  3577,   629,   610,   639,  3581,  1566,  1262,
     635,   636,   637,  3567,  4424,  1202,  1491,  1575,  3403,   439,
    3623,   681,   436,   612,  3863,  1500,   427,   428,   688,  1504,
     432,   691,   692,   693,  3418,  1510,  1511,   402,   439,   726,
     434,   436,   436,   390,   438,   436,   655,   436,  1603,   302,
    1605,   383,   726,  1528,   845,   436,   436,   422,   860,   436,
    1615,   440,   436,   436,  1619,   856,   427,   428,   396,  4190,
     434,   436,  1627,  1628,   438,  2540,   726,  2542,   728,   728,
     728,   728,   728,   728,    22,  1640,  1641,  3347,  4398,   436,
     252,   396,   402,  3082,   379,  3084,  1651,   103,  3103,   342,
    2045,  2779,  1960,   712,  2782,  2783,    51,    74,  2786,   391,
    1299,  3329,   422,   152,  2792,   427,   428,   429,   430,   431,
     432,  2856,   400,  1301,   440,   916,   436,   716,  3144,   280,
     340,   341,   741,   256,   319,    96,  1631,  1632,   427,   428,
    3979,    11,     3,    96,  1900,   112,   108,  3986,   147,   427,
     428,   133,    18,   423,   424,   425,     5,   427,   428,   429,
     430,   431,   432,  4473,   349,   690,  4107,    60,  2026,   694,
     795,  3160,    96,    74,   783,   427,   428,   429,   430,   431,
     432,    23,  2474,  2475,  2476,     5,  1375,   440,   349,    18,
    1477,    96,  2784,  2785,    18,    24,  2374,  2375,  1900,   105,
      24,  2379,   387,   429,   430,   431,   432,   429,   430,   431,
     432,   112,     5,   728,    75,   400,     3,    18,     5,    96,
    2487,   251,   108,   185,    97,  4070,  3131,   152,  1978,   728,
     236,  3082,   728,  3084,   728,  1988,   728,   728,   131,   728,
     728,  2419,  2420,   728,  3937,   728,   728,   728,   728,   103,
    1439,   436,   103,   361,   120,   154,   149,  2013,  3440,  1572,
    1573,   423,   424,   425,   125,   427,   428,   429,   430,   431,
     432,  4198,  4199,   154,    74,   774,    98,  1661,  1639,   310,
     820,   821,  1501,   182,  3987,   436,    74,  3980,    74,   234,
     326,   120,  1653,  1512,    30,   403,   120,   134,   265,   185,
     299,   146,   175,   963,   161,  1524,    28,  1496,   314,  3160,
     359,    98,   112,    98,   437,   975,   177,   440,   108,   120,
     359,   161,   103,   193,   112,     5,   112,   977,  1536,   977,
      96,  1509,  2208,   271,  2799,   241,   277,   103,   115,  3938,
     117,   221,  3898,   165,   186,  4286,   328,   980,  1008,   982,
     975,   984,  2817,   986,  1829,   988,   989,   990,   303,  4280,
      83,  4296,   995,   130,   265,  2220,     5,   103,  3942,  1029,
     919,   252,   153,  3947,  4077,   405,  3950,   234,   165,   102,
     165,   326,   236,   321,   423,   278,   353,  1037,   349,   314,
     241,   440,   241,   147,   234,   185,   349,   254,   264,   438,
    4245,   223,   438,   157,   226,   436,  2162,  1057,   269,  3863,
    1497,   134,   134,  1535,   352,  1101,   354,   379,   172,  3637,
     361,   241,   189,   103,  4117,   349,   359,   434,   273,   436,
      11,   297,  2897,  3838,    60,   264,   223,  1087,   223,   226,
     264,   226,  3675,  1103,   349,   308,   154,   263,   241,    42,
      76,  1101,   353,  1113,   223,    36,   237,  3841,   198,  1637,
     326,   342,   403,   264,   103,   265,  1126,   392,   297,   246,
     236,   290,   349,   297,     5,   348,   349,   265,  4399,   265,
     366,   374,   319,  1143,  1673,    66,  1146,  1147,  4191,   256,
    1172,  1151,  1152,   379,     0,   317,   297,   326,  4201,  1301,
    1187,  1188,   326,  1190,  4431,   131,  4188,   440,   165,  2282,
     326,   372,   349,  1187,  1188,  2040,  1190,   380,   384,   380,
     256,  1146,   383,   149,  2153,   326,  1151,  1152,   385,   319,
     317,  4472,   317,    83,   120,  4476,   161,  1187,  1188,  4283,
    1190,  2374,  2375,  2538,   252,   385,  2379,    60,   317,  2544,
     387,   256,   306,   353,  3621,     0,  1869,   427,   428,   429,
     430,   431,   432,   400,   381,   353,   223,   353,   436,  4408,
     293,  2096,   103,   339,   393,   168,   342,    83,  1356,   172,
    4521,  2077,   153,   264,  4140,   197,  2419,  2420,  3577,   379,
     103,  3593,  3581,  3598,   416,  1204,   319,  4171,  3603,   436,
     381,   156,    95,    44,   400,   319,   373,   157,   107,   234,
     181,   316,   193,   115,   436,   117,   297,   210,   108,   436,
    1245,   105,   234,  4316,   130,   196,   349,  3305,  1253,   416,
     120,   416,  2048,  3311,  3312,   349,   142,   208,   140,   264,
    2056,   147,  2058,  2399,   440,   326,   152,   107,  3472,  2405,
     155,   157,   278,    94,   160,  4012,   162,   263,  4214,   214,
     317,  1987,  4218,  4219,   387,  1290,  1291,  1327,   254,  2234,
     436,   439,   297,   387,   286,  2244,  1454,   400,  4340,  4341,
    2238,  4482,  4012,   189,   177,   440,  1311,   423,  2133,  1314,
    1315,  1240,  1470,   192,  2190,  2191,  2192,  2193,   434,  1490,
     436,   437,   438,  4088,   440,   211,  2202,  1509,  1499,  4094,
      75,   195,   280,   436,  4407,   301,   328,   263,     8,  2045,
     326,    11,   436,   236,  1502,  1334,  3577,   105,   241,   222,
    3581,   224,   192,  1393,   236,   363,   307,   330,    28,   241,
     326,  2067,   248,   184,   246,   106,   172,  1525,   374,   106,
     256,   172,   236,   197,  2935,   436,  1381,   359,  2233,   124,
     385,   156,  3138,  4564,  2228,   278,  1985,   379,  2495,   286,
    3235,  1949,  2098,  3402,  2249,  2250,   299,  1568,  2253,   292,
     326,   298,  2637,     5,  2259,   275,   381,     9,  2343,   437,
     234,   423,   440,   234,  2567,   393,  1456,   352,   304,   354,
     400,   316,   286,  1992,  1303,   322,   438,  1306,   169,   180,
     181,  3103,   169,   184,  2971,   186,   321,   195,  1905,   214,
    2998,   423,   377,  3001,  3002,  3003,  3004,  3005,  3006,  3007,
    3008,  3009,  3010,  4495,   205,  1637,   438,  2392,   203,   204,
     440,   436,  2317,   349,  2720,   350,   427,   428,   429,   430,
     431,   432,   217,  3031,  4072,  3447,  1355,  3449,   236,   312,
    1359,   374,   290,   365,   369,   264,  4271,   373,  2423,   245,
    2286,   297,  2730,   375,   315,   301,   297,   400,    57,    58,
     301,   103,  3060,  3061,   328,  1535,   115,  1535,   117,   264,
      11,   397,   320,   399,   400,   290,  2924,   310,   297,   264,
     326,   359,   105,   193,   290,   326,  2461,   105,   286,   264,
     363,   140,  1545,   254,  1547,    36,  1549,   440,  1551,  2548,
    1553,   349,   297,   264,  1557,   338,   301,   326,   434,  2216,
    1596,   437,   438,   439,   320,   379,  1586,  1586,  1586,  1586,
    1586,  1586,   297,  4125,   147,    66,   301,  1536,  3937,  2036,
     400,   326,  2141,  3942,  4408,   333,   297,   352,  3947,   354,
     238,  3950,   252,   349,  1624,   393,   264,    26,    27,   312,
    2577,   326,  1581,   199,   400,  4208,   179,    84,   142,   400,
     319,   179,   377,   147,  4202,  3882,   351,    78,   353,   312,
     440,  3980,  1617,  1618,   264,    11,   264,   285,   393,   297,
    1625,  4406,   381,  4009,  1629,  1630,   236,   393,    68,   436,
     349,   241,   241,  2374,  2375,  2223,    76,   246,  2379,  1644,
     363,  1646,  2882,   311,    83,  2885,   117,  1595,   326,   297,
    1680,   234,     8,   236,    38,    11,   234,  4043,   236,  2608,
     363,   319,  1667,   102,  1669,   400,   153,   211,   387,  2257,
      66,   392,    28,  1602,   284,    59,   326,   436,  2419,  2420,
    2816,   400,   301,   363,  1724,   264,  3658,  3659,  2993,   314,
      49,   349,  2488,  2223,   181,   134,  3343,  3974,   363,  3976,
    4465,  3759,  3760,   115,   248,   117,  3937,   326,  3820,   196,
     299,  3942,  3017,   147,  3829,   142,  3947,   436,   297,  3950,
     147,   208,  2808,  2809,  2810,  2580,   351,  2257,  3840,   387,
     402,   402,    76,   167,   316,  2304,    95,   264,  1896,  4301,
     221,  2481,   400,  1901,   231,  4343,  1904,   326,  4117,  3980,
     422,   422,  2596,   423,   424,   425,   365,   427,   428,   429,
     430,   431,   432,   250,   436,   436,   375,  1949,  1926,  1940,
     297,   156,   310,   311,    68,   400,  1947,   402,   436,   437,
    2933,   439,    76,   534,   211,  2998,   314,   538,  3001,  3002,
    3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,  2653,   326,
    2655,  3359,  4171,   221,   555,     8,   351,  1848,    11,  1967,
     152,   436,   156,  3188,     8,   174,   352,    11,   354,  2624,
     307,   248,   402,   351,   236,    28,  1984,   310,   311,   214,
     172,   175,  1452,  3164,   246,  4433,   221,   193,  2485,   147,
      20,  2646,   422,  1848,  1874,  1874,  1303,  3060,  3061,  1306,
      80,  1471,  2010,   314,   293,   400,   352,   402,   354,   167,
      40,   130,  1831,   222,  1910,   224,  1912,   436,   175,   438,
     214,     5,   400,   142,   402,   234,    10,   363,   147,  2866,
     319,  2039,  2440,   434,    18,  2043,  4117,   438,  2875,  3536,
     351,   436,  3040,   400,   381,   402,   252,  3033,  1355,  2754,
    2488,    35,  1359,  2061,   263,  2760,   437,   814,   436,   440,
     349,   255,     4,  2391,  2072,  2393,  2394,     9,    44,  2625,
     189,  3593,   829,     4,   831,   167,  3598,  2085,     9,    73,
    3769,  3603,  3771,  1973,   237,   238,  3775,  2095,  3777,   400,
    4171,   402,   211,   302,  4542,   250,   431,  4316,   387,     0,
     255,   436,   391,   438,     8,   393,   314,    11,  3196,    85,
    2956,   400,   436,   435,   438,  2564,  2565,   352,   440,   354,
    1959,    48,  3212,  3213,    28,   436,  3020,  3021,   337,   248,
    3538,  3539,   434,   109,   436,  2691,   438,   256,  4046,   431,
     193,  3139,   377,   351,   436,   250,   438,   436,   124,   193,
     255,  3239,   128,   316,   435,  2830,  2594,    21,   352,   440,
     354,   437,    26,   400,   440,   402,   319,   437,  2963,   363,
     440,   437,   148,   437,   440,   151,   440,   352,  2597,   354,
     374,   437,    83,   377,   440,   199,   437,   163,  4407,   440,
     314,   436,   400,  2048,   402,     9,   349,   798,   799,   252,
     436,  2056,  2907,  2058,   419,   420,  2911,  2912,   252,  2914,
     437,  2916,  2917,   440,  2594,   250,   440,   423,   424,   425,
    2925,   427,   428,   429,   430,   431,   432,   351,   436,   130,
    2120,   436,    48,   437,   387,  4316,   440,   437,  2128,   393,
     440,   142,  3027,  1016,  1017,    84,   147,   400,  3234,    38,
    3236,   152,  2957,   418,   373,   437,   157,   437,   440,   160,
     440,   162,  2711,   195,   438,   241,  2960,  4089,   314,   250,
     253,   437,   873,   249,   440,   253,   400,   437,   402,  2698,
     440,  2700,  3141,   436,  2292,   359,   147,   437,   189,   193,
     440,  3533,   418,   894,   895,  2150,  3359,   437,  2319,  2189,
     440,  4002,   250,  4430,  2325,   351,   437,  2315,   284,   440,
     211,    38,   436,   914,   153,   253,   418,  4012,  2964,  3883,
    3884,  3885,  3886,   195,  3161,  3162,  4407,  2217,   429,  3315,
    2210,  2210,  4033,  2223,   151,    48,  2755,  2854,  3423,  3408,
    3862,  2176,   181,   944,   945,   440,   437,   248,   252,   440,
     437,   436,   436,   440,   400,   256,   402,   196,   437,   437,
     437,  2780,   440,   440,   352,   437,   354,  2257,   440,   208,
     423,   424,   425,   437,   427,   428,   429,   430,   431,   432,
     424,   425,   152,   427,   428,   429,   430,   431,   432,   400,
     436,   402,   231,  2831,   437,  2833,  2845,   440,  2847,   437,
     191,   438,   440,   304,     0,   326,   437,  2998,  2440,   440,
    3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,
     627,   628,   629,   436,  4119,   632,   633,   634,     3,  3106,
     437,  2286,   404,   440,   437,   642,   437,   440,   437,   440,
    3031,   440,   437,   314,    19,   440,   437,   172,   349,   440,
    2471,  2831,   135,  2833,  3457,  3458,  3459,   437,  2896,   436,
     440,     8,  2881,   437,    11,   439,  3963,   314,   307,  3060,
    3061,   437,   373,   439,  2506,  3538,  3539,   438,   172,   437,
     351,  3095,   440,   250,   135,   314,  3894,    83,   437,  2908,
     437,   440,   172,   440,   437,  3903,   397,   440,   399,   400,
      75,  2522,   437,   135,   351,   440,  2955,  2423,  3098,  3099,
    3100,  4212,  3920,  3921,   437,   437,  2896,   440,   440,   423,
     424,   425,   351,   427,   428,   429,   430,   431,   432,   400,
     250,   402,   437,   434,   130,   440,   437,   438,   439,   437,
     147,  2549,   440,  2423,   437,   437,   142,   440,   440,   437,
     125,   147,   440,   400,   135,   402,   152,  2437,  2977,   209,
     437,   157,   314,   440,   160,   436,   162,   437,   105,   437,
     440,   400,   440,   402,   437,   381,  2456,   440,  2997,    11,
     731,   437,   733,  2591,   440,  2466,  2467,  2468,  3582,   436,
    3584,  2471,   437,   189,   250,   440,  3594,   172,  2488,   351,
     436,   363,   177,  3022,    36,   437,   245,   436,   440,  2525,
     437,   437,    21,   440,   440,   211,   437,   316,   437,   440,
    3618,   440,  2502,  2502,  2502,  2502,  2502,  2502,   393,   437,
     199,  2486,   440,  2488,    66,   437,   283,   437,   440,  3058,
     440,   437,  2522,  3298,   440,  2525,   193,    60,   400,   436,
     402,   437,   248,   437,   440,   437,   440,  4068,   440,    68,
     256,   437,   437,     8,   440,   440,    11,   400,   437,   437,
      50,   440,   440,  1655,    31,   236,  1658,  1278,   404,   436,
     236,  2689,    38,    28,   436,    38,   368,   264,    97,   147,
     393,    36,   393,  2701,   269,    73,   281,    42,   135,   135,
     436,   135,    82,   440,  2594,   252,  3432,   404,   304,   118,
     135,   135,   135,   135,   135,   250,   135,   135,   135,   250,
     129,    66,   349,   135,   135,   436,    31,  3730,  3731,   209,
    3733,  4139,   148,   308,   250,  3520,   436,   147,  4439,  3444,
     149,  1342,  1343,  1344,  1345,   154,   147,  3452,  3453,  4450,
       5,     5,   436,   349,   147,   436,   274,   436,   138,   436,
     436,   193,   194,   436,   436,     5,  2774,  2799,  3359,     5,
     436,   978,   347,   436,   981,  4297,   983,   373,   985,   436,
     987,  2671,  1383,  1384,   991,  2817,     5,   436,  1389,     5,
     170,   200,   436,   436,   436,   436,   436,   372,   436,   436,
    4501,   397,   436,   399,   400,   380,   436,   239,   383,   401,
     436,   436,   221,   436,   436,   436,  3462,   436,   261,  2709,
     191,    31,   440,   168,   440,    86,   206,   172,   209,    31,
     147,  3894,  1433,   248,   147,   326,   359,   359,   434,   246,
     314,   437,   438,   439,   438,   359,   359,   314,   193,   194,
     359,   359,   359,    76,   314,   135,   236,  3920,  3921,  1460,
    1461,  1462,  1463,    60,   250,   210,   318,  2757,   206,    66,
       8,   359,   281,    11,   359,   241,   423,   424,   425,    76,
     427,   428,   429,   430,   431,   432,   359,   380,   351,  2779,
      28,   236,  2782,  2783,   239,   250,  2786,   246,    36,   308,
     177,   166,  2792,   436,    42,   314,   103,   252,   105,  2799,
     255,   320,   359,  1514,  2935,   359,  2924,   436,    76,   440,
     264,   301,  1523,   303,   172,   305,   135,  2817,    66,  1530,
    2938,   311,  3766,  3382,  3383,   381,   381,    97,   318,   359,
     349,  2831,   351,  2833,  2799,   359,   326,  3538,  3539,  3654,
    2958,  2806,  2807,   359,    48,   335,  2811,    48,   254,   368,
     359,   359,  2817,   343,   359,   359,   351,  3386,   359,    37,
      37,   359,   314,   404,   440,   359,   359,   250,   250,  2869,
    3685,  3686,   179,   436,   393,   330,   193,   390,   436,    31,
    3827,    30,   400,  2848,   436,   427,   428,   429,   430,   431,
     432,    20,   135,   250,   236,  2895,  2896,  2887,  2887,   436,
     103,   381,   135,   392,   217,   395,   130,   246,   236,    31,
     147,    31,   199,   315,   135,   135,  2906,  2906,   142,  3643,
     168,   436,   135,   147,   172,   381,  4105,   135,   381,   236,
     135,   245,   240,   359,   241,   152,   436,  3752,  3753,   396,
     357,  3070,   228,   418,   436,   193,   194,   228,    11,   326,
     357,  3082,   436,  3084,   440,   359,     8,  4053,   436,    11,
     160,   143,   210,   152,   361,   189,  4139,  1678,   423,   424,
     425,   278,   427,   428,   429,   430,   431,   432,   440,   437,
     435,   166,   166,   189,    36,   292,   441,   211,   236,   436,
      42,   239,   328,   251,   440,   197,   440,   381,   258,  2964,
      48,   437,    75,   359,   252,   359,   436,   255,   314,   314,
    3766,   381,   241,   241,    66,  3544,   197,   197,   359,   359,
     436,   359,   316,   199,   248,   393,   363,   241,   250,  3160,
      38,   333,   256,   249,   359,   351,   359,   440,   314,   167,
     297,   297,  3068,   323,  3044,   286,   193,    31,   359,   359,
     193,  4164,  3867,   193,  3869,  3870,   193,   381,  3084,   381,
    3955,  4174,   193,   249,   423,    30,  3881,   374,   434,   359,
     359,   434,   423,  3191,   359,   436,   359,   135,  3068,   147,
     149,   246,   330,  3074,  3075,  3076,  3077,   436,   323,   393,
     135,  3609,  3082,  3235,  3084,    31,   250,   400,   164,   250,
     164,   436,    31,   147,   135,   250,   250,   147,   323,   440,
     172,  4055,   172,  3672,    19,  4228,  4063,  4064,   172,   440,
     172,   158,   404,   225,   250,   440,   400,  3656,    48,   363,
     349,   440,   245,   152,   393,   268,   437,   437,   199,   437,
     437,   193,   194,   418,   437,   437,   437,   152,   359,   373,
     260,    13,   440,   437,   418,  3684,    13,   397,   437,   437,
    3278,   379,   387,  3281,  3723,   437,   437,   397,   437,   304,
     437,   437,   437,   436,  3703,   423,   424,   425,   423,   427,
     428,   429,   430,   431,   432,   436,  3813,   239,    48,   436,
     436,   211,   440,  3894,   250,   250,   253,   436,   436,   175,
     252,   135,  3903,   359,   359,   404,   359,   241,   183,  4322,
     434,   359,   254,   437,   438,   175,   135,   135,  3766,  3920,
    3921,   211,  3751,   269,   219,   359,   269,   359,   378,   359,
     219,  1942,  1943,  1944,   359,  3235,   219,   314,   359,   314,
    1951,   359,  1953,   359,  1955,  1956,   326,   359,   359,  4144,
     359,   359,   135,   359,  3954,   314,   236,  3258,    37,  3259,
     359,  3961,  3262,   314,  3264,  4050,  3968,   193,   193,   193,
    3235,  3389,   436,     3,   434,   437,   317,    22,    23,   226,
     437,   211,    27,   368,   423,    38,   299,    32,    33,    34,
      31,    36,  4239,  3258,    39,    40,   437,    42,   440,    44,
      96,   437,   440,   249,    31,  3305,   250,  4216,   161,    50,
    4215,  3311,  3312,   436,  3314,   314,   381,   314,  4133,   133,
     437,   359,   314,   133,   193,   440,  4224,   434,  4226,   126,
     253,   381,   152,    11,   147,    58,   437,   437,   421,   437,
     437,    82,   436,  2054,   152,   392,   437,  3465,   256,  3349,
    3350,  3351,  3352,   152,  3319,  3320,   440,   436,   397,   160,
     251,   437,   368,   437,   436,  3330,   437,   147,    31,  3898,
     381,   381,   359,    48,  4189,   427,   428,   429,   430,   431,
     432,   183,   351,   436,  3349,   359,   368,   359,   359,   359,
      48,   359,   314,   314,   351,   147,    66,   138,   135,    96,
     193,   437,  2113,   193,   437,   437,   368,   437,   435,   435,
    2121,   197,   437,    31,  4229,  2126,   282,   323,  4313,   436,
    3420,   400,   436,  4519,   436,   440,  4370,  3417,  3417,   170,
     147,   404,    50,   437,   179,   180,   181,   182,  4139,   184,
     440,   186,   178,   188,    71,   190,  3577,   351,   193,   440,
    3581,   436,   359,   198,  4013,  4108,   201,   157,   199,  4159,
     205,    96,   207,  3981,    82,   206,   152,  3609,   323,   193,
     437,   193,   193,  4569,   193,   152,   437,   436,    48,   437,
    3480,  4577,   291,   398,   398,   437,   440,   437,   436,   196,
     259,   196,   437,   436,   436,   236,     8,  3462,    48,    11,
    2211,   162,   437,   246,   437,  4023,   437,  4055,   359,   368,
     423,   152,   400,    66,   423,   177,    28,    48,   351,   359,
     138,   241,   135,   241,    36,   193,   154,   152,   440,  2240,
      42,  2242,   381,   435,   172,   381,    31,   440,   121,   400,
     396,   436,   400,   152,   436,   253,   180,   152,   386,   436,
     436,   291,   170,   336,    66,   437,   437,   267,   436,   196,
     301,   436,   399,   437,   305,   250,   292,   437,   359,   436,
     311,   359,   436,   400,   147,   110,   241,   318,    31,   175,
    3698,   199,   241,   282,   220,   326,   436,  3577,   206,   436,
     134,  3581,  3710,   437,   335,   436,    31,  4502,   437,   254,
     311,    48,   343,    48,    31,  3605,  3606,   311,   436,   351,
     436,  4140,   437,   437,   381,   234,   351,   250,   236,   351,
     437,     5,   323,   141,    60,  2336,  3616,  3616,  3629,  3635,
     282,   253,    60,   116,   385,   291,   386,   440,   436,    31,
     397,   152,   351,   289,   147,   400,   121,  4176,   177,   250,
     250,   436,    31,    31,   395,   253,   168,    48,   399,   400,
     172,   253,   437,   436,  3629,   436,   310,   437,   108,   437,
       5,   436,    17,   379,    28,   134,   282,   436,   310,  4494,
    3681,   193,   194,   301,  3815,  4214,  1358,   305,  2174,  4218,
    4219,   787,  1152,   311,   821,  2646,  2488,  2020,   210,   728,
     318,   820,  3234,  3314,  2089,  4231,  2797,  4053,   326,  4370,
    4101,  3380,  4105,  3806,  4087,  4342,  3681,   335,  2274,  2571,
    4437,  3980,  4499,  4383,   236,   343,  4384,   239,  4456,  4281,
    3372,  2575,  2165,  3229,  2666,  2165,  3701,  3702,  1457,  2159,
     252,  3706,  3707,   255,  2868,  4507,  4577,  4569,  4082,  3749,
    3750,  2816,  2801,  4467,  4025,  1447,  4357,  4447,  4028,  3759,
    3760,    26,  1004,  3465,  3882,  4187,  3766,  3421,  1887,  2547,
    3770,   575,  3423,  4297,  2758,  4481,  4571,   395,  1014,   524,
     707,   399,  1831,  3406,   529,  1832,   531,  3788,  2502,   534,
    1536,   536,  3136,   538,  2503,  1872,  1197,  1178,  1196,  3617,
     545,  3766,  2514,   548,   720,  2509,  3937,  1871,  1199,  2530,
     555,  3942,  2522,  3084,  4172,  3583,  3947,  3568,   330,  3950,
    4338,  3082,  4370,  3788,  1204,  4316,  4315,   712,  3137,  2140,
    4142,  3043,  4428,   578,  4429,  3835,  3035,  4420,   583,  3981,
    2506,  2437,  2345,   588,  2435,  3132,  1707,   592,    -1,  3980,
      -1,    -1,    -1,    -1,    -1,    -1,  3974,    -1,  3976,    -1,
      -1,  3861,   607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4023,    -1,  3883,  3884,  3885,  3886,    -1,    -1,    -1,
      -1,  4022,  2603,    -1,  2605,  2606,  2607,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     655,   423,   424,   425,    -1,   427,   428,   429,   430,   431,
     432,   666,   667,    -1,    31,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4068,    -1,    -1,
      -1,    -1,   687,    50,   689,   690,    -1,    -1,    -1,   694,
      -1,    -1,  3942,    -1,    -1,    -1,    -1,  3947,    -1,    -1,
    3950,    -1,    -1,   708,    -1,    -1,    -1,   712,    -1,    -1,
      21,    -1,     3,   718,    -1,    82,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,   729,    -1,  4117,     8,    -1,    -1,
      11,    -1,  3965,    -1,    -1,    -1,   741,    28,    -1,    -1,
      31,    -1,    -1,    54,    -1,    36,    -1,    28,    -1,    -1,
      -1,    42,  4012,    -1,    -1,    36,    67,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,   138,    -1,    -1,    -1,    66,    -1,    -1,   783,    -1,
    4171,    -1,    -1,    -1,    -1,    66,  4046,  4012,    -1,    -1,
      -1,   796,    -1,   798,   799,  4055,    -1,    -1,    -1,  4059,
      -1,  4061,    -1,   170,    -1,  4065,  4066,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   820,   821,    -1,   129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,   199,    -1,    -1,    -1,    -1,    -1,   149,   206,
     845,  4091,  4091,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   856,    -1,    -1,    -1,   860,    -1,    -1,    -1,    -1,
      -1,    82,    -1,    -1,    -1,    -1,    -1,  4258,   873,   236,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,    -1,   888,    -1,    -1,    -1,   168,    -1,   894,
     895,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   193,   194,    -1,   910,   911,   912,    -1,   914,
     221,   916,   193,   194,    -1,    -1,    -1,   138,    -1,   210,
      -1,  4171,    -1,    -1,    -1,  4316,    -1,    -1,    -1,   210,
      -1,    -1,    -1,    -1,   301,    -1,  4338,   942,   305,   944,
     945,   252,    -1,    -1,   311,   236,    -1,  2918,   239,   170,
    2921,   318,    -1,    -1,    -1,   236,    -1,    -1,   239,   326,
      -1,   252,   967,    -1,   255,    -1,    -1,    -1,   335,    -1,
     281,   252,  4232,    -1,   255,    -1,   343,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,   997,   998,    -1,  2966,    -1,  1002,    -1,  1004,
      -1,    -1,    -1,   314,    -1,  4396,    -1,    -1,    -1,   320,
      -1,    -1,   323,    -1,    -1,   236,  4407,  1022,    -1,    -1,
    1025,    -1,    -1,  1028,    -1,    -1,    -1,    -1,   395,  4279,
    4279,    -1,   399,    -1,    -1,    -1,  1041,    -1,   349,   330,
      -1,    -1,    -1,   264,   355,    -1,    -1,    -1,    -1,   330,
      -1,  4442,  4430,    -1,    -1,    -1,    -1,   368,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1070,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,
     301,    -1,   393,    -1,   305,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,  1098,  1099,    -1,  1101,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,
    4370,    -1,    -1,    -1,   335,  1120,    -1,    -1,    -1,    -1,
      -1,    -1,   343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,   424,   425,    -1,   427,   428,   429,   430,
     431,   432,   423,   424,   425,    -1,   427,   428,   429,   430,
     431,   432,  1157,    -1,    -1,  1160,   437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4573,    -1,  1189,    -1,    -1,    -1,  1193,  1194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,  1204,
    1205,  1206,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,
      -1,  3182,  3183,  3184,  3185,    -1,    -1,  1222,  4468,  4468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4481,  4481,  4481,  4481,  4481,  4481,    -1,  4524,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
    1255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4519,
      -1,    -1,    -1,  1268,  1269,    -1,    -1,    -1,    -1,    -1,
    1275,    -1,    -1,  1278,  4524,  4524,  4524,  4524,  4524,  4524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,  4519,    -1,  1301,    -1,    -1,    -1,
     120,    -1,  1307,   123,    18,  1310,    -1,    -1,    -1,  4569,
      24,    -1,    -1,    -1,    -1,     8,    -1,  4577,    11,    -1,
      -1,  4571,  4571,  4571,  4571,  4571,  4571,    -1,    -1,  1334,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  1342,  1343,  1344,
    1345,  1346,    -1,    36,  4569,    -1,    -1,    -1,    -1,    42,
      64,    -1,  4577,    -1,    -1,  1360,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1371,    -1,  1373,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,  1383,  1384,
      -1,    -1,    -1,    -1,  1389,    -1,  3357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,   123,
      -1,    -1,    -1,    -1,   234,    -1,   236,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,  1433,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1460,  1461,  1462,  1463,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,  1472,    -1,    -1,
      -1,    -1,    -1,  1478,    -1,   168,  1481,   297,    -1,   172,
     300,   301,    -1,    -1,    -1,  1490,    -1,    -1,    -1,    -1,
      -1,    -1,  1497,    -1,  1499,    -1,    -1,    -1,    -1,    -1,
     193,   194,    -1,    -1,  1509,    -1,   326,    -1,    -1,  1514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,  1523,    -1,
     234,    -1,   236,    -1,  1529,  1530,    -1,    -1,    -1,  1534,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     254,     8,    -1,   236,    11,    -1,   239,    -1,    -1,    -1,
     264,    -1,    -1,    -1,  1559,    -1,    -1,    -1,    -1,   252,
      -1,  1566,   255,  1568,   384,    -1,    -1,  1572,  1573,    36,
    1575,    -1,    -1,    -1,    -1,    42,  1581,    -1,    -1,    -1,
      -1,    -1,    -1,  1588,    -1,    -1,   300,   301,    -1,    -1,
    1595,  1596,    -1,    -1,  1599,    -1,    -1,    -1,  1603,    66,
    1605,    -1,    -1,    -1,    -1,    -1,    -1,  1612,    -1,    -1,
    1615,    -1,   326,    -1,  1619,    18,    -1,    -1,    -1,    -1,
      -1,    24,  1627,  1628,    -1,    -1,    -1,    -1,    -1,    -1,
    1635,    -1,  1637,  1638,  1639,  1640,  1641,   330,    -1,    -1,
      -1,    -1,    -1,  1648,  1649,    -1,  1651,    -1,  1653,  1654,
      -1,    -1,  1657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1674,
     384,    -1,    -1,  1678,  1679,    -1,    -1,    -1,  1683,    -1,
      -1,    -1,  1687,    -1,  1689,  1690,  1691,  1692,  1693,  1694,
    1695,  1696,  1697,    -1,  1699,    -1,    -1,    -1,    -1,    -1,
    1705,   168,  1707,  1708,    -1,   172,    -1,    -1,    -1,  1714,
     113,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
      -1,    -1,    -1,   210,   437,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,    -1,   177,  3746,     0,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    26,    27,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1830,    -1,  1832,    -1,  1834,
      -1,   234,    -1,   236,    -1,    36,    -1,    61,    -1,    63,
      64,    42,    -1,   246,    -1,    69,    -1,    71,    -1,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,
      -1,   264,    -1,   330,  1869,    66,    -1,    -1,  3839,    -1,
    1875,    -1,  1877,    -1,    -1,    99,    -1,    -1,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,   297,    -1,   120,   300,   301,    -1,
    1905,    -1,   126,    -1,    -1,  1910,    -1,  1912,    -1,    -1,
     134,    -1,   136,    -1,    -1,    -1,    -1,    -1,   142,    -1,
      -1,    -1,    -1,   326,  1929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   157,    -1,  1940,    -1,  1942,  1943,  1944,
      -1,    -1,  1947,    -1,  1949,    -1,  1951,    -1,  1953,    -1,
    1955,  1956,    -1,    -1,  1959,    -1,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,    -1,   168,    -1,    -1,
      -1,   172,    -1,  1978,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   384,    -1,  1988,    -1,    -1,    -1,    -1,   212,   213,
    1995,    -1,   193,   194,   218,  2000,    -1,    -1,    -1,    -1,
      -1,  2006,    -1,   227,    -1,    -1,    -1,    -1,    -1,   210,
      -1,  3982,  3983,  3984,   238,    -1,    -1,    -1,    -1,    -1,
    2025,    -1,    -1,    -1,  2029,  2030,    -1,    -1,    -1,    -1,
      -1,  2036,  2037,    -1,    -1,    -1,    -1,    -1,   239,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2054,
      -1,   252,   276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,    -1,  2081,   301,  2083,  2084,
      -1,    -1,   306,    -1,    -1,   309,    -1,    -1,    -1,   313,
      -1,    -1,    -1,    -1,   318,   319,    -1,    -1,    -1,    -1,
      -1,    -1,   326,    -1,    -1,   329,    -1,    -1,  2113,    -1,
      -1,    -1,    -1,   337,    -1,    -1,  2121,    -1,    -1,     8,
      -1,  2126,    11,    -1,    -1,   349,    -1,    -1,    -1,   330,
      -1,    -1,    -1,    -1,  2139,    -1,    -1,    -1,    -1,    28,
      -1,    -1,   366,    -1,    -1,  4116,    -1,    36,    -1,    -1,
      -1,    -1,   376,    42,    -1,    -1,    -1,    -1,   382,    -1,
      -1,    -1,  2167,   387,    -1,  2170,    -1,  2172,    -1,  2174,
      -1,    -1,  2177,    -1,    -1,    -1,   400,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2211,  2212,    -1,    -1,
      -1,    -1,   436,    -1,    -1,   439,    -1,    -1,    -1,    -1,
      -1,    -1,   423,   424,   425,  4196,   427,   428,   429,   430,
     431,   432,    -1,  2238,    -1,  2240,  2241,  2242,  2243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4225,    -1,  4227,  2262,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,  2274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    28,    -1,   172,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   193,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2319,    -1,    -1,    -1,    -1,    66,
    2325,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2336,    -1,    -1,    -1,    -1,    -1,    -1,  2343,  2344,
      -1,    -1,    -1,    -1,  2349,    -1,    -1,   236,    -1,    -1,
     239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,  4336,   255,    -1,    -1,  2374,
    2375,    -1,    -1,    -1,  2379,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2391,  2392,  2393,  2394,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2404,
      -1,    -1,  2407,    -1,  2409,  2410,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,  2419,  2420,    -1,    -1,  2423,    -1,
    4391,   168,    -1,    -1,    -1,   172,    28,    -1,    -1,    -1,
      -1,  2436,    -1,  2438,    36,  2440,    -1,  2442,    -1,    -1,
      42,   330,    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,
      -1,    18,    -1,    -1,    -1,    -1,  2461,    24,    -1,    -1,
    2465,    -1,    -1,   210,    66,    -1,  2471,    -1,    -1,  2474,
    2475,  2476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4451,    -1,    49,    -1,    -1,    18,  2491,    -1,    -1,   236,
      -1,    24,   239,    -1,    -1,    -1,    -1,    64,  2503,    -1,
      -1,    -1,    -1,  2508,    -1,   252,    -1,    -1,   255,  2514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2522,    -1,    -1,
    2525,    -1,    -1,    -1,  2529,    -1,    -1,    -1,    95,    -1,
      -1,    64,  4503,    -1,   423,   424,   425,    -1,   427,   428,
     429,   430,   431,   432,    -1,    -1,   113,    -1,   437,    -1,
      -1,     8,    -1,   120,    11,    -1,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2570,   168,  2572,    -1,    -1,
     172,    -1,  2577,    -1,    -1,    -1,    -1,    -1,    -1,    36,
     113,    -1,    -1,   330,    -1,    42,    -1,   120,    -1,    -1,
     123,   193,   194,    -1,    -1,    -1,    -1,    -1,  2603,    -1,
    2605,  2606,  2607,    -1,    -1,    -1,    -1,   174,   210,    66,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,   236,    -1,    -1,   239,    -1,    28,
      -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,   255,    -1,   222,    -1,   224,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,   236,
      -1,    -1,    -1,    -1,    -1,    -1,   423,   424,   425,   246,
     427,   428,   429,   430,   431,   432,    -1,   254,    -1,     8,
     437,    -1,    11,    -1,    -1,    -1,   263,   264,    -1,    -1,
      -1,   234,    -1,   236,    -1,    -1,    -1,    -1,    -1,    28,
      -1,   168,    -1,   246,    -1,   172,    -1,    36,    -1,    -1,
      -1,   254,    -1,    42,    -1,    -1,    -1,    -1,   330,    -1,
     297,   264,    -1,   300,   301,   302,   193,   194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,   326,
      -1,    -1,    -1,    -1,   297,    -1,    -1,   300,   301,    -1,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2784,
    2785,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,   252,    -1,   186,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,   197,    -1,
     199,    -1,    -1,   202,    -1,   204,    -1,   384,    -1,    -1,
      -1,   423,   424,   425,    -1,   427,   428,   429,   430,   431,
     432,    -1,  2837,  2838,    -1,   437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,   168,
      -1,   384,    -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2866,  2867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2875,  2876,    -1,   330,   193,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2890,    -1,    -1,    -1,    -1,
      -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2918,    -1,    -1,  2921,   236,    -1,    -1,
     239,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
    2935,    -1,    -1,   252,    -1,    42,   255,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,  2966,    -1,    -1,    -1,    -1,    -1,   424,   425,  2974,
     427,   428,   429,   430,   431,   432,    -1,    -1,    -1,  2984,
      -1,    -1,    -1,    -1,    -1,  2990,    -1,  2992,    -1,    -1,
      -1,    -1,    -1,  2998,    -1,    -1,  3001,  3002,  3003,  3004,
    3005,  3006,  3007,  3008,  3009,  3010,    -1,    -1,    -1,  3014,
    3015,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3027,    -1,    -1,    -1,  3031,    -1,    -1,    -1,
    3035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3045,    -1,    -1,  3048,    -1,  3050,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3059,  3060,  3061,    -1,    -1,    -1,
    3065,   168,    -1,  3068,    -1,   172,    -1,  3072,    -1,    -1,
      -1,    -1,    -1,    -1,  3079,  3080,  3081,  3082,    -1,  3084,
    3085,    -1,    -1,    -1,  3089,  3090,   193,   194,    -1,    -1,
      -1,  3096,    -1,    -1,    -1,    -1,    -1,  3102,  3103,    -1,
      -1,    -1,    -1,   210,   423,   424,   425,    -1,   427,   428,
     429,   430,   431,   432,    -1,    -1,    -1,    -1,   437,    -1,
      -1,  3126,    -1,    -1,    -1,    -1,    -1,  3132,    -1,   236,
      -1,  3136,   239,  3138,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   532,    -1,   252,    -1,    -1,   255,    -1,
      -1,   540,    -1,    -1,    -1,  3160,  3161,  3162,    -1,  3164,
     549,   550,    -1,    -1,    -1,   554,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   565,  3182,  3183,  3184,
    3185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,   595,    -1,    11,   598,
      -1,   600,    -1,   602,  3219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,    -1,    28,    -1,    -1,     8,    -1,
      -1,    11,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    18,    -1,    -1,    36,    -1,    -1,    24,
      -1,    -1,    42,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   662,    -1,   664,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
    3295,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,
     437,   720,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,  3346,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,
      -1,    -1,  3357,    -1,  3359,   120,    -1,    -1,   123,    -1,
    3365,    -1,    -1,    -1,    -1,   168,  3371,    -1,    -1,   172,
      -1,    -1,    -1,    -1,    -1,  3380,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3392,   168,   778,
     193,   194,   172,    -1,    -1,    -1,    -1,  3402,    -1,    -1,
      -1,    -1,    -1,  3408,    -1,    -1,    -1,   210,    -1,    -1,
      -1,    -1,   177,   193,   194,    -1,    -1,    -1,    -1,  3424,
    3425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     210,    -1,    -1,   236,    -1,    -1,   239,   168,    -1,    -1,
      -1,   172,  3447,    -1,  3449,   834,    -1,    -1,    -1,   252,
      -1,    -1,   255,    -1,    -1,    -1,   236,    -1,    -1,   239,
     849,    -1,   193,   194,    -1,    -1,    -1,    -1,    -1,   234,
      -1,   236,   252,   862,    -1,   255,    -1,    -1,  3483,   210,
     869,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      -1,    -1,   881,    -1,    -1,   884,    -1,    -1,    -1,   264,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,    -1,
      -1,    -1,    -1,    -1,    -1,  3520,    -1,    -1,    -1,    -1,
      -1,   252,    -1,    -1,   255,  3530,  3531,   330,   917,    -1,
      -1,    -1,   297,  3538,  3539,   300,   301,    -1,  3543,    -1,
      -1,    -1,    -1,    -1,  3549,  3550,    -1,    -1,  3553,    -1,
     330,  3556,  3557,    -1,    -1,  3560,  3561,  3562,  3563,    -1,
      -1,   326,  3567,  3568,    -1,  3570,    -1,    -1,  3573,    -1,
      -1,    -1,  3577,    -1,     8,    -1,  3581,    11,    -1,    -1,
      -1,    -1,  3587,    -1,    -1,    -1,    -1,    -1,  3593,    -1,
      -1,    -1,    -1,  3598,    28,    -1,    -1,    -1,  3603,   330,
      -1,    -1,    36,    -1,  3609,    -1,    -1,    -1,    42,    -1,
      -1,    -1,  3617,    -1,    -1,    -1,  3621,    -1,    -1,   384,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
    3635,    -1,    66,  3638,   437,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   423,   424,   425,    -1,   427,   428,   429,
     430,   431,   432,  3658,  3659,    -1,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3682,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,   424,   425,    -1,   427,   428,   429,   430,
     431,   432,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3732,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,    -1,
      -1,  3746,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
     194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,  1178,
    1179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3804,
      -1,    -1,   236,    28,    -1,   239,    -1,    18,    -1,    -1,
    3815,    36,    -1,    24,    -1,  3820,    -1,    42,   252,    -1,
       8,   255,  3827,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3839,  3840,    -1,    -1,    -1,    -1,
      28,    66,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,  1241,    64,    42,    -1,    -1,    -1,    -1,    -1,
    3865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3894,
      -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,  3903,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,   123,    -1,    -1,  3920,  3921,    -1,    -1,  3924,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3937,  3938,    -1,    -1,    -1,  3942,    -1,    -1,
      -1,    -1,  3947,   168,    -1,  3950,  3951,   172,  3953,    -1,
    3955,  3956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,   193,   194,
      -1,    -1,    -1,    -1,    -1,  3980,  3981,  3982,  3983,  3984,
     168,    -1,    -1,    -1,   172,   210,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,    -1,
      -1,    -1,    -1,   437,    -1,   193,   194,    -1,    -1,    -1,
      -1,   236,    -1,    -1,   239,    -1,    -1,  4022,  4023,    -1,
      -1,    -1,   210,   234,    -1,   236,    -1,   252,    -1,    -1,
     255,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,   236,    -1,
      -1,   239,    -1,   264,  1443,    -1,    -1,    -1,  4063,  4064,
      -1,    -1,    -1,  4068,   252,     8,  4071,   255,    11,  1458,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4082,    -1,    -1,
      -1,    -1,    -1,    -1,  4089,    28,   297,    -1,  4093,   300,
     301,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
    4105,    -1,    -1,  4108,    -1,   330,    -1,    -1,    -1,  1498,
      -1,  4116,  4117,    -1,    -1,   326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,  1513,    -1,  1515,    -1,  1517,    -1,
      -1,    -1,    -1,  1522,  4139,    -1,    -1,  4142,    -1,  4144,
      -1,    -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4167,    -1,    -1,    -1,  4171,    -1,    -1,  4174,
      28,    -1,    -1,   384,    -1,  4180,  1565,    -1,    36,    -1,
    1569,    -1,  1571,    -1,    42,  1574,    -1,    -1,    -1,    -1,
      -1,  4196,    -1,    -1,    -1,  4200,    -1,    -1,   423,   424,
     425,    -1,   427,   428,   429,   430,   431,   432,    66,    -1,
      -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,  4224,
    4225,  4226,  4227,    -1,    -1,   168,    -1,    -1,    -1,   172,
      -1,    -1,    -1,    -1,  4239,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,   437,
     193,   194,    -1,  4258,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,
      -1,     8,  4277,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,
      -1,    28,   198,   236,    -1,    32,   239,    -1,    -1,    36,
      -1,   207,    -1,    -1,    -1,    42,    -1,    -1,  4313,   252,
     168,  4316,   255,    -1,   172,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,  4336,    -1,  4338,    -1,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,  4348,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,   236,    -1,
      -1,   239,    -1,    -1,    -1,    -1,  4391,   330,    -1,    -1,
      -1,  4396,    -1,    -1,   252,    -1,     8,   255,    -1,    11,
      -1,    -1,  4407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4419,  4420,    28,    -1,    -1,  4424,
      -1,    -1,    -1,  4428,    36,    -1,    -1,    -1,    -1,    -1,
      42,   168,    -1,    -1,    -1,   172,    -1,  4442,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4451,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,   193,   194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   330,   210,    -1,    -1,    -1,  4482,    -1,    -1,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
      -1,  4496,    -1,    -1,   437,    -1,    -1,    -1,  4503,   236,
      -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,  1897,  1898,
      -1,    -1,    -1,  1902,  1903,   252,    -1,  1906,   255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1916,    -1,   879,
      -1,    -1,    -1,    -1,  1923,   147,    -1,    -1,  1927,  1928,
     152,    -1,  1931,  1932,    -1,    -1,    -1,    -1,    -1,  1938,
      -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,  4564,
     172,  1950,    -1,  1952,    -1,   423,   424,   425,  4573,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,    -1,  1968,
      -1,   193,   194,    -1,  1973,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,    -1,    -1,    -1,  1986,   210,    -1,
      -1,    -1,    -1,    -1,    -1,  1994,    -1,  1996,  1997,  1998,
    1999,    -1,    -1,    -1,  2003,  2004,    -1,    -1,   524,    -1,
      -1,    -1,  2011,   529,   236,    -1,  2015,   239,    -1,    -1,
    2019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,   255,   381,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2044,    -1,    -1,    -1,    -1,
      -1,  1011,    -1,    -1,    -1,    -1,  2055,    -1,  2057,    -1,
      -1,    -1,    -1,  2062,    -1,    -1,    -1,  2066,    -1,  2068,
    2069,  2070,  2071,    -1,  2073,    -1,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,    -1,  2086,  2087,  2088,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
    2099,  2100,     8,    -1,    -1,    11,    -1,    -1,   330,    18,
      -1,    28,    -1,    -1,    -1,    24,    -1,    -1,    -1,    36,
      -1,    -1,    28,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
     666,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      66,    -1,    -1,    -1,  2163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   689,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   423,   424,   425,   113,   427,   428,   429,   430,   431,
     432,   120,    -1,   729,   123,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    31,
     146,    -1,    -1,    -1,    36,    -1,    -1,    -1,    18,  1209,
      42,   168,    -1,    -1,    24,   172,    -1,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    66,    -1,   193,   194,    -1,    -1,
     796,    -1,    -1,  2282,    -1,    -1,    -1,   193,   194,    -1,
      -1,    -1,    -1,   210,    64,    -1,    -1,   179,    -1,    -1,
      -1,    -1,    -1,  1263,   210,    -1,   188,   189,    -1,    -1,
      -1,  2310,    -1,   195,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,    -1,   206,   234,    -1,   236,    -1,    -1,
     236,    -1,    -1,   239,    -1,   252,    -1,   246,   255,  1299,
      -1,    -1,    -1,   113,    -1,   254,   252,    -1,    -1,   255,
     120,    -1,    -1,   123,    -1,   264,    -1,    -1,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,
      -1,    -1,   888,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,   300,   301,    -1,   910,   911,   912,    -1,    -1,    -1,
      -1,   193,   194,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,   330,    -1,  1375,    -1,   326,   210,    -1,
      -1,    -1,    -1,    -1,   330,    -1,    -1,   344,    -1,    -1,
      -1,    -1,    -1,    -1,  1394,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,   239,    -1,    -1,
      -1,    -1,    -1,    -1,  1414,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,   255,   234,    -1,   236,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,   384,   246,    -1,    -1,  1439,
      -1,    -1,    -1,    -1,   254,    -1,  1002,    -1,    -1,    -1,
      28,    -1,    -1,    -1,   264,    -1,    -1,    -1,    36,    -1,
      -1,    -1,  2501,    -1,    42,    -1,   423,   424,   425,  1025,
     427,   428,   429,   430,   431,   432,    -1,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,   297,    66,    -1,
     300,   301,    -1,    -1,    -1,    -1,  1496,    -1,   330,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2550,  2551,    -1,    -1,    -1,   326,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2567,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,  2592,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2601,    -1,    -1,    28,    -1,    -1,    31,    -1,
      -1,    -1,    -1,    36,   384,    -1,    -1,  2616,  2617,    42,
      -1,    -1,  2621,    -1,    -1,    -1,    -1,  2626,  2627,  2628,
     168,   423,   424,   425,   172,   427,   428,   429,   430,   431,
     432,  1157,    -1,    66,    -1,    -1,    -1,    -1,    -1,   531,
      -1,    -1,    -1,    -1,    -1,   193,   194,  2656,  2657,  2658,
    2659,   543,    -1,    -1,    -1,   547,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,   558,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,  1205,
      -1,  2690,   574,  2692,  2693,  2694,   578,    -1,   236,    -1,
      -1,   239,    -1,  2702,    -1,    -1,   588,   589,    -1,    36,
      -1,    -1,   594,  1673,   252,    42,    -1,   255,    -1,    -1,
      -1,    -1,   604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     612,    -1,   270,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,  1708,   172,
      -1,    -1,  1268,    -1,    -1,    -1,    -1,    -1,    -1,  1275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2767,    -1,
     193,   194,    -1,    -1,    -1,    -1,  2775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,
      -1,  1307,   330,    -1,  1310,    -1,    -1,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    -1,   687,    -1,    -1,    -1,    18,
     692,    -1,    -1,   236,    -1,    24,   239,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
    1346,    -1,   255,  2832,    -1,    -1,   718,    -1,    -1,    -1,
      -1,   168,    -1,    -1,  1360,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,  1373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2874,    -1,    -1,  2877,    -1,
      -1,    -1,    -1,   210,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,    -1,   330,    -1,    -1,
    2909,   120,   239,    -1,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1882,    -1,  2923,   252,  1886,  1887,    -1,    -1,
      -1,    -1,    -1,    -1,  2933,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,  1472,    -1,    11,    -1,
      -1,    -1,  1478,   845,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,   856,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   879,    -1,    -1,
     423,   424,   425,   330,   427,   428,   429,   430,   431,   432,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,  1534,    -1,
      -1,    -1,    -1,    -1,    -1,   234,    -1,   236,    -1,    -1,
      -1,    -1,  1992,    -1,   916,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,  1572,  1573,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,   948,    -1,    -1,    -1,
      -1,    -1,  1588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   963,    28,    -1,    -1,   967,    -1,    -1,   297,    -1,
      36,   300,   301,   975,    -1,    -1,    42,    -1,    -1,   152,
     427,   428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,   326,    -1,   172,
      66,  1003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1011,
      -1,  1013,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,   194,    -1,    -1,  1026,    -1,    -1,  1029,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,  1041,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3167,    -1,
    3169,    -1,    -1,    -1,    -1,   384,    -1,  3176,    -1,    -1,
      -1,  2141,    -1,   236,    -1,    -1,   239,    -1,  1070,  1705,
      -1,    -1,    -1,  3192,    -1,    -1,    -1,    -1,  1714,   252,
      -1,    -1,   255,    -1,    -1,    -1,    -1,    -1,  3207,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1098,  1099,  3217,  1101,
      -1,    -1,   168,    -1,    -1,    -1,   172,    -1,    -1,    -1,
      -1,    -1,    -1,  3232,    -1,    -1,    -1,    -1,  1120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2220,  1143,    -1,    -1,   210,    -1,  3265,  3266,  3267,  1151,
    1152,  3270,  3271,  3272,  3273,  3274,    -1,   330,  1160,  1161,
    3279,  3280,    -1,  3282,  3283,  3284,  3285,  3286,  3287,  3288,
     236,    -1,    -1,   239,    -1,    -1,    -1,    -1,  3297,    -1,
    3299,  3300,    -1,    -1,    -1,    -1,   252,  1189,    -1,   255,
      -1,  1193,  1194,    -1,  1830,    -1,  1832,    18,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,  1209,    -1,    -1,
      -1,    -1,    -1,  1215,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2304,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,  1869,  3353,  3354,  3355,    -1,    -1,  3358,
      -1,    -1,     8,    64,    -1,    11,    -1,    -1,    -1,    -1,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
      -1,  1263,    28,    -1,   330,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    95,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     356,    -1,   113,    -1,    -1,    -1,    -1,  1299,    -1,   120,
      66,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3457,  3458,
    3459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,  1356,    -1,   177,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    -1,    -1,    -1,
    2006,    -1,    -1,  1375,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2025,
      -1,    -1,  1394,    -1,  2474,  2475,  2476,    -1,    -1,    -1,
      -1,   222,   168,   224,    -1,    -1,   172,    -1,    -1,    -1,
      -1,    -1,  1414,   234,    -1,   236,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,   193,   194,    -1,
      -1,    -1,  1434,   254,    -1,    -1,    -1,  1439,    -1,    -1,
      -1,    -1,   263,   264,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1454,    -1,    -1,    -1,    -1,  2537,    -1,    -1,
    2540,    -1,  2542,    -1,    -1,    -1,    -1,  2547,  1470,    -1,
     236,    -1,    -1,   239,    -1,    -1,   297,    -1,    -1,   300,
     301,   302,    -1,    -1,    -1,    -1,   252,    -1,  1490,   255,
      -1,    -1,    -1,    -1,  1496,    -1,    -1,  1499,    -1,  1501,
    1502,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,
    1512,    -1,    -1,    -1,    -1,    -1,   337,  2597,    -1,    -1,
      -1,    -1,  1524,  1525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1536,    -1,  2172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,  3668,
    3669,  3670,    -1,    -1,  3673,    -1,    -1,  2637,    -1,    -1,
      -1,    -1,    -1,   384,   330,    -1,  1568,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3694,  3695,  3696,  3697,    -1,
    3699,  3700,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3711,  3712,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1603,    -1,  1605,    -1,  3724,    -1,    -1,    -1,    -1,
    1612,  3730,  3731,  1615,  3733,    -1,    -1,  1619,  2698,    -1,
    2700,    -1,    -1,    -1,    -1,  1627,  1628,    -1,    -1,    -1,
      -1,    -1,    -1,  1635,    -1,    -1,  1638,  1639,  1640,  1641,
      -1,    -1,    -1,    -1,    -1,    -1,  1648,  1649,    -1,  1651,
      -1,  1653,  1654,    -1,    -1,  1657,    -1,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    -1,    -1,    -1,
      -1,  1673,  1674,  1675,    -1,  2755,    -1,  1679,    -1,    -1,
      -1,  1683,    -1,    -1,    -1,  1687,    -1,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,    -1,  1699,    -1,    -1,
    2780,    -1,    -1,  3822,    -1,  1707,  1708,    -1,    -1,    -1,
      -1,    -1,  3831,    -1,    -1,    -1,    -1,    -1,    -1,  2799,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,  3851,    -1,    -1,    -1,    -1,  2817,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    28,    -1,    -1,
      31,    24,    -1,    -1,  3873,    36,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    28,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,  2881,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2897,    -1,    -1,
      -1,  3940,    -1,    -1,    -1,    -1,    66,    -1,  2908,  2465,
      -1,    -1,  1834,    -1,  3953,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    28,    -1,
    1882,    -1,    -1,    -1,  1886,  1887,    36,   168,    -1,    -1,
      -1,   172,    42,    -1,  1896,  4014,    -1,  2977,  1900,  1901,
      36,    -1,  1904,   189,   177,    -1,    42,    -1,    -1,   195,
      -1,    -1,   193,   194,    -1,  4034,    66,  2997,    -1,    -1,
     206,    -1,    -1,    -1,  1926,    -1,    -1,  1929,   168,   210,
      66,    -1,   172,    -1,    -1,    -1,    -1,    -1,  1940,    -1,
      -1,    -1,  3022,    -1,    -1,  1947,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,   194,   236,    -1,    -1,   239,    -1,
      -1,   234,    -1,   236,    -1,  1967,    -1,    -1,    -1,    -1,
     210,   252,    -1,   246,   255,    -1,    -1,    -1,  3058,    -1,
      -1,   254,  1984,  1985,    -1,    -1,    -1,    -1,    -1,    -1,
    1992,   264,   128,    -1,    -1,    -1,   236,    -1,    -1,   239,
      -1,    -1,    -1,    -1,    -1,    -1,  4125,  2009,  2010,    -1,
      -1,  2013,   252,    -1,    -1,   255,    -1,    -1,   168,    -1,
      -1,    -1,   172,  3103,   297,    -1,    -1,   300,   301,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,  2039,    -1,    -1,
      -1,  2043,    -1,   193,   194,  4164,    -1,    -1,    -1,   330,
      -1,    -1,    -1,   326,    -1,  4174,    -1,   193,   194,  2061,
     210,    -1,    -1,    -1,  3144,    -1,    -1,    -1,    -1,    -1,
    2072,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2085,    -1,  4204,   236,    -1,    -1,   239,
     330,    -1,    -1,  2095,  4213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,   239,    -1,    -1,    -1,    -1,    -1,  4228,
      -1,   384,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2139,    -1,  2141,
      -1,    -1,   423,   424,   425,    -1,   427,   428,   429,   430,
     431,   432,    -1,    -1,    -1,  3235,    -1,    -1,    -1,    -1,
    2162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     330,    -1,  4301,   423,   424,   425,    -1,   427,   428,   429,
     430,   431,   432,    -1,   330,    -1,    -1,    -1,    -1,    -1,
      -1,  2837,  2838,  4322,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,  2853,  2220,    -1,
      -1,  2223,    -1,    -1,    -1,    -1,    -1,  4346,    -1,    -1,
      -1,  2867,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
    2876,  4360,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2890,  2257,    -1,   543,    -1,    -1,
    2262,   547,    -1,    -1,    -1,    -1,  4385,    -1,    66,    -1,
      -1,  4390,   558,   423,   424,   425,    -1,   427,   428,   429,
     430,   431,   432,    -1,    -1,    -1,    -1,    -1,   574,    -1,
    2292,   427,   428,   429,   430,   431,   432,    -1,    -1,    -1,
      -1,    -1,  2304,   589,    -1,    -1,  3386,    -1,   594,    -1,
      -1,    -1,    -1,  2315,    -1,    -1,    -1,  2319,   604,    -1,
    2956,    -1,  4441,  2325,    -1,    -1,   612,    -1,    -1,    -1,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2343,  2344,  3423,    -1,    -1,    -1,  2349,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     168,    -1,  2374,  2375,   172,    -1,    -1,  2379,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2391,
    2392,  2393,  2394,    -1,    -1,   193,   194,  2399,    -1,    -1,
      -1,    -1,  2404,  2405,    -1,  2407,   692,  2409,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,  2419,  2420,    -1,
      -1,  2423,    18,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,  2436,    -1,  2438,    -1,    -1,    -1,
    2442,   239,    -1,  3079,  3080,  3081,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3533,   252,    -1,    -1,    -1,    -1,  2461,
      -1,    -1,    -1,    -1,  3544,    -1,    -1,    -1,    64,  2471,
      -1,    -1,  2474,  2475,  2476,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,  2488,    -1,     8,  2491,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2503,    -1,    -1,    -1,    -1,  2508,    -1,    -1,    36,
      -1,    -1,  2514,  3593,    -1,    42,    36,   113,  3598,    -1,
    2522,    -1,    42,  3603,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,   330,    -1,    -1,  2537,    -1,    -1,  2540,    66,
    2542,    -1,    -1,    -1,    -1,  2547,    66,  2549,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2564,  2565,    -1,    -1,    -1,    -1,  2570,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3656,    -1,    -1,    -1,
      -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2591,
      -1,    -1,  2594,    -1,    -1,  2597,    -1,    -1,    -1,    -1,
      -1,   128,    -1,    -1,  3684,    -1,    -1,    -1,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3703,    -1,    -1,    -1,    -1,    -1,   427,
     428,   429,   430,   431,   432,  2637,    -1,    -1,   234,    -1,
     236,   168,    -1,    -1,    -1,   172,    -1,    -1,   168,    -1,
     246,    -1,   172,    -1,    -1,    -1,    -1,    -1,   254,    -1,
      -1,    -1,   948,  2665,  2666,  2667,   193,   194,   264,    -1,
      -1,  3751,    -1,   193,   194,    -1,    -1,   963,    -1,    -1,
      -1,    -1,    -1,   210,    -1,    -1,    -1,  2689,    -1,   975,
     210,    -1,    -1,    -1,    -1,    -1,  2698,    -1,  2700,  2701,
      -1,   297,    -1,    -1,   300,   301,    -1,    -1,    -1,  2711,
    3346,    -1,   239,    -1,    -1,    -1,    -1,  1003,    -1,   239,
      -1,    -1,    -1,    -1,    -1,   252,    -1,  1013,    -1,  3365,
     326,    -1,   252,     8,    -1,    -1,    11,    -1,    -1,    -1,
    1026,    -1,    -1,  1029,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2755,    -1,    -1,  3392,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,  2774,    -1,    -1,    -1,    -1,    -1,  2780,    -1,
      -1,    -1,  3862,    -1,    -1,    -1,    -1,    -1,   384,    -1,
      -1,    66,    -1,    -1,    -1,    -1,    -1,  2799,    -1,    -1,
      -1,    -1,    -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,
     330,    -1,    -1,    -1,  2816,  2817,    -1,    -1,  3898,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2831,
      -1,  2833,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2845,    -1,  2847,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   128,    -1,    -1,    -1,  1143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1151,  1152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1161,    -1,    -1,    -1,  2881,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,  2896,  2897,    -1,   172,    -1,    -1,
     427,   428,   429,   430,   431,   432,  2908,   427,   428,   429,
     430,   431,   432,    -1,    -1,    -1,    -1,    -1,   193,   194,
      -1,    -1,  2924,    -1,  3560,  3561,  3562,  3563,    -1,  1215,
      -1,    -1,  4012,  2935,    -1,   210,  2938,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2955,    -1,    -1,  2958,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2974,    -1,    -1,  2977,    -1,   252,    -1,    -1,
      -1,    -1,  2984,    -1,    -1,    -1,    -1,    -1,  2990,    -1,
    2992,    -1,    -1,    -1,    -1,  2997,  2998,    -1,    -1,  3001,
    3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,    -1,
      -1,    -1,  3014,  3015,    -1,    -1,    -1,    -1,    -1,    -1,
    3022,    -1,    -1,    -1,    -1,  3027,    -1,    -1,    -1,  3031,
      -1,  3033,    -1,  3035,    -1,    -1,    -1,    -1,    -1,  4119,
      -1,    -1,    -1,  3045,    -1,    -1,  3048,    -1,  3050,    -1,
      -1,    -1,    -1,    -1,    -1,   330,  3058,  3059,  3060,  3061,
    4140,    -1,    -1,  3065,    -1,    -1,  3068,    -1,    -1,    -1,
    1356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3082,    -1,  3084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3096,    -1,  4176,    -1,    -1,    -1,
    3102,  3103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3126,    -1,    33,    -1,    -1,    -1,
    3132,    -1,    -1,    -1,  4214,    -1,  3138,    -1,  4218,  4219,
      -1,    -1,  3144,    -1,    -1,    -1,    -1,    54,  1434,    -1,
      -1,    -1,   427,   428,   429,   430,   431,   432,  3160,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1454,    76,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1470,    -1,    -1,    -1,    -1,  3191,
      97,    -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   118,    -1,    -1,    -1,  1501,  1502,  4297,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,  1512,  3229,    -1,  3865,
     137,    -1,  3234,  3235,  3236,    -1,    -1,    -1,  1524,  1525,
      -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,   156,
    1536,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3278,    -1,    21,  3281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   214,    -1,    -1,
      -1,    -1,    -1,  3315,   221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    -1,    67,    68,    -1,   252,    -1,    -1,   255,    -1,
      -1,    76,    -1,    -1,    97,    80,    -1,  3359,    -1,    -1,
     103,   189,    -1,    -1,    -1,    -1,    -1,   195,    -1,    -1,
      -1,    -1,    97,    -1,    -1,   118,    -1,    -1,   206,    -1,
    3382,  3383,    -1,   290,  3386,    -1,   129,  3389,    -1,  1675,
      -1,    -1,    -1,   118,   137,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    -1,   129,    -1,   149,   314,    -1,    -1,
      -1,   154,   137,   320,    -1,    -1,   323,   160,    -1,    -1,
      -1,  3423,  3424,  3425,   149,    -1,    -1,    -1,    -1,   154,
      -1,    -1,   175,    -1,    -1,  4071,    -1,    -1,    -1,    -1,
      -1,    -1,   349,    -1,   351,   352,    -1,   354,   355,    -1,
     175,    -1,    -1,    -1,    -1,    -1,   363,   200,    -1,    -1,
      -1,   368,    -1,  3465,    -1,    -1,    -1,   374,    -1,    -1,
     377,    -1,  4108,   380,    -1,   200,    -1,    -1,   221,    -1,
      -1,  3483,    -1,    -1,    -1,    -1,   393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3520,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,  3530,  3531,
      -1,  3533,    -1,    -1,    -1,    -1,  3538,  3539,   281,    -1,
      -1,  3543,  3544,    -1,    -1,    -1,    -1,  3549,  3550,    -1,
      -1,  3553,    -1,    -1,  3556,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4200,   308,    -1,    -1,    -1,   312,
      -1,   314,    -1,    -1,    -1,  3577,    -1,   320,    -1,  3581,
     323,    -1,    -1,   308,    -1,    -1,    -1,   312,    -1,   314,
      -1,  3593,    -1,    -1,    -1,   320,  3598,    -1,   323,    -1,
      -1,  3603,    -1,    -1,    -1,   348,   349,    -1,   351,    -1,
    1896,    -1,   355,    -1,  1900,  1901,    -1,    -1,  1904,    -1,
     363,    -1,    -1,    -1,   349,   368,   351,    -1,    -1,    -1,
     355,    -1,    -1,    -1,    -1,    -1,  3638,   380,   363,    -1,
    1926,    -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,
     393,    -1,    -1,    -1,  3656,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,    -1,
    3672,    -1,    -1,  3675,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1967,  3684,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3698,    -1,  1984,  1985,
      -1,  3703,    -1,    -1,    -1,    -1,    -1,    -1,  3710,    -1,
      -1,    -1,    -1,    -1,    -1,   543,    -1,    -1,    -1,   547,
      -1,  3723,    -1,  2009,  2010,    -1,    -1,  2013,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,    -1,    -1,  3751,
      -1,    -1,    -1,  2039,    -1,    21,    -1,  2043,    -1,    -1,
      -1,   589,    -1,    -1,  3766,    -1,   594,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2061,   604,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   612,    -1,  2072,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2085,
      -1,    67,  3804,    -1,    -1,    -1,    -1,    -1,    -1,  2095,
      -1,    -1,    -1,  3815,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   687,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3862,    -1,    -1,   129,   692,    -1,    -1,   718,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    -1,  2162,    -1,    -1,    -1,
    3882,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,
      -1,    -1,  3894,    -1,   160,    -1,  3898,    -1,    -1,    -1,
      -1,  3903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3920,  3921,
      -1,    -1,  3924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3937,    -1,  2223,    -1,    -1,
    3942,    -1,    -1,    -1,    -1,  3947,    -1,    -1,  3950,    -1,
      -1,    -1,    -1,  3955,  3956,   221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2257,  3974,    -1,  3976,    -1,    -1,    -1,  3980,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   263,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2292,    -1,    -1,    -1,
    4012,  4013,    -1,    -1,    -1,   281,    -1,    -1,    -1,    -1,
    4022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,   312,    -1,   314,    -1,
      -1,  4053,    -1,  4055,   320,    -1,    -1,   323,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4068,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   349,    -1,   351,    -1,    -1,    -1,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,    -1,
      -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2399,   380,  4117,    -1,  4119,    -1,  2405,
     948,    -1,    -1,    -1,    -1,    -1,    -1,   393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   963,    -1,  4139,  4140,    -1,
    4142,    -1,  4144,    -1,    -1,    -1,    -1,   975,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4167,    -1,    -1,    -1,  4171,
      -1,    -1,    -1,    -1,  4176,  1003,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1013,    -1,    -1,    -1,    -1,
    1041,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1026,    -1,
      -1,  1029,  2488,    -1,    -1,    -1,  4208,    -1,    -1,    -1,
      -1,    -1,  4214,    -1,    -1,    -1,  4218,  4219,    -1,  1070,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1098,  1099,    -1,
    1101,    -1,    -1,    -1,    -1,    -1,  4258,    -1,    -1,    -1,
      -1,    -1,    -1,  2549,    -1,    -1,    -1,    -1,    -1,  1120,
      -1,    -1,    -1,    -1,    -1,  4277,    -1,    -1,  2564,  2565,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4297,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2591,    -1,    -1,  2594,  1160,
      -1,  4313,    -1,    -1,  4316,  1143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1151,  1152,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1161,    -1,    -1,    -1,    -1,  1189,    -1,
      -1,    -1,  1193,  1194,    -1,    -1,  4348,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4370,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2665,
    2666,  2667,    -1,    -1,    -1,    -1,    -1,  1215,    -1,    -1,
      -1,    -1,    -1,    -1,  4396,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2689,    -1,  4407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2701,    -1,  4419,  4420,    -1,
      -1,    -1,    -1,    -1,    -1,  2711,    -1,    -1,  4430,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2774,    -1,
      -1,    -1,    -1,    -1,  4496,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4519,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1356,    -1,
    2816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2831,    -1,  2833,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2845,
      -1,  2847,  4564,    -1,    -1,    -1,    -1,  4569,    -1,    -1,
      -1,  4573,    -1,    -1,    -1,  4577,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1434,    -1,    -1,    -1,
    2896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1454,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2924,    -1,
      -1,    -1,  1470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2938,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2955,
      -1,    -1,  2958,  1501,  1502,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1524,  1525,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3033,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1635,    -1,    -1,  1638,    -1,    -1,
    1641,    -1,    -1,    -1,    -1,    -1,    -1,  1648,  1649,    -1,
      -1,    -1,    -1,  1654,    -1,    -1,  1657,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1674,    -1,    -1,    -1,    -1,  1679,    -1,
      -1,    -1,  1683,    -1,    -1,    -1,  1687,    -1,  1689,  1690,
    1691,  1692,  1693,  1694,  1695,  1696,  1697,  1675,  1699,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1707,  1708,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3191,    -1,   879,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3229,    -1,    -1,    -1,    -1,  3234,    -1,
    3236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1834,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3278,    -1,    -1,  3281,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1011,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1114,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1896,    -1,
      -1,    -1,  1900,  1901,    -1,    -1,  1904,    -1,  1929,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3382,  3383,  1926,    -1,
      -1,    -1,    -1,  3389,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1967,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1984,  1985,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1146,    -1,    -1,    -1,    -1,  3465,
      -1,  2009,  2010,    -1,    -1,  2013,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2039,    -1,    -1,    -1,  2043,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2061,    -1,    -1,    -1,  1209,    -1,    -1,
      -1,    -1,    -1,    -1,  2072,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1263,  2085,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2095,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2139,    -1,
      -1,  1263,  1299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1299,    -1,    -1,
      -1,    -1,    -1,    -1,  2162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3672,  1394,    -1,  3675,
      -1,    -1,    -1,    -1,    -1,  2223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1375,    -1,    -1,    -1,  1414,    -1,    -1,
      -1,  2262,  3698,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1394,    -1,  3710,    -1,    -1,    -1,    -1,  2257,
      -1,    -1,  1439,    -1,    -1,    -1,    -1,  3723,    -1,    -1,
      -1,    -1,  1414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2292,    -1,    -1,  1439,    -1,    -1,
      -1,  1532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3766,    -1,    -1,    -1,    -1,    -1,    -1,  2315,    -1,  1496,
      -1,    -1,    -1,  2344,    -1,    -1,    -1,    -1,  2349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1496,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2391,    -1,  2393,  2394,    -1,    -1,    -1,    -1,    -1,  1610,
      -1,    -1,    -1,  2404,    -1,    -1,  2407,    -1,  2409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2399,    -1,  1634,    -1,    -1,    -1,  2405,  1639,    -1,
      -1,    -1,    -1,    -1,    -1,  2436,    -1,  2438,    -1,    -1,
      -1,  2442,    -1,    -1,    -1,    -1,  3882,    -1,  1659,  1660,
      -1,  1662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2474,  2475,  2476,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2491,    -1,   879,  1704,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2503,    -1,    -1,    -1,    -1,  2508,    -1,    -1,
    2488,    -1,    -1,  2514,    -1,    -1,  1673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1740,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3974,    -1,
    3976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1673,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2570,
      -1,  2549,    -1,    -1,    -1,    -1,    -1,  4013,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2564,  2565,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2591,    -1,    -1,  2594,  4053,    -1,  4055,
      -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1844,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1856,    -1,    -1,  1859,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2665,  2666,  2667,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2701,    -1,  1882,    -1,    -1,    -1,  1886,
    1887,    -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1882,    -1,    -1,    -1,  1886,  1887,    -1,    -1,    -1,    -1,
      -1,    -1,  4208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2774,    -1,    -1,   879,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1992,    -1,    -1,  2816,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2831,    -1,  2833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2845,    -1,  2847,
    1992,    -1,    -1,    -1,    -1,    -1,  1263,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1299,    -1,    -1,    -1,    -1,    -1,  2896,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1011,    -1,    -1,  4370,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2924,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2938,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2974,    -1,    -1,    -1,  2955,    -1,    -1,
    2958,    -1,    -1,  2984,  2141,    -1,    -1,    -1,  1375,  2990,
      -1,  2992,    -1,    -1,  4430,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1394,    -1,    -1,
      -1,    -1,    -1,  3014,  3015,    -1,    -1,    -1,    -1,  2141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1414,    -1,    -1,
      -1,    -1,    -1,    -1,  3035,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3045,    -1,    -1,  3048,    -1,  3050,
      -1,    -1,  1439,    -1,    -1,  3033,    -1,    -1,  3059,    -1,
      -1,    -1,    -1,  2220,  3065,    -1,    -1,  3068,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4519,   879,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3096,    -1,    -1,  2220,    -1,
      -1,  3102,  3103,    -1,    -1,    -1,    -1,    -1,    -1,  1496,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3126,    -1,    -1,    -1,  1209,
      -1,  3132,    -1,  4569,    -1,    -1,  2347,  3138,    -1,    -1,
      -1,  4577,    -1,    -1,    -1,    -1,    -1,  2304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2370,
      -1,  2372,    -1,  2374,  2375,  2376,    -1,    -1,  2379,    -1,
      -1,    -1,  2383,    -1,    -1,    -1,    -1,    -1,    -1,  2390,
      -1,    -1,  2304,  1263,  2395,    -1,    -1,    -1,    -1,    -1,
    2401,    -1,    -1,    -1,    -1,  2406,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2415,    -1,    -1,    -1,  2419,  2420,
      -1,  2422,    -1,  3191,    -1,    -1,  1011,    -1,    -1,  1299,
      -1,    -1,    -1,  2434,    -1,    -1,    -1,    -1,    -1,    -1,
    2441,    -1,  2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3229,    -1,    -1,    -1,    -1,  3234,    -1,  3236,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2480,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1375,    -1,    -1,    -1,    -1,
    3278,    -1,    -1,  3281,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1394,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1414,    -1,    -1,  3315,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2585,    -1,    -1,    -1,    -1,    -1,
    2537,    -1,    -1,  2540,    -1,  2542,    -1,    -1,    -1,    -1,
    2547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3382,  3383,    -1,    -1,    -1,    -1,
      -1,  3389,    -1,    -1,  1209,  2537,  1496,    -1,  2540,    -1,
    2542,    -1,    -1,  3424,  3425,  2547,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1263,    -1,
      -1,    -1,    -1,    -1,    -1,  2597,    -1,    -1,    -1,    -1,
    2637,    -1,  3483,    -1,    -1,    -1,    -1,  3465,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1882,    -1,    -1,    -1,  1886,
    1887,    -1,    -1,    -1,  1299,    -1,    -1,    -1,   879,    -1,
      -1,    -1,    -1,    -1,    -1,  2637,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3530,
    3531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2698,  3543,  2700,    -1,    -1,    -1,    -1,  3549,  3550,
      -1,    -1,  3553,    -1,    -1,  3556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2698,    -1,  2700,    -1,
    1375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2802,  3593,  1673,    -1,    -1,    -1,  3598,  2755,  1394,
      -1,    -1,  3603,    -1,    -1,  1992,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1414,
      -1,    -1,    -1,  2780,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2755,    -1,    -1,    -1,  3638,    -1,    -1,
    1011,    -1,  2799,    -1,  1439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2780,    -1,
    2817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2799,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3672,  2817,    -1,  3675,    -1,    -1,
      -1,  1496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2927,    -1,    -1,    -1,
    3698,    -1,    -1,    -1,  2881,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2897,    -1,    -1,    -1,    -1,  3723,    -1,    -1,    -1,    -1,
      -1,  2908,    -1,    -1,  2141,    -1,    -1,    -1,    -1,  2881,
      -1,    -1,  2973,    -1,    -1,    -1,    -1,    -1,  2979,    -1,
      -1,    -1,    -1,    -1,    -1,  2897,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2995,  2996,  2908,  2998,  3766,    -1,
    3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,
    3011,    -1,  1882,  3804,    -1,    -1,  1886,  1887,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2977,    -1,    -1,    -1,    -1,  3036,    -1,    -1,  3039,    -1,
    3041,    -1,    -1,  2220,    -1,  3046,  3047,    -1,  1209,    -1,
    2997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3060,
    3061,  3062,    -1,  3064,    -1,  2977,  3067,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3022,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,  1673,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1263,    -1,    -1,    -1,    -1,    -1,    -1,  3110,
    3022,  3058,    -1,    -1,  3882,    -1,    -1,    -1,    -1,    -1,
    3121,    -1,  1992,    -1,    -1,    -1,    -1,  2304,    -1,    -1,
      -1,    -1,    -1,  3924,    -1,    -1,    -1,    -1,  1299,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3058,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3956,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3974,    -1,  3976,    -1,
      -1,    -1,    -1,    -1,  1375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3144,  1394,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4013,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1414,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2141,    -1,    -1,    -1,    -1,    -1,    -1,  1439,    -1,
      -1,    -1,    -1,    -1,    -1,  4053,    -1,  4055,  3235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1882,    -1,    -1,
      -1,  1886,  1887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1496,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2220,  4142,    -1,    -1,    -1,    -1,    -1,    -1,  3359,    -1,
    2537,    -1,    -1,  2540,    -1,  2542,    -1,    -1,    -1,    -1,
    2547,    -1,    -1,    -1,    -1,    -1,  4167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1992,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2304,    -1,    -1,    -1,    -1,  3386,
    4208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,    -1,  3423,    -1,    -1,    -1,
      -1,    -1,    -1,  3484,    -1,    -1,  4277,  3488,  3489,  3490,
      -1,    -1,  3493,    -1,    -1,    -1,    -1,  3498,  3499,  3500,
    3501,  3502,  3503,  3504,  3505,  3506,  3507,  3508,  3509,    -1,
      -1,  3423,  1673,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2698,    -1,  2700,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3537,  3538,  3539,  3540,
      -1,  3542,    -1,    -1,    -1,  3546,  3547,  3548,    -1,    -1,
    3551,    -1,    -1,  3554,    -1,    -1,  2141,  4348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2755,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,
      -1,    -1,  1209,    -1,  3595,    -1,    -1,  3544,    -1,    -1,
      -1,  3602,  4370,  2780,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3614,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3533,  2799,    -1,    -1,    -1,    -1,    -1,  4419,  4420,
      -1,    -1,  3544,    -1,    -1,  2220,    -1,    -1,    -1,    -1,
    2817,    -1,    -1,    -1,    -1,    -1,  1263,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4430,    -1,    -1,    -1,    -1,  2537,    -1,    -1,
    2540,    -1,  2542,    -1,    -1,    -1,    -1,  2547,    -1,    -1,
      -1,    -1,  1299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2881,  4496,    -1,    -1,    -1,  3656,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2304,
    2897,  1882,    -1,    -1,    -1,  1886,  1887,  2597,    -1,    -1,
      -1,  2908,    -1,    -1,    -1,    -1,    -1,  3684,    -1,    -1,
      -1,    -1,    -1,    -1,  3656,    -1,    -1,    -1,    -1,    -1,
      -1,  4519,    -1,    -1,    -1,    -1,  3703,    -1,  1375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2637,    -1,    -1,
      -1,    -1,  3684,  4564,    -1,    -1,    -1,  1394,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3703,    -1,    -1,    -1,    -1,    -1,  1414,    -1,    -1,
    2977,  4569,    -1,    -1,  3751,    -1,  3807,    -1,    -1,  4577,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2997,    -1,  1439,    -1,    -1,    -1,    -1,    -1,  2698,    -1,
    2700,  1992,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3751,
      -1,    -1,    -1,    -1,    -1,  3022,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3859,  3860,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1496,
      -1,  3058,    -1,    -1,    -1,  2755,    -1,    -1,    -1,  3890,
      -1,    -1,    -1,  3894,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3908,    -1,  3910,
    2780,    -1,    -1,    -1,  3915,  3916,  3917,    -1,    -1,  3920,
    3921,  3922,  3923,    -1,  3925,    -1,    -1,  3928,    -1,  2799,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2817,    -1,    -1,
      -1,  3898,  2537,    -1,    -1,  2540,    -1,  2542,    -1,    -1,
      -1,    -1,  2547,    -1,    -1,    -1,    -1,  3144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3978,    -1,    -1,
    2141,    -1,    -1,    -1,    -1,    -1,  3898,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2881,  2597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2897,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2908,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2637,    -1,    -1,    -1,  1673,    -1,  3235,  2220,
      -1,    -1,    -1,    -1,    -1,  4012,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4074,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4012,    -1,    -1,    -1,    -1,    -1,    -1,  2977,    -1,    -1,
      -1,    -1,    -1,  2698,    -1,  2700,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4138,  4139,    -1,
      -1,    -1,    -1,  2304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3022,  4154,  4155,  4156,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2755,    -1,  4119,    -1,    -1,    -1,    -1,    -1,  4179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3058,    -1,
      -1,    -1,    -1,  4140,    -1,  2780,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4119,    -1,  3386,
      -1,    -1,    -1,    -1,  2799,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4140,  4176,
      -1,    -1,  2817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4176,  1882,    -1,  4214,    -1,  1886,
    1887,  4218,  4219,    -1,  3144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2881,    -1,    -1,    -1,
      -1,    -1,  4214,    -1,  4305,    -1,  4218,  4219,    -1,    -1,
      -1,    -1,  2897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4321,    -1,    -1,  2908,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3235,    -1,  3544,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1992,  2537,    -1,    -1,  2540,
      -1,  2542,    -1,    -1,    -1,    -1,  2547,    -1,    -1,    -1,
      -1,    -1,  2977,    -1,  4395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2597,  3022,    -1,  4440,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3058,    -1,    -1,  2637,    -1,    -1,  3656,
      -1,    -1,    -1,    -1,  4485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3684,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2141,    -1,  3703,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2698,    -1,  2700,
    4541,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3423,    -1,    -1,    -1,    -1,    -1,  3144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3751,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2755,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2780,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2799,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3235,    -1,    -1,    -1,    -1,    -1,  2817,    -1,    -1,    -1,
      -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3544,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2881,  3898,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2897,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2908,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3656,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3684,    -1,  2977,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3703,    -1,  4012,  2997,    -1,  3423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3058,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2537,    -1,    -1,  2540,    -1,  2542,    -1,    -1,    -1,    -1,
    2547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4119,    -1,    -1,    -1,    -1,    -1,  3533,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3544,
      -1,    -1,    -1,  4140,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2597,    -1,    -1,  3144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3898,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4214,    -1,    -1,
      -1,  4218,  4219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3656,    -1,    -1,  3235,    -1,    -1,    -1,    -1,    -1,
      -1,  2698,    -1,  2700,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3684,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3703,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2755,    -1,
      -1,    -1,  4012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2780,    -1,    -1,  3751,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2799,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3423,    -1,  2881,    -1,    -1,    -1,    -1,    -1,
    4140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2908,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4176,    -1,    -1,    -1,
      -1,    -1,    -1,  3898,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4214,    -1,    -1,    -1,  4218,  4219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2997,    -1,    -1,  3544,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3022,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4012,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3656,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3684,    -1,    -1,    -1,  3144,    -1,    -1,
      -1,    -1,    -1,    -1,  4119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4140,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3751,  4176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4214,
      -1,    -1,    -1,  4218,  4219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3544,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4176,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3656,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4214,    -1,    -1,    -1,  4218,  4219,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3684,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,  3703,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    -1,
      44,    -1,    -1,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    -1,  3751,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,    -1,    -1,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,
     144,    -1,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,    -1,   183,
     184,   185,   186,    -1,    -1,    -1,    -1,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,  3898,   206,    -1,   208,   209,   210,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,   231,    -1,   233,
     234,    -1,    -1,   237,   238,   239,   240,    -1,    -1,   243,
      -1,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,  4012,   320,   321,   322,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,    -1,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,    -1,    -1,    -1,    -1,   361,    -1,   363,
      -1,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,    -1,    -1,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4140,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,  4214,    -1,    -1,
      30,  4218,  4219,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,   436,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,     3,    -1,    -1,    -1,    -1,    -1,
      -1,   436,   437,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,    -1,   237,   238,   239,   240,    -1,    -1,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,    -1,   363,    -1,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   416,   417,   418,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,   208,   209,
     210,    -1,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,   239,
     240,    -1,    -1,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,    -1,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,    -1,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,   416,   417,   418,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,   437,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,   434,   435,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,   429,    -1,    -1,    -1,
      -1,    -1,    -1,   436,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,     3,     4,     5,     6,
       7,   436,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,    -1,     9,    10,    -1,    -1,   436,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,   436,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,    -1,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,    -1,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,    -1,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,   251,   252,   253,
     254,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   436,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
     251,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,   391,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,
      -1,   436,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,   174,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,    -1,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,   246,   247,    -1,   249,   250,    -1,
     252,   253,   254,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,    -1,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,
     382,   383,   384,   385,   386,   387,   388,    -1,   390,   391,
     392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,   427,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,   436,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,   174,   175,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,    -1,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
     246,   247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,    -1,    -1,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,    -1,   382,   383,   384,   385,
     386,   387,   388,    -1,   390,   391,   392,   393,   394,   395,
      -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     436,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,    -1,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,   207,    -1,   209,
      -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,    -1,   232,   233,   234,   235,    -1,   237,   238,    -1,
     240,    -1,   242,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,
     260,    -1,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
      -1,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,    -1,   382,   383,   384,   385,   386,   387,   388,    -1,
     390,    -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   436,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   436,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    -1,    -1,    -1,   436,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,    -1,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
      -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,   237,
     238,    -1,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
     258,    -1,   260,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,     3,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     429,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   429,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,    -1,
     237,   238,   239,   240,    -1,    -1,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,    -1,   363,    -1,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,   416,
     417,   418,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,   429,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,   208,   209,
     210,    -1,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,   239,
     240,    -1,    -1,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,    -1,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,    -1,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,   416,   417,   418,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,   429,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,     4,     5,    -1,
      -1,    -1,     9,    -1,    -1,    -1,   429,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,   250,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,     4,     5,    -1,    -1,    -1,     9,    -1,
     427,   428,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,   250,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,     4,
       5,    -1,    -1,    -1,     9,    -1,   427,   428,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,   250,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
       9,    -1,   427,   428,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,   152,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,     4,     5,    -1,    -1,    -1,     9,    -1,   427,   428,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,   250,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      -1,    68,    69,    70,    71,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,   251,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
     251,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
     251,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,    -1,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,    -1,   237,   238,
     239,   240,    -1,    -1,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,   418,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,    -1,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,   208,   209,   210,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,   363,
      -1,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   416,   417,   418,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,    -1,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,    -1,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,
     363,    -1,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,   417,   418,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,   181,    -1,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
     208,   209,   210,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,    -1,    -1,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
      -1,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,    -1,   273,    -1,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,    -1,   363,    -1,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,    -1,
     388,    -1,   390,   391,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,
     418,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,    -1,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,    -1,   237,   238,   239,   240,    -1,    -1,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,
     363,    -1,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,   417,   418,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,   181,    -1,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
     208,   209,   210,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,    -1,   237,
     238,   239,   240,    -1,    -1,   243,   244,   245,   246,   247,
      -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,
      -1,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,    -1,   273,    -1,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,    -1,   363,    -1,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,    -1,
     388,    -1,   390,   391,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,
     418,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,    -1,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,    -1,   237,   238,   239,   240,    -1,    -1,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,
     363,    -1,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,   417,   418
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    81,    83,    99,   102,   114,   116,   120,   126,   134,
     136,   142,   157,   212,   213,   218,   227,   238,   276,   288,
     293,   294,   296,   301,   306,   309,   313,   318,   319,   326,
     329,   337,   349,   366,   376,   382,   387,   400,   436,   443,
     444,   445,   446,   452,   453,   455,   456,   457,   458,   459,
     460,   461,   463,   464,   468,   480,   485,   486,   489,   490,
     491,   503,   506,   507,   523,   560,   563,   566,   567,   568,
     575,   581,   583,   585,   586,   589,   592,   593,   597,   598,
     607,   611,   612,   613,   614,   615,   617,   618,   619,   632,
     633,   637,   639,   640,   641,   651,   653,   660,   661,   664,
     665,   666,   667,   668,   673,   675,   678,   682,   686,   687,
     697,   698,   701,   706,   717,   739,   742,   743,   744,   747,
     750,   752,   754,   757,   758,   761,   762,   763,   770,   771,
     773,   774,   775,   780,   782,   783,   787,   788,   791,   792,
     793,   794,   796,   797,   798,   799,   801,   804,   805,   810,
     816,   819,   821,   822,   827,   829,   833,   840,   844,   845,
     846,   847,   848,   849,   852,   880,   361,   403,   776,    21,
      67,    80,    97,   103,   118,   129,   137,   149,   154,   160,
     175,   200,   221,   252,   281,   308,   312,   314,   320,   323,
     348,   349,   351,   355,   363,   368,   380,   393,   582,   776,
       3,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    33,    34,    36,    37,    39,    40,    41,
      42,    43,    45,    46,    48,    49,    50,    51,    52,    55,
      56,    57,    58,    59,    61,    62,    63,    64,    65,    69,
      70,    71,    72,    74,    75,    77,    78,    79,    80,    81,
      82,    85,    86,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   104,   106,   107,   108,   109,   110,   112,   113,
     114,   117,   118,   119,   120,   121,   123,   124,   125,   127,
     128,   129,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   141,   143,   144,   145,   146,   148,   150,   154,   155,
     156,   158,   159,   161,   163,   164,   165,   166,   167,   169,
     170,   171,   173,   174,   175,   176,   177,   178,   180,   182,
     183,   184,   185,   186,   187,   188,   190,   192,   195,   197,
     198,   199,   200,   201,   203,   204,   206,   207,   209,   212,
     213,   214,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   232,   233,   234,   235,
     237,   238,   240,   242,   243,   244,   245,   246,   247,   249,
     252,   253,   254,   257,   258,   260,   262,   263,   264,   265,
     266,   267,   268,   269,   271,   272,   273,   274,   275,   276,
     277,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   305,   306,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   320,   321,
     322,   323,   324,   326,   327,   328,   329,   331,   332,   333,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   347,   348,   350,   351,   352,   353,   354,   355,   357,
     358,   361,   362,   363,   364,   366,   367,   368,   369,   370,
     371,   372,   375,   376,   377,   378,   379,   382,   383,   384,
     385,   386,   387,   388,   390,   392,   393,   394,   395,   398,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   841,   997,
    1010,  1014,  1015,   391,   806,   250,   277,   776,    44,   514,
     845,    21,    33,    54,    67,    76,    97,   103,   118,   129,
     137,   149,   156,   160,   214,   252,   255,   308,   314,   323,
     351,   352,   354,   355,   363,   368,   374,   377,   380,   524,
     565,   656,   707,   718,    22,   276,   997,   841,    22,   271,
     321,   352,   354,     5,   199,   748,   749,  1006,    21,    33,
      54,    67,    80,    97,   118,   129,   137,   149,   154,   160,
     175,   221,   252,   263,   308,   312,   314,   320,   323,   349,
     351,   355,   363,   368,   380,   393,   582,   669,   776,   997,
      83,   391,   436,   560,   563,   566,   805,   811,   819,   822,
     827,   833,   840,   844,     9,    15,    22,    39,   144,   150,
     152,   172,   201,   233,   279,   295,   427,   428,   683,   684,
     841,  1005,  1009,    22,    83,   292,   319,   688,   689,   690,
    1010,  1010,  1002,  1006,   349,   855,   683,  1010,   361,   997,
     263,   221,    97,   175,   348,   349,   755,   313,  1010,    22,
     324,   357,   361,   472,   481,   482,  1010,    19,   157,   688,
     689,   277,   776,  1010,   198,    22,   115,   857,    55,    77,
     214,   229,   308,   314,   324,   357,   361,   406,   469,   470,
     471,   472,    22,   324,   357,   361,   472,   361,   251,   891,
     995,  1010,   855,   429,  1010,   153,   436,   807,   436,   990,
     290,   850,   851,   997,   845,   846,   849,     0,   439,   806,
     130,   189,   256,   373,   858,   859,   845,   847,   848,   108,
     185,   379,   440,     3,    38,    44,    67,    73,    84,    90,
     151,   153,   168,   181,   193,   194,   196,   208,   210,   231,
     239,   259,   261,   307,   330,   391,  1003,  1010,  1011,  1014,
    1016,   671,  1010,   671,   998,  1010,   280,   671,   363,   671,
     997,  1010,    96,   349,   696,  1003,     3,  1007,  1012,  1014,
    1015,  1016,    22,   167,   995,   245,   393,     8,    62,   141,
     423,   424,   425,   427,   428,   429,   430,   431,   432,   746,
     957,   958,  1010,    22,  1007,   997,   997,   167,   995,   997,
     301,   326,    22,   167,   891,   997,   316,   997,   671,    22,
     219,  1007,   167,   995,   199,   105,   195,   236,   286,   777,
     778,   779,   995,  1001,  1010,    21,    54,    67,    68,    76,
      80,    97,   118,   129,   137,   149,   154,   175,   200,   221,
     252,   308,   312,   314,   320,   323,   349,   351,   355,   363,
     368,   393,   582,   676,  1006,   995,   359,  1003,   997,   436,
     671,   363,   998,   671,   363,   167,   997,    96,   349,   352,
     354,  1007,   352,   354,    62,   141,   746,   299,  1007,   167,
     465,  1010,   997,   997,   316,   997,   671,   219,  1007,   290,
     320,   349,   393,   221,    80,   175,   154,   312,   367,   576,
      22,   997,   842,   479,  1006,  1012,   749,   167,  1003,   997,
     167,   753,   167,   998,   363,    96,   349,   167,  1003,   167,
    1007,  1008,    73,   393,    62,   141,   167,   746,    48,   167,
    1008,   167,   997,   167,   997,   167,   997,   316,   167,   997,
     167,   219,  1008,   199,   167,   670,   671,   436,   820,   524,
     811,   387,   805,   812,   813,   814,  1012,   806,  1009,   684,
     685,    22,   685,  1009,   685,    22,   685,  1009,   685,   685,
     685,  1009,  1005,  1005,   841,   685,   280,   436,   436,   543,
     543,   543,   250,   359,   440,   543,   891,   892,   440,   772,
    1006,   436,   817,    48,   393,   997,   997,   995,  1010,    38,
     418,   195,   438,   253,   253,   250,   152,  1006,   359,   147,
     679,   250,     4,     6,     7,     8,    10,    30,    43,    45,
      46,    53,    54,    57,    58,    65,    67,    87,    88,    89,
      90,    91,    92,    93,   100,   101,   119,   135,   139,   140,
     145,   159,   187,   188,   190,   207,   215,   216,   230,   232,
     236,   241,   242,   244,   252,   262,   272,   287,   310,   325,
     332,   345,   357,   358,   362,   364,   365,   374,   380,   388,
     408,   409,   410,   411,   412,   413,   414,   415,   427,   428,
     429,   436,   845,   907,   910,   913,   914,   915,   917,   918,
     919,   920,   923,   924,   928,   930,   931,   932,   934,   955,
     959,   978,   983,   991,   992,   993,  1003,  1004,  1005,  1006,
    1010,  1006,    22,   487,   994,   995,   324,   469,   103,   478,
    1006,   479,  1006,    38,    59,   469,   418,   333,   778,   253,
     152,   359,   423,    38,   418,   195,   779,   436,   995,   429,
     434,   438,   984,   985,   892,   151,   153,   391,   802,   803,
     805,   151,   808,   103,   928,   988,   989,   850,   440,   436,
     809,   437,   437,   445,   995,    22,   115,   856,   856,    48,
     856,   142,   147,   211,   248,   862,   864,   865,   874,   876,
     877,   878,   858,   859,   152,   191,   891,   893,   990,   436,
     730,   985,   264,   297,   326,   438,   672,   264,   297,   326,
     264,   297,   326,   400,   447,   480,   483,   702,    18,   120,
     264,   297,   326,   384,   494,   997,   326,    18,   120,   379,
     462,   404,   167,   891,    50,    82,   138,   170,   206,   236,
     264,   297,   305,   311,   318,   326,   335,   343,   395,   480,
     484,   733,   740,   436,   719,   297,   462,   172,   135,    18,
      24,    64,   113,   120,   123,   177,   234,   236,   246,   254,
     264,   297,   300,   301,   326,   384,   492,   493,   601,     4,
     427,   428,   573,  1009,    22,   167,   995,   671,   671,   436,
     745,   438,   172,   454,   297,   447,   454,   250,   264,   297,
     135,    49,    95,   174,   222,   224,   234,   263,   297,   302,
     326,   337,   492,   570,   571,   264,   297,   392,   601,   609,
     482,   470,   472,   172,   135,   297,   326,   492,   264,   297,
     301,   326,    74,   112,   265,   353,   250,    18,    24,   120,
     264,   297,   326,   504,   505,   454,   147,   297,   447,   454,
     135,   297,   326,   492,   997,   209,   105,   251,   405,   440,
     777,   381,   800,   250,  1003,   436,   997,   363,    96,   349,
    1003,   245,   393,    62,   141,   746,   997,   316,   997,   199,
     671,   543,   283,   509,   436,   646,   730,    60,     3,    43,
      45,    46,    57,    58,   100,   101,   145,   187,   188,   190,
     230,   232,   244,   287,   327,   332,   357,   358,   388,   904,
     906,   908,   910,   912,   914,   915,   916,   918,   919,   923,
     924,  1011,  1014,   152,   436,   642,   997,   447,    31,   795,
     997,   236,   447,   404,   167,   995,   447,   671,   671,   642,
     377,   524,   447,   236,    38,   466,   368,   608,   264,   584,
      74,   112,   265,   353,    20,    40,   186,   620,    31,   642,
     147,   447,   393,   995,   167,   561,   995,   995,   393,   671,
      73,   708,  1003,   997,   582,    44,    94,   184,   234,   315,
     135,   730,    51,   303,   495,   135,   436,   135,   404,   135,
     719,   135,   440,   167,   670,   167,   671,   167,   671,   135,
     745,  1008,   135,   135,   250,   135,   495,   135,    74,   112,
     265,   353,   135,   250,   135,   147,   167,   167,   479,   135,
     440,   495,   928,   962,   349,   437,   440,   140,   250,   365,
     476,   479,   573,   815,   811,   685,   841,   685,   841,   685,
     841,   685,   841,   685,   841,   841,   841,   685,   841,   436,
     544,   545,  1010,   544,    22,    97,   118,   149,   154,   199,
     200,   314,   320,   349,   351,   368,   691,   994,  1008,   690,
     172,   440,   830,  1006,   904,   965,    31,  1008,   708,   148,
     756,   756,   756,   209,  1010,   147,   147,   691,  1008,   313,
    1010,   479,   250,   436,   986,   434,   845,   966,   390,   921,
     928,   982,   436,   921,   921,   436,   147,   436,   436,   436,
     909,   909,   274,   845,   436,   436,   911,   436,   436,   436,
     436,    57,    58,   921,   928,   436,   909,   436,   436,   436,
     436,   436,   402,   422,   436,   925,   436,   925,   436,   436,
     845,   436,   436,   436,   436,   436,   436,   436,   436,   928,
     928,   845,   928,   962,   985,  1006,    58,   436,   922,   436,
    1006,     3,     8,    11,    28,    31,    36,    42,    66,   168,
     172,   193,   194,   210,   236,   239,   252,   255,   330,   423,
     424,   425,   427,   428,   429,   430,   431,   432,   957,   959,
     961,   401,   943,   261,   928,   191,   853,   440,   436,  1006,
     985,   106,   169,   488,   440,    59,   103,   479,    31,     3,
     103,   214,   477,   573,   924,  1006,  1006,    78,   117,   940,
      86,   103,   473,   474,   476,   573,   103,   473,   209,   995,
     928,     3,    22,    26,    27,    28,    29,    30,    31,    32,
      35,    47,    53,    54,    60,    66,    68,    76,    83,    87,
      88,    89,    91,    92,    93,   103,   105,   111,   115,   116,
     122,   126,   130,   140,   142,   147,   149,   152,   157,   160,
     162,   172,   179,   189,   191,   202,   205,   211,   215,   216,
     236,   241,   248,   250,   251,   255,   256,   270,   278,   292,
     304,   319,   325,   334,   346,   349,   356,   359,   360,   365,
     373,   374,   380,   381,   389,   396,   397,   399,   400,   429,
    1000,  1013,  1014,  1015,  1016,  1017,   984,    79,   302,   674,
     437,   440,   806,   437,   440,   851,   996,   997,    31,   809,
     847,   847,   860,   861,   928,   847,   144,   233,   871,   197,
     234,   286,   328,   379,    22,   866,   928,   867,   869,   928,
     930,   874,   875,   865,   864,   862,   863,   147,   877,   246,
     879,   862,   874,   893,   995,    31,  1010,   326,   172,   182,
     256,   258,   327,   389,   429,   723,   724,   725,   727,   729,
     731,   904,  1011,   264,   297,   326,   359,   359,   314,  1000,
     438,   359,   359,   314,   359,   359,   351,   469,   789,   147,
     157,   172,   306,   703,   704,    60,    76,   131,   149,   278,
     374,   540,   541,    76,   103,   236,   359,    76,   359,   103,
     236,   314,    76,   113,   123,   264,   297,   638,   314,   590,
      21,    54,    67,    80,   118,   129,   149,   154,   221,   252,
     314,   320,   323,   349,   355,   368,   393,   582,   997,   135,
     297,   326,   492,   250,   573,   318,   206,   359,   359,   241,
     573,   107,   192,   314,   324,   361,   471,   303,   326,   733,
     741,   437,   720,   723,   359,   380,   351,   995,    68,   131,
     531,   540,  1010,    68,    76,   759,   250,   312,   363,    76,
     759,    25,   300,   312,   363,   995,   177,   246,   671,   436,
     359,   359,   166,   436,   499,   351,   400,   402,   499,    76,
     440,     4,     4,   264,   172,   135,   297,   326,   492,   381,
     381,   235,   904,   264,   326,   746,    97,   326,   483,   359,
     449,   483,   995,   359,   359,   995,   573,    48,   572,   573,
     573,    95,   222,   224,    48,   359,   447,   314,   447,   234,
     571,   359,   359,   241,  1006,   601,   351,   891,    76,   359,
     759,   314,   359,   359,   499,   499,   671,   671,   671,   671,
     995,    37,   386,    37,    37,   359,    37,   359,   314,   440,
     483,    93,   380,   616,  1007,   359,   449,   483,   995,   359,
     314,   264,   297,   286,   298,   322,   475,   777,  1001,  1010,
     995,   730,   904,   250,   404,   719,   573,   671,   671,   745,
     193,   250,    74,   112,   265,   353,   250,   671,   193,   400,
     515,   340,   341,   510,  1006,     3,   647,   648,   642,   436,
     906,    31,    30,   905,    98,   165,   223,   226,   317,   416,
     436,   926,   927,   672,   909,   671,   643,   644,  1013,    20,
     784,   904,   250,   135,   587,   997,   236,   436,   448,   656,
     381,   290,   393,   448,   135,  1007,    83,   157,   467,   523,
     567,   619,   686,   706,   780,  1006,   609,   610,   997,   217,
     671,   671,   671,   671,   246,   108,   185,   366,   379,   621,
     622,   127,   285,   436,   616,   448,   995,   569,   570,   236,
      31,   246,   436,   543,   543,   564,   995,   147,   709,  1001,
     436,   721,    31,   199,   400,   402,   843,   315,  1003,   495,
     904,   998,   167,   997,  1003,   495,  1008,  1007,   135,   495,
     135,   381,   135,   381,   746,   495,   495,  1008,   997,   671,
     997,   997,   997,   671,  1008,   616,   135,   135,   495,   670,
     671,   437,   440,   995,   811,   813,   841,   841,   841,   841,
     841,   841,   544,   437,   440,   437,   155,   321,   350,   996,
     670,    96,   323,   695,   696,   996,   245,   996,   994,   994,
     996,   670,   359,   400,   699,    16,   133,   310,   328,   831,
     891,   240,   832,   437,   440,   818,   822,   827,   833,   844,
     359,   995,   689,   688,   689,   152,   158,   700,  1010,    21,
      68,    97,   118,   129,   149,   154,   200,   221,   308,   314,
     320,   349,   351,   368,   393,   582,   680,   962,   984,   435,
     962,   966,   967,   436,   396,   979,   980,   928,   962,   436,
    1005,  1005,   962,     3,    98,   165,   223,   226,   317,   416,
     968,   969,  1006,  1005,   962,   962,  1005,  1005,   921,   921,
     928,   746,   928,   970,   427,   428,   929,   930,   955,   959,
     972,   437,   962,   928,   962,   973,   357,   418,  1005,  1005,
     928,    47,   152,   205,   360,   928,   962,   976,   962,   228,
     930,   928,   938,   939,   940,   228,   928,   940,   437,   440,
     326,  1005,  1005,   926,   904,   928,  1013,   357,    35,   346,
     987,   671,   928,   436,   845,   977,   115,   117,   140,   236,
     241,   246,   365,   375,   928,    42,   168,   172,   210,   330,
     436,   928,   359,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,    22,    29,   334,   956,   160,   143,   944,
     310,   436,   955,   156,   214,   349,   352,   354,   377,   854,
     995,   152,   881,   993,    22,   115,   389,   429,   437,   725,
     928,   963,   964,  1011,   995,   361,   436,  1006,   440,   437,
     435,   441,   166,   166,   495,   995,   803,   804,   995,   988,
     437,   440,   436,   440,    32,   111,   381,   715,   436,   868,
    1009,   328,   197,   251,   440,   310,   311,   870,   994,   832,
     875,   863,   381,   828,   103,   436,   823,   844,  1010,   436,
     834,   835,   836,   837,   838,  1010,   258,    48,  1011,   437,
     725,   727,   724,   727,  1011,   256,   437,   440,   672,   359,
     359,   314,  1007,   997,   997,  1000,  1007,   997,   997,  1007,
     998,   997,    75,   790,   308,   380,   688,   314,   157,   688,
     436,   997,   381,   710,   197,   197,   381,   436,   559,   167,
     997,   241,  1007,   997,   997,   928,   241,   997,   997,    25,
     300,   359,   359,   997,   359,   591,  1003,   436,   671,   671,
     671,   363,    96,   349,   696,   393,    62,   141,   746,   997,
     671,   997,   671,   316,   671,   671,   199,   161,   234,   264,
     297,   385,   594,   595,   596,   891,   359,   759,   314,   241,
     107,   192,  1007,   997,   250,   997,   437,   440,  1007,  1008,
     997,   297,   492,   531,   904,   997,  1010,   997,   997,    22,
     380,   997,   167,   997,   167,  1010,   312,   363,   312,   363,
     997,    22,   380,   997,   995,    18,   120,   326,   602,   603,
     604,   605,  1013,  1007,   997,   103,   153,   237,   381,   498,
     501,   502,  1013,   997,   249,    64,   249,   997,   493,   359,
     351,   995,   359,   759,   314,   999,  1010,   999,   440,   437,
     440,   359,   314,   998,  1007,     3,    75,   125,   177,   269,
     372,   380,   383,   450,   297,  1007,   997,   297,   326,   492,
     570,   573,   671,   997,   573,   997,   573,  1007,   997,   997,
     297,   326,   492,   997,   997,   997,   997,  1007,   997,    18,
      24,   120,   264,   297,   326,   264,   297,   326,   642,   297,
     326,   297,   326,   297,   903,  1010,   167,   652,  1010,   167,
    1010,  1007,   997,   997,   997,    18,   505,   323,  1007,   297,
     326,   492,   997,   997,   359,   359,    72,   371,   286,   193,
      31,   671,   193,   193,   381,   381,   193,   241,   677,  1006,
     671,   671,   193,   677,   249,   152,   359,   508,   447,   423,
     437,   440,   928,    30,   905,   904,   434,   434,   359,   359,
     359,   436,   359,  1005,   909,   437,   440,   423,   621,    75,
     124,   203,   204,   217,   264,   351,   353,   785,   533,  1013,
     997,   152,   314,   392,   588,   595,   596,   135,   210,   525,
     527,   529,   531,   537,   540,    19,   172,   308,   347,   450,
     451,   147,   999,   393,   995,   465,  1010,   466,   255,   524,
     149,  1006,   642,   642,   642,   642,   246,   250,   255,   436,
     642,   901,   902,   903,   323,   436,   135,   134,   844,   671,
     525,  1010,   400,   402,   555,   400,   500,    31,   543,  1006,
     250,   437,   722,   723,   728,    31,   199,   305,   399,   732,
     733,   734,   250,   479,   164,   164,   147,   730,    31,   135,
     495,   719,   670,   671,   999,   671,   999,   745,   250,   495,
     495,   250,   495,   323,   147,   479,   495,   928,   437,   545,
     172,   172,   172,   404,   996,   440,   573,   574,   160,   692,
     693,  1007,    19,   700,   133,   328,   133,   328,   310,   379,
     225,   904,   997,   400,   562,   152,   250,   692,    48,   495,
    1003,   363,   349,  1003,   245,   393,   199,   671,   437,   435,
     435,   440,   962,   928,   122,   980,   981,    31,   437,   928,
     437,   437,   437,   437,   152,   437,   437,   437,   437,   437,
     440,   437,   270,   971,   437,   929,   929,    11,   172,   193,
     252,   423,   424,   425,   427,   428,   429,   430,   431,   432,
     959,   929,   437,   437,   147,   152,   974,   975,   437,   418,
     437,   437,    31,   976,   962,   976,   976,   152,   437,   437,
    1013,   268,   942,    31,   437,   440,   928,  1013,   440,   928,
     986,   928,  1010,   437,   437,   418,   929,   929,   128,   962,
     152,   115,   117,   140,   241,   246,   365,   375,   436,   128,
     346,   987,   928,   977,   928,   359,   746,   928,   436,   845,
     436,   436,   260,   948,   352,   354,   352,   354,   995,   855,
     855,   855,   202,   311,   436,   845,   882,   883,   884,   891,
     894,   931,   933,   934,  1003,  1010,   397,   899,   963,   963,
     964,   437,    13,   440,   858,   859,   778,  1005,   926,   474,
     928,   809,   997,   818,   861,   252,   957,   960,   419,   420,
     716,   928,   870,   379,   867,   882,   397,   900,   387,   824,
     825,  1010,   304,   826,   838,   839,   440,   881,   423,   986,
     731,   672,   727,   727,    48,   729,   431,  1007,   997,   997,
     211,  1008,  1008,   250,   996,   253,   250,   928,   541,   999,
     436,   436,   436,   559,   175,   544,   630,   135,   495,   359,
    1007,   997,   479,   730,   904,   997,   404,   671,   671,   671,
     671,   745,    74,   112,   265,   353,   997,   577,   997,   161,
     385,   359,   359,   577,   594,   601,   297,   326,   492,   997,
     997,   997,   183,   241,   723,   263,   326,   359,   254,   599,
     630,   120,   301,   326,   494,   601,   760,   135,   495,   135,
     495,   997,   997,   997,   997,   604,   605,   604,   437,   440,
     606,  1006,   175,   437,   440,   423,   438,  1007,   997,   297,
     326,   492,   997,   997,   997,   264,   297,   326,    18,   120,
     264,   297,   326,   904,   235,   904,  1007,   997,   211,   269,
     241,  1006,   269,  1008,   378,   359,   359,   314,   263,   326,
     359,   759,   314,   359,   359,   219,   219,   219,   359,   359,
     314,   359,   359,   314,   359,   314,   359,   314,   359,   495,
     904,   236,  1006,   326,   760,   135,   495,   359,   997,   359,
     314,  1007,   997,   677,   904,   193,   677,   677,   999,   999,
     677,   193,   193,   677,   509,   436,   511,   512,   252,   427,
     428,   573,   645,   727,   960,  1006,  1017,     3,   648,   437,
     434,   437,  1005,   435,  1005,   165,   223,   927,   223,   927,
     927,  1005,   226,   437,   644,   645,   250,   211,   423,   786,
     786,   786,   786,   786,   786,   786,    60,    66,    76,   103,
     105,   179,   236,   241,   278,   292,   374,   534,   535,   536,
     134,   396,   447,   479,   997,   479,   599,   995,   995,   437,
     440,  1008,   160,   308,  1008,  1005,   368,   995,   543,    38,
     466,   299,   349,    96,   500,   544,   995,   622,   649,   650,
    1006,   437,   440,   997,   544,   995,   997,   562,   436,   526,
     437,   249,   499,   249,   250,   556,   499,    31,   844,   500,
     359,   995,   437,   440,   103,   423,   735,  1006,   479,   349,
     726,   727,   400,   734,   736,   108,   185,   319,   379,   768,
     161,   844,   495,   904,   997,   495,   495,   381,   495,   381,
     495,   495,   671,   671,   997,   616,   495,   314,   314,   314,
     996,   696,   440,  1007,   400,   440,   694,   253,   133,   133,
      96,   234,  1008,   691,   495,  1007,   730,   719,   573,   671,
     193,   966,   437,   356,   928,   126,   904,   437,   928,   928,
     928,   974,   904,   929,   115,   117,   236,   246,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   928,   928,
     975,   974,   925,   925,   904,   437,   437,   437,   962,   437,
     440,    48,   930,   437,  1013,   939,   275,   344,   941,   437,
     440,   392,   935,    31,   437,   922,  1006,   928,    28,    28,
     928,   437,   928,   152,   436,   965,   928,   929,   929,   128,
     128,   928,   437,   128,   928,   859,   397,   436,   949,  1010,
     855,   855,   855,   855,   995,   995,   995,   845,   894,   152,
     845,   883,   884,    31,   885,   886,  1010,   440,    84,   153,
     181,   196,   208,   231,   307,   888,   886,    31,   885,   887,
    1010,   421,   898,   436,   985,   928,   160,   872,   440,   858,
     858,   858,   928,   389,   964,   437,   437,   435,   437,   436,
     716,   437,   251,    86,   928,   826,   437,   440,   986,   992,
     437,   440,   835,   900,   988,   437,   431,   731,   368,   786,
     155,   321,   350,   369,   705,   147,   705,   437,   436,   547,
     548,   712,   933,  1010,   544,   544,   630,  1001,   437,   105,
     179,   234,   236,   631,   997,   997,    31,   997,   381,   381,
     671,   671,   671,   671,   672,  1007,   997,   359,   759,   314,
     359,   183,    48,   351,   997,   436,   533,   236,   499,    96,
     236,   339,   342,   499,   368,   997,  1010,   603,   997,   502,
     645,  1013,   263,   326,   359,   759,   314,   359,   359,   359,
     314,   154,   252,   342,   654,   655,   154,   252,   662,   663,
     359,   359,   314,   437,   437,   437,  1009,  1006,  1006,  1006,
     997,   997,   997,    48,   351,   997,   997,   997,   997,   997,
     147,   147,   299,   147,   167,  1007,   997,   997,  1007,   997,
     997,   997,   997,   997,   997,   997,    66,   496,   135,    20,
      40,   368,  1010,   997,   601,   997,   997,   437,   677,   193,
     193,   677,   677,   510,   518,   519,  1013,    44,    85,   109,
     124,   128,   148,   151,   163,   241,   249,   284,   513,   630,
    1005,   400,   402,   435,   435,   437,   926,   995,   786,   103,
    1005,  1006,   103,  1006,   103,  1006,   103,  1006,   103,   997,
     103,   997,   103,   997,   436,   671,   997,   929,   106,   169,
     105,   241,   197,   995,   736,   282,   634,   635,  1010,   587,
     436,   538,   323,   529,  1008,  1008,   904,   436,   500,  1007,
     995,   404,   147,   623,   437,   440,   903,   599,   437,   246,
     436,   820,   528,   530,   532,   540,  1010,   555,   178,   554,
      71,   351,   557,   844,   562,   557,  1006,   710,   728,   928,
     928,   440,   436,   732,   642,   359,   577,   437,   495,   999,
     999,   495,   495,   323,   996,   996,   996,   573,   157,   693,
      96,   700,   152,   193,   193,   193,   193,   241,   681,  1006,
     928,   437,   437,   975,   152,   115,   117,   246,   436,   437,
     407,   937,   962,   291,    48,   398,   398,   437,   928,   234,
     928,   440,   936,   906,   926,   929,   929,   928,   965,   437,
      28,    28,   928,   928,   128,   928,   437,   437,   928,   950,
    1010,   995,   995,   995,   995,   886,   887,   436,   437,  1010,
     436,   883,   196,   259,   889,   883,   889,   196,   888,   889,
     196,   436,  1010,   436,   963,    48,   162,   873,   437,   437,
     437,   964,  1006,  1006,   746,   246,   844,   825,   423,   838,
     826,   368,   437,  1009,   359,   688,   152,   630,   928,   437,
     440,   400,    66,   713,   713,   437,   437,   736,   106,   169,
     177,   105,   383,   495,   904,   999,   999,   997,   997,   997,
     997,  1008,   997,   600,   604,   241,   241,  1009,  1010,   904,
     495,   495,   423,    48,   351,   997,   997,   997,   997,  1007,
     997,   997,  1005,  1005,   904,   440,  1005,  1005,   440,  1007,
     997,   997,  1008,   997,   359,   996,   996,   671,   996,   135,
     671,  1006,  1006,   904,   495,   495,   193,   677,   677,   381,
     516,   517,   437,   440,   429,   436,   476,   520,   573,   795,
    1006,   795,   236,   241,   284,   795,   795,   435,   154,   182,
     154,   152,   629,  1009,   928,   236,   535,   736,   543,   381,
     558,  1003,    28,   134,   172,   525,   132,   173,   997,   381,
     544,    31,   466,   436,   997,   121,   624,   396,   626,  1006,
     500,   671,   525,   562,   437,   440,   400,   556,   436,   555,
     108,   120,   275,   997,   400,   781,   152,   436,  1006,   725,
     737,   738,  1011,   736,   995,   180,   578,   495,   495,   495,
     997,   253,   495,   692,   681,   681,   681,   681,   929,   152,
     436,   965,   436,   437,   440,   437,   930,   291,   437,   386,
     336,   437,   437,   437,   929,   929,   928,   437,   267,   951,
     895,   896,   933,   885,   436,   996,   883,   250,   381,   890,
     883,   196,   883,   902,   436,   902,  1010,   858,   962,   928,
     399,   945,   858,   926,   437,   841,   990,   692,   250,   692,
     437,   736,   548,   252,   746,   671,   381,   671,   714,   714,
     292,   736,   558,   437,   359,   326,   832,   437,   440,   496,
     645,  1008,   997,   359,   436,  1003,   746,   655,   436,   436,
     663,   326,   832,   997,   400,   299,   400,   400,   147,   496,
     677,   447,   110,   519,   476,   521,   522,  1006,  1006,   241,
     544,   429,   544,  1006,  1006,   696,    31,   751,   751,   995,
     630,   437,   558,   220,   546,   175,   436,   635,   282,   436,
     437,    22,    70,    77,   104,   176,   342,   539,   539,   599,
     999,   437,   844,   599,   310,   338,   625,   436,   134,    31,
     526,   437,   530,   254,   557,   994,   556,   311,   311,    52,
      60,   214,   671,   711,   712,   727,   437,   440,   899,   577,
     234,   385,   579,   580,   495,   929,   965,   437,   938,   962,
      48,   234,   417,    48,   858,   437,   440,    31,   897,   996,
     437,   928,   436,   883,   890,   437,   902,   437,   437,   946,
     947,  1010,   437,   694,   705,   495,   713,   558,   436,   671,
     715,   715,   995,   558,   630,   997,   351,   604,   381,   497,
     326,   832,   997,   965,   719,   147,   658,   745,   965,   965,
     351,   670,   671,   670,   671,   996,   495,   511,  1006,   437,
     440,   544,   751,    34,   171,   147,   234,   542,   153,   266,
     331,   250,   550,   551,   552,   351,   437,  1003,     5,   636,
     323,   141,   657,   500,   781,   928,   282,   844,   555,   554,
     533,   437,   557,    60,   253,    60,   437,   440,   732,   737,
     116,   385,   577,   437,   437,   437,   291,   386,   962,   285,
     311,   952,   898,   895,   436,   437,   996,   437,   440,    31,
     152,   714,   397,   549,   746,   716,   716,   543,   630,   997,
     928,   351,   437,   256,   316,   289,   659,   658,   437,   437,
     997,   400,   522,   121,   177,   108,   379,   250,   552,   250,
     551,   997,   436,   437,   440,   997,   671,    31,    31,   437,
    1003,   781,   556,   555,   253,   253,   500,   712,   736,    23,
     186,   769,    42,    86,   370,   928,   953,   954,   953,   437,
     902,   437,   947,   949,   692,   715,   436,   630,   437,   546,
     832,   997,  1003,    48,   659,   832,   671,   310,    51,   234,
     303,   326,   553,   553,   437,     5,   599,   654,   844,   436,
     557,   556,   557,   237,   436,   764,   766,   771,   822,   827,
     833,   844,   954,   310,   146,   273,   146,   273,   437,   495,
     716,   928,   550,   832,   719,   671,   626,    17,   103,   241,
     781,     4,   627,   628,  1005,  1006,  1013,   557,   899,   765,
     766,   767,   845,   846,    28,   437,   630,   134,   437,   440,
     437,   439,   954,   282,   628,   767,  1003,   436,   627,   437
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   442,   443,   444,   444,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   446,   447,   447,   448,   448,   449,   449,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   451,   451,
     451,   451,   451,   451,   452,   453,   454,   454,   455,   455,
     456,   457,   457,   458,   458,   459,   459,   460,   461,   462,
     462,   463,   463,   464,   464,   464,   464,   465,   465,   466,
     466,   467,   467,   467,   467,   467,   467,   468,   468,   468,
     469,   469,   469,   470,   470,   470,   470,   471,   471,   471,
     471,   471,   471,   471,   471,   471,   471,   471,   472,   472,
     473,   473,   474,   474,   475,   475,   475,   475,   476,   476,
     476,   476,   477,   477,   477,   477,   477,   477,   477,   478,
     478,   478,   479,   479,   480,   481,   481,   481,   481,   482,
     482,   483,   483,   484,   484,   485,   485,   485,   485,   485,
     486,   487,   487,   488,   488,   489,   490,   490,   490,   490,
     490,   491,   491,   491,   491,   491,   491,   491,   491,   491,
     491,   491,   491,   491,   491,   491,   491,   492,   492,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   494,   494,   495,   495,   495,   496,   496,
     497,   497,   498,   498,   498,   498,   499,   500,   500,   501,
     501,   502,   502,   502,   502,   503,   504,   504,   505,   505,
     505,   505,   506,   506,   507,   507,   508,   508,   509,   509,
     510,   510,   510,   511,   511,   512,   512,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   514,   514,   515,   515,   516,   516,   517,   517,   518,
     518,   519,   520,   520,   520,   520,   520,   521,   521,   522,
     523,   523,   523,   523,   524,   524,   524,   524,   524,   524,
     524,   524,   525,   525,   526,   526,   527,   527,   528,   528,
     529,   529,   529,   530,   530,   531,   532,   533,   533,   534,
     534,   534,   534,   535,   535,   535,   535,   535,   535,   535,
     536,   536,   536,   536,   537,   538,   538,   538,   539,   539,
     539,   539,   539,   539,   540,   540,   541,   541,   541,   541,
     541,   541,   541,   542,   542,   543,   543,   544,   544,   545,
     546,   546,   546,   546,   547,   547,   548,   548,   549,   549,
     550,   550,   550,   550,   550,   551,   552,   553,   553,   553,
     553,   553,   554,   554,   555,   555,   555,   555,   556,   556,
     556,   556,   557,   557,   558,   558,   559,   560,   561,   562,
     562,   562,   563,   564,   565,   565,   566,   567,   568,   568,
     569,   569,   570,   570,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   572,   572,   573,   573,
     573,   573,   574,   574,   575,   575,   576,   576,   577,   577,
     578,   578,   579,   579,   580,   580,   581,   581,   582,   582,
     583,   584,   584,   585,   585,   586,   586,   587,   587,   588,
     588,   588,   589,   590,   590,   591,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     593,   594,   594,   594,   594,   595,   595,   596,   596,   597,
     597,   598,   598,   599,   599,   600,   600,   601,   602,   602,
     603,   603,   603,   603,   604,   605,   606,   607,   608,   608,
     609,   609,   610,   610,   611,   611,   612,   612,   612,   613,
     613,   614,   614,   615,   616,   616,   616,   617,   617,   618,
     619,   619,   620,   620,   620,   621,   621,   622,   622,   622,
     622,   622,   623,   623,   624,   624,   625,   625,   626,   626,
     627,   627,   627,   628,   628,   628,   628,   629,   629,   630,
     630,   631,   631,   631,   631,   631,   631,   632,   632,   633,
     633,   634,   634,   635,   636,   636,   637,   638,   638,   638,
     638,   639,   640,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   642,   643,   643,
     644,   644,   645,   645,   645,   645,   645,   646,   647,   647,
     648,   649,   649,   650,   650,   651,   651,   651,   652,   652,
     653,   654,   654,   655,   655,   655,   655,   655,   656,   656,
     657,   657,   658,   658,   658,   659,   659,   660,   661,   661,
     662,   662,   663,   663,   664,   664,   665,   665,   666,   667,
     668,   668,   668,   668,   669,   669,   669,   669,   669,   669,
     669,   669,   669,   669,   669,   669,   669,   669,   669,   669,
     669,   670,   670,   671,   671,   672,   672,   673,   674,   674,
     674,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   676,   676,   676,   677,   677,   678,
     678,   678,   678,   678,   679,   679,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   681,
     681,   682,   682,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   684,
     684,   685,   685,   686,   687,   687,   688,   688,   688,   688,
     688,   689,   689,   690,   690,   690,   690,   691,   691,   691,
     691,   691,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   692,   692,   693,   693,   694,   694,   695,
     695,   696,   697,   698,   698,   699,   699,   700,   700,   701,
     702,   702,   703,   703,   703,   704,   704,   704,   705,   705,
     705,   705,   706,   707,   707,   708,   708,   709,   709,   710,
     710,   711,   711,   712,   712,   712,   713,   713,   714,   714,
     714,   715,   715,   715,   716,   716,   716,   717,   717,   717,
     718,   718,   719,   719,   720,   720,   721,   721,   722,   722,
     723,   723,   723,   723,   723,   724,   724,   724,   724,   724,
     725,   726,   727,   727,   727,   728,   728,   728,   729,   730,
     730,   730,   730,   731,   731,   732,   732,   733,   733,   733,
     733,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   734,   734,   734,   734,   735,   735,   736,   736,
     737,   738,   738,   739,   740,   740,   741,   741,   742,   742,
     743,   743,   744,   744,   745,   745,   745,   745,   746,   746,
     747,   748,   748,   749,   749,   750,   750,   750,   751,   751,
     751,   752,   753,   753,   754,   754,   754,   755,   755,   756,
     756,   757,   757,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   759,   759,
     760,   760,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   763,   764,   764,   764,   765,
     765,   766,   766,   766,   766,   766,   767,   767,   768,   768,
     768,   768,   769,   769,   769,   770,   770,   771,   772,   772,
     773,   774,   774,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   776,   776,   776,
     777,   777,   777,   777,   777,   778,   778,   778,   779,   779,
     780,   780,   780,   780,   781,   781,   781,   781,   782,   783,
     784,   784,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   786,   786,
     787,   787,   788,   789,   789,   790,   791,   791,   792,   792,
     793,   794,   794,   794,   794,   794,   794,   794,   795,   795,
     796,   797,   797,   797,   797,   797,   797,   798,   799,   799,
     799,   800,   800,   801,   801,   801,   801,   801,   802,   802,
     803,   803,   803,   803,   804,   804,   805,   805,   806,   806,
     807,   807,   808,   808,   809,   809,   810,   810,   810,   810,
     811,   811,   811,   811,   811,   811,   811,   811,   811,   812,
     812,   813,   814,   814,   815,   815,   815,   816,   817,   817,
     818,   818,   818,   818,   819,   819,   820,   820,   821,   821,
     821,   821,   822,   823,   823,   823,   824,   824,   825,   826,
     826,   827,   828,   828,   829,   830,   830,   831,   831,   831,
     831,   831,   831,   831,   831,   832,   832,   833,   834,   834,
     835,   835,   836,   837,   838,   839,   839,   840,   841,   842,
     842,   842,   842,   842,   843,   843,   843,   844,   844,   845,
     845,   846,   846,   846,   846,   846,   846,   846,   846,   847,
     847,   848,   848,   848,   848,   848,   848,   849,   849,   850,
     850,   851,   852,   852,   853,   853,   854,   854,   854,   854,
     854,   854,   854,   854,   854,   855,   855,   856,   856,   856,
     857,   857,   857,   857,   858,   858,   859,   860,   860,   861,
     861,   862,   862,   862,   862,   863,   863,   864,   864,   864,
     865,   865,   866,   866,   867,   868,   868,   868,   869,   870,
     870,   871,   871,   872,   872,   873,   873,   874,   874,   875,
     875,   876,   876,   877,   878,   878,   878,   878,   879,   879,
     880,   880,   881,   881,   882,   882,   883,   883,   883,   883,
     883,   883,   883,   884,   884,   884,   884,   884,   884,   885,
     885,   885,   885,   886,   886,   887,   887,   887,   887,   887,
     888,   888,   888,   888,   889,   889,   890,   890,   891,   891,
     891,   891,   892,   892,   893,   893,   893,   894,   894,   895,
     896,   896,   897,   897,   898,   898,   899,   899,   900,   900,
     900,   901,   901,   902,   902,   903,   904,   904,   904,   904,
     904,   904,   905,   905,   905,   906,   906,   906,   906,   906,
     906,   906,   907,   907,   907,   907,   908,   908,   909,   909,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   911,   911,   912,   912,   913,   913,   914,   915,   916,
     916,   917,   917,   918,   919,   920,   920,   920,   920,   920,
     920,   921,   921,   922,   922,   923,   923,   923,   923,   924,
     925,   925,   925,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   927,   927,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     930,   930,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   931,   931,   931,   931,   931,   931,   931,   932,
     932,   933,   933,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   935,   935,   936,   936,   936,
     936,   937,   938,   938,   939,   939,   940,   940,   941,   941,
     941,   942,   942,   942,   942,   943,   943,   944,   944,   945,
     945,   946,   946,   947,   948,   948,   948,   949,   950,   950,
     951,   951,   952,   952,   952,   953,   953,   954,   954,   954,
     954,   954,   955,   955,   955,   956,   956,   956,   957,   957,
     958,   958,   958,   958,   958,   958,   958,   958,   958,   959,
     959,   960,   960,   961,   961,   961,   961,   961,   961,   962,
     962,   963,   963,   964,   964,   965,   965,   966,   966,   966,
     967,   967,   968,   968,   969,   969,   969,   969,   969,   969,
     969,   969,   970,   970,   971,   972,   972,   973,   973,   973,
     973,   973,   973,   974,   975,   976,   976,   976,   977,   977,
     978,   979,   979,   980,   981,   981,   982,   982,   983,   983,
     984,   984,   984,   984,   985,   985,   986,   986,   987,   987,
     988,   988,   989,   989,   990,   991,   991,   992,   992,   993,
     993,   993,   993,   994,   994,   995,   995,   996,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,  1003,  1004,  1004,  1004,
    1004,  1004,  1004,  1004,  1004,  1004,  1004,  1004,  1004,  1004,
    1005,  1006,  1007,  1008,  1008,  1009,  1009,  1009,  1010,  1010,
    1010,  1011,  1011,  1011,  1012,  1012,  1012,  1012,  1013,  1013,
    1013,  1013,  1013,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     5,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     5,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     3,     5,     6,     4,     9,     7,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     6,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     1,     2,     3,     2,     1,
       1,     2,     1,     2,     1,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,    10,    13,     4,     6,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     1,     3,     2,
       3,     4,     6,     6,     6,     5,     5,     6,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     3,     2,
       2,     3,     1,     3,     2,     1,     1,     0,     2,     0,
       2,     0,     1,     1,     1,     3,     3,     2,     0,     1,
       3,     3,     1,     5,     3,     4,     1,     3,     4,     6,
       4,     8,     2,     2,    11,     7,     1,     1,     1,     0,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     1,
       3,     3,     1,     1,     3,     3,     3,     3,     4,     3,
       2,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    14,    10,    13,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     3,     8,
       4,     9,    11,     2,     0,     3,     0,     1,     3,     1,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     7,     5,     2,
       3,     0,     8,     4,     1,     0,     6,     5,     4,     6,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       2,     1,     1,     3,     6,    10,     1,     0,     1,     2,
       2,     0,     2,     2,     1,     0,     5,     7,     1,     0,
       7,     2,     0,     3,     5,     5,     8,     2,     0,     2,
       2,     2,     5,     2,     0,     2,     7,    10,     6,     6,
       6,     6,     7,     7,     9,     9,     6,     7,     6,     8,
       8,     8,     8,     6,     6,     7,     7,     8,     6,     6,
       7,     2,     2,     2,     2,     1,     2,     1,     0,     6,
       8,     7,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,    10,
      13,     5,     7,     8,     1,     1,     1,     7,     9,     8,
      15,    20,     1,     1,     2,     1,     3,     1,     1,     1,
       3,     1,     3,     0,     1,     0,     1,     1,     4,     0,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,     6,     8,    11,
      13,     1,     3,     5,     1,     3,     5,     1,     2,     2,
       1,     8,     4,     5,     4,     4,     4,     3,     7,     8,
       6,     6,     6,     6,     6,     4,     5,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     3,     0,
      13,     1,     3,     5,     6,     4,     7,     2,     1,     0,
       2,     0,     2,     4,     0,     1,     0,     6,     8,     8,
       1,     3,     5,     5,     7,     9,     7,     9,     5,     6,
       6,     4,     5,     7,     1,     1,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     3,     1,     2,     2,     3,     5,     2,     2,
       0,     6,     7,     7,     7,     8,     8,     6,     8,     9,
       9,     7,    10,     7,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       1,     3,     2,     3,     3,     3,     3,     1,     1,     8,
       9,     9,     9,     9,     2,     0,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     2,     2,     1,     2,     3,     3,     3,     3,     4,
       4,     3,     3,     3,     4,     4,     3,     4,     4,     1,
       1,     1,     0,     7,     7,    10,     1,     1,     2,     4,
       5,     1,     3,     2,     2,     2,     2,     1,     2,     2,
       4,     3,     2,     2,     2,     2,     3,     2,     2,     2,
       5,     5,     5,     1,     3,     1,     2,     3,     0,     1,
       3,     2,     6,     6,     9,     3,     0,     3,     0,     5,
       2,     0,     3,     3,     3,     7,     7,    10,     1,     1,
       1,     1,    14,     1,     0,     1,     0,     1,     0,     2,
       0,     1,     3,     5,     5,     7,     2,     0,     1,     2,
       0,     1,     1,     0,     1,     1,     0,     9,    12,     7,
       2,     0,     3,     2,     1,     3,     3,     2,     1,     3,
       3,     3,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     5,     1,     3,     3,     1,     3,
       3,     5,     6,     1,     3,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     1,     2,     2,     1,     1,     1,     3,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     5,     7,
       5,     7,     5,     7,     3,     5,     5,     5,     1,     3,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,     4,     4,     4,     1,     1,     1,
       0,     5,     5,     7,     6,     6,     6,     6,     8,     8,
       6,     6,     7,     9,     9,     6,     6,     6,     8,     6,
       8,     6,     8,     7,     9,     6,     8,     7,     9,     8,
      10,     9,    11,     8,     9,    11,     8,     8,     7,     6,
       6,     6,     8,     8,     8,     8,     6,     9,     1,     0,
       2,     0,     7,     6,     6,     6,     6,     6,     7,     9,
       9,     6,     8,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     7,     6,     6,     6,
       6,     6,     7,     7,     7,     9,     9,     6,     6,     6,
       8,     8,     8,     6,     7,    13,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     0,     6,     8,     3,     2,     0,
       2,     2,     2,     2,     3,     3,     2,     2,     2,     2,
       3,     2,     5,     4,     3,     3,     3,     1,     1,     0,
       3,     2,     2,     1,     2,     1,     3,     2,     1,     0,
       9,    11,    12,    14,     3,     4,     4,     0,     2,     5,
       2,     0,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     1,     0,
       5,     6,     4,     2,     0,     4,     3,     5,     4,     4,
       6,     4,     6,     6,     5,     7,     9,     6,     1,     0,
       6,    11,    11,    11,    13,     9,    11,    10,     4,     2,
       5,     2,     0,     4,     5,     5,     4,     6,     1,     3,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     0,     5,     3,     0,
       1,     1,     1,     1,     3,     9,     3,     0,     2,     3,
       2,     3,     6,     1,     4,     2,     1,     3,     2,     2,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     8,     1,     3,
       1,     1,     3,     5,     2,     1,     3,     7,     1,     0,
       3,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     1,     2,     4,     4,     4,     2,     3,     1,
       3,     6,     1,     0,     2,     0,     3,     3,     4,     4,
       4,     4,     3,     2,     1,     1,     0,     1,     1,     0,
       1,     5,     1,     0,     1,     0,     3,     1,     3,     4,
       3,     2,     2,     1,     1,     1,     0,     2,     4,     5,
       2,     3,     1,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     3,     0,     2,     0,     1,     3,     1,
       0,     1,     2,     3,     2,     4,     2,     3,     2,     0,
       2,     3,     2,     0,     1,     3,     2,     2,     3,     2,
       3,     1,     4,     3,     4,     5,     4,     5,     4,     5,
       2,     4,     1,     1,     0,     1,     4,     5,     4,     0,
       2,     2,     2,     1,     1,     0,     4,     2,     1,     2,
       2,     4,     1,     3,     1,     2,     3,     2,     6,     2,
       1,     3,     4,     0,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     1,     3,     3,     2,     3,     5,     6,
       2,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       2,     5,     1,     1,     1,     1,     2,     3,     3,     0,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       1,     3,     0,     1,     1,     1,     1,     5,     2,     1,
       1,     1,     1,     5,     2,     2,     2,     1,     3,     3,
       2,     1,     0,     3,     0,     5,     2,     5,     2,     1,
       2,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     0,     1,     4,     1,
       3,     3,     5,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     3,     3,     2,
       3,     5,     4,     6,     3,     5,     4,     6,     4,     6,
       5,     7,     3,     2,     4,     2,     3,     3,     4,     3,
       4,     3,     4,     5,     6,     6,     7,     6,     7,     6,
       7,     3,     4,     4,     6,     2,     3,     4,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     5,     6,     6,     7,     3,     4,
       1,     1,     2,     4,     1,     1,     1,     2,     2,     2,
       2,     1,     3,     5,     6,     8,     6,     6,     4,     4,
       1,     1,     1,     5,     1,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     1,     1,     1,     1,     1,     6,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     5,     4,
       6,     5,     7,     7,     7,     2,     3,     3,     3,     4,
       0,     4,     1,     3,     3,     1,     1,     1,     2,     2,
       0,     2,     4,     4,     6,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     2,     2,     0,     1,     4,     2,     2,     2,
       2,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     3,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     3,     0,     3,     3,     2,
       2,     1,     0,     2,     2,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     5,     1,     2,     0,     2,     1,     0,
       1,     1,     1,     3,     3,     1,     0,     1,     3,     3,
       2,     1,     1,     1,     3,     1,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     6,     2,     3,     6,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 691 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 20382 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 698 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 20393 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 705 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 20404 "gram.c" /* yacc.c:1646  */
    break;

  case 121:
#line 831 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20410 "gram.c" /* yacc.c:1646  */
    break;

  case 122:
#line 842 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20422 "gram.c" /* yacc.c:1646  */
    break;

  case 123:
#line 852 "gram.y" /* yacc.c:1646  */
    {}
#line 20428 "gram.c" /* yacc.c:1646  */
    break;

  case 124:
#line 853 "gram.y" /* yacc.c:1646  */
    {}
#line 20434 "gram.c" /* yacc.c:1646  */
    break;

  case 125:
#line 862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 20440 "gram.c" /* yacc.c:1646  */
    break;

  case 126:
#line 863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20446 "gram.c" /* yacc.c:1646  */
    break;

  case 127:
#line 867 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 20452 "gram.c" /* yacc.c:1646  */
    break;

  case 128:
#line 868 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20458 "gram.c" /* yacc.c:1646  */
    break;

  case 129:
#line 873 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 20467 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 878 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 20475 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 20484 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 887 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 20493 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 892 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 20501 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 20509 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 900 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 20517 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 905 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 20525 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 909 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[0].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 20580 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 962 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 20586 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 20594 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 20602 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 973 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 20610 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 20618 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 20626 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 995 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20638 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1013 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 20650 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1023 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20656 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1024 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20662 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1029 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20674 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1037 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20686 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1055 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 20698 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1067 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20710 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1075 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20722 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1096 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20733 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1103 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20744 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1122 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20755 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1129 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 20766 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1146 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20778 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1164 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 20791 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 20797 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 20803 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1188 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20814 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1195 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20825 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1212 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20842 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1225 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20856 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1235 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20878 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1253 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20897 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1270 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20903 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1271 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20909 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1276 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 20919 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1282 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20925 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1310 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 20935 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1316 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 20945 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1322 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 20955 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1331 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20967 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1339 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20979 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1351 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20991 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1359 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 21003 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1367 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 21014 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1374 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 21025 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1382 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 21031 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1384 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 21042 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1392 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 21057 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1403 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 21069 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1411 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21081 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1419 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 21096 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1430 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21108 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1438 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21120 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1446 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 21131 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1453 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21143 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1462 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21155 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1471 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21161 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1473 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 21167 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1476 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21173 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1477 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 21179 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1481 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 21185 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1483 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 21191 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1486 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 21197 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1487 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 21203 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1488 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 21209 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1489 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 21215 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1493 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 21221 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1494 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 21227 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1495 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 21233 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1501 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21239 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 21247 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1518 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 21255 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1522 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 21274 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1537 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 21301 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1559 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 21307 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1560 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21313 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1561 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21319 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1565 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21325 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1566 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21331 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1567 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21337 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1571 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21343 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1572 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21349 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1576 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 21355 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1580 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 21361 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1582 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 21372 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1589 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 21383 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1596 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 21394 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1606 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 21405 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1613 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 21415 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1622 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 21421 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1623 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 21427 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1628 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 21433 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1629 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 21439 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1635 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 21449 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1641 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 21459 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1647 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 21469 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1653 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 21479 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1659 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 21489 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1669 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 21500 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1678 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21506 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1679 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21512 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1683 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21518 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1684 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21524 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1693 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 21533 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1708 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 21543 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1714 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 21553 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1720 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 21563 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1726 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 21573 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1732 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 21583 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1751 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21596 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1760 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21609 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1769 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21624 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1780 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21639 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1791 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21652 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1800 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21665 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1809 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21680 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1820 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21695 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1831 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21708 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1840 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21721 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1849 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21734 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1858 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21747 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1867 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21760 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1876 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21773 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1885 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21788 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1896 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21803 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1909 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21809 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1910 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 21815 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1916 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21826 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1924 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21837 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1932 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21849 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1941 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 21860 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1949 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 21871 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1957 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 21883 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1966 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21895 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1975 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21907 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1984 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 21919 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1993 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 21932 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2003 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 21945 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2016 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 21963 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2031 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21975 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2040 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21986 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2048 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22004 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2063 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22015 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2071 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 22028 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2081 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 22041 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2091 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 22051 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2098 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 22061 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2105 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22072 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2113 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22083 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2121 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22094 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2129 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22105 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2137 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22116 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2145 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 22126 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2152 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 22136 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2159 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22147 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2167 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 22157 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2174 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 22167 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2181 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22178 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2189 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22189 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2197 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22200 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2205 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22211 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2213 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 22222 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2221 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 22233 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2229 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 22246 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2239 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 22256 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2246 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22267 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2254 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22278 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2262 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22289 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2270 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22300 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2278 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 22311 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2285 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22322 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2294 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22328 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2295 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22334 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2299 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 22340 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2300 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 22346 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2301 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 22352 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2306 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 22364 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2313 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22370 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2317 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22376 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22382 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2323 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 22393 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2330 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 22404 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2337 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 22415 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2344 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 22426 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2353 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22432 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2356 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22438 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2357 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22444 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2361 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 22450 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2362 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 22456 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2368 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 22464 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 22472 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 22481 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2381 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 22489 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2396 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 22503 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2408 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 22509 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 22515 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2415 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 22527 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2424 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 22540 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2434 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 22553 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2444 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 22572 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2470 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22582 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2476 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22592 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2507 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-6].defelt))
						n->options = lappend(n->options, (yyvsp[-6].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 22624 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2535 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-5].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-2]))));

					(yyval.node) = (Node *)n;
				}
#line 22647 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2556 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22653 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2557 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22659 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2561 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22665 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2562 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22671 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2571 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22677 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2572 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22683 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2573 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22689 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2576 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22695 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2577 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22701 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2582 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 22707 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22713 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 22721 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2592 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 22729 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2596 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
#line 22737 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2600 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 22745 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2604 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 22753 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2608 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 22761 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2612 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 22769 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2616 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 22777 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 22785 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 22793 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2628 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 22801 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 22809 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list));
				}
#line 22817 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2640 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 22825 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2649 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 22833 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2652 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 22839 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2657 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 22847 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2660 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 22853 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2665 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 22861 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2668 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 22867 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2672 "gram.y" /* yacc.c:1646  */
    {}
#line 22873 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2673 "gram.y" /* yacc.c:1646  */
    {}
#line 22879 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2679 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 22887 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 22895 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2690 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 22903 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2696 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 22909 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 22915 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2698 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 22921 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2699 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 22927 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22933 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 22941 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 22949 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2716 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 22955 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2729 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 22973 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2745 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 22991 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2760 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 23010 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2776 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 23029 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2803 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 23035 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2804 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 23041 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2805 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 23047 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2806 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 23053 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2808 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 23064 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2815 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 23075 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2821 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 23081 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2822 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 23087 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2826 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23093 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2827 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23099 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2831 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23105 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2832 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23111 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2837 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 23119 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2841 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 23127 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2848 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 23135 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2852 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 23143 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2858 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23149 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2859 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23155 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2860 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23161 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2864 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23167 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2865 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23173 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2869 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 23196 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2890 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 23218 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2910 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 23224 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23230 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2916 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 23242 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2923 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23248 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2924 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23254 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2926 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 23271 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2957 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23282 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2964 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 23293 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2971 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 23308 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2982 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 23323 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2993 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 23337 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3003 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 23350 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3012 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 23369 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3045 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 23380 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3052 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23391 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3059 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23402 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3066 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23413 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3077 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 23424 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3086 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 23430 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3087 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 23436 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3088 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 23442 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3092 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 23448 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3093 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 23454 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3094 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 23460 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3095 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 23466 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3096 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 23472 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3097 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 23478 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3107 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 23490 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3114 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23496 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3119 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 23513 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3133 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23531 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3147 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23549 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3162 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23567 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3176 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23585 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3192 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23605 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3209 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 23627 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3228 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 23633 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3229 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 23639 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3233 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23645 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3234 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23651 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3238 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 23657 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 23663 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 23671 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3249 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 23679 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3253 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 23691 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3261 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 23699 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3265 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 23707 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 23713 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 23719 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3277 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 23727 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3282 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 23735 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3288 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 23741 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3289 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23747 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3300 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 23753 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3302 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 23759 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3304 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 23765 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3306 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 23771 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3308 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 23777 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3311 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 23783 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3314 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 23789 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3318 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 23795 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3319 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 23801 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3320 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 23807 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3321 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 23813 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3322 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 23819 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3325 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23825 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23831 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3331 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23837 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3332 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 23843 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 23849 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23855 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3337 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 23861 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3338 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 23867 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3339 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 23873 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3340 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 23879 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3343 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23885 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3344 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23891 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3347 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23897 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3348 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23903 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3351 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23909 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3367 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 23925 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 23940 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3395 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23946 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3396 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 23952 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3397 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23958 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3410 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 23974 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3425 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 23989 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3437 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 23995 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3438 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 24001 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3451 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 24013 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3471 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 24026 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3483 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24038 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3491 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24050 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24056 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3502 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24062 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3505 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24068 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3506 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24074 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3510 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 24082 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 24090 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3518 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 24098 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3522 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 24106 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3526 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 24114 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3530 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 24122 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3534 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 24130 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3538 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 24138 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3542 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 24146 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3546 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 24154 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3550 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 24162 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3554 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 24170 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3559 "gram.y" /* yacc.c:1646  */
    {}
#line 24176 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3560 "gram.y" /* yacc.c:1646  */
    {}
#line 24182 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3564 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 24188 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3565 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 24194 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3567 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 24203 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3571 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 24209 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3574 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 24215 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3575 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 24221 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3588 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 24237 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3601 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 24252 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3614 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24258 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3615 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24264 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3623 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 24270 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3624 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 24276 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3628 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24282 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3629 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24288 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3633 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24294 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3634 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24300 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3638 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24306 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3639 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24312 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3644 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 24327 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3655 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 24341 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3667 "gram.y" /* yacc.c:1646  */
    {}
#line 24347 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3668 "gram.y" /* yacc.c:1646  */
    {}
#line 24353 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3679 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].str);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24366 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3689 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24372 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3690 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24378 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3704 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 24389 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3711 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 24400 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3728 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24412 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3736 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24424 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3747 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24430 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3749 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24436 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3754 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 24444 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3758 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 24452 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3762 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 24460 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3774 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24471 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3784 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24477 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3786 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24483 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3791 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 24491 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3804 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 24505 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3814 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 24519 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3824 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24532 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3833 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24545 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3842 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24558 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3851 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 24572 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3861 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24585 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3870 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24599 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3880 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24613 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3890 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24627 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3900 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24640 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3909 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24653 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3918 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24666 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3927 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24679 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3936 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24692 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3945 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24705 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3954 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24718 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3963 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24731 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3972 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24744 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3981 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24757 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3990 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24770 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3999 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24783 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4008 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24796 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4017 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24809 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4035 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24821 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4045 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 24827 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4046 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 24833 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4047 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 24839 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4048 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 24845 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4052 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24851 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24857 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24863 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24869 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4069 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24884 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4080 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24899 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4100 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24911 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4108 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 24923 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4119 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24929 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24935 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4125 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 24943 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4129 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 24951 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24957 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4141 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 24965 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4145 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 24973 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4152 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 24981 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4156 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 24990 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4161 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 24999 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4166 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 25007 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4173 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 25015 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4179 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25021 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4184 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 25027 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4196 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25041 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4208 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25047 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4209 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25053 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4214 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25059 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4215 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25065 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4219 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25071 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4220 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25077 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4231 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25092 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4242 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25107 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4262 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 25120 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4271 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 25132 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4279 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25143 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4298 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25160 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4313 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25177 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4336 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 25190 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4345 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 25203 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4363 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25215 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4374 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 25221 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 25227 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4376 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (strcmp((yyvsp[0].str), "public") == 0) ? NULL : (yyvsp[0].str); }
#line 25233 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4387 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 25245 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4395 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 25257 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4412 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25269 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4433 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 25291 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4454 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 25314 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4475 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 25320 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4476 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 25326 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4477 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 25332 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4482 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25338 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4484 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 25361 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4506 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 25367 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4508 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 25373 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4510 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 25379 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 25385 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 25391 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 25399 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4523 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 25411 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4533 "gram.y" /* yacc.c:1646  */
    {}
#line 25417 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4534 "gram.y" /* yacc.c:1646  */
    {}
#line 25423 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4538 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25429 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4539 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25435 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4543 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 25441 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4544 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25447 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4548 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 25453 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4549 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 25459 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25465 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4555 "gram.y" /* yacc.c:1646  */
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[0].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
#line 25475 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4560 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 25481 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4561 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 25487 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4562 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 25493 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4566 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 25499 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4567 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 25505 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4572 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 25511 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4574 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 25539 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4600 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 25545 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4601 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 25551 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4602 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 25557 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4603 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 25563 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4604 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 25569 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4605 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 25575 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4611 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25590 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4622 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25605 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4646 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 25618 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4657 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 25631 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4669 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25637 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25643 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4676 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list)); }
#line 25649 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25655 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 25661 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4688 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 25672 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4697 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 25678 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4698 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 25684 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4699 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 25690 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4700 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 25696 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4714 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 25716 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4733 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 25732 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4756 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25746 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4766 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25761 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4777 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25775 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4787 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25789 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4797 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 25804 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4808 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 25817 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4817 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 25828 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4824 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25839 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4831 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25852 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4840 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25865 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4849 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25878 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4858 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25891 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4867 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25904 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4876 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 25917 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25923 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4889 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25929 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25935 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 25943 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4898 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 25951 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4904 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 25957 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4905 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 25963 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4906 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 25969 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4907 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 25975 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4908 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 25981 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25987 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4914 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25993 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4915 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25999 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4924 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 26007 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4930 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26013 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26019 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26025 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 26031 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4948 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 26045 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4958 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 26059 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4968 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 26073 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4979 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 26079 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4980 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 26085 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4998 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 26100 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26106 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26112 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5017 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26126 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5028 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26140 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5038 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 26153 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5047 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 26167 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5057 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 26178 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5065 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26184 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5066 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26190 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26196 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26202 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5073 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26208 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26214 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5075 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26220 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5079 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 26238 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5092 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26244 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5098 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26255 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5108 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 26268 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5117 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 26281 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5128 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26287 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5129 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26293 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5134 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26305 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5142 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26317 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5154 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26332 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5165 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26347 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5179 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26362 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5190 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26377 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5213 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26388 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5223 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26399 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5241 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26414 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5252 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26429 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5263 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 26444 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5274 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 26459 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5287 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 26465 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5288 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 26471 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5289 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 26477 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5290 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 26483 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5291 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 26489 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5292 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 26495 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5293 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 26501 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5294 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 26507 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5295 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 26513 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5296 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 26519 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5297 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 26525 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5298 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 26531 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5299 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 26537 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5300 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 26543 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5301 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 26549 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5302 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 26555 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5303 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 26561 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 26567 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5308 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 26573 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26579 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5312 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 26585 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5316 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26591 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5318 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 26597 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5331 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26609 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5341 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 26615 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5342 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 26621 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5343 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 26627 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5376 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26640 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5385 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26653 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5394 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26666 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5403 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26679 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5412 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26692 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5421 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26705 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5430 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26719 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5440 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26732 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5449 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26745 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5458 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26758 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5467 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26771 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5476 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26784 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5485 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26797 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5496 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 26803 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5497 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 26809 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5498 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 26815 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5499 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 26821 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5500 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 26827 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5501 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 26833 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5502 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 26839 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5503 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 26845 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5504 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 26851 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5505 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 26857 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5506 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 26863 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5507 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 26869 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5508 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 26875 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5509 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 26881 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5510 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 26887 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5511 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 26893 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5512 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 26899 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5513 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 26905 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5514 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 26911 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5515 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 26917 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5516 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 26923 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5517 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 26929 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5518 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 26935 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5522 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26941 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5523 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26947 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5539 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26961 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5550 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26975 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5561 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26989 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5572 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 27003 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5583 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 27017 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5594 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27023 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5595 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27029 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5599 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 27035 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5600 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 27041 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5601 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 27047 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5602 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 27053 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5603 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 27059 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5604 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 27065 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5605 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 27071 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5606 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 27077 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5607 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 27083 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5608 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 27089 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5609 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 27095 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5610 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 27101 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5611 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 27107 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5614 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27113 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5615 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27119 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5626 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 27129 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5632 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27139 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5640 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27151 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5648 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27163 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5656 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27175 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5664 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27187 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5672 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27199 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5680 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 27211 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5688 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27223 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5696 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27235 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5704 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27247 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5712 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 27259 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5720 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27271 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5728 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27283 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5736 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 27295 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5744 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27307 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5752 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27319 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5760 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 27331 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5769 "gram.y" /* yacc.c:1646  */
    {}
#line 27337 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5770 "gram.y" /* yacc.c:1646  */
    {}
#line 27343 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5773 "gram.y" /* yacc.c:1646  */
    {}
#line 27349 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5774 "gram.y" /* yacc.c:1646  */
    {}
#line 27355 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5786 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 27371 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5802 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27388 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5816 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27405 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5841 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27411 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5843 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27417 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5845 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27423 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5847 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 27434 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5854 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 27445 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 27451 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 27457 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5867 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27468 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5874 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27479 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5881 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27490 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5888 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27501 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5902 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27513 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5910 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27525 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5918 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27537 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5926 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27549 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 5934 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27561 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 5942 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27573 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 5950 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27585 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 5958 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27597 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 5966 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27609 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 5974 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27621 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 5982 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27633 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 5990 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27645 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 5998 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27657 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6006 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27669 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6014 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27681 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6022 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27693 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6033 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27699 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6034 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27705 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6038 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27719 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6048 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27733 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6061 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27739 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6062 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27745 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6066 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 27751 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6068 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 27757 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6073 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 27768 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6089 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].str);
					(yyval.node) = (Node*)n;
				}
#line 27782 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6102 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 27796 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6112 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 27810 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6123 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27816 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6124 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27822 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6127 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27828 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6128 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27834 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6139 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 27845 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6148 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27851 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6149 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27857 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 27865 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6158 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 27873 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6162 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 27881 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6174 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 27897 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6187 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27914 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6201 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27931 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6216 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 27937 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6217 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 27943 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6218 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 27949 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6219 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 27955 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6234 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
#line 27981 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6258 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27987 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6259 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27993 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6263 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27999 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6264 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28005 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6268 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28011 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6269 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28017 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6273 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28023 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6274 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 28029 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6277 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 28035 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6278 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 28041 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 28056 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6298 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 28071 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 28086 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28092 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6322 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28098 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6325 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28104 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28110 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28116 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6330 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 28122 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6331 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 28128 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6332 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 28134 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6335 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 28140 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6336 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 28146 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6337 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 28152 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6355 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28167 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6367 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28183 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6380 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28198 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6393 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28204 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6394 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28210 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6397 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28216 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28222 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 28228 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6403 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 28234 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6411 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28240 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6412 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28246 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6416 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 28252 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6418 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 28258 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6433 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28271 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6442 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28284 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6451 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28297 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6460 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28310 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6469 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28323 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6480 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 28329 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6481 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 28335 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6482 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 28341 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6483 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 28347 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6484 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 28353 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6495 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 28365 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6509 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 28371 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 28381 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6517 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 28392 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 28400 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6531 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 28409 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6536 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 28418 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6544 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 28432 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6585 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 28440 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6589 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 28448 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6593 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 28456 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6597 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 28465 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6604 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 28471 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6605 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 28477 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28483 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6611 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28489 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6619 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 28497 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6623 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 28505 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6627 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 28513 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6631 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 28521 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 28529 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6639 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 28537 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6643 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 28545 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6647 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 28553 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6651 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 28561 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6655 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 28569 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6659 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 28577 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6663 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 28585 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6667 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 28593 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 28601 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6675 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 28610 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 28618 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6687 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 28626 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 28634 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 28642 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6700 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 28648 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6702 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 28656 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28662 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28668 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6713 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28681 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 28689 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 28697 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6744 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 28708 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6754 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28714 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6755 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28720 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6777 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28735 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6788 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28750 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6802 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28765 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6813 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28780 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6827 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28795 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6838 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28810 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6852 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 28822 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 6860 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 28828 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 28834 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 6864 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 28840 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 28846 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6871 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 28852 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6884 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28862 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6892 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28868 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6893 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28874 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6898 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 28882 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 6902 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 28890 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 6915 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 28904 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 6926 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 28918 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 6937 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 28932 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 6948 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 28938 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 6949 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 28944 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 6950 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 28950 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 6955 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28965 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 6967 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28971 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 6968 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28977 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 6983 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].objtype);
					n->relation = (yyvsp[-1].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28989 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 6991 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
#line 29003 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7001 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
#line 29017 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7013 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 29023 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7014 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 29029 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7017 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 29035 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7018 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 29041 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7030 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 29054 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7039 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 29067 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7056 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29081 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7066 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29094 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7075 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29107 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7084 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29120 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7093 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29133 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7102 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29147 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7112 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29160 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7121 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29174 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7131 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29187 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7140 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29200 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7149 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29214 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7159 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29228 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7169 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29241 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7178 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29254 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7187 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29268 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7197 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29282 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7207 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29296 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7217 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29310 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7227 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29324 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7237 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29338 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7247 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29352 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7257 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29366 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7267 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29380 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7277 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29394 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7287 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29408 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7297 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29422 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7307 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29437 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7318 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29452 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7329 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29467 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7340 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29482 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7351 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29496 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7361 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29511 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7372 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29526 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7383 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29540 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7393 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29554 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7403 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29566 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7411 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29579 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7420 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29592 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7429 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29605 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7438 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29618 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7447 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29631 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7456 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29644 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7465 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29657 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7474 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29670 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7483 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29686 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7496 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 29692 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7497 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29698 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7500 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 29704 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7501 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29710 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7512 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29724 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7522 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29737 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7531 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29750 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7540 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29763 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7549 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29776 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7558 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29790 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7568 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29804 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7578 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29818 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7588 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29832 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7598 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29845 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7607 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29858 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7616 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29871 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7625 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29884 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7634 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29897 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7643 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29910 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7652 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29923 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7661 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29936 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7670 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29949 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7679 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29962 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7688 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29975 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7697 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29988 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7706 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30001 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7715 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 30014 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7724 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30027 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7741 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30040 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7750 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30052 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7758 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30064 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7766 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30076 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7774 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30088 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7782 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30101 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7791 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30113 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7799 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30125 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7807 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30138 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7816 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30151 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7825 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30164 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7834 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30176 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7842 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30188 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7850 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30200 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7858 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30212 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7866 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30224 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7874 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30236 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7882 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30248 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7890 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30260 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7909 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30276 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7923 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30282 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30288 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7925 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30294 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7931 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 30304 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7937 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 30314 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7953 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30320 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7954 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30326 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7957 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 30332 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7958 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 30338 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7959 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 30344 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7960 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 30350 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7964 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30356 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7965 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30362 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7966 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30368 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7972 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 30383 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 30398 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8005 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30409 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8014 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30415 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8015 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30421 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8019 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30431 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8028 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30441 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8034 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 30451 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8053 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30462 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8060 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30473 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8067 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30484 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8074 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30495 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8081 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30506 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8088 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30517 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8095 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30529 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8103 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30541 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8111 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30553 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8119 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30565 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8127 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30577 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8135 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30588 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8142 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30599 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8149 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30610 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8157 "gram.y" /* yacc.c:1646  */
    {}
#line 30616 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8158 "gram.y" /* yacc.c:1646  */
    {}
#line 30622 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8159 "gram.y" /* yacc.c:1646  */
    {}
#line 30628 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8164 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 30635 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8167 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 30642 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8170 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 30649 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8173 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 30656 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8176 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 30663 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8183 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30669 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8185 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30675 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8187 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30681 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8193 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30687 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8207 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 30703 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8220 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 30719 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8233 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 30740 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8251 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 30761 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8270 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 30767 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8271 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 30773 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8272 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 30779 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8273 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 30785 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8284 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30795 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8300 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30806 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30812 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8310 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30818 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8315 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[0].str)));
				}
#line 30826 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
#line 30834 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8323 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[0].str)));
				}
#line 30842 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
#line 30850 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8331 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[0].str)));
				}
#line 30858 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8335 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
#line 30866 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8339 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 30874 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8343 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 30882 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8347 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
#line 30890 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8351 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[0].str)));
				}
#line 30898 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8355 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
#line 30906 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8359 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[0].str)));
				}
#line 30914 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8363 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
#line 30922 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 30930 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[0].str)));
				}
#line 30938 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
#line 30946 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8384 "gram.y" /* yacc.c:1646  */
    {}
#line 30952 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8385 "gram.y" /* yacc.c:1646  */
    {}
#line 30958 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8397 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 30969 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8404 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 30981 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8415 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 30992 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8425 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30998 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8426 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31004 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8431 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 31012 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8445 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 31023 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8452 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 31034 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8470 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 31044 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8476 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 31054 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8492 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31067 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8505 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 31079 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8514 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 31090 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8522 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 31101 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8530 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 31113 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8539 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 31127 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8550 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 31141 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8561 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31153 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8570 "gram.y" /* yacc.c:1646  */
    {}
#line 31159 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8571 "gram.y" /* yacc.c:1646  */
    {}
#line 31165 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8583 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31176 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8593 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 31190 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8603 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 31204 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8613 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 31218 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8623 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 31232 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8633 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 31244 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8641 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 31256 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8663 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 31270 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8685 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31282 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8693 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31294 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8702 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31306 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8712 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31312 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8713 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31318 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8726 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31338 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8742 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31358 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8758 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
#line 31376 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8772 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 31400 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8792 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 31426 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8816 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 31432 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8817 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 31438 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8821 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 31444 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8822 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 31450 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8823 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 31456 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8824 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 31462 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8829 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31480 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8843 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31498 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8859 "gram.y" /* yacc.c:1646  */
    {}
#line 31504 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8860 "gram.y" /* yacc.c:1646  */
    {}
#line 31510 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8864 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31516 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8865 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31522 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8868 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31528 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8869 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31534 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8872 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31540 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8873 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31546 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8877 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31552 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8878 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31558 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8892 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 31569 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8899 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 31583 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8909 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 31594 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8916 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 31605 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8938 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31613 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8942 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31621 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8949 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 31629 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8955 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31635 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8956 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 31641 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8960 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31647 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8961 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 31653 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8962 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31659 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8973 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31671 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8982 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31677 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8983 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31683 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9001 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31694 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9009 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 31713 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9025 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31719 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9026 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31725 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9037 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 31735 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9043 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 31745 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9049 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 31755 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9055 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 31765 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9071 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].istmt)->relation = (yyvsp[-2].range);
					(yyvsp[-1].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-1].istmt)->withClause = (yyvsp[-5].with);
					(yyval.node) = (Node *) (yyvsp[-1].istmt);
				}
#line 31776 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 31786 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9087 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 31796 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9093 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 31806 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9102 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 31812 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9104 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 31818 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9109 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 31830 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9119 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31836 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31842 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9133 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 31856 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31862 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9146 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31868 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9158 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 31881 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9168 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 31887 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9169 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 31893 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9172 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 31899 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 31905 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 31911 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 31917 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9176 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 31923 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9177 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 31929 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9178 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 31935 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 31941 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9182 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31947 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9183 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31953 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9199 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 31968 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9212 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31974 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 31980 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9217 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 31986 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31992 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9223 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 32001 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9231 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[-4]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 32030 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9259 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 32042 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9269 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 32048 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9270 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 32054 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9281 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 32067 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9291 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32073 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9294 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32079 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9295 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 32085 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9296 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 32091 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9297 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 32097 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9298 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 32103 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9301 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32109 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9302 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 32115 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9303 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32121 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9356 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32127 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9357 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32133 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9372 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32139 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9374 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 32150 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9381 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32162 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9389 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32174 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9397 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 32186 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9405 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 32198 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9413 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32210 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9421 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32222 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9431 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32228 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9432 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32234 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9462 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32251 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9474 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32257 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9476 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 32280 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9495 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 32288 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9499 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 32296 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9503 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 32304 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9518 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 32315 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9525 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 32326 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9534 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32332 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9535 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32338 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9539 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 32351 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9550 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 32357 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9551 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 32363 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9556 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 32378 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9567 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 32384 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32393 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9581 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32402 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32411 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9591 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32420 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9596 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32432 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9604 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32444 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9612 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 32453 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9617 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 32462 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9622 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 32471 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9628 "gram.y" /* yacc.c:1646  */
    {}
#line 32477 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9629 "gram.y" /* yacc.c:1646  */
    {}
#line 32483 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9632 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32489 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9633 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32495 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9634 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32501 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 32507 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32513 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9643 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32519 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9644 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32525 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9648 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 32531 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9649 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32537 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32543 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9657 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 32549 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9658 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 32555 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9662 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 32568 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 32581 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 32587 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 32593 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9685 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 32599 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 32605 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9690 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32611 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9691 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 32617 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9696 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32623 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9698 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 32636 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9708 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 32642 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9713 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32648 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9716 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32654 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9720 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32660 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9722 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 32669 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9729 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32675 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9739 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 32681 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9740 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32687 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9741 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 32693 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9749 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32699 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9753 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32705 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9754 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32711 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9757 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32717 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9758 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32723 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9763 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32729 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9764 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32735 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9768 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32741 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9769 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32747 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32753 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9774 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32759 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9778 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32765 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9779 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32771 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9783 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32777 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9784 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32783 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9789 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32795 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9799 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 32801 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9800 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 32807 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9801 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 32813 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9802 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 32819 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 9806 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32825 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 9807 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32831 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 9813 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32841 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 9819 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32851 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 9836 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32857 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 9837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32863 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 9841 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32869 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 9842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32875 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 9849 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 32884 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 9854 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32895 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 9861 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32907 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 9869 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 32946 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 9904 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 32975 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 9929 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 32983 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 9933 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 32992 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 9959 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 33000 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 9963 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 33016 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 9975 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 33033 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 9988 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 33051 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10002 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 33066 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10013 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 33082 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10028 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 33092 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10034 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 33101 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10039 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 33111 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10045 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 33120 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10051 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 33126 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10052 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 33132 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10061 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 33140 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10065 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 33148 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10069 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 33158 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10075 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 33168 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 33176 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10086 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 33182 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10087 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 33188 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10088 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 33194 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10089 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 33200 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10093 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33206 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10094 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33212 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10106 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 33218 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10107 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33224 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10113 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 33235 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10120 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 33246 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10127 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 33257 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10134 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 33268 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 33274 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 33280 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 33288 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10163 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 33299 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10170 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 33310 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10191 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 33324 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10201 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 33338 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 33344 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10217 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 33350 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 33356 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10221 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33362 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10222 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33368 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10225 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33374 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10226 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33380 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10231 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33386 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10232 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33392 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10237 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33398 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10239 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 33410 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10246 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33416 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10251 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33422 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10252 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33428 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33436 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33444 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10267 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 33466 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10297 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 33475 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 33485 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 33494 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 33504 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 33513 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 33523 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10334 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 33529 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10336 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 33535 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10338 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 33541 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10342 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33547 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10343 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33553 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10344 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33559 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10345 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33565 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10346 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33571 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 33580 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-4]))));
						(yyval.typnam)->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
				}
#line 33600 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10382 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33606 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10383 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33612 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10384 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33618 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10385 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33624 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33634 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10403 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 33644 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10410 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10411 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33656 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10418 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33665 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10423 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33674 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10428 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33683 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33692 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10438 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33701 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10443 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33710 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33719 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10453 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33729 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33739 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10465 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33749 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33758 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10478 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 33783 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10499 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 33791 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10509 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33799 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33807 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33815 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10525 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 33824 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10533 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33837 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10545 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33855 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10566 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33863 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10570 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33871 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33879 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10580 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 33894 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10593 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-4].str) = psprintf("%s_%s", (yyvsp[-4].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33907 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10604 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-1].str) = psprintf("%s_%s", (yyvsp[-1].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33924 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10619 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33930 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10621 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33936 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10623 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 33942 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10625 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33948 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10627 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33954 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10629 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33960 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10633 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 33966 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10634 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33972 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10638 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33978 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10639 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33984 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10647 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33997 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10656 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 34009 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10664 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 34022 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10673 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 34034 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 34043 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10691 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34049 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10692 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34055 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10693 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34061 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10698 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 34067 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10700 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 34073 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10702 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 34079 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10704 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 34085 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10706 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 34091 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34097 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10710 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 34106 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10715 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 34115 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10720 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 34125 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 34137 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10734 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 34146 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10739 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 34157 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10746 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 34167 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10752 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34173 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10757 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 34181 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10761 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 34190 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10790 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34196 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10792 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 34202 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10794 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34214 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10802 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 34224 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10817 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34230 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10819 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 34236 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10821 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34242 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10823 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34248 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 10825 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34254 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 10827 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34260 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 10829 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34266 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 10831 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34272 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 10833 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34278 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 10835 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34284 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 10837 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34290 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 10840 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34296 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 10842 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34302 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 10844 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 34308 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 10847 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34314 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 10849 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34320 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 10851 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34326 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 10854 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34332 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 10856 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 34343 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 10863 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 34349 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 10865 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 34360 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 10872 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34366 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 10874 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 34377 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 10881 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 34383 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 10883 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 34394 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 10891 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 34405 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 10898 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 34416 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 10905 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 34427 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 10912 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 34438 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 10929 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34449 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 10936 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34460 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 10943 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34471 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 10950 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34482 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 10957 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 34502 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 10973 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 34513 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 10980 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 34524 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 10987 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 34535 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 10994 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 34546 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11001 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 34557 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11008 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 34568 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11015 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 34576 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11019 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));

				}
#line 34588 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11027 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 34596 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11031 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 34604 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11041 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));
				}
#line 34615 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11048 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											 (yylsp[-5]));
				}
#line 34626 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11055 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											(yylsp[-4])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
											(yylsp[-4])),
											 (yylsp[-4]));
				}
#line 34643 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11068 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											(yylsp[-5])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
											(yylsp[-5])),
											 (yylsp[-5]));
				}
#line 34660 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11081 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-2].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 34683 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11100 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-3].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 34708 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11121 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 34722 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11131 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 34733 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11138 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 34753 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 34762 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 34773 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11177 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34779 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11179 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 34785 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11181 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34791 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11183 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 34797 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11185 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34803 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11187 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34809 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11189 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34815 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11191 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34821 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11193 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34827 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11195 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34833 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11197 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34839 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11199 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34845 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11201 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34851 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11203 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34857 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11205 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34863 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11207 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 34869 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11209 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 34877 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11213 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])), (yylsp[-4]));
				}
#line 34886 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 34894 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11222 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 34902 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11226 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 34911 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11231 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 34922 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11247 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34928 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11248 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34934 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11250 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 34953 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11265 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 34969 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11277 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34975 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11279 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34981 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11281 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34995 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11291 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 35022 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11314 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 35036 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11324 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 35050 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11334 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 35062 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11342 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 35075 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 35083 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11357 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35093 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11363 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35104 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11370 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35115 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11377 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 35129 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11387 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 35140 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11394 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 35160 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11422 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 35199 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11457 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35205 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11467 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35211 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11468 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35217 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11476 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 35227 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11482 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 35257 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11508 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 35271 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11518 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 35288 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11531 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[0]));
				}
#line 35300 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11539 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 35317 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11552 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 35331 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11562 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 35348 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11575 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 35362 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11585 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 35379 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 35387 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 35395 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11606 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[0]));
				}
#line 35403 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 35411 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11614 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[0]));
				}
#line 35419 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11618 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[0]));
				}
#line 35427 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11622 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 35433 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35441 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11628 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35454 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11637 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35463 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11642 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35474 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11649 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 35493 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11664 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 35504 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 35512 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11675 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 35520 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11679 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35528 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 35536 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11687 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 35547 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11694 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 35559 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11702 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 35571 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11710 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35579 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11714 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 35587 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11718 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 35595 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11722 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 35603 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 35611 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11730 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 35621 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11736 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 35629 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11740 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 35642 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11749 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 35650 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11753 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 35658 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11757 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 35667 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11762 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 35680 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11776 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35686 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11778 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 35692 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11782 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 35698 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11784 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 35704 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 11786 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 35710 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 11788 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 35716 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 11791 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35722 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 11794 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35728 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 11795 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 35734 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 11799 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 35746 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 11807 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 35758 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 11816 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 35764 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 11817 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 35770 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 11820 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 35776 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 11821 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35782 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 11822 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35788 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 11828 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 35796 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 11832 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 35804 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 11836 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 35812 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 11840 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 35820 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 11850 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35826 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 11851 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35832 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 11855 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35838 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 11856 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35844 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 11864 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35850 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 11865 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35856 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 11869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 35862 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 11871 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 35868 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 11876 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 35878 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 11884 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 35884 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 11886 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 35901 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 11899 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 35907 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 11904 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 35925 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 11929 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35931 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 11930 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35937 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 11933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35943 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 11934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35949 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 11946 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 35971 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 11964 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 35981 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 11970 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35993 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 11980 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 36014 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 11997 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 36055 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12042 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36067 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12050 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36079 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12058 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36091 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12066 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36103 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12074 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36115 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12094 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36121 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12095 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36127 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12096 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 36133 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12099 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 36139 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12100 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 36145 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12101 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 36151 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12104 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36157 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12105 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36163 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12108 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 36169 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12109 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 36175 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12110 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 36181 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12111 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 36187 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12112 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 36193 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12113 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 36199 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12114 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 36205 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12115 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 36211 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12116 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 36217 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36223 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36229 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12127 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36235 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12129 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36241 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12134 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36247 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36253 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12138 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 36259 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12140 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 36265 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 36271 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 36277 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12156 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 36285 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12160 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 36293 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12167 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 36301 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12171 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 36309 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12177 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 36317 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12181 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 36330 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12191 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36336 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12192 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 36342 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12196 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 36350 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12200 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 36358 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12204 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 36366 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12209 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36372 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12210 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36378 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 36386 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12219 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36392 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12226 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36398 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12227 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 36404 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12228 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 36410 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12229 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 36416 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12230 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 36422 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12231 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 36428 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12232 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 36434 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12233 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36440 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12244 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36448 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12248 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36456 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12255 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36462 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12261 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 36468 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12262 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36474 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12279 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36482 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12283 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 36491 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12288 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36499 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12292 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 36518 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12307 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 36526 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36532 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12315 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36538 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36544 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 36550 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12322 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36556 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12323 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36562 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12327 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 36573 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12333 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 36579 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12344 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 36593 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12357 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36599 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12358 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36605 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12363 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 36617 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12373 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36623 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12374 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36629 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12377 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36635 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12378 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36641 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 36649 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12386 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 36657 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 36665 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 36673 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12401 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 36684 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12408 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 36695 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12417 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36701 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12418 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36707 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12422 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36713 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12423 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36719 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 12438 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 36725 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 12440 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 36735 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 12448 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36741 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 12449 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36747 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 12457 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36753 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 12467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36759 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 12468 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36765 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 12472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 36771 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 12473 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 36777 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 12477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 36789 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 12493 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 36801 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 12501 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 36813 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 12509 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 36829 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 12530 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 36835 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 12531 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 36841 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 12543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 36849 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 12547 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 36878 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 12574 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36884 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 12576 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36890 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 12580 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36896 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 12583 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36902 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 12586 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36908 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 12588 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36914 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 12590 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36920 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 12592 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36926 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 12603 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36932 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 12605 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 36941 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 12616 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 36949 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 12620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36957 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 12624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36965 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 12628 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36973 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 12632 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36986 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 12641 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 36997 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 12648 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 37033 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 12680 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 37041 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 12684 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 37051 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 12690 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 37072 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 12707 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 37080 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 12711 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 37088 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 12715 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 37096 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 12720 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 37102 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 12721 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37108 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 12722 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37114 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 12725 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37120 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 12727 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37126 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 12730 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 37132 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 12731 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 37138 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 12732 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 37144 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 12748 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37150 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 12749 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37156 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 12750 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37162 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 12755 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37168 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 12756 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37174 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 12757 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37180 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 12762 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37186 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 12763 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37192 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 12764 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37198 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 12765 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37204 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 12771 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37210 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 12772 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37216 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 12773 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37222 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 12774 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37228 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 12775 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37234 "gram.c" /* yacc.c:1646  */
    break;


#line 37238 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 13237 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
